#ifndef POINT4D_H
#define POINT4D_H

#include "Point3D.h"

class Point4D : public Point3D
{
    public:
        Point4D( double x = 0.0, double y = 0.0, double z = 0.0, double w = 1.0 )
            : Point3D( x, y, z ) { this->w = w; }
        Point4D( const Point3D& p ) : Point3D( p ) { w = 1.0; }
        Point4D( const Point4D& p ) : Point3D( p.x, p.y, p.z ) { w = p.w; }
        virtual ~Point4D() {}

        void homDiv();

        bool isIdeal() { return (w == 0); }
        Point4D operator+( Point4D& p )
        {
            Point4D point( x + p.x, y + p.y, z + p.z, w + p.w );
            return point;
        }
        Point4D operator-( Point4D& p )
        {
            Point4D point( x - p.x, y - p.y, z - p.z, w - p.w );
            return point;
        }
        void operator+=( Point4D& p ) { x += p.x; y += p.y; z += p.z; w += p.w; }
        void operator/=( double d );

        Point4D operator*( double s )
        {
            Point4D point( x*s, y*s, z*s, w*s );
            return point;
        }
        Point4D operator/( double s );

        wxString toString() const
        {
            return wxString::Format( _T("( %f, %f, %f, %f )"), x, y, z, w );
        }

        double w;

};

WX_DEFINE_ARRAY( Point4D*, Point4DArray );

#endif // POINT4D_H
