#ifndef PRIMITIVE3D_H
#define PRIMITIVE3D_H

#include "Point4D.h"

class Matrix;

class Primitive3D
{
    public:
        Primitive3D() : m_color( *wxWHITE ) {}
        virtual ~Primitive3D();

        void render( wxDC& dc, int w, int h, const Matrix* m );
        virtual void transform( const Matrix* m );
        virtual void homDiv();
        void setColor( wxColor c ) { m_color = c; }
        //virtual void createModel() = 0;
        virtual void draw( wxDC& dc, int w, int h ) = 0;
    protected:
        Point4DArray    m_points;   //transformed points
        wxColor         m_color;
    private:
        Primitive3D( const Primitive3D& );
        Primitive3D& operator=( const Primitive3D& );
};


#endif // PRIMITIVE3D_H
