#include "ChannelValidationHelper.h"
#include "Utils.h"

wxString ChannelValidationHelper::createCollisionHtmlMessage( const wxArrayString& collisions )
{
    if ( ! collisions.GetCount() )
        return wxEmptyString;

    wxString htmlMsg = _T("<font size='+2'><b>Following collisions are found:</b></font><br><br>");

    for ( size_t i = 0; i < collisions.GetCount(); ++i )
    {
        wxArrayString tokens;
        Utils::tokenizeToArray( collisions[i], _T("|"), tokens );
        //wxString first = collisions[i].BeforeFirst('|'), second = collisions[i].AfterFirst('|');
        wxString first = tokens[0], second = tokens[1];

        wxString target = _T("");
        if ( tokens.GetCount() > 2 )
            target = tokens[2];
        if ( tokens.GetCount() > 3 )
            target += _T(",") + tokens[3];
        if ( target != wxEmptyString )
        {
            target = _T(" target=\"") + target + _T("\"");
        }


        wxString fdlgs, sdlgs;

        if ( first.StartsWith(_T("Injector") ) )
            fdlgs = _T("<a href='injOutVisual'") + target +_T(">Injector output visuals dialog</a>");
        else if ( first.StartsWith(_T("Ignition") ) )
            fdlgs = _T("<a href='ignitionOutputsVisual'") + target + _T(">Ignition outputs visual dialog</a>");
            else fdlgs = _T("<a href='outputChannels'") + target + _T(">Output channels dialog</a>");

        if ( second.StartsWith(_T("Injector") ) )
            sdlgs = _T("<a href='injOutVisual'") + target + _T(">Injector output visuals dialog</a>");
        else if ( second.StartsWith(_T("Ignition") ) )
            sdlgs = _T("<a href='ignitionOutputsVisual'") + target + _T(">Ignition outputs visual dialog</a>");
            else sdlgs = _T("<a href='outputChannels'") + target + _T(">Output channels dialog</a>");

        htmlMsg += _T("<b>") + first + _T("</b> conflicts with <b>") + second + _T("</b><br>");
        if ( fdlgs == sdlgs )
            htmlMsg += _T("Check ") + fdlgs;
        else
            htmlMsg += _T("Check ") + fdlgs + _T(" and ") + sdlgs;
        htmlMsg += _T("<br><br>");
    }

    return htmlMsg;
}

wxString ChannelValidationHelper::createInvalidHtmlMessage( const wxArrayString& invalids )
{
    if ( invalids.IsEmpty() ) {
        return wxEmptyString;
    }

    wxString htmlMsg = _T("<font size='+2'><b>Following channels are invalid:</b></font><br><br>");

    wxString target = _T("");

    for ( size_t i = 0; i < invalids.GetCount(); ++i )
    {
        wxString channel = invalids[i].BeforeFirst('|');
        wxString symName = invalids[i].AfterFirst('|');
        if ( symName != _T("") )
            target +=  symName + _T(",");

        htmlMsg += _T("<b>") + channel + _T("</b><br>");
    }
    if ( target.IsEmpty() == false )
        target.RemoveLast( 1 );

    htmlMsg += _T("Check <a href='outputChannels' target='") + target + _T("'>Output channels dialog</a><br>");

    return htmlMsg;
}
