#include "DnDFile.h"


#include <wx/file.h>
#include <wx/filename.h>


#include "mainframe.h"


bool DnDFile::OnDropFiles(wxCoord, wxCoord, const wxArrayString& filenames)
{
    size_t nFiles = filenames.GetCount();

    if ( nFiles != 1 )
    {
        return false;
    }

    wxString filename = filenames[0];

    if ( !wxFile::Exists( filename ) )
    {
        return false;
    }

    wxFileName fn( filename );

    if ( fn.GetExt().IsSameAs( _T("vemscfg"), false ) )
    {
        m_pOwner->OnOpenVemsCfg( filename );
    }
    else if ( fn.GetExt().IsSameAs( _T("vemslog"), false ) )
    {
        m_pOwner->OnOpenVemsLog( filename );
    }

    return true;
}
