#ifndef FILEPOSSLIDER_H
#define FILEPOSSLIDER_H

#include <wx/wx.h>
#include "common/typedef.h"
#include "ObserverBase.h"
#include "Observable.h"
#include "customwidgets/AggToolTipFrame.h"

class FilePosSlider: public wxSlider, public ObserverBase, public Observable
{
    public:

        FilePosSlider(wxWindow* parent, wxWindowID id, int value , int minValue, int maxValue, const wxPoint& point = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxSL_HORIZONTAL | wxSL_AUTOTICKS, const wxValidator& validator = wxDefaultValidator, const wxString& name = _T("slider"));
        virtual ~FilePosSlider();

        virtual void notify( int i );
        virtual void notify(int i, int idx);
        virtual void notify(const wxString& str);
        void notify( int i, void* classType );
        virtual void Init(const wxString& name, const wxString& msg, const int max);

        void SetSensibility(size_t sensibility);

    protected:

        void OnScrollThumbRelease( wxScrollEvent &evt );

        void OnScroll( wxScrollEvent &evt );

        void OnMouseDown( wxMouseEvent &evt );

    private:
        int m_currentTime;

        size_t m_sensibility;
        bool m_isMouseLeftDown;
        bool m_mouseIn;
        double m_time;
        AggToolTipFrame* m_ttip;

        wxString        m_timeStr;

        void    OnMouse(wxMouseEvent& event);

        DECLARE_EVENT_TABLE();
};



#endif // FILEPOSSLIDER_H
