#include "FirmwareInfoDialog.h"

#include "RawLogHelper.h"
#include "logger.h"

FirmwareInfoDialog::FirmwareInfoDialog(wxWindow* parent, FirmwareInfo *fwi,const wxString& messagein,
    const wxString& caption, long style, const wxPoint& pos)
{
    //ctor
    Create(parent,wxID_ANY,caption,pos);
    SetIcon(wxIcon(_T("vemsLogoIcon2")));

    wxString message;

    Logger::logf(LOG_MSG,_T("FirmwareInfoDialog::CTOR()") );

    if(fwi == NULL || fwi->isEmpty() ){
        message =  _T("Firmware info not available!");
    }else{
        message =  RawLogHelper::fwVersion + _T(": ") + fwi->getFirmwareVersionAsString() + _T("\n") +
                    RawLogHelper::fwcompTime + _T(": ") + fwi->getCompilationTime() + _T("\n") +
                    RawLogHelper::fwSN + _T(": ") + fwi->getSerialNumber() + _T("\n") +
                    RawLogHelper::signature + _T(": ") + fwi->getSignature();
    }

     if( !messagein.IsEmpty() ){
             message +=    _T("\n\n") + messagein;
    }


    wxBoxSizer * mainsizer = new wxBoxSizer(wxVERTICAL);
/*
    wxTextCtrl * ctrl = new wxTextCtrl(this,wxID_ANY,message, wxDefaultPosition, wxSize(300,100),  wxTE_DONTWRAP | wxNO_BORDER | wxTE_READONLY | wxTE_MULTILINE);

    ctrl->SetBackgroundColour(wxSystemSettings::GetColour(wxSYS_COLOUR_3DFACE));
    ctrl->ClearBackground();
*/

    wxStaticText * ctrl = new wxStaticText(this,-1,message);

    mainsizer->Add(ctrl,1,wxALL|wxEXPAND,15);

    mainsizer->Add( CreateStdDialogButtonSizer(wxOK),0,wxALL|wxALIGN_CENTER_HORIZONTAL,5 );

	SetSizer(mainsizer);
	mainsizer->Fit(this);
	mainsizer->SetSizeHints(this);

    //wxMessageDialog *dlg = new wxMessageDialog(parent,message,caption,style,pos);
    //dlg->ShowModal();
}

FirmwareInfoDialog::~FirmwareInfoDialog()
{
    //dtor
}
