#include "FirmwareVersion.h"
#include <wx/tokenzr.h>

FirmwareVersion::FirmwareVersion()
{
    major = 0;
    minor = 0;
    build = 0;
}

FirmwareVersion::FirmwareVersion( const wxString& verStr )
{
    fromString( verStr );
}

FirmwareVersion::FirmwareVersion( int major, int minor, int build )
{
    this->major = major;
    this->minor = minor;
    this->build = build;
}

bool FirmwareVersion::operator==( const FirmwareVersion& f )
{
    return ( ( major == f.major ) &&
             ( minor == f.minor ) &&
             ( build == f.build ) );
}

bool FirmwareVersion::operator!=( const FirmwareVersion& f )
{
    return ( ( major != f.major ) ||
             ( minor != f.minor ) ||
             ( build != f.build ) );
}

bool FirmwareVersion::operator<( const FirmwareVersion& f )
{
    return ( ( major < f.major ) ||
             ( ( major == f.major ) && ( minor < f.minor ) ) ||
             ( ( major == f.major ) && ( minor == f.minor ) && ( build < f.build ) ) );
}

bool FirmwareVersion::operator>( const FirmwareVersion& f )
{
    return ( ( major > f.major ) ||
             ( ( major == f.major ) && ( minor > f.minor ) ) ||
             ( ( major == f.major ) && ( minor == f.minor ) && ( build > f.build ) ) );
}


bool FirmwareVersion::operator<=( const FirmwareVersion& f )
{
    return ( (*this) == f || (*this) < f  );
}

bool FirmwareVersion::operator>=( const FirmwareVersion& f )
{
    return ( (*this) == f || (*this) > f  );
}

void FirmwareVersion::fromString( const wxString& fwVer )
{
    wxStringTokenizer tkz( fwVer, _T(".") );
    long version[3] = { 0,0,0 };

    int i = 0;
    bool b = tkz.HasMoreTokens();

    for( ; b && i < 3; b = tkz.HasMoreTokens(), ++i )
    {
        tkz.GetNextToken().ToLong( &version[i] );
    }

    major = (int)version[0];
    minor = (int)version[1];
    build = (int)version[2];
}
