#include "FwWebToolHelper.h"

#include "web/WebInterfacePanel.h"
#include "configmanager/ConfigHelper2.h"

wxWindow* FwWebToolHelper::OpenFwWebTool(wxWindow* parent)
{

    WIPDesc desc(_T("Firmware package downloader and installer"));

    ConfigBase* cfg = ConfigHelper2::getConfig();

    cfg->setPath(_T("/webservice"));

    cfg->read( _T("baseserver"), &desc.BaseServer, _T(""));
    cfg->read( _T("handler"), &desc.Handler, _T(""));
    cfg->read( _T("timeout_insec"), &desc.Timeout, 15);
    desc.LocalPath = _T("fw");

    //desc.FileFilter = _T("v3_firmware_[0-9]{1}\\.[0-9]{1,3}\\.[0-9]{1,3}\\.zip");
    desc.FileFilter = _T("(round|v3)_firmware_[0-9]{1}\\.[0-9]{1,3}\\.[0-9]{1,3}\\.zip$");

    desc.RemotePathTypeList[_T("v3")] = _T("v3firmware");

    desc.LocalChecker = new FirmwarePackChecker();

    desc.LocalInstaller = new FirmwareInstallService();

    desc.PopupMenuStrings[0] = _T("Install Firmware");

    desc.PopupMenuStrings[1] = _T("Reinstall Firmware");

    desc.PopupMenuStr = _T("(Re)Install Firmware");


    WebInterfacePanel * pn = new WebInterfacePanel(parent);
    pn->Init(desc);

    return pn;
}
