#include "GPSData.h"

#include <stdio.h>
#include <string.h>
#include "logger.h"

//#include <windows.h>

GPSData::GPSData( int length )
{
    m_length = length;
    m_data = new uint8_t[ m_length + 16]; // +1 if we need '\0'
    memset( m_data, '\0', m_length );
    m_capturedIdx = 255;
}

GPSData::~GPSData()
{
    delete[] m_data;
}

void GPSData::set( const uint8_t* src )
{
    memcpy( m_data, src, m_length );
    //if(m_length > 13)
    m_data[13] = m_capturedIdx;
}

void GPSData::get( uint8_t* dest ) const
{
    memcpy( dest, m_data, m_length );
}

void GPSData::captureEcuBlock(uint8_t idx)
{
    m_capturedIdx = idx;
    //Logger::logf(LOG_MSG, _T("GPSData::captureEcuBlock(): %d"), m_capturedIdx);
}
