#include "LayerHandler.h"

#include "common/typedef.h"

LayerHandler::LayerHandler()
{
    //ctor
}

LayerHandler::~LayerHandler()
{
    //dtor
}


bool LayerHandler::DrawBitmaps(wxBufferedPaintDC &dc)
{

    for(uint8_t a=0;a<m_bmpArray.Count();a++)
        dc.DrawBitmap( *(m_bmpArray.Item(a)) ,0,0,1);

	return true;
}

wxBitmapLayer* LayerHandler::GetBitmapPtrByDepth(char depth)
{
    if (m_layers.find(depth) == m_layers.end())
        return NULL;
    else
        return m_layers[depth];
}

int LayerHandler::AddBitmap(wxBitmapLayer *bmp)
{
    if(m_layers.find(bmp->GetDepth()) != m_layers.end())
        m_layers.erase(bmp->GetDepth());

    m_layers[bmp->GetDepth()] = bmp;

    RefreshBitmapArray();

    return 1;
}

int LayerHandler::AddBitmapArray(const BitmapLayerArray &bmparr)
{
    int count=0;

    for(uint16_t a=0;a<bmparr.Count();a++){
        if(m_layers.find(bmparr.Item(a)->GetDepth()) != m_layers.end()) {
            m_layers.erase(bmparr.Item(a)->GetDepth());
            count++;
        }
        m_layers[bmparr.Item(a)->GetDepth()] = bmparr.Item(a);
    }


    RefreshBitmapArray();

    return count;
}

void LayerHandler::RefreshBitmapArray()
{

    m_bmpArray.Clear();

    for(char a=-125;a<=126;a++) {
        if(m_layers.find(a) != m_layers.end())
            m_bmpArray.Add(m_layers[a]);
    }

}

bool LayerHandler::DelBitmapByDepth(char depth)
{
    if (m_layers.find(depth) == m_layers.end())
        return false;
    else {
        m_layers.erase(depth);
        RefreshBitmapArray();
        return true;
    }


}

bool LayerHandler::DelBitmapByPtr(wxBitmapLayer *bmp)
{
    return DelBitmapByDepth(bmp->GetDepth());
}


