#ifndef LAYERHANDLER_H
#define LAYERHANDLER_H

#include "wxBitmapLayer.h"
#include <wx/dcbuffer.h>

WX_DECLARE_HASH_MAP(char, wxBitmapLayer*, wxIntegerHash, wxIntegerEqual, wxBitmapHash);

class LayerHandler
{
    public:
        LayerHandler();
        virtual ~LayerHandler();

        int AddBitmap(wxBitmapLayer *bmp);
        int AddBitmapArray(const BitmapLayerArray &bmparr);

        wxBitmapLayer* GetBitmapPtrByDepth(char depth);

        bool DelBitmapByDepth(char depth);
        bool DelBitmapByPtr(wxBitmapLayer *bmp);

        bool DrawBitmaps(wxBufferedPaintDC &dc);



    protected:

    private:

        void RefreshBitmapArray();

        wxBitmapHash        m_layers;
        BitmapLayerArray    m_bmpArray;

};



#endif // LAYERHANDLER_H
