#ifndef LOGGERWIDGET_H
#define LOGGERWIDGET_H

#include "rtdatamanager/RTDataMgrBase.h"
#include "rtdatamanager/RTDataLogWriter.h"

#include <wx/checkbox.h>
#include <wx/button.h>
#include <wx/textctrl.h>
#include <wx/combobox.h>

#include "wxStaticTextEx.h"

class LoggerWidget: public wxControl
{
    public:
        LoggerWidget(wxWindow* parent, wxWindowID id, wxPoint gPos, int gSize, bool isShow = false);
        virtual ~LoggerWidget();

        void SetDataLogWriter( RTDataLogWriter * DataLogWriter);
        void SetDataMgr( RTDataMgrBase *rtDataMgr);
        wxString StartLogging(bool overcheck = false);

    protected:

        DECLARE_EVENT_TABLE();

    private:

        void OnStopClick(wxCommandEvent& event);
        void OnStartClick(wxCommandEvent& event);
        void OnHighCheckClick(wxCommandEvent& event);
        void setHighEdit(wxString name);

        void OnTextEditFocus(wxFocusEvent& event);
        void OutTextEditFocus(wxFocusEvent& event);

        void SetAndOpenHighLogFile();

        wxWindow    *m_window;

        wxString    m_HighLogName;

        RTDataLogWriter *m_DataLogWriter;
        RTDataMgrBase   *m_rtDataMgr;


        wxStaticTextEx  *HighText;
        wxStaticTextEx  *FileMethodsText;

        wxTextCtrl      *HighEdit;

        wxCheckBox      *HighCheckBox;

        wxButton        *startButton;
        wxButton        *stopButton;

        wxComboBox      *FileMethodsComboBox;

        wxArrayString   choices;

/*
        wxRadioButton   *overRadio;
        wxRadioButton   *dateRadio;
        wxRadioButton   *appeRadio;
*/

};



#endif // LOGGERWIDGET_H
