#include <math.h>
#include "MGraphics.h"
// #include "vemsgauge.h"
// #include "gaugeframe.h"
// #include <iostream>

#include <wx/dcclient.h>
#include <wx/brush.h>

#include <wx/image.h>

#include "../logger.h"


//-----------------------------------------------------------------------
// TRGB *GT = NULL;
int   NG = 0;

//-----------------------------------------------------------------------
// Antialiased circle drawer function
// Majer JĂˇnos
// ToDo
//   1) Alap kĂ¶rrajzolĂˇs
//
//   N) Figyelni kell a hatĂˇrokra, nem szabad kilĂ©pni a BMP terĂĽletĂ©rĂµl
//
void TMGraphics::DrawCircle(TRGB RGB, int w, double cx, double cy, double r)
  {
    double  x,    y,  t;
    int     X,    Y;
    double  From, To;
    double  RR;
    double  e,  f;
    int     i;
    BYTE    R, G, B;
    BYTE    *pB;

    R = RGB.R;
    G = RGB.G;
    B = RGB.B;

    RR = r * r;

    From = -1 * sin(M_PI/4) * r;
    To = -1 * From;

    for(i = (int)From; i < To; i++)
      {
        // kell egy SQRT LUT !!!, dĂ¶g lassĂş ez a gyĂ¶kvonĂˇs
        t = sqrt(RR - i * i);
        y = cy + t;

        //---------------------------------
        /**/
        Y = (int)floor(y);
        e = y - Y ;
        f = 1 - e;

        X = (int)floor(cx + i);
        BEGIN_ALIAS

        Y++;
        END_ALIAS

        /**/
        //---------------------------------
        /**/
        y = cy - t;
        Y = (int)floor(y);
        e = y - Y;
        f = 1 - e;

        X = (int)floor(cx + i);
        BEGIN_ALIAS

        Y++;
        END_ALIAS
        /**/
      }


    From = -t;
    To   = t;
    for(i = (int)From; i < To; i++)
      {
        t = sqrt(RR - i * i);
        x = cx + t;

        //---------------------------------
        /**/
        X = (int)floor(x);
        e = x - X;
        f = 1 - e;

        Y = (int)floor(cy + i);
        BEGIN_ALIAS

        X++ ;
        END_ALIAS
        /**/
        //---------------------------------
        /**/
        x = cx - t;
        X = (int)floor(x);
        e = x - X;
        f = 1 - e;
        Y = (int)floor(cy + i);

        BEGIN_ALIAS

        X++ ;
        END_ALIAS
        /**/
      }

  }//TMGraphics::DrawCircle()

//-----------------------------------------------------------------------
// Antialiased filled circle drawer function
// The outline and fill colour are same
// Robust version. Very slow, better to use the kamikadze version!
// Posible to optimalization with lead-in and lead-out cycles,
// like Perspective-trans anno, it will working!!!
void TMGraphics::DrawFillCircle(TRGB RGB, double cx, double cy, double r)
  {
    double  x,    y,  t;
    int     X,    Y;
    int     X1,   X2;
    double  From, To;
    double  RR;
    double  e,  f;
    int     i,  j;
    BYTE    R, G, B;
    int     **SB;         // Segment Buffer
    bool    **SBV;        // Segment Buffer Validator
    BYTE    *pB;


    R = RGB.R;
    G = RGB.G;
    B = RGB.B;

    // RGB_MAGENTA

    RR = r * r;

    W = BMP->GetWidth();
    H = BMP->GetHeight();

    SB = new int*[H];
    SBV = new bool*[H];

    for(j=0; j<H; j++)
      {
        SB[j] = new int[2];
        SBV[j] = new bool[2];
        SBV[j][0] = false;
        SBV[j][1] = false;
      }


    From = -1 * sin(M_PI/4) * r;
    To = -1 * From;

    /**
    X = floor(cx + From);
    if(X < 0)
      From = ceil(0 - cx);

    X = floor(cx + To);
    if(W <= X)
      To = floor(W - cx);
    **/

    for(i = (int)From; i < To; i++)
      {
        // kell egy SQRT LUT !!!, dĂ¶g lassĂş ez a gyĂ¶kvonĂˇs
        t = sqrt(RR - i * i);
        y = cy + t;

        //---------------------------------
        Y = (int)floor(y);
        e = y - Y ;
        f = 1 - e;

        X = (int)floor(cx + i);

        if((0 <= Y) && (Y < H))
          {
            if(!SBV[Y][0])
              {
                SB[Y][0] = X;
                SBV[Y][0] = true;
              }
            else
              {
                SB[Y][1] = X;
                SBV[Y][1] = true;
              }
          }

        Y++;

        if((0 <= Y) && (Y < H) &&
           (0 <= X) && (X < W))
          {
            END_ALIAS
          }

        //---------------------------------
        y = cy - t;
        Y = (int)floor(y);
        e = y - Y;
        f = 1 - e;

        X = (int)floor(cx + i);

        if((0 <= Y) && (Y < H) &&
           (0 <= X) && (X < W))
          {
            BEGIN_ALIAS
          }

        Y++;

        if((0 <= Y) && (Y < H))
          {
            if(!SBV[Y][0])
              {
                SB[Y][0] = X;
                SBV[Y][0] = true;
              }
            else
              {
                SB[Y][1] = X;
                SBV[Y][1] = true;
              }
          }
      }

    // R = 0;
    // G = 255;
    // B = 255;

    From = -t;
    To   = t;


    Y = (int)floor(cy + From);
    if(Y < 0)
      From = ceil(0 - cy);

    Y = (int)floor(cy + To);
    if(H <= Y)
      To = floor(H - cy);

    for(i = (int)From; i < To; i++)
      {
        t = sqrt(RR - i * i);
        x = cx + t;

        //---------------------------------
        X = (int)floor(x);
        e = x - X;
        f = 1 - e;

        Y = (int)floor(cy + i);

        SB[Y][1] = X;
        SBV[Y][1] = true;

        X++ ;

        if((0 <= X) && (X < W))
          {
            END_ALIAS
          }

        //---------------------------------
        x = cx - t;
        X = (int)floor(x);
        e = x - X;
        f = 1 - e;
        Y = (int)floor(cy + i);

        if((0 <= X) && (X < W))
          {
            BEGIN_ALIAS
          }

        X++ ;

        SB[Y][0] = X;
        SBV[Y][0] = true;
      }

    //-----------------------------------------------------------------------
    // Paint filled body
    //
    FillRow(RGB);
    for(Y=0; Y < H; Y++)
      {
        X1 = SB[Y][0];
        X2 = SB[Y][1];

        if(X1 < 0)
          X1 = 0;
        if(W <= X2)
          X2 = W - 1;

        if(SBV[Y][0] && SBV[Y][1])
          {
            /**
            for(X = X1; X <= X2; X++)
              {
                SET_PIXEL
                // Here I will use memcpy (more effective)
              }
            **/
            FillSegment(Y, X1, X2);

            if(X1 == X2)
              {
                X = X1;
                SET_PIXEL
              }
          }
        else if(SBV[Y][0])
          {
            X = X1;
            SET_PIXEL
          }
        else if(SBV[Y][1])
          {
            X = X2;
            SET_PIXEL
          }

        delete SB[Y];
        delete SBV[Y];
      }

    delete SB;
    delete SBV;
  }//TMGraphics::DrawFillCircle()

//-----------------------------------------------------------------------
// Antialiased filled circle drawer function
// The outline and fill colour are same
void TMGraphics::DrawGradientCircle(TRGB rgb_A, TRGB rgb_B, double cx, double cy, double r, double Alpha)
  {
    //Logger::logf(LOG_MSG,_T(" TMGraphics::DrawGradientCircle() START"));
    double  x,    y,  t;
    int     X,    Y;
    int     X1,   X2;
    double  From, To;
    double  RR;
    double  e,  f;
    int     i,  j;
    BYTE    R, G, B;
    int     **SB;         // Segment Buffer
    TRGB    RGB;
    TRGB    *pG;
    BYTE    *pB;


    RGB = rgb_A;

    CreateGradient(rgb_A, rgb_B, (int)(2*r + 3));
   // Logger::logf(LOG_MSG,_T(" TMGraphics::DrawGradientCircle() 1"));
    pG = GT;

    R = RGB.R;
    G = RGB.G;
    B = RGB.B;

    RR = r * r;

    H = BMP->GetHeight();
    W = BMP->GetWidth();

    SB = new int*[H];
//     Logger::logf(LOG_MSG,_T(" TMGraphics::DrawGradientCircle() 2"));
    for(j=0; j<H; j++)
      {
        SB[j] = new int[2];
        SB[j][0] = -1;
        SB[j][1] = -1;
      }

//     Logger::logf(LOG_MSG,_T(" TMGraphics::DrawGradientCircle() 3 j=%d"),j);
    From = -1 * sin(M_PI/4) * r;
    To = -1 * From;

    int E = (int)(cx - r);
//     Logger::logf(LOG_MSG,_T(" TMGraphics::DrawGradientCircle() 4"));
    for(i = (int)From; i < To; i++)
      {
        //Logger::logf(LOG_MSG,_T(" TMGraphics::DrawGradientCircle() 40 i=%d  RR=%f To=%f"),i, RR, To);
        // kell egy SQRT LUT !!!, dĂ¶g lassĂş ez a gyĂ¶kvonĂˇs
        t = sqrt(RR - i * i);
        y = cy + t;

        //---------------------------------
        Y = (int)floor(y);
        /**
        if(H <= Y)
          continue;
        **/

        e = y - Y ;
        f = 1 - e;
       //  Logger::logf(LOG_MSG,_T(" TMGraphics::DrawGradientCircle() 43 Y=%d"), Y);
         X = (int)floor(cx + i);
       //  Logger::logf(LOG_MSG,_T(" TMGraphics::DrawGradientCircle() 431 X=%d"), X);
        if(SB[Y][0] == -1){
        //   Logger::logf(LOG_MSG,_T(" TMGraphics::DrawGradientCircle() 441 Y=%d"), Y);
          SB[Y][0] = X;
        }else{
        //   Logger::logf(LOG_MSG,_T(" TMGraphics::DrawGradientCircle() 442 Y=%d"), Y);
          SB[Y][1] = X;
        }
        Y++;

        if(H <= Y)
          continue;
       // Logger::logf(LOG_MSG,_T(" TMGraphics::DrawGradientCircle() 45"));
        pG[X - E].GetRGB(&R, &G, &B);

//        Logger::logf(LOG_MSG,_T(" TMGraphics::DrawGradientCircle() SL[%i]=%0X"),Y, SL[Y]);
        //END_ALIAS
        pB = SL[Y] + 3 * X;
//        Logger::logf(LOG_MSG,_T(" TMGraphics::DrawGradientCircle() X=%i, pB=%p"),X, pB);
//        Logger::logf(LOG_MSG,_T(" TMGraphics::DrawGradientCircle() X=%i, pB=%0X"),X, pB);
//        Logger::logf(LOG_MSG,_T(" TMGraphics::DrawGradientCircle() X=%i, pB=%u"),X, *pB);
        *pB++ = (BYTE)(f * *pB + e * B);
        *pB++ = (BYTE)(f * *pB + e * G);
        *pB = (BYTE)(f * *pB + e * R);

        //---------------------------------
        y = cy - t;
        Y = (int)floor(y);
        e = y - Y;
        f = 1 - e;

        /**
        if(Y < 0)
          continue;
        **/

        X = (int)floor(cx + i);
        pG[X - E].GetRGB(&R, &G, &B);

        BEGIN_ALIAS

        Y++;
        /**
        if(Y < 0)
          continue;
        **/

        if(SB[Y][0] == -1)
          SB[Y][0] = X;
        else
          SB[Y][1] = X;
      }

    // R = 0;
    // G = 255;
    // B = 255;
   //  Logger::logf(LOG_MSG,_T(" TMGraphics::DrawGradientCircle() 5"));
    From = -t;
    To   = t;
    for(i = (int)From; i < To; i++)
      {
        X = (int)(i - From);
        pG[X].GetRGB(&R, &G, &B);

        t = sqrt(RR - i * i);
        x = cx + t;

        //---------------------------------
        X = (int)floor(x);
        /*
        if(W <= X)
          continue;
        */

        e = x - X;
        f = 1 - e;

        Y = (int)floor(cy + i);

        SB[Y][1] = X;

        X++ ;
        /**
        if(W <= X)
          continue;
        **/

        pG[X - E].GetRGB(&R, &G, &B);

        END_ALIAS

        //---------------------------------
        x = cx - t;
        X = (int)floor(x);
        e = x - X;
        f = 1 - e;
        Y = (int)floor(cy + i);

        /**
        if(X < 0)
          continue;
        **/

        pG[X - E].GetRGB(&R, &G, &B);


        BEGIN_ALIAS

        X++ ;
        /**
        if(X < 0)
          continue;
        **/
        SB[Y][0] = X;
      }
  //   Logger::logf(LOG_MSG,_T(" TMGraphics::DrawGradientCircle() 10"));
    //-----------------------------------------------------------------------
    // Paint filled body
    //
    for(Y=0; Y<H; Y++)
      {
        X1 = SB[Y][0];
        X2 = SB[Y][1];

        /**/
        if((X1 != -1) && (X2 != -1))
          {
            /**
            for(X=X1; X<=X2; X++)
              {
                pG[X-E].GetRGB(&R, &G, &B);
                SET_PIXEL
                // Here I will use memcpy (more effective)
              }
            **/
            FillGradient(Y, X1 - E, X1, X2);

            if(X1 == X2)
              {
                X = X1;
                pG[X-E].GetRGB(&R, &G, &B);
                SET_PIXEL
              }
          }
        else if(X1 != -1)
          {
            X = X1;
            pG[X-E].GetRGB(&R, &G, &B);
            SET_PIXEL
          }
        else if(X2 != -1)
          {
            X = X2;
            pG[X-E].GetRGB(&R, &G, &B);
            SET_PIXEL
          }
        //delete SB[Y];
      }

    // delete GT;
    //delete[] SB;
  }//TMGraphics::DrawGradientCircle()



