#include <math.h>
#include "MGraphics.h"
#include <wx/dcclient.h>
#include <wx/brush.h>
#include <wx/image.h>
#include "../logger.h"


//-----------------------------------------------------------------------
void TMGraphics::DrawDonut(TRGB RGB, double cx, double cy, double R1, double R2)
  {
    double  x,    y,  t;
    int     X,    Y;
    double  From, To;
    double  RR;
    double  e,  f;
    int     i;
    BYTE    R, G, B;
    BYTE    *pB;
    int     **SB1, **SB2;
    int     X1, X2;

    W = BMP->GetWidth();
    H = BMP->GetHeight();

    SB1 = new int*[H];
    SB2 = new int*[H];

    for(Y=0; Y<H; Y++)
      {
        SB1[Y] = new int[2];
        SB2[Y] = new int[2];

        SB1[Y][1] = SB1[Y][0] = SB2[Y][1] = SB2[Y][0] = -1;
      }


    R = RGB.R;
    G = RGB.G;
    B = RGB.B;

    //-----------------------------------------------------------------------
    // Outside Circle
    //
    RR = R1 * R1;

    From = -1 * sin(M_PI/4) * R1;
    To = -1 * From;

    for(i = (int)From; i < To; i++)
      {
        t = sqrt(RR - i * i);
        y = cy + t;

        //---------------------------------
        // RGB_RED
        Y = (int)ceil(y);
        e = Y - y;
        f = 1 - e;
        X = (int)floor(cx + i);
        BEGIN_ALIAS

        Y--;
        if(SB1[Y][0] == -1)
          SB1[Y][0] = X;
        else
          SB1[Y][1] = X;

        //---------------------------------
        // RGB_BLUE
        y = cy - t;
        Y = (int)floor(y);
        e = y - Y;
        f = 1 - e;
        X = (int)floor(cx + i);
        BEGIN_ALIAS

        Y++;
        if(SB1[Y][0] == -1)
          SB1[Y][0] = X;
        else
          SB1[Y][1] = X;
      }

    From = -t;
    To   = t;
    for(i = (int)From; i < To; i++)
      {
        t = sqrt(RR - i * i);

        //---------------------------------
        // RGB_GREEN
        x = cx + t;
        X = (int)ceil(x);
        e = X - x;
        f = 1 - e;
        Y = (int)floor(cy + i);
        BEGIN_ALIAS

        X--;
        SB1[Y][1] = X;

        //---------------------------------
        // RGB_YELLOW
        x = cx - t;
        X = (int)floor(x);
        e = x - X;
        f = 1 - e;
        Y = (int)floor(cy + i);
        BEGIN_ALIAS

        X++;
        SB1[Y][0] = X;
      }

    //-----------------------------------------------------------------------
    // Inside Circle
    //
    // RGB_YELLOW

    RR = R2 * R2;

    From = -1 * sin(M_PI/4) * R2;
    To = -1 * From;

    for(i = (int)From; i < To; i++)
      {
        t = sqrt(RR - i * i);

        //---------------------------------
        // RGB_CYAN
        y = cy + t;
        Y = (int)floor(y);
        e = y - Y ;
        f = 1 - e;
        X = (int)floor(cx + i);
        BEGIN_ALIAS


        if(SB2[Y][0] == -1)
          SB2[Y][0] = X - 1;
        else
          SB2[Y][1] = X + 1;

        //---------------------------------
        // RGB_MAGENTA
        y = cy - t;
        Y = (int)ceil(y);
        e = Y - y;
        f = 1 - e;
        X = (int)floor(cx + i);
        BEGIN_ALIAS

        if(SB2[Y][0] == -1)
          SB2[Y][0] = X - 1;
        else
          SB2[Y][1] = X + 1;
      }


    From = -t;
    To   = t;
    for(i = (int)From; i < To; i++)
      {
        t = sqrt(RR - i * i);

        //---------------------------------
        // RGB_YELLOW
        x = cx + t;
        X = (int)floor(x);
        e = x - X;
        f = 1 - e;
        Y = (int)floor(cy + i);
        BEGIN_ALIAS

        X++;
        SB2[Y][1] = X;

        //---------------------------------
        // RGB_BLUE
        x = cx - t;
        X = (int)ceil(x);
        e = X - x;
        f = 1 - e;
        Y = (int)floor(cy + i);
        BEGIN_ALIAS

        X--;
        SB2[Y][0] = X;
      }

    //-----------------------------------------------------------------------
    // FILL THE BODY

    FillRow(RGB);

    for(Y=0; Y<H; Y++)
      {
        if((SB1[Y][0] != -1) && (SB2[Y][0] != -1))
            // && (SB1[Y][1] != -1) && (SB2[Y][1] != -1))
          {
            X1 = SB1[Y][0];
            X2 = SB2[Y][0];

            FillSegment(Y, X1, X2);

            if((SB2[Y][1] != -1))
              {
                X1 = SB2[Y][1];
                X2 = SB1[Y][1];
              }
            else
              {
                // Avoid one-pixel tip errors
                X1 = SB2[Y][0];
                X2 = SB1[Y][1];
              }


            FillSegment(Y, X1, X2);

          }
        else if((SB1[Y][0] != -1) && (SB2[Y][0] == -1))
          {
            X1 = SB1[Y][0];
            X2 = SB1[Y][1];

            FillSegment(Y, X1, X2);
          }

        delete SB1[Y];
        delete SB2[Y];
      }

    delete SB1;
    delete SB2;

  }//TMGraphics::DrawDonut()
