#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif

#include "wx/spinbutt.h"
#include "wx/tglbtn.h"
#include "wx/bookctrl.h"
#include "wx/imaglist.h"
#include "wx/artprov.h"
#include "wx/cshelp.h"

#include "wx/tooltip.h"

#ifdef WXPLOT
    #include "wx/plot/plot.h"
#endif
class VemsTuneController;

class MainPanel: public wxPanel
{
public:
    MainPanel(wxFrame *frame, int x, int y, int w, int h, VemsTuneController* vemsController);
    virtual ~MainPanel();
    /*
    void OnReadConfig(wxCommandEvent& event);
    void OnTestAndRead(wxCommandEvent& event);
    void OnRead(wxCommandEvent& event);
    void OnVerify(wxCommandEvent& event);
    */
#ifdef WXPLOT
    void OnResize(wxSizeEvent& event);
    void OnOpen(wxCommandEvent& WXUNUSED(event));
    void OnStart(wxCommandEvent& WXUNUSED(event));
    void OnStop(wxCommandEvent& WXUNUSED(event));
    void OnInvert(wxCommandEvent& WXUNUSED(event));

    wxPlotWindow  *m_plot;
    wxPlotCurve  *m_curve;
    wxToggleButton *invert;
    wxString file;

#endif
    wxTextCtrl    *m_debug_text;
    wxTextCtrl    *m_config;
    wxBookCtrl    *m_book;
    wxBitmapButton *bmp_button;
    wxBitmapButton *bmp_load;
    wxBitmapButton *bmp_read;
    wxBitmapButton *bmp_verify;
    wxBitmapButton *bmp_button2;
private:
    void OnDownloadConfig(wxCommandEvent& event);
    void OnUploadFirmware(wxCommandEvent& event);
    void OnUploadConfig(wxCommandEvent& event);

    VemsTuneController* m_vemsController;

    DECLARE_EVENT_TABLE()
};


