#ifndef NMEAPARSE_H
#define NMEAPARSE_H

#include "common/typedef.h"
/**constant of state, we store Sequence of state in m_gprmc_sate_arra and _gpgga_sate_array,
**     m_noOfdecimalfraction is choose which array is current (format(whichformat()) set m_noOfdecimalfraction)
**/
#define START -1
#define FORMAT 0
#define UTC 1
#define STATUS 2
#define LATITUDE 3
#define LATITUDEIN 4
#define LONGNITUDE 5
#define LONGNITUDEIN 6
#define SPEED 7
#define COURSE 8
#define DATEOFPOSITION 9
#define MAGNETICVARIATION 10
#define MAGNETICVARIATIONIN 11
#define MODEINDICATOR 12
#define CHECKSUM 13
#define END 14
#define POSITIONINDICATOR 15
#define NOOFSATELITE 16
#define HORIZDILUTIONOFPRECISION 17
#define ANTENNAHEIGH 18
#define GEODIALHEIGH 19
#define AGEOFDGPS 20
#define REFERENCESTATION 21
#define RECIVEM 22

//#define LASTBITONE 0x80
//#define LASTBITNULL 0x7f

#define INDEX 5
#define PERIOD 8
#define AMICONST 0xA3;

class NMEAParse
{
    public:
        NMEAParse();
        virtual ~NMEAParse();

    void printTestVektor();
    void feddGPScharacter(char c);
    char *m_testvektor;
    void print_struct();
    uint8_t get_binpacked(uint8_t idx);
    void printbinaryarray();
    uint8_t binary_array[21];// include utc time(4 element), latitude(4 element),longnitude(4 element),speed(3 element),
                            // antennaheight(4 element),horizontalprecision(2 element)
    void writeToStruct();
    int getvaluefrombinaryformat(char howmanybit,char idx);
    ////////////////////////////////////////////////////////////////////////////////////
    /*AMI PROTOCOL FUNCTION*/
    uint8_t sendamiprotocoll(void);
    int16_t getrpmvalue(void);
    int16_t getwheelspeed(void);
    int16_t getthrottleangle(void);
    int16_t getmanifoldpress(void);
    int16_t getlambdasensor(void);
    int16_t getfuelpressure(void);
    int16_t getbatteryvoltage(void);
    int16_t getwatertemp(void);
    int16_t getdummy(void);
    uint8_t curentbyte(int16_t value,char channel);
    void printamibinaryarray(void);
    uint8_t amibinary_array[INDEX];
    uint8_t NMEAParse::sendamiprotocol(void);

    protected:

    private:

        uint16_t n;
        int storeNumber(char c);
        int hextobin(char c);
        int checkout();
        void initiation();
        int wichformat(char c);
        uint8_t get_firstbine(int number);
        uint8_t get_secondbine(int number);
        uint8_t get_thirdbine(int number);
        uint8_t get_fourthbine(int number);



        char *m_statearray;   //  char *m_statearray; //show array of current format

        char  m_calculatedchecksum; //store in  count out checksum

        int   m_tempnumber;// store current (received) number of digit's

        char  m_counter; //normaly  count fraction of digit
                        //;or receive  high bine of checksum  m_couner = 1
                         //;or show state when find out which format received

        char  m_noOfdecimalfraction;//normaly how many is fraction digit of date  evry state is other
                                  // ; =0 if receive GPRMC format, or =1 receive GPGGA format else =-1

        char  m_idx; //which is state
        ////////////////////////////////////////////////////////////////////////////////////
        /*AMI PROTOCOL FUNCTION*/
        uint8_t valuestate;
        uint8_t bytestate;
        uint8_t state;
        uint16_t sum;
        uint16_t m_count;


    public:
            /*store in data what is receiving*/
            struct m_data_t{

                char format[5];
                int  utc;
                char status;
                int  latitude;
                char latitudeindicator;
                int  longnitude;
                char longnitudeindicator;
                int speed;
                int  course;
                int  dateofposition;
                int  magneticvariation;
                char magneticvariationdirection;
                char modeindicator;
                int  positionindic;
                int  noofsatellite;
                uint16_t  horizontalprecision;
                int  antennaheight;
                int  geodialheight;
                int  dgps;
                int  station;
                uint8_t  checksum;
                unsigned int  errorbyte;

        };
        m_data_t gpsdata;
};



#endif // NMEAPARSE_H
