#ifndef PROGRESSBAR_H
#define PROGRESSBAR_H

//#include "wx/settings.h"
#include "events/UpdateViewerEvent.h"
#include <wx/wx.h>

enum ProgressBarStyle{
/*
    PB_ELAPSED_TIME      = 1,
    PB_REMAINING_TIME    = 2,
    PB_ESTIMATED_TIME    = 4,*/
    PB_SMOOTH            = 8,
    PB_BORDER_BAR        = 16,
    PB_PERCENTTEXT_INNER = 32,
    PB_PERCENTTEXT_LEFT  = 64,
    PB_PERCENTTEXT_RIGHT = 128,
    PB_PERCENTTEXT_UNDER = 256,


    PB_DEFAULT           = 0
    //PB_


};

class ProgressBar: public wxControl
{
    public:
        ProgressBar(wxWindow *parent, wxWindowID id = wxID_ANY, wxPoint pos = wxDefaultPosition, wxSize size = wxDefaultSize, long style = 0,const wxValidator &validator = wxDefaultValidator, const wxString& name = wxPanelNameStr);
        virtual ~ProgressBar();

        //void Configure(double minValue = 0, double maxValue = 100, const wxString &title = _T("Title"), ProgressBarStyle style = PB_DEFAULT);

        void SetValueFormat(const wxString &format);
        void SetValueLimits(double minValue, double maxValue, double deltaValue = 0.1);
        void SetTitle(const wxString &title);
        void SetProgressStyle(ProgressBarStyle style);
        void SetProgressStyleFlag(ProgressBarStyle style);

        void Update(double value, bool isFilterSmallChanges = true);
        void Update();

        void SetBarBackgroundColour(const wxColour &colour);
        void SetBarForegroundColour(const wxColour &colour);

        double GetValue() { return m_value; };

    protected:

        DECLARE_EVENT_TABLE();

    private:

        void OnPaint(wxPaintEvent& event);
        void OnSize(wxSizeEvent& event);
        void OnMouse(wxMouseEvent& event);
        void OnUpdateValue( UpdateViewerEvent& event );

        wxColor m_parentBGColor;

        double m_value;
        double m_minValue;
        double m_maxValue;
        double m_deltaValue;

        wxString m_title;
        wxString m_valueFormat;

        wxSize m_size;

        wxColor m_barBGColor;
        wxColor m_barFGColor;

        ProgressBarStyle m_progressBarStyle;

        wxFont m_percentFont;

};



#endif // PROGRESSBAR_H
