#ifndef RAW2HIGHCONVERTERDIALOG_H
#define RAW2HIGHCONVERTERDIALOG_H

#include <wx/statline.h>

#include "ProgressBarObserverWidget.h"
//#include "RawToHighLogConverter.h"
//#include "ThreadStatus.h"

#include "ObserverBase.h"
#include "FirmwareInfo.h"
#include "configmanager/CSVConfig.h"
#include "common/types/DoubleHash.h"

class MTConfigData;
class RTDataMgrFacade;
class RTDataInputSIPR;
class VemsLogReader;
class RTDataCSVWriter;
class STDataMgrFacade;
class LogHistoryMgr;
class LogFilter;
class LogHistoryProcessFilterThread;
class STDataModelSerial;


class Raw2HighConverterDialog: public wxFrame, public ObserverBase
{
    public:
        Raw2HighConverterDialog(wxWindow *parent, DoubleHash* viewerModel = NULL );
        virtual ~Raw2HighConverterDialog();


        void setInputFile(const wxString& inputFile);

        void SetAutoClose(bool autoclose){
            m_autoCloseCB->SetValue(autoclose);
        }
        void notify( int i ){};
        void notify(int i, int idx){};
        void notify(const wxString& str); //{};
        void Init(const wxString& name, const wxString& msg, const int max){};

    protected:

        DECLARE_EVENT_TABLE();
        void SetIniCtrlStyle(bool isactive);

        void OnClose(wxCloseEvent& event);
        void OnAutoCloseCB(wxCommandEvent &evt);

    private:
        void init();
        void startNext();
        //void iniParser();
        bool ConvertFirstItem();

        void OnBrwInput(wxCommandEvent& event);
        void OnBrwInputDel(wxCommandEvent& event);
        void OnBrwOutput(wxCommandEvent& event);
        void OnBrwIni(wxCommandEvent& event);
        void OnConvert(wxCommandEvent& event);
        void OnPause(wxCommandEvent& event);
        void OnStop(wxCommandEvent& event);

        void OnIniCtrlFocus(wxFocusEvent& evt);
        void OnIniCtrlKillFocus(wxFocusEvent& evt);

        bool DoConvert(const wxString &input, const wxString &output);

        void initSTModule();
        void registerStaticViewers();
        void clearStaticViewers();
        void printDoubleHash();
        bool ParseHeader(const wxString& filename, FirmwareInfo &fwInfo );
        //void TSNotify(ThreadState state);


        wxCheckBox *m_autoCloseCB;
        wxTextCtrl *m_tEditIni;
        wxListBox *m_tListInput;
        wxTextCtrl *m_tEditOutputExt;
        wxTextCtrl *m_tEditOutputPath;

        wxButton *m_btnConvert;
        wxButton *m_btnStop;
        wxButton *m_btnPause;

        wxComboBox *m_combOutputExts;

        wxFileDialog *m_fileDlg;

        ProgressBarObserverWidget *m_progBarObWidg;


        wxArrayString m_inputFiles;
        wxArrayString m_outputFiles;
        wxString m_outFileName;
        wxString m_outFilePath;
        wxString m_iniFileName;


        int m_cond1;

        //RawToHighLogConverter *m_converter;
        wxString    m_iniDefStr;
        wxString    m_logInitDir;
        DoubleHash  m_viewerModel;
        CSVConfig   m_csvConfig;

        wxDirDialog*    m_dirDialog;

        MTConfigData*   m_mtConfigData;
        RTDataMgrFacade* m_rtDataMgr;
        RTDataInputSIPR* m_rtInput;
        VemsLogReader*  m_vemsLogReader;

        //RTDataLogWriter* m_dataLogWriter;
        RTDataCSVWriter* m_dataLogWriter;
        STDataMgrFacade* m_stController;

        LogHistoryMgr*      m_logHisoryMgr;
        LogFilter*          m_logWriter;
        LogHistoryProcessFilterThread*   m_historyConverter;
		STDataModelSerial*  m_staticModel;

};



#endif // RAW2HIGHCONVERTERDIALOG_H

