#ifndef RAWLOGHELPER_H
#define RAWLOGHELPER_H

#include <wx/string.h>

class FirmwareInfo;
class StringHash;

class RawLogHelper
{
    public:
        RawLogHelper();
        virtual ~RawLogHelper();

        static void fillFirmwareInfo(FirmwareInfo& fwInfo, const StringHash& headerH);
        static wxString getVemsCfgHeader(const FirmwareInfo& fwInfo);
        static wxString getVemslogHeader(const FirmwareInfo& fwInfo, int logVersion, bool isTriggerLog = false);

        static wxString creator;
        static wxString blockSize;
        static wxString dataLen;
        static wxString fwcompTime;
        static wxString fwVersion;
        static wxString logVersion;
        static wxString fwSN;
        static wxString gpsDataLen;
        static wxString gpsDataFormat;
        static wxString signature;
        static wxString options;
        static wxString compileOptions;
    protected:
    private:
        static wxString getValue(const StringHash& headerH, const wxString& key);

};



#endif // RAWLOGHELPER_H
