#ifndef SDIMAGEHANDLER_H
#define SDIMAGEHANDLER_H

#include <wx/wx.h>
#include <wx/file.h>

#include "Interruptable.h"
#include "common/MMCFilesDesc.h"

WX_DEFINE_ARRAY_INT( uint32_t, UInt32Arr );

/// IMPORTANT - will be deleted by SDCardDialog!
class SDImageHandler : public Interruptable
{
    public:
        SDImageHandler( const wxString& imgname );
        virtual ~SDImageHandler();

        void    setEvtHandler( wxEvtHandler* evtHandler );

        void    searchFiles();
        void    downloadSDFile( const MMCFilesDesc& desc );
        void    createSDSummary( const MMCFilesDesc& desc );

        void    Abort();

    private:

        wxEvtHandler*       m_evtHandler;
        wxFile*             m_imageFile;
        wxFileOffset        m_imageSize;

        uint32_t            m_stopIdx;
        short               m_size;
        UInt32Arr           m_addrarr;
        UInt32Arr           m_rttypearr;
        MMCFilesDescA       m_mmcdescarr;
        int                 m_lastSecCountInBlock;

    private:

        bool                getMMCBlock( uint32_t blockIdx, uint8_t* data, size_t len );
        bool                __getMMCBlock( uint32_t blockIdx, uint8_t* data, size_t len );
        uint32_t            getStopIdx();
        short               getDataSize();
        bool                CheckSectorIsEmpty( uint32_t blockIdx );
        bool                isNextLog( uint8_t* data );

};

#endif // SDIMAGEHANDLER_H
