#include "SerialException.h"


SerialException::SerialException(int code)
{
    //ctor
     m_code = code;
}

SerialException::~SerialException()
{
    //dtor

}

wxString SerialException::toString()
{
    wxString tmp1 = _T("It seems that there is some problems with Vems communication.\n");
    wxString tmp2 = _T("Check power, cables and serial port settings.");

    switch (m_code){
        case SP_CANNOT_INIT_ECU:
            return tmp1 + _T("Cannot initialize ECU!\n") + tmp2;
        case SP_CANNOT_CLEAR_BUFF:
            return tmp1 +_T("Serial port flooded with junk data!\n") +tmp2;
        case SP_CANNOT_OPEN:
            return tmp1 + _T("Cannot open serial port!\n") + tmp2;
        case SP_WRITE_ERROR:
             return tmp1 + _T("Cannot write to serial port!\n") + tmp2;
        case SP_UNKNOWN:
        default:
            return tmp1 + tmp2;
            //return _T("Unknown error!");
    }
}
int SerialException::getCode(){
    return m_code;
}

wxString SerialException::getErrorCodeAsString() const
{
    switch (m_code)
    {
        case SP_CANNOT_INIT_ECU:
            return _T("SP_CANNOT_INIT_ECU");

        case SP_CANNOT_CLEAR_BUFF:
            return _T("SP_CANNOT_CLEAR_BUFF");

        case SP_CANNOT_OPEN:
            return _T("SP_CANNOT_OPEN");

        case SP_WRITE_ERROR:
            return _T("SP_WRITE_ERROR");

        case SP_UNKNOWN:
            return _T("SP_UNKNOWN");

        default:
            return _T("INVALID");
    }
}
