#include "TextValidator.h"

TextValidator::TextValidator(long style)
{
    //ctor
    m_validatorStyle = style;
}

TextValidator::~TextValidator()
{
    //dtor
}

bool TextValidator::Validate(const wxString& value)
{
    return false;
}

bool TextValidator::IsInCharIncludes(const wxString& val)
{
    size_t i;
    for ( i = 0; i < val.length(); i++)
    {
        if (m_includes.Index((wxString) val[i]) == wxNOT_FOUND)
            return false;
    }
    return true;
}

bool TextValidator::IsNotInCharExcludes(const wxString& val)
{
    size_t i;
    for ( i = 0; i < val.length(); i++)
    {
       if (m_excludes.Index((wxString) val[i]) != wxNOT_FOUND)
            return false;
    }
    return true;
}

bool TextValidator::IsValid(wxKeyEvent& event)
{
    int keyCode = event.GetKeyCode();

    // we don't filter special keys and Delete
    if (
         !(keyCode < WXK_SPACE || keyCode == WXK_DELETE || keyCode > WXK_START) &&
         (
          ((m_validatorStyle & wxFILTER_INCLUDE_CHAR_LIST) && !IsInCharIncludes(wxString((wxChar) keyCode, 1))) ||
          ((m_validatorStyle & wxFILTER_EXCLUDE_CHAR_LIST) && !IsNotInCharExcludes(wxString((wxChar) keyCode, 1))) ||
          ((m_validatorStyle & wxFILTER_ASCII) && !isascii(keyCode)) ||
          ((m_validatorStyle & wxFILTER_ALPHA) && !wxIsalpha(keyCode)) ||
          ((m_validatorStyle & wxFILTER_ALPHANUMERIC) && !wxIsalnum(keyCode)) ||
          ((m_validatorStyle & wxFILTER_NUMERIC) && !wxIsdigit(keyCode)
                            && keyCode != wxT('.') && keyCode != wxT(',') && keyCode != wxT('-') && keyCode != wxT('+') && keyCode != wxT('e') && keyCode != wxT('E'))
         )
       )
    {
        return false;
    } else {

        return true;

    }
}

bool TextValidator::tvIsAlpha(const wxString& val)
{
    int i;
    for ( i = 0; i < (int)val.length(); i++)
    {
        if (!wxIsalpha(val[i]))
            return false;
    }
    return true;
}

bool TextValidator::tvIsAlphaNumeric(const wxString& val)
{
    int i;
    for ( i = 0; i < (int)val.length(); i++)
    {
        if (!wxIsalnum(val[i]))
            return false;
    }
    return true;
}

bool TextValidator::tvIsNumeric(const wxString& val)
{
    int i;
    for ( i = 0; i < (int)val.length(); i++)
    {
        // Allow for "," (French) as well as "." -- in future we should
        // use wxSystemSettings or other to do better localisation
        if ((!wxIsdigit(val[i])) && (val[i] != wxT('.')) && (val[i] != wxT(',')) && (val[i] != wxT('e')) && (val[i] != wxT('E')) && (val[i] != wxT('+')) && (val[i] != wxT('-')))
            return false;
    }
    return true;
}
