#ifndef TEXTVALIDATOR_H
#define TEXTVALIDATOR_H


class TextValidator
{
    public:
        TextValidator(long style = wxFILTER_NONE);
        virtual ~TextValidator();

        bool IsValid(wxKeyEvent& event);
        bool Validate(const wxString& value);

        static bool tvIsAlpha(const wxString& val);
        static bool tvIsAlphaNumeric(const wxString& val);
        static bool tvIsNumeric(const wxString& val);

        inline long GetStyle() const { return m_validatorStyle; }
        inline void SetStyle(long style) { m_validatorStyle = style; }

        void SetIncludes(const wxArrayString& includes) { m_includes = includes; }
        inline wxArrayString& GetIncludes() { return m_includes; }

        void SetExcludes(const wxArrayString& excludes) { m_excludes = excludes; }
        inline wxArrayString& GetExcludes() { return m_excludes; }

        bool IsInCharIncludes(const wxString& val);
        bool IsNotInCharExcludes(const wxString& val);

    protected:

    private:



        long            m_validatorStyle;

        wxArrayString   m_includes;
        wxArrayString   m_excludes;


};

#endif // TEXTVALIDATOR_H
