#ifndef USERLOGWINDOW_H
#define USERLOGWINDOW_H

#include <wx/wx.h>
#include <wx/wxhtml.h>

#include "UserLog.h"
#include "ObserverBase.h"

class UserDialogBase;

WX_DECLARE_HASH_MAP( UserLogType, wxString, wxIntegerHash, wxIntegerEqual, UserLogType2StringHash);
WX_DECLARE_HASH_MAP( UserLogLineSize, UserLogType2StringHash, wxIntegerHash, wxIntegerEqual, UserLogLineSize2UserLogType2StringHash );
WX_DECLARE_HASH_MAP( UserLogLineSize, int, wxIntegerHash, wxIntegerEqual, UserLogLineSize2IntHash);
WX_DECLARE_HASH_MAP( UserLogType, wxColor, wxIntegerHash, wxIntegerEqual, UserLogType2wxColorHash);

class UserLogWindow: public wxHtmlWindow, public ObserverBase
{
    public:
        UserLogWindow(wxWindow * parent, int id);
        virtual ~UserLogWindow();

        void PutLog(UserLogType type, const wxString& str, UserLogLineSize size = ULOGLS_MEDIUM, ShowPolicy policy = SPC_NORMAL);
        void PutRawLog(const wxString& str);

        void Init();

        void Init(const wxString& name, const wxString& msg, const int max) {};

        void notify( int i );
        void notify(int i, int idx);
        void notify(const wxString & str);

        void ClearWin();

        void setUserDialog(UserDialogBase* userDialog);
    protected:

        //virtual bool OnCellClicked(wxHtmlCell *cell, wxCoord x, wxCoord y, const wxMouseEvent& event);
        virtual void OnLinkClicked(const wxHtmlLinkInfo& link);

    private:

        UserLogLineSize2UserLogType2StringHash m_iconFiles;

        UserLogLineSize2IntHash     m_fontSize;
        UserLogType2wxColorHash     m_fontColor;

        wxString    m_logStr;

        wxString    m_lastLine;

        wxString    m_winStartStr;

        UserDialogBase* m_userDialog;

};

#endif // USERLOGWINDOW_H
