#ifndef VEMSMSGLISTCTRL_H
#define VEMSMSGLISTCTRL_H

#include <wx/wx.h>
#include <wx/aui/aui.h>
#include <wx/listctrl.h>
#include <wx/arrimpl.cpp>

#include "common/VemsMessageViewerBase.h"
#include "common/VemsMessage.h"

WX_DECLARE_OBJARRAY( VemsMessage, VemsMessageArray);

class VemsGuideHtmlWindow;
class UserDialogBase;

WX_DECLARE_HASH_MAP( VemsMessageType, int, wxIntegerHash, wxIntegerEqual, Int2VemsMessageTypeHash);

class VemsMsgListCtrl: public wxFrame, public VemsMessageViewerBase
{
    public:
        VemsMsgListCtrl(UserDialogBase* userDialog = NULL, wxWindow * parent = NULL, int id = wxID_ANY, const wxString &title = _T("Vems Messages") );
        virtual ~VemsMsgListCtrl();

        static VemsMsgListCtrl* deleteAndCreate(UserDialogBase* userDialog, const wxString& name);
        virtual void show(const VemsMessage& message);

    protected:
        void Init();

        void AddLine( const VemsMessage& message );

    private:

        void OnItemSelected(wxListEvent &evt);

        enum {
            idListCtrl
        };


        wxAuiManager        *   m_auiMgr;
        wxListCtrl          *   m_shortMsgList;
        VemsGuideHtmlWindow *   m_htmlMsg;

        VemsMessageArray    m_msgList;


        Int2VemsMessageTypeHash m_imgHandler;

        DECLARE_EVENT_TABLE();
};

#endif // VEMSMSGLISTCTRL_H
