#include "VemsTaskBarIcon.h"

#include "logger.h"
#include <wx/menu.h>

#if defined (__WINCE_STANDARDSDK__)
    //#include <shellsdk.h>		// for WinAPI support
    #include <aygshell.h>		// for WinAPI support
    #include <wx/app.h>
#endif

BEGIN_EVENT_TABLE(VemsTaskBarIcon, wxTaskBarIcon)

    EVT_MENU(PU_RESTORE, VemsTaskBarIcon::OnMenuRestore)
    EVT_MENU(PU_EXIT, VemsTaskBarIcon::OnMenuExit)
    EVT_MENU(PU_NEW_ICON,VemsTaskBarIcon::OnMenuSetNewIcon)
    EVT_TASKBAR_LEFT_DOWN(VemsTaskBarIcon::OnLeftDown)
    EVT_TASKBAR_RIGHT_DOWN(VemsTaskBarIcon::OnRightDown)


END_EVENT_TABLE()

VemsTaskBarIcon::VemsTaskBarIcon(wxWindow *parent)
{
    //ctor
    menu = new wxMenu;
    menu->Append(PU_RESTORE, wxT("&Restore"));
    //menu->Append(PU_NEW_ICON,wxT("&Set New Icon"));
    menu->AppendSeparator();
    menu->Append(PU_EXIT, wxT("E&xit"));

    m_parent = parent;

    m_IsRestore = false;

#if !defined (__WINCE_STANDARDSDK__)
    //menu->Enable(PU_RESTORE,false);
#endif

}

VemsTaskBarIcon::~VemsTaskBarIcon()
{
    //dtor
}


void VemsTaskBarIcon::OnMenuRestore(wxCommandEvent& )
{

    Logger::logf(LOG_MSG,_T("VemsTaskBarIcon::OnMenuRestore"));

    if(m_parent != NULL) {

        if(m_parent->IsShown()) return;

        m_IsRestore = true;
        m_parent->Show(true);
/*
    #if defined (__WINCE_STANDARDSDK__)
        HWND hWnd = (HWND)(m_parent->GetHandle());
        SHFullScreen(hWnd , SHFS_HIDETASKBAR | SHFS_HIDESIPBUTTON | SHFS_HIDESTARTICON);
    #endif
*/
    }


}

void VemsTaskBarIcon::OnMenuExit(wxCommandEvent& )
{
    Logger::logf(LOG_MSG,_T("VemsTaskBarIcon::OnMenuExit"));

    if(m_parent != NULL) {
        m_parent->Destroy();
    #if defined (__WINCE_STANDARDSDK__)
        wxExit();
    #endif
    }


}

void VemsTaskBarIcon::OnMenuSetNewIcon(wxCommandEvent&)
{
    Logger::logf(LOG_MSG,_T("VemsTaskBarIcon::OnMenuSetNewIcon"));
}

void VemsTaskBarIcon::OnRightDown(wxTaskBarIconEvent& evt)
{

    int x, y;
    wxGetMousePosition(&x, &y);

    PopupMenu(menu);
}

void VemsTaskBarIcon::OnLeftDown(wxTaskBarIconEvent& evt)
{

}

bool VemsTaskBarIcon::IsRestored()
{
	//Logger::logf(LOG_MSG,_T("VemsTaskBarIcon::IsRestored() START"));
    return m_IsRestore;
}

void VemsTaskBarIcon::SetRestored(bool rest)
{
    m_IsRestore = rest;
}



