#ifndef VEMSTUNECORE_H
#define VEMSTUNECORE_H

#include "common/types/wxVariantHash.h"

class MTConfigData;
class DoubleHash;
class RTDataMgrFacade;
class RTDataInputSIPR;
class STDataMgrFacade;
class STDataModelSerial;
class STDataModelSerial;
class LogHistoryMgr;
class GaugeDescManager;
class GaugeGroupManager;
class GaugeCarrierFrame;
class UserDialogManager;
class UserMenuRefresher;

class VemsTuneCore: public wxEvtHandler
{
    public:
        VemsTuneCore(wxVariantHash& properties);
        virtual ~VemsTuneCore();

        void Init();

    protected:

        void OnCommand(wxCommandEvent& evt);

    private:

        void CleanUp();

        enum {
            idCommand1 = 42
        };

        wxVariantHash       m_properties;

        MTConfigData*       m_mtConfigData;
        DoubleHash*         m_rtViewerModel;
        RTDataMgrFacade*    m_rtMgr;
        RTDataInputSIPR*    m_inputSIPR;
        STDataMgrFacade*    m_stMgr;
        STDataModelSerial*  m_myModelSerial;
        STDataModelSerial*  m_deviceModel;
        LogHistoryMgr*      m_logHistoryMgr;
        GaugeDescManager*   m_gaugeDescMgr;
        GaugeGroupManager * m_gaugeGroupManager;
        GaugeCarrierFrame*  m_carrier;
        UserDialogManager*  m_userDialogManager;
        UserMenuRefresher*  m_pUserMenuRefresher;



};

#endif // VEMSTUNECORE_H
