#include "VemsTuneInfo.h"

VemsTuneInfo::VemsTuneInfo()
{
    m_vemsTuneStartTime = wxDateTime::UNow();
    m_recivedRtPackets  = 0;
    m_crcErrorCount     = 0;
    m_timeoutCount      = 0;
}

VemsTuneInfo::~VemsTuneInfo()
{

}

wxString VemsTuneInfo::toString() const
{
    wxTimeSpan elapsedTime = getElapsedTime();

    wxString infoStr = _T("Elapsed time: ") + elapsedTime.Format( _T("%H:%M:%S") ) + _T("\n");

    infoStr += wxString::Format( _T("Received RT packets: %d \n"), m_recivedRtPackets );

    long averageUpdateFrequency = m_recivedRtPackets / elapsedTime.GetSeconds().ToLong();

    infoStr += wxString::Format( _T("Average update frequency: %d\n"), averageUpdateFrequency );

    infoStr += wxString::Format( _T("RT CRC errors: %d\n"), m_crcErrorCount );

    infoStr += wxString::Format( _T("RT timedout packets: %d\n"), m_timeoutCount );

    return infoStr;
}

wxTimeSpan VemsTuneInfo::getElapsedTime() const
{
    wxDateTime now = wxDateTime::UNow();
    wxTimeSpan elapsedTime = now.Subtract( m_vemsTuneStartTime );

    return elapsedTime;
}

void VemsTuneInfo::receiveRtPacket()
{
    ++m_recivedRtPackets;
}

void VemsTuneInfo::receiveRtCRCError()
{
    ++m_crcErrorCount;
}
void VemsTuneInfo::receiveRtTimeout()
{
    ++m_timeoutCount;
}
