#ifndef WXAGGBLUR_H
#define WXAGGBLUR_H

#include <wx/wx.h>
#include "aggHelper.h"

class acolor {
    public:
        acolor() { m_color = agg::rgba( 0.5,0.5,0.5, 1.0 ); }
        agg::rgba operator = ( const wxColor& c ) { m_color = Agg::convertToRGBA( c ); return m_color; }
        agg::rgba operator = ( const agg::rgba& c ) { m_color = c; return m_color;}
        agg::rgba getColor() const { return m_color; }
    private:
        agg::rgba m_color;
};

class wxAggBlur : public wxAggObject
{
    public:
        wxAggBlur() {}

        wxAggBlur( wxRealPoint t, double r, const wxColor& c ) { translate = t; gaussianradius = r; color = c; }
        wxAggBlur( wxRealPoint t, double r, const agg::rgba& c ) { translate = t; gaussianradius = r; color = c; }

        wxAggBlur( double t, double r, const wxColor& c ) { translate.x = t; translate.y = t; gaussianradius = r; color = c; }
        wxAggBlur( double t, double r, const agg::rgba& c ) { translate.x = t; translate.y = t; gaussianradius = r; color = c; }

        wxAggBlur& operator = (const wxAggBlur& b ) { if ( &b == this ) return *this;
            translate = b.translate; gaussianradius = b.gaussianradius; color = b.color; return *this; }
        wxRealPoint translate;
        double      gaussianradius;
        acolor      color;
};

extern const wxAggBlur wxAggNullBlur;
extern const wxAggBlur wxAggDropShadow;

#endif // WXAGGBLUR_H
