#ifndef AIMCUSTOMVALUESEDITORPANEL_H
#define AIMCUSTOMVALUESEDITORPANEL_H

#include <wx/wx.h>
#include "../Observable.h"
#include "../common/types/StringHash.h"

class wxSQLite3Database;

class AIMDisplayFrame;

class CustomSettings {
    public:
        wxString    aimchId;
        wxString    multiplicator;
        wxString    add;
        wxString    dot;
        int         dotSelection;
        wxString    conversion;

        wxString    dotTop;
        wxString    dotBottom;
};

class AIMCustomValuesEditorPanel : public wxPanel, public Observable
{
    public:
        // type: 0 if top, 1 if bottom
        AIMCustomValuesEditorPanel( wxWindow* parent, int type, wxSQLite3Database* db );

    public:
        CustomSettings      getCustomSettings();


    private:
        enum { idAimChId = 29890, idMultip, idTransl, idDotPosId, idConvers, idPredefinedChannels, idPredefinedSettings };
        wxSQLite3Database*  m_db;
        int                 m_type;
        CustomSettings      m_customSettings;

        wxComboBox*         m_channelName;
        wxTextCtrl*         m_channelId;
        wxTextCtrl*         m_multiplicator;
        wxTextCtrl*         m_translation;
        wxComboBox*         m_dotpos;
        wxTextCtrl*         m_conversion;

        wxComboBox*         m_predefChans;

        wxArrayString       m_dotposS;
        wxArrayString       m_predefChansA;

        StringHash          m_name2chanHash;

        CustomSettings*     m_predefinedSettings;
        wxComboBox*         m_predefinedSCombo;


    private:
        void        getDBSettings();
        void        setCustomSettings( CustomSettings& settings );

        wxString    checkChannelID();

        void        onTextCtrlChanged( wxCommandEvent& event );
        void        onComboboxChanged( wxCommandEvent& event );

        void        onKillFocus( wxFocusEvent& event );

        // helpers

        template<class T>
        void    minmaxcheck( T& val, T minval, T maxval, wxTextCtrl* ctrl, wxString format );

        friend class AIMDisplayPanel;
};

#endif // AIMCUSTOMVALUESEDITORPANEL_H
