#ifndef APP_H
#define APP_H

#include <wx/wxprec.h>

#ifdef __BORLANDC__
	#pragma hdrstop
#endif

#ifndef WX_PRECOMP
	#include <wx/wx.h>
#endif

#include "mainframe.h"


#include <wx/keybinder.h>


class MyApp;


DECLARE_APP(MyApp)


class MyApp : public wxApp
{
	public:
	    MyApp();
		virtual bool OnInit();
		virtual int OnExit();
		void setCwd(wxChar * path_c);
		void prepareSession(wxChar * path_c);
		wxFrame* getMainFrame();
		//virtual int OnRun();

        virtual void HandleEvent(wxEvtHandler *handler, wxEventFunction func, wxEvent& event) const;

		void OnAssertFailure(const wxChar *file, int line, const wxChar *func, const wxChar *cond, const wxChar *msg);
		void OnAssert(const wxChar *file, int line, const wxChar *func, const wxChar * msg);

        size_t GetRunningTimeMs();

///	under mingw is not works
//		virtual void OnUnhandledException();
//		virtual void OnFatalException();
//		virtual bool OnExceptionInMainLoop();

    private:
        MainFrame*  m_frame;
        wxTimer*    m_timer;
        wxFrame*    m_splashFrame;

        wxStopWatch m_runningTime;

        void OnKeyDown(wxKeyEvent &evt);
        int FilterEvent(wxEvent& event);
        void eventBlocker(int blocktime = 500);
        void ShowSplashScreen();

        DECLARE_EVENT_TABLE();
};

#endif // APP_H

