#ifndef BITMAPCANVASSYSTEMSETTINGS_H
#define BITMAPCANVASSYSTEMSETTINGS_H

#include "../wxRealSize.h"
#include "../common/types/wxVariantIntHash.h"

enum BitmapCanvasWidgetBaseStyleTypes {
    BCBS_BACKGROUND_COLOR = 2000,
    BCBS_DISABLED_BACKGROUND_COLOR,
    BCBS_FOREGROUND_COLOR,
    BCBS_BORDER_COLOR,
    BCBS_BORDER_WIDTH,
    BCBS_BORDER_RADIUS,
    BCBS_BORDER_HIGHLIGHT_COLOR,
    BCBS_SELECTION_COLOR,
    BCBS_PADDDING,
    BCBS_FONT_FILE,
    BCBS_TEXT_HEIGHT,
    BCBS_TEXT_WEIGHT,
    BCBS_TEXT_COLOR,
    BCBS_DISABLED_TEXT_COLOR,
    BCBS_TEXT_GRAVEN_COLOR,
    BCBS_TEXT_SELECTION_COLOR,
    BCBS_SHADOW_COLOR,
    BCBS_VEMS_COLOR,
    BCBS_DYNAMIC_CONTENT_COLOR
};

class BitmapCanvasSystemSettings
{
    public:

        static void Init(int prof = -1);

        static void SetProfileId(int id);
        static int  GetProfileId() { return m_currProfile; }

        static bool        GetBool(int key);
        static long        GetLong(int key);
        static double      GetDouble(int key);
        static wxColor     GetColor(int key);
        static wxSize      GetSize(int key);
        static wxRealSize  GetRealSize(int key);
        static wxRealPoint GetRealPoint(int key);
        static wxPoint     GetPoint(int key);
        static wxString    GetString(int key);

    private:

        static Int2wxVariantIntHash    m_properties;

        static int m_currProfile;

};

#endif // BITMAPCANVASSYSTEMSETTINGS_H
