#include "bcCarrierPanel.h"

#include "bcWrapper.h"
#include "../logger.h"

#include <wx/dcbuffer.h>

BEGIN_EVENT_TABLE(bcCarrierPanel, wxPanel)

    EVT_PAINT(bcCarrierPanel::OnPaint)

END_EVENT_TABLE()

bcCarrierPanel::bcCarrierPanel(wxWindow* parent, long propStyles, wxWindowID id, const wxPoint& pos, const wxSize& size, long style, const wxString& name)
{
    //ctor
    Create(parent, id, pos, size, style, name);

    CreateBcParent(this);

    m_propStyle = propStyles;

    wxBoxSizer* mainsizer = new wxBoxSizer( (m_propStyle & BCCP_VERTICAL) ? wxVERTICAL : wxHORIZONTAL );
    SetSizer(mainsizer);
}

bcCarrierPanel::~bcCarrierPanel()
{
    //dtor
}

void bcCarrierPanel::WidgetAddCallBack(BitmapCanvasWidgetBase* widget)
{
    wxSizer* mainsizer = GetSizer();

    int propotion = 0;
    long flags = wxALL | wxALIGN_CENTER_HORIZONTAL | wxALIGN_CENTER_VERTICAL;

    if(m_propStyle & BCCP_VERTICAL) {
        if(m_propStyle & BCCP_EXPAND_X) {
            flags |= wxEXPAND;
        }
        if(m_propStyle & BCCP_EXPAND_Y) {
            propotion = 1;
        }
    }
    if(m_propStyle & BCCP_HORIZONTAL) {
        if(m_propStyle & BCCP_EXPAND_X) {
            propotion = 1;
        }
        if(m_propStyle & BCCP_EXPAND_Y) {
            flags |= wxEXPAND;
        }
    }

    mainsizer->Add( new bcWrapper( widget ), propotion, flags , 1 );
}

void bcCarrierPanel::OnPaint(wxPaintEvent& evt)
{
    wxBufferedPaintDC dc(this);

    dc.SetBackground( GetBackgroundColour() );
    dc.Clear();

    PaintWidgets(dc);
}
