#ifndef BCCHECKBOX_H
#define BCCHECKBOX_H

#include "BitmapCanvasWidgetBase.h"

#include "../common/types/RealPointArray.h"

enum bcCheckBoxStyles {
  ///marker styles
    BCCBS_CHECK         = 0x0001,
    BCCBS_RECT          = 0x0002,
    BCCBS_CROSS         = 0x0004,
    BCCBS_CROSS2        = 0x0008,
    BCCBS_CUSTOM        = 0x0010,

    BCCBS_INVERTED3D    = 0x0020,
    BCCBS_TEXT_GRAVEN   = 0x0040,

    BCCBS_DEFAULT   = BCCBS_CHECK
};

class bcCheckBox: public BitmapCanvasWidgetBase
{
    DECLARE_DYNAMIC_CLASS(bcCheckBox);

    public:
        bcCheckBox() {};
        bcCheckBox(BitmapCanvasParentBase* parent, int id, const wxString& text = wxEmptyString, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = BCCBS_DEFAULT);
        virtual ~bcCheckBox();

        virtual void Create(BitmapCanvasParentBase* parent, wxVariantIntHash& properties);
        virtual void DrawWidget();

        void SetValue(bool isChecked);
        bool GetValue();

        void SetCustomCheckPoints(const RealPointArray& points);

    protected:

        void OnLeftDown(wxMouseEvent& evt);
        void OnLeftUp(wxMouseEvent& evt);

        void PaintCheckMarker(wxAgg2& aggCanvas, const wxRealRect& box);

    private:

        enum statesflags {
            BCCB_NORMAL = 0,
            BCCB_HOVER = 1,
            BCCB_CHECKED = 2
        };

        long m_state;

        wxString m_label;

        DECLARE_EVENT_TABLE();

        RealPointArray m_customCheckPoints;

};

#endif // BCCHECKBOX_H
