#include "bcLinkInfo.h"

#include <wx/regex.h>

#include "../StringHelper.h"

wxString bcLinkInfo::GetLabel() const
{
    wxString label = Label == wxEmptyString ? HRef : Label;

    if(label == wxEmptyString) return label;

    if(LabelLimit) label = StringHelper::StringShorter(label,LabelLimit,wxALIGN_CENTER);

    return label;
}

bool bcLinkInfo::isHyperLink() const
{
    wxRegEx ex;
    ex.Compile(_T("(http:\\/\\/|ftp:\\/\\/|https:\\/\\/|irc:\\/\\/)"));

    return ex.Matches(HRef);
}
