#include "bcParentDialog.h"


#include "bcButton.h"

#include <wx/dcbuffer.h>

BEGIN_EVENT_TABLE(bcParentDialog, wxDialog)

    EVT_PAINT(bcParentDialog::OnPaint)
    EVT_KILL_FOCUS( bcParentDialog::OnFocus )

END_EVENT_TABLE()

bcParentDialog::bcParentDialog(wxWindow* parent, wxWindowID id, const wxString& title, const wxPoint& pos, const wxSize& size, long style, const wxString& name)
{
    //ctor
    Create(parent, id, title, pos, size, style, name);

    CreateBcParent(this);
}

bcParentDialog::~bcParentDialog()
{
    //dtor
}

bool bcParentDialog::Show( bool show )
{
    return wxDialog::Show( show );
}

void bcParentDialog::OnPaint(wxPaintEvent& evt)
{
    wxBufferedPaintDC dc(this);

    dc.SetBackground( GetBackgroundColour() );
    dc.Clear();

    PaintWidgets(dc);
}

bcStdDialogButtonSizer* bcParentDialog::CreateBcStdDialogButtonSizer(long flags)
{
    bcStdDialogButtonSizer *sizer = new bcStdDialogButtonSizer();

    bcButton *ok = NULL;
    bcButton *yes = NULL;
    bcButton *no = NULL;

    if (flags & wxOK)
    {
        ok = new bcButton(this, wxID_OK, _T("OK"));
        sizer->AddButton(ok);
    }

    if (flags & wxCANCEL)
    {
        bcButton *cancel = new bcButton(this, wxID_CANCEL, _T("Cancel"));
        sizer->AddButton(cancel);
    }

    if (flags & wxYES)
    {
        yes = new bcButton(this, wxID_YES, _T("Yes"));
        sizer->AddButton(yes);
    }

    if (flags & wxNO)
    {
        no = new bcButton(this, wxID_NO, _T("No"));
        sizer->AddButton(no);
    }

    if (flags & wxHELP)
    {
        bcButton *help = new bcButton(this, wxID_HELP, _T("Help"));
        sizer->AddButton(help);
    }

    if (flags & wxNO_DEFAULT)
    {
        if (no)
        {
///            no->SetDefault();
            no->SetFocus();
        }
    }
    else
    {
        if (ok)
        {
///            ok->SetDefault();
            ok->SetFocus();
        }
        else if (yes)
        {
///            yes->SetDefault();
            yes->SetFocus();
        }
    }

    if (flags & wxOK)
        SetAffirmativeId(wxID_OK);
    else if (flags & wxYES)
        SetAffirmativeId(wxID_YES);

    sizer->Realize();

    return sizer;
}
