#ifndef BCRADIOBUTTON_H
#define BCRADIOBUTTON_H

#include "BitmapCanvasWidgetBase.h"

enum bcRadioButtonStyles{
    BCRBS_DEFAULT       = 0x0000,
    BCRBS_CANOFF        = 0x0001,
    BCRBS_INVERTED3D    = 0x0002,
    BCRBS_TEXT_GRAVEN   = 0x0004
};

class bcRadioButton: public BitmapCanvasWidgetBase
{
    DECLARE_DYNAMIC_CLASS(bcRadioButton);

    public:
        bcRadioButton() {};
        bcRadioButton(BitmapCanvasParentBase* parent, int id, const wxString& text = wxEmptyString, int groupID = 1, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = BCRBS_DEFAULT);
        virtual ~bcRadioButton();

        virtual void Create(BitmapCanvasParentBase* parent, wxVariantIntHash& properties);

        virtual void DrawWidget();

        void SetValue(bool isChecked);
        bool GetValue();

        void SetGroupId(int grpid);
        int GetGroupId() { return m_grpId; }

    protected:

        void CheckGroupButtons(bool isCheckingSelf);

        void OnLeftDown(wxMouseEvent& evt);
        void OnLeftUp(wxMouseEvent& evt);

    private:

        enum statesflags {
            BCCB_NORMAL = 0,
            BCCB_HOVER = 1,
            BCCB_CHECKED = 2
        };

        long m_state;
        long m_grpId;

        wxString m_label;

        DECLARE_EVENT_TABLE();

};
#endif // BCRADIOBUTTON_H
