#include "bcStdDialogButtonSizer.h"

#include "bcButton.h"
#include "bcWrapper.h"

bcStdDialogButtonSizer::bcStdDialogButtonSizer()
: wxBoxSizer(wxHORIZONTAL)
{
    //ctor
    m_buttonAffirmative = NULL;
    m_buttonApply = NULL;
    m_buttonNegative = NULL;
    m_buttonCancel = NULL;
    m_buttonHelp = NULL;
}

bcStdDialogButtonSizer::~bcStdDialogButtonSizer()
{
    //dtor
}

void bcStdDialogButtonSizer::AddButton(bcButton *mybutton)
{
    switch (mybutton->GetId())
    {
        case wxID_OK:
        case wxID_YES:
        case wxID_SAVE:
            m_buttonAffirmative = mybutton;
            break;
        case wxID_APPLY:
            m_buttonApply = mybutton;
            break;
        case wxID_NO:
            m_buttonNegative = mybutton;
            break;
        case wxID_CANCEL:
            m_buttonCancel = mybutton;
            break;
        case wxID_HELP:
        case wxID_CONTEXT_HELP:
            m_buttonHelp = mybutton;
            break;
        default:
            break;
    }
}

void bcStdDialogButtonSizer::SetAffirmativeButton( bcButton *button )
{
    m_buttonAffirmative = button;
}

void bcStdDialogButtonSizer::SetNegativeButton( bcButton *button )
{
    m_buttonNegative = button;
}

void bcStdDialogButtonSizer::SetCancelButton( bcButton *button )
{
    m_buttonCancel = button;
}

void bcStdDialogButtonSizer::Realize()
{
    Add(0, 0, 1, wxEXPAND, 0);

    if(m_buttonAffirmative)
        Add( new bcWrapper(m_buttonAffirmative), 0, wxALIGN_CENTRE | wxLEFT | wxRIGHT, 2);

    if(m_buttonNegative)
        Add(new bcWrapper(m_buttonNegative), 0, wxALIGN_CENTRE | wxLEFT | wxRIGHT, 2);

    if(m_buttonCancel)
        Add(new bcWrapper(m_buttonCancel), 0, wxALIGN_CENTRE | wxLEFT | wxRIGHT, 2);

    if(m_buttonApply)
        Add(new bcWrapper(m_buttonApply), 0, wxALIGN_CENTRE | wxLEFT | wxRIGHT, 2);

    if(m_buttonHelp)
        Add(new bcWrapper(m_buttonHelp), 0, wxALIGN_CENTRE | wxLEFT | wxRIGHT, 2);
}

