#ifndef PARSERHELPER_H
#define PARSERHELPER_H

class MTConfigData;
class SymbolMgr;
class SymbolTable;

class ParserHelper
{
    public:
        ParserHelper( const wxString& firmwareDir, MTConfigData* mtConfigData );
        virtual ~ParserHelper();

    public:
        void                    doParsing();
        const wxArrayString&    getRequiredAddresses() const { return m_requiredAddrs; }

    private:
        wxString        m_firmwareDir;
        MTConfigData*   m_mtConfigData;

        wxArrayString   m_requiredAddrs;

        long int        m_engineAddr;
        long int        m_etimeAddr;
        long int        m_cfgAddr;
        long int        m_cfgExtAddr;
        SymbolMgr*      m_symbolMgr;
        SymbolTable*    m_symbolTable;

    private:
        // parse extra ini file, map file & global.h
        void        parseIni( const wxString& fname );
        bool        parseMap( const wxString& fname );
        void        parseGlobalH( const wxString& fname );
        void        parseEventqueueH( const wxString& fname );
        void        checkEnginetSection();
        void        checkETimeSection();

};

#endif // PARSERHELPER_H
