#ifndef FSMAIM_H
#define FSMAIM_H

#include "typedef.h"

struct AIMPacket //AIMData
{
    uint8_t     channel;
    uint16_t    data;
    uint8_t     sum;
    static const uint8_t AIM_CONST;
    void reset();
};

class FSMAIM
{
    public:
        enum State
        {
            START = 1,
            DATA_HIGH = 2,
            DATA_LOW = 3,
            CHECKSUM = 4,
            END = 5,
            CHECKSUM_ERROR = 6
        };

        FSMAIM();
        virtual ~FSMAIM();

        int feed( uint8_t c );

        void reset();

        AIMPacket& getData() { return m_data; };

    protected:

    private:

        AIMPacket   m_data;

        uint8_t m_prevByte;
        uint8_t m_sum;
        uint8_t m_state;


};

#endif // FSMAIM_H
