#ifndef DROPTARGET_H
#define DROPTARGET_H

#include <wx/dnd.h>


template <class T>
class FileDropTarget : public wxFileDropTarget
{
    public:
        FileDropTarget( T* owner )
        {
            m_owner = owner;
            m_owner->SetDropTarget( this );
        }

        bool OnDropFiles( wxCoord x, wxCoord y, const wxArrayString& filenames )
        {
            return m_owner->onDropFiles( filenames );
        }

        const T* GetOwner() const { return m_owner; }

    private:
        T* m_owner;
};

template <class T>
class FileDropTargetExt : public wxFileDropTarget
{
    public:

        FileDropTargetExt( T* owner, wxWindow* target ) {
            m_owner = owner;
            target->SetDropTarget( this );
        }

        bool OnDropFiles( wxCoord x, wxCoord y, const wxArrayString& filenames ) {
            return m_owner->onDropFiles( filenames );
        }

    private:
        T* m_owner;
};


#endif // DROPTARGET_H
