#include "SIPR2AIMConverter.h"

#include "FSMAIM.h"
#include "../vemsprotocol/SIPRPacket.h"
#include "../vemsprotocol/SIPRTypes.h"

/**
    0: channel
    1: header
    2: high
    3: low
    4: crc
*/

bool SIPR2AIMConverter::Convert(SIPRPacket& p, uint8_t* aimbuffer)
{
    if( p.type() != SIPR_AIM ) return false;

    uint8_t* siprbuffer = p.data();

    aimbuffer[0] = siprbuffer[0];
    aimbuffer[1] = AIMPacket::AIM_CONST;
    aimbuffer[2] = siprbuffer[1];
    aimbuffer[3] = siprbuffer[2];
    aimbuffer[4] = aimbuffer[0] + aimbuffer[1] + aimbuffer[2] + aimbuffer[3];

    return true;
}
