#include "VemsContext.h"

#include <wx/object.h>
#include "../logger.h"

wxStringToObjectHash VemsContext::m_objects;

VemsContext::VemsContext()
{
    //ctor
}

VemsContext::~VemsContext()
{
    //dtor
}
/*
void VemsContext::setObjectByKey(const wxString& key, wxObject* obj)
{
    m_objectHash[m_hashSize] = obj;
    m_hashSize++;
}
*/
void VemsContext::setObject(wxObject* obj)
{
    wxASSERT_MSG( (obj != NULL), _T("object should not be NULL in VemsContext::setObject()!") );

    wxClassInfo *cInfo = obj->GetClassInfo();
    wxString className =  cInfo->GetClassName();

    if ( m_objects.find( className ) != m_objects.end() ) {
        Logger::logf(LOG_MSG, _T("VemsContext::setObject() - object is already exist ") + className );
    }

    m_objects[className] = obj;
}

void VemsContext::setObject( const wxString& objId, wxObject* obj)
{
    wxASSERT_MSG( (obj != NULL), _T("object should not be NULL in VemsContext::setObject()!") );


    if ( m_objects.find( objId ) != m_objects.end() ) {
        Logger::logf(LOG_MSG, _T("VemsContext::setObject() - object is already exist ") + objId );
    }

    m_objects[objId] = obj;
}

wxObject* VemsContext::initObject(const wxString& name)
{
    wxObject* obj = wxCreateDynamicObject(name);
	if(!obj){
		Logger::logf(LOG_MSG, _T("VemsContext::initObject: cannot init class: ") + name );
	} else {
        if ( m_objects.find( name ) != m_objects.end() ) {
            Logger::logf(LOG_MSG, _T("VemsContext::initObject() - object is already exist ") + name );
        }
        m_objects[name] = obj;
	}

    return obj;
}

wxObject* VemsContext::getObject(const wxString& name)
{
    wxStringToObjectHash::const_iterator iter = m_objects.find( name );

    if ( iter != m_objects.end() ) {
        return iter->second;
    } else {
        return NULL;
    }
}

wxObject* VemsContext::removeObject(const wxString& name)
{
    wxStringToObjectHash::const_iterator iter = m_objects.find( name );

    if ( iter != m_objects.end() ) {
        wxObject* obj = iter->second;
        m_objects.erase(name);
        return obj;
    } else {
        return NULL;
    }
}

void VemsContext::cleanup()
{
//	WX_CLEAR_HASH_MAP( wxObjectHash, m_objectHash );
}
