#ifndef WXCSVPARSER_H
#define WXCSVPARSER_H

WX_DECLARE_OBJARRAY(wxArrayString, wxArrayStringRefArray);

#include "types/StringHash.h"

enum CSVErrorCode {
    CSV_NO_ERROR = 0,
    CSV_ERROR_TO_LARGE_LINE_PARAM,
    CSV_ERROR_NOT_ENOUGH_LINE_FOR_HEADERHASH,
    CSV_ERROR_HEADER_AND_DATA_COUNT_NOT_EQUALS,
    CSV_ERROR_HEADER_EMPTY
};

class wxCSVParser
{
    public:
        wxCSVParser(const wxString& rawtext);
        virtual ~wxCSVParser();

        bool Parse(const wxString& data_separator = _T(","), const wxString& textlimiter = _T("\""));

        CSVErrorCode GetLine(size_t line, StringHash& data); //key-value with header
        CSVErrorCode GetLine(size_t line, wxArrayString& data);

    protected:

    private:

        wxString m_rawText;

        wxArrayStringRefArray m_lines;

};

#endif // WXCSVPARSER_H
