#ifndef COMMUNICATIONLOGGER_H
#define COMMUNICATIONLOGGER_H


#include <wx/textfile.h>


#include "../common/typedef.h"
#include "../CommunicationBase.h"


class CommunicationLogger : public wxEvtHandler, public CommunicationBase
{
    public:
        CommunicationLogger( CommunicationBase* commBase, const wxString& logFileName );
        virtual ~CommunicationLogger();

        int SendString(const wxString& str);
        int SendString(const uint8_t* chr);
        int SendString(const uint8_t* str, size_t len);
        int sendStringBlock(uint8_t* value, size_t len, size_t blockLen);

        int Read(uint8_t* str, size_t len);
        int ReadString(uint8_t* str, size_t len);
        int ReadString(uint8_t* data, size_t len, int maxTryCount);

        void setBaudRate( int baudRate );
        int  getBaudRate();

        void setPortName( const wxString& portname );
        wxString getPortName() const;

        int sendNumber(uint32_t number, int length);
        int sendNumber(uint16_t number);


        int open();
        void close();
        int  clear();
        bool IsOpen();

    private:
        CommunicationBase*  m_commBase;
        wxString            m_logFileName;
        wxTextFile*         m_logFile;

        wxString            m_readBuffer;
        size_t              m_maxLineLength;

        wxTimer             m_timer;

        void addReadBuffer();
        wxString getLogString( uint8_t ch );

        void OnTimer(wxTimerEvent& event);

};

#endif // COMMUNICATIONLOGGER_H
