#include "SerialPortHandlerFactory.h"

#ifdef __WIN32__
#include "../vemsprotocol/SerialPortHandlerSFile.h"
#endif


#include "../vemsprotocol/SerialPortHandlerCTB.h"
#include "../TCPClientHandler.h"


//#define SFILE_LIB


CommunicationBase* SerialPortHandlerFactory::create( SerialConfig* config )
{
    CommunicationBase* commBase = NULL;

#ifdef SFILE_LIB
        commBase = new SerialPortHandlerSFile( config );
#else
        commBase = new SerialPortHandlerCTB( config );
#endif

    return commBase;
}

CommunicationBase* SerialPortHandlerFactory::create( const wxString& host, unsigned short port )
{
    CommunicationBase* commBase = new TCPClientHandler( host, port  );
    return commBase;
}
