#ifndef AIMDETECTOR_H
#define AIMDETECTOR_H

#include "../CommunicationControllerClient.h"
#include "../CommunicationController2BufferSizes.h"
#include "../../events/InputEvent.h"
#include "../../common/types/IntArray.h"

class FSMAIM;

class AIMDetector : public CommunicationControllerClient, public wxEvtHandler
{
    public:
        AIMDetector(wxEvtHandler* eventHandler);
        virtual ~AIMDetector();


        /// CommunicationControllerClient methods
        void write( uint8_t* buffer, int& size );
        void read( uint8_t* buffer, int size );
        void finish();
        bool isFinished();

        // send event only if an incoming aim data has the required channel
        //void addReqChannel( int channelid );
        //void clearReqChannels() { m_reqChannels.Clear(); }

    protected:
    private:

        void OnSIPRInputEvent(InputEvent& evt);

        enum State {
            READ,
            WRITE,
            TIMEOUT,
            FINISHED
        } m_state;


        wxEvtHandler*                       m_eventHandler;

        uint8_t         m_txBuff[TX_BUFFER_SIZE];
        int             m_txCurrentSize;


        FSMAIM*         m_fsm;
        size_t          m_timeoutCtr;
        uint8_t         m_siprbuffer[3];
        //IntArray        m_reqChannels;


};

#endif // AIMDETECTOR_H
