#ifndef ROUNDFIRMWAREINFOFETCHER_H
#define ROUNDFIRMWAREINFOFETCHER_H


#include <wx/wx.h>
#include "../CommunicationControllerClient.h"
#include "../../common/typedef.h"
#include "../../common/types/ResponseRecognizerPtrArray.h"


class FirmwareInfo;
class FirmwareInfoFetcherListener;


class RoundFirmwareInfoFetcher : public CommunicationControllerClient
{
    public:
        RoundFirmwareInfoFetcher( FirmwareInfoFetcherListener* listener );
        virtual ~RoundFirmwareInfoFetcher();

        /// CommunicationControllerClient methods
        void write( uint8_t* buffer, int& size );
        void read( uint8_t* buffer, int size );
        void finish();
        bool isFinished();

    private:
        enum State { CLEAR, SEND, WAIT, END };
        enum { TIMEOUT = 100 };

        enum CommandID
        {
            MAN = 0,
            SERIAL_NUMBER,
            MEGATUNE,
            SIGNATURE,
        };

        size_t                      m_currentRecognizerIdx;
        State                       m_state;
        State                       m_nextState;
        ResponseRecognizerPtrArray  m_recognizers;
        FirmwareInfo*               m_firmwareInfo;
        bool                        m_isTimedout;

        FirmwareInfoFetcherListener* m_listener;

        wxDateTime  m_clearingStartTime;
        size_t      m_clearingTime;

        void changeStateToClearing();
        void clear( uint8_t* buffer, int size );
};

#endif // ROUNDFIRMWAREINFOFETCHER_H
