#ifndef SDCARDFILEHELPER_H
#define SDCARDFILEHELPER_H

#include "../../common/typedef.h"
#include "../../FirmwareVersion.h"




namespace SDCardFile
{
    enum SDLogType {
            SDLOG_RAW = 1,
			SDLOG_TR_FRAME = 2,
    };

    enum { SDFS_OK = 0, SDFS_EMPTY = -1, SDFS_NOTVALIDFS = -2, SDFS_MSDFAIL = -21, SDFS_MSSFAIL = -22, SDFS_TIMEOUT = -42 };

    bool                isCRCValid( uint8_t* data, size_t len );
    bool                isDataValid( uint8_t* data, size_t len );
    bool                checkSectorIsEmpty( uint8_t * data, size_t len );
    size_t              CalcLogTimeLength( size_t len, size_t datalen );
    size_t              CalcLogTimeLength( size_t len );

    bool                isVEMSFilesystem( uint8_t* data );
    FirmwareVersion     getFwVersion( uint8_t* data );
    unsigned int        getFWVersionAsInt( uint8_t*data );
    uint8_t             getInodeVersion( uint8_t* data );
};

#endif // SDCARDFILEHELPER_H
