#include "condtree.h"

#include <stdlib.h>

CondTree::CondTree()
{
    //ctor
     m_parent = NULL;
     m_state = NOT_IF;
     m_condValue = false;
}

CondTree::~CondTree()
{
    //dtor
}

// depends on state
bool CondTree::isValid()
{
    if( m_state == IN_IF){ return m_condValue;}
    else { return !m_condValue;}

}

// invoke parent
bool CondTree::isActive()
{
    CondTree * tmpCT = this;

    while( tmpCT != NULL && tmpCT->isValid() ){
        tmpCT = tmpCT->getParent();
    }
    if(tmpCT == NULL){ return true; }
    else{ return false; }
}


void CondTree::setCondValue(bool val)
{
    m_condValue = val;
}

bool CondTree::getCondValue()
{
    return m_condValue;
}

void CondTree::setParent(CondTree * ct)
{
    m_parent = ct;
}

void CondTree::setState(State st)
{
    m_state = st;
}

CondTree * CondTree::getParent(){
    return m_parent;
}
