#ifndef COLORSETUPPANEL_H
#define COLORSETUPPANEL_H

#include "wxPanelWithCtrlExBase.h"

class ColorSetupPanel: public wxPanelWithCtrlExBase
{

    DECLARE_DYNAMIC_CLASS(ColorSetupPanel);

    public:
        ColorSetupPanel() {}
        ColorSetupPanel(wxWindow* parent, const wxColor& color, int deafultcolorstrstyle = wxC2S_CSS_SYNTAX);
        virtual ~ColorSetupPanel();

        void SetDefaultColorStrStyle(int style) { m_colorStrStyle = style; };

        void SetColor(const wxColor& color);
        void SetColor(const wxString& color);

        wxColor GetColor();
        wxString GetColorStr();

        virtual void SetValue(const wxVariant& value);
        virtual wxVariant GetValue();


    protected:

        void OnButton(wxCommandEvent& evt);

        void OnUpdated(wxCommandEvent& evt);
        void OnSetFocus(wxFocusEvent& evt);
        void OnKillFocus(wxFocusEvent& evt);

    private:

        enum {
            idColorButt
        };

        wxTextCtrl*   m_textCtrl;

        int           m_colorStrStyle;

        DECLARE_EVENT_TABLE();

};

#endif // COLORSETUPPANEL_H
