#include "ConfirmationDialog.h"
#include "../logger.h"


BEGIN_EVENT_TABLE( ConfirmationDialog, wxDialog )
    EVT_BUTTON( wxID_OK, ConfirmationDialog::onButtonPressed )
    EVT_BUTTON( wxID_CANCEL, ConfirmationDialog::onButtonPressed )
    EVT_BUTTON( wxID_YES, ConfirmationDialog::onButtonPressed )
    EVT_BUTTON( wxID_NO, ConfirmationDialog::onButtonPressed )
    EVT_BUTTON( wxID_HELP, ConfirmationDialog::onButtonPressed )
END_EVENT_TABLE()

ConfirmationDialog::ConfirmationDialog( wxWindow* parent, const wxString& message, const wxString& title, const wxPoint& pos, const wxSize& size,
    int buttonstyle, int style, const wxString& checkBoxMsg ) : wxDialog( parent, wxID_ANY, title, pos, size ), m_style( style ), m_buttonstyle( buttonstyle )
{
    wxSizer* mainsizer = new wxBoxSizer( wxVERTICAL );

    wxStaticText* msgtxt = new wxStaticText( this, -1, message );

    mainsizer->Add( msgtxt, 0, wxEXPAND | wxALL, 10 );

    if ( m_style & CONFIRMDLG_SHOWCHECKBOX )
    {
        m_checkBox = new wxCheckBox( this, wxID_ANY, checkBoxMsg );

        mainsizer->Add( m_checkBox, 0, wxEXPAND | wxALL | wxALIGN_CENTER, 10 );
    }
    else
    {
        m_checkBox = NULL;
    }

    // add buttons
    wxSizer* bs = CreateButtonSizer( buttonstyle );

    if ( bs != NULL )
    {
        mainsizer->Add( bs, 0, wxEXPAND | wxALL, 10 );
    }

    SetSizer( mainsizer );

    mainsizer->Fit( this );

    mainsizer->SetSizeHints( this );
}

bool ConfirmationDialog::getCheckBoxState( bool& isChecked )
{
    if ( m_checkBox == NULL )
    {
        isChecked = false;
        return false;
    }
    else
    {
        isChecked = m_checkBox->GetValue();
        return true;
    }
}

void ConfirmationDialog::onButtonPressed( wxCommandEvent& event )
{
    int id = event.GetId();

    EndModal( id );
}
