#ifndef CONFIRMATIONDIALOG_H
#define CONFIRMATIONDIALOG_H

#include <wx/wx.h>

class ConfirmationDialog : public wxDialog
{
    public:
        ConfirmationDialog(  wxWindow* parent, const wxString& message, const wxString& title, const wxPoint& pos = wxDefaultPosition,
            const wxSize& size = wxDefaultSize, int buttonstyle = wxYES | wxNO, int style = CONFIRMDLG_DEFAULT, const wxString& checkBoxMsg = wxEmptyString );

    public:
        enum { CONFIRMDLG_DEFAULT = 1, CONFIRMDLG_SHOWCHECKBOX, CONFIRMDLG_EXTENDED = CONFIRMDLG_DEFAULT | CONFIRMDLG_SHOWCHECKBOX };

    public:
        // if checkbox is shown -> returns true and sets isChecked depending on the state of the checkbox
        // if checkbox is not shown -> returns false and isChecked will be false
        bool    getCheckBoxState( bool& isChecked );

    protected:
        int             m_style;
        int             m_buttonstyle;

    private:
        wxCheckBox*     m_checkBox;

    private:
        void    onButtonPressed( wxCommandEvent& event );

        DECLARE_EVENT_TABLE()
};

#endif // CONFIRMATIONDIALOG_H
