#ifndef INFOPANEL_H
#define INFOPANEL_H

#include <wx/wx.h>
#include <wx/html/htmlwin.h>

class InfoPanel: public wxFrame
{
    public:
        InfoPanel(wxWindow * parent, const wxString& text, const wxString& title = _T(""), int id = -1, const wxPoint& pinpoint = wxPoint(0,0), bool expand = false);
        virtual ~InfoPanel();

        //void SetPage(const wxString& text);

        void SetPinPoint(const wxPoint& pt);

        void SetAlpha(int a) { m_defAlpha = a; SetTransparent(a); };

    protected:

        void OnButton(wxCommandEvent& evt);

        void OnEnter(wxMouseEvent& evt);
        void OnLeave(wxMouseEvent& evt);

        void OnSlider(wxScrollEvent& evt);

    private:

        enum {
            idBtnToggle,
            idSlider
        };

        wxHtmlWindow*   m_win;
        wxButton*       m_btn;
        wxPoint         m_pinPoint;

        int             m_hideSizeDist;

        int             m_defAlpha;

    DECLARE_EVENT_TABLE();

};

#endif // INFOPANEL_H
