#include "GraphNode.h"


GraphNode::GraphNode()
{
    //ctor
    m_porder = PORDER_UNKNOWN;
}

GraphNode::~GraphNode()
{
    //dtor
}

void GraphNode::setPorder(int porder)
{
    m_porder = porder;
}
int GraphNode::getPorder(void)
{
    return m_porder;
}

void GraphNode::insertNode(GraphNode* ptr)
{
    m_nodeSet.insert(ptr);
}

bool GraphNode::hasDepending()
{
    return !m_nodeSet.empty();
}

/**
* return true if porder of all edge is known
* and not equal to porder_now
*/
bool GraphNode::isAlledgeKnown(int porder_now)
{
    for(GraphNodeSet::iterator it = m_nodeSet.begin(); it !=m_nodeSet.end(); it++) {
        GraphNode *ptr;
        ptr = *it;
        int porder = ptr->getPorder();
        if((porder == PORDER_UNKNOWN) || (porder == porder_now) ){
            return false;
        }
    }
    return true;
}

GraphNodeSet GraphNode::getDependNodeSet()
{
    return m_nodeSet;
}

