/***************************************************************
 * Name:      HotkeyManagerWizardMain.h
 * Purpose:   Defines Application Frame
 * Author:     ()
 * Created:   2010-07-08
 * Copyright:  ()
 * License:
 **************************************************************/

#ifndef HOTKEYMANAGERWIZARDMAIN_H
#define HOTKEYMANAGERWIZARDMAIN_H

#ifndef WX_PRECOMP
    #include <wx/wx.h>
#endif

#include "HotkeyManagerWizardApp.h"

class HotkeyManagerWizardFrame: public wxFrame
{
    public:
        HotkeyManagerWizardFrame(wxFrame *frame, const wxString& title);
        ~HotkeyManagerWizardFrame();

        void BuildGUI();

    private:
        enum
        {
            idMenuQuit = 1000,
            idMenuAbout,
            idTargetClassCtrl,
            idButtonBrowse,
            idButtonClose,
            idButtonOK
        };

        void CreateDatabases();

        void OnClose(wxCloseEvent& event);
        void OnQuit(wxCommandEvent& event);
        void OnAbout(wxCommandEvent& event);
        void OnTargetClassUpdated(wxCommandEvent& event);
        void OnButton(wxCommandEvent& event);

        wxTextCtrl*     m_targetClassName;
        wxTextCtrl*     m_titleCtrl;
        wxTextCtrl*     m_symbolsFilename;

        wxTextCtrl*     m_profileTitleCtrl;
        wxTextCtrl*     m_profileSymbolsFilename;

        wxTextCtrl*     m_path;

        wxString        m_profilesAndTargetsDBPath;


        DECLARE_EVENT_TABLE()
};


#endif // HOTKEYMANAGERWIZARDMAIN_H
