#include "EEpromConfigLoader.h"

#include "../events/GeneralEvent.h"

#include "../Math.h"
#include "../Utils.h"

EEpromConfigLoader::EEpromConfigLoader( const wxString& filename )
{
    m_eepromfilename = filename;
}

void EEpromConfigLoader::getEepromData()
{
    memset( m_eepromdata, 0, 4096 );

    m_size = 0;

    parse( m_eepromfilename );

    if ( m_size != 4096 )
    {
        GeneralEvent evt;
        evt.SetLong( EEPROM_SAVE_ERROR );
        AddPendingEvent( evt );
    }
    else
    {
        GeneralEvent evt;
        evt.SetLong( EEPROM_SAVE_OK );
        AddPendingEvent( evt );
    }

}

void EEpromConfigLoader::parseLine()
{
    if ( m_line.StartsWith(_T("#") ) )
        return;

    if ( m_size > 4095 )
        return;

    m_line = m_line.Mid( 10 );

    wxArrayString hexvals;
    Utils::tokenizeToArray( m_line, _T(" "), hexvals );

    if ( hexvals.GetCount() != 16 )
        return;

    for ( size_t i = 0; i < hexvals.GetCount(); ++i )
    {
        m_eepromdata[m_size+i] = Math::hex2int( hexvals[i] );
    }

    m_size += 16;
}
