#ifndef COMMUNICATIONEVENT_H
#define COMMUNICATIONEVENT_H

#include <wx/event.h>

extern const wxEventType wxEVT_COMMUNICATION;    /// without this MinGW gives undifened referenced linker error
//extern const wxEventType wxEVT_COMM_ERROR;
//extern const wxEventType wxEVT_COMM_TIMEOUT;
//extern const wxEventType wxEVT_COMM_CANNOT_OPEN;

#define EVT_COMMUNICATION(id, func) \
    wx__DECLARE_EVT1(wxEVT_COMMUNICATION, id, CommunicationEventHandler(func))

class CommunicationEvent : public wxEvent
{
    public:
        enum { CANNOT_OPEN_PORT, COMMUNICATION_ERROR, TIMEOUT, PORT_CLOSED, REMOVE_USB, COMM_WORX };

    public:
        CommunicationEvent( int id = 0 ) : wxEvent( id, wxEVT_COMMUNICATION ) {}
        virtual wxEvent *Clone() const { return new CommunicationEvent(*this); }
        DECLARE_DYNAMIC_CLASS(CommunicationEvent)

        wxString toString() const;

    private:
};

typedef void (wxEvtHandler::*CommunicationEventFunction)(CommunicationEvent&);

#define CommunicationEventHandler(func) \
    (wxObjectEventFunction)(wxEventFunction)wxStaticCastEvent(CommunicationEventFunction, &func)

#endif // COMMUNICATIONEVENT_H
