#ifndef CONFIGDOWNLOADEVENT_H
#define CONFIGDOWNLOADEVENT_H

#include <wx/event.h>

extern const wxEventType wxEVT_CONFIG_DOWNLOAD;    /// without this MinGW gives undifened referenced linker error

#define EVT_CONFIG_DOWNLOAD(id, func) \
    wx__DECLARE_EVT1(wxEVT_CONFIG_DOWNLOAD, id, ConfigDownloadEventHandler(func))

class ConfigDownloadEvent : public wxEvent
{
    DECLARE_DYNAMIC_CLASS(ConfigDownloadEvent)

    public:
        enum { PAGE_VERIFIED, FAILED, SUCCEEDED };

    public:
        ConfigDownloadEvent( int id = 0 ) : wxEvent( id, wxEVT_CONFIG_DOWNLOAD ) {}
        virtual wxEvent *Clone() const { return new ConfigDownloadEvent(*this); }

    private:

};

typedef void (wxEvtHandler::*ConfigDownloadEventFunction)(ConfigDownloadEvent&);

#define ConfigDownloadEventHandler(func) \
    (wxObjectEventFunction)(wxEventFunction)wxStaticCastEvent(ConfigDownloadEventFunction, &func)


#endif // CONFIGDOWNLOADEVENT_H
