#ifndef DEVICEEVENT_H
#define DEVICEEVENT_H

#include <wx/event.h>

#include "../vemsprotocol/ECUInfo.h"

extern const wxEventType wxEVT_DEVICE;    /// without this MinGW gives undifened referenced linker error

#define EVT_DEVICE(id, func) \
    wx__DECLARE_EVT1(wxEVT_DEVICE, id, DeviceEventHandler(func))

class DeviceEvent : public wxEvent
{
    public:
        DeviceEvent(int id = 0);
        virtual wxEvent *Clone() const { return new DeviceEvent(*this); }
        ECUInfo::Device device;
        DECLARE_DYNAMIC_CLASS(DeviceEvent)
};

typedef void (wxEvtHandler::*DeviceEventFunction)(DeviceEvent&);

#define DeviceEventHandler(func) \
    (wxObjectEventFunction)(wxEventFunction)wxStaticCastEvent(DeviceEventFunction, &func)

#endif // DEVICEEVENT_H
