#ifndef GPSEVENT_H
#define GPSEVENT_H

#include <wx/event.h>

#include "../GPSInfo.h"
#include "../common/types/wxVariantHash.h"

extern const wxEventType wxEVT_GPS;    /// without this MinGW gives undifened referenced linker error

#define EVT_GPS(id, func) \
    wx__DECLARE_EVT1(wxEVT_GPS, id, GPSEventHandler(func))

class GPSEvent : public wxEvent
{
    public:
        GPSEvent( int id = 0 );
        virtual wxEvent *Clone() const { return new GPSEvent( *this ); }
        GPSInfo::State state;
        wxVariantHash data;
        //wxString getStateAsString();
    public:
        DECLARE_DYNAMIC_CLASS(GPSEvent)
};

typedef void (wxEvtHandler::*GPSEventFunction)(GPSEvent&);

#define GPSEventHandler(func) \
    (wxObjectEventFunction)(wxEventFunction)wxStaticCastEvent(GPSEventFunction, &func)

#endif // GPSEVENT_H
