#ifndef INPUTEVENT_H
#define INPUTEVENT_H

#include <wx/event.h>
#include "../vemsprotocol/SIPRPacket.h"

extern const wxEventType wxEVT_INPUT;    /// without this MinGW gives undifened referenced linker error

#define EVT_INPUT(id, func) \
    wx__DECLARE_EVT1(wxEVT_INPUT, id, InputEventHandler(func))

enum SIPREventType
{
    SIPR_EVENT_TYPE_INPUT   = 0,
    SIPR_EVENT_TYPE_OUTPUT,
    SIPR_EVENT_TYPE_TX_REQUEST,
    SIPR_EVENT_TYPE_TX,
    SIPR_EVENT_TYPE_TIMED_OUT
};

class InputEvent : public wxEvent
{
    public:
        InputEvent(int id = 0 );
        virtual InputEvent *Clone() const //{ wxLogMessage( _T("InputEvent::Clone()") ); return new InputEvent(*this); }
        { return new InputEvent(*this); }

        SIPRPacket  getPacket() const { return m_packet; }
        void        setPacket( const SIPRPacket& packet ) { m_packet = packet; }
        void        setType( int t ) { m_type = t; }
        int         getType() const { return m_type; }
    public:
        DECLARE_DYNAMIC_CLASS(InputEvent)
    private:
        SIPRPacket  m_packet;
        int         m_type;
};

typedef void (wxEvtHandler::*InputEventFunction)(InputEvent&);

#define InputEventHandler(func) \
    (wxObjectEventFunction)(wxEventFunction)wxStaticCastEvent(InputEventFunction, &func)
#endif // INPUTEVENT_H
