#ifndef OFFSETREADEREVENT_H
#define OFFSETREADEREVENT_H

#include <wx/wx.h>
#include "../common/types/DoubleHash.h"

extern const wxEventType wxEVT_OFFSETREADER;    /// without this MinGW gives undifened referenced linker error

#define EVT_OFFSETREADER(func) \
    wx__DECLARE_EVT0(wxEVT_OFFSETREADER, OffsetReaderEventHandler(func))


class OffsetReaderEvent : public wxEvent
{
    public:
        OffsetReaderEvent( int id = 0 );
        virtual wxEvent *Clone() const { return new OffsetReaderEvent(*this); }

        DoubleHash values;

    private:

        DECLARE_DYNAMIC_CLASS( OffsetReaderEvent );
};

typedef void (wxEvtHandler::*OffsetReaderEventFunction)(OffsetReaderEvent&);

#define OffsetReaderEventHandler(func) \
    (wxObjectEventFunction)(wxEventFunction)wxStaticCastEvent(OffsetReaderEventFunction, &func)

#endif // OFFSETREADEREVENT_H
