#ifndef SELECTINPUTEVENT_H
#define SELECTINPUTEVENT_H

#include "../rtdatamanager/RTDataInputBase.h"
#include <wx/event.h>

extern const wxEventType wxEVT_SELECT_INPUT;    /// without this MinGW gives undifened referenced linker error

#define EVT_SELECT_INPUT(id, func) \
    wx__DECLARE_EVT1(wxEVT_SELECT_INPUT, id, SelectInputEventHandler(func))

class SelectInputEvent : public wxEvent
{
    public:
        SelectInputEvent(int id = 0);
        virtual wxEvent *Clone() const { return new SelectInputEvent(*this); }
        RTDataInputType type;
    public:
        DECLARE_DYNAMIC_CLASS(SelectInputEvent)
};

typedef void (wxEvtHandler::*SelectInputEventFunction)(SelectInputEvent&);

#define SelectInputEventHandler(func) \
    (wxObjectEventFunction)(wxEventFunction)wxStaticCastEvent(SelectInputEventFunction, &func)

#endif // SELECTINPUTEVENT_H
