#ifndef SLIDERPOSEVENT_H
#define SLIDERPOSEVENT_H

#include <wx/wx.h>

extern const wxEventType wxEVT_SLIDERPOS;    /// without this MinGW gives undifened referenced linker error

#define EVT_SLIDERPOS(id, func) \
    wx__DECLARE_EVT1(wxEVT_SLIDERPOS, id, SliderPosEventHandler(func))

class SliderPosEvent : public wxEvent
{
    public:
        SliderPosEvent( int id = 0 );
        virtual wxEvent *Clone() const { return new SliderPosEvent( *this ); }

        size_t  getCurrentPos() const { return m_pos; }
        size_t  getTotal() const { return m_total; }
        double  getPercent() const { return m_percent; }

        void    setCurrentPos( size_t pos ) { m_pos = pos; if ( m_total > 0 ) m_percent = 100.0 * (double) m_pos / m_total; }
        void    setTotal( size_t total ) { m_total = total; if ( m_total > 0 ) m_percent = 100.0 * (double) m_pos / m_total; }
        void    setPercent( double percent ) { m_percent = percent; }

    public:
        DECLARE_DYNAMIC_CLASS(SliderPosEvent)

    private:
        size_t  m_pos;
        size_t  m_total;
        double  m_percent;
};

typedef void (wxEvtHandler::*SliderPosEventFunction)(SliderPosEvent&);

#define SliderPosEventHandler(func) \
    (wxObjectEventFunction)(wxEventFunction)wxStaticCastEvent(SliderPosEventFunction, &func)


#endif // SLIDERPOSEVENT_H
