#include "VemsDeviceControllerEvent.h"

DEFINE_EVENT_TYPE( wxEVT_VEMS_DEVICE_CONTROLLER )
IMPLEMENT_DYNAMIC_CLASS( VemsDeviceControllerEvent, wxEvent )

wxString VemsDeviceControllerEvent::toString() const
{
    switch ( GetId() )
    {
        case VDC_EVENT_DEVICE_FOUND:
            return _T("VDC_EVENT_DEVICE_FOUND");

        case VDC_EVENT_DEVICE_NOT_FOUND:
            return _T("VDC_EVENT_DEVICE_NOT_FOUND");

        case VDC_EVENT_DEVICE_CHECKING_PASSWORD:
            return _T("VDC_EVENT_DEVICE_CHECKING_PASSWORD");

        case VDC_EVENT_DEVICE_PROTECTED:
            return _T("VDC_EVENT_DEVICE_PROTECTED");

        case VDC_EVENT_DEVICE_NOT_PROTECTED:
            return _T("VDC_EVENT_DEVICE_NOT_PROTECTED");

        case VDC_EVENT_DEVICE_FIRMWAREINFO_FETCHING:
            return _T("VDC_EVENT_DEVICE_FIRMWAREINFO_FETCHING");

        case VDC_EVENT_DEVICE_FIRMWAREINFO_FETCHED:
            return _T("VDC_EVENT_DEVICE_FIRMWAREINFO_FETCHED");

        case VDC_EVENT_DEVICE_FIRMWAREDATA_SYNCING:
            return _T("VDC_EVENT_DEVICE_FIRMWAREDATA_SYNCING");

        case VDC_EVENT_DEVICE_FIRMWAREDATA_SYNCED:
            return _T("VDC_EVENT_DEVICE_FIRMWAREDATA_SYNCED");

        case VDC_EVENT_DEVICE_CONNECTED:
            return _T("VDC_EVENT_DEVICE_CONNECTED");

        case VDC_EVENT_DEVICE_DISCONNECTED:
            return _T("VDC_EVENT_DEVICE_DISCONNECTED");

        case VDC_EVENT_DEVICE_RECONNECTED:
            return _T("VDC_EVENT_DEVICE_RECONNECTED");

        case VDC_EVENT_STARTED:
            return _T("VDC_EVENT_STARTED");

        case VDC_EVENT_STOPPED:
            return _T("VDC_EVENT_STOPPED");

        case VDC_EVENT_PAGE_SYNCED:
            return _T("VDC_EVENT_PAGE_SYNCED");

        case VDC_EVENT_DEVICE_BAUDRATE_CHANGED:
            return _T("VDC_EVENT_DEVICE_BAUDRATE_CHANGED");

        case VDC_EVENT_CANNOT_OPEN_PORT:
            return _T("VDC_EVENT_CANNOT_OPEN_PORT");

        case VDC_EVENT_START_RESUMING:
            return _T("VDC_EVENT_START_RESUMING");

        case VDC_EVENT_RESUMED:
            return _T("VDC_EVENT_RESUMED");

        case VDC_EVENT_LEAVING_BOOT_MODE:
            return _T("VDC_EVENT_LEAVING_BOOT_MODE");

        default:
            return _T("VDC_EVENT_UNDEFINED");
    }
}
