#ifndef VEMSGUICOMMANDEVENT_H
#define VEMSGUICOMMANDEVENT_H

#include "../common/types/wxVariantHash.h"

extern const wxEventType wxEVT_VEMS_GUI_COMMAND;    /// without this MinGW gives undifened referenced linker error

#define EVT_VEMS_GUI_COMMAND(func) \
    wx__DECLARE_EVT1(wxEVT_VEMS_GUI_COMMAND, -1, VemsGUICommandEventHandler(func))

class VemsGUICommandEvent : public wxEvent
{
    public:
        VemsGUICommandEvent( int command = 0, int id = 0 );
        virtual wxEvent *Clone() const { return new VemsGUICommandEvent( *this ); }

        wxVariantHash GetVariantHash() const  { return m_vhvalue; }
        void SetVariantHash( const wxVariantHash& value ) { m_vhvalue = value; }

        void SetMessage(const wxVariant& msg) { m_message = msg; }
        wxVariant GetMessage() { return m_message; }

        long GetCommand() { return m_command; }
        void SetCommand(long cmd) { m_command = cmd; }

    public:
        DECLARE_DYNAMIC_CLASS(VemsGUICommandEvent)

    private:
        long        m_command;
        wxVariant   m_message;

        wxVariantHash   m_vhvalue;
};

typedef void (wxEvtHandler::*VemsGUICommandEventFunction)(VemsGUICommandEvent&);

#define VemsGUICommandEventHandler(func) \
    (wxObjectEventFunction)(wxEventFunction)wxStaticCastEvent(VemsGUICommandEventFunction, &func)

#endif // VEMSGUICOMMANDEVENT_H
