#ifndef EXPRESSIONFVCONDITIONAL_H
#define EXPRESSIONFVCONDITIONAL_H

#include "ExpressionBase.h"

class ExpressionFvConditional : public ExpressionBase
{
    public:
        ExpressionFvConditional()
        {
            setPrec( 40 );
            setAssoc( ASSOC_LEFT );
            setType( OPERATOR );
            setOperator( _T("?") );
        }

        virtual ~ExpressionFvConditional();

        void interpret(RPNStack& rpnStack)
        {
            RPNStackItem* c = rpnStack.pop();
            RPNStackItem* b = rpnStack.pop();
            RPNStackItem* a = rpnStack.pop();

            if( a->getType() == RPNStackItem::NUMBER && b->getType() == RPNStackItem::NUMBER &&  c->getType() == RPNStackItem::NUMBER)
            {
                RPNStackItem* item = new RPNStackItem();
                if( a->getNumber() )
                {
                    item->setNumber( b->getNumber() );
                }
                else
                {
                    item->setNumber( c->getNumber() );
                }

                rpnStack.push( item );
            }
            delete a;
            delete b;
            delete c;
        }
        wxString toString() { return _T("?"); }
    protected:
    private:
};



#endif // EXPRESSIONFVCONDITIONAL_H
