#ifndef EXPRESSIONFVDIV_H
#define EXPRESSIONFVDIV_H

#include "ExpressionBase.h"

class ExpressionFvDiv : public ExpressionBase
{
    public:
        ExpressionFvDiv()
        {
            setPrec( 140 );
            setAssoc( ASSOC_LEFT );
            setType( OPERATOR );
        }

        virtual ~ExpressionFvDiv();

        void interpret(RPNStack& rpnStack)
        {
            RPNStackItem * a = rpnStack.pop();
            RPNStackItem * b = rpnStack.pop();
            if(a->getType() == RPNStackItem::NUMBER && b->getType() == RPNStackItem::NUMBER)
            {
                if( a->getNumber() == 0.0 )
                {
                    wxString tmp = wxString::Format(_T("%f/%f"),  b->getNumber(),  a->getNumber() );
					delete a;
					delete b;
                    throw ExpError::ZeroDivide( _T("divide by zero: ")+ tmp);
                }

                RPNStackItem* item = new RPNStackItem();
                item->setNumber( b->getNumber() / a->getNumber() );
                rpnStack.push( item );
            }
            delete a;
            delete b;
        }
        wxString toString() { return _T("/"); }
    protected:
    private:
};



#endif // EXPRESSIONFVDIV_H
