#include "ExpressionFvSwitchCase8.h"
#include "../logger.h"

void ExpressionFvSwitchCase8::interpret( RPNStack& rpnStack )
{
    const int PARAM_COUNT = 9;

    RPNStackItem* params[PARAM_COUNT];

    for ( size_t i = 0; i < PARAM_COUNT; ++i )
        params[i] = NULL;

    for ( int i = 0; i < PARAM_COUNT; ++i ) {
        params[8-i] = rpnStack.pop();
    }

    for ( int i = 0; i < PARAM_COUNT; ++i ) {
        if ( params[i]->getType() != RPNStackItem::NUMBER ) {
            for ( size_t j = 0; j < PARAM_COUNT; ++j )
                if ( params[j] )
                    delete params[j];

             throw ExpError::VariableException( _T("function switchCase8 parameter mismatch") );
        }
    }

    int selection = (int)params[0]->getNumber();

    if ( selection < 0 || selection > ( PARAM_COUNT - 2 ) ) {
        wxString message = wxString::Format( _T("function switchCase8 invalid selection: %d"), selection );

        for ( size_t j = 0; j < PARAM_COUNT; ++j )
            if ( params[j] )
                delete params[j];
        throw ExpError::VariableException( message );
    }

    double result = params[selection+1]->getNumber();

    RPNStackItem* item = new RPNStackItem();
    item->setNumber( result );
    rpnStack.push( item );

    for ( size_t j = 0; j < PARAM_COUNT; ++j )
        if ( params[j] )
            delete params[j];
}
