#ifndef EXPRESSIONFVTABLE_H
#define EXPRESSIONFVTABLE_H

#include "ExpressionBase.h"
#include "../common/types/DoubleArray.h"

WX_DECLARE_STRING_HASH_MAP(DoubleArray*, TableHash);

class ExpressionFvTable : public ExpressionBase
{
    public:
        ExpressionFvTable()
        {
            setType( FUNCTION );
        }

        virtual ~ExpressionFvTable();

        void interpret( RPNStack& stack );

        wxString toString() { return _T("table"); }

    private:
        static  TableHash tables;
        bool    doRead( const wxString& fileName );
        double  get( const wxString& name, int key );
        wxArrayString  parseLine( const wxString& line );
};



#endif // EXPRESSIONFVTABLE_H
