#ifndef INFIXOPERATOR_H
#define INFIXOPERATOR_H

#include <wx/dynarray.h>
#include <wx/string.h>

#include "../common/typedef.h"

class InfixOperator
{
    public:
        enum AssocType { ASSOC_NONE=0, ASSOC_LEFT, ASSOC_RIGHT };

        InfixOperator( const wxString& op, uint32_t prec, AssocType assoc);
        virtual ~InfixOperator();

        wxString    getOp() { return m_operator; }
        uint32_t    getPrec() { return m_prec; }
        AssocType   getAssoc() { return m_assoc; }
    protected:
    private:
        wxString    m_operator;
        uint32_t    m_prec;
        AssocType   m_assoc;
};

WX_DEFINE_ARRAY( InfixOperator*, InfixOperatorA );

#endif // INFIXOPERATOR_H
