#include "RPNTester.h"

#include "RPNParser.h"
#include "../logger.h"
#include "../common/types/DoubleHash.h"
#include "../common/typedef.h"
#include "VariableData.h"

RPNTester::RPNTester()
{
    //ctor
}

RPNTester::~RPNTester()
{
    //dtor
}

void RPNTester::test()
{

    RPNParser rpn;
    DoubleHash data;

    data[_T("rpn[-1]")] = 0;
    data[_T("rpn[-2]")] = 0;
    data[_T("rpn")] = 500;
    data[_T("map")] = 100;
    data[_T("map[-5]")] = 0;
    data[_T("rpn[-5]")] = 0;

    VariableDataDH vd( &data );
    rpn.setVariableData( &vd );

//    DoubleHash testH;
//    testH[_T("3*rpn[-1] + 0.5*rpn[-2]")] = 0;
    wxString expr = _T("3*rpn[-1] - 0.5 * rpn[-2] - 400 + 2 * map - 5 * rpn - map[-5] + rpn[-5]");

    Int2ArrayStringHash vars = rpn.getPVariables(expr);
    Int2ArrayStringHash::iterator it = vars.begin();

    for ( ; it != vars.end(); ++it )
    {
        Logger::logf(LOG_MSG, _T("Shift = %d"), it->first );
        wxArrayString svars = it->second;
        for ( unsigned int j = 0; j < svars.GetCount(); ++j )
        {
            Logger::logf(LOG_MSG, _T("-->") + svars[j] );
        }
        Logger::logf(LOG_MSG, _T("------"));
    }

//    try {
//        double rs = rpn.calculate(expr);
//        Logger::logf(LOG_MSG, _T("WinceTest res=%f"),rs);
//    }
//    catch(ExpError::ZeroDivide ){
//            Logger::logf(LOG_WARNING, _T("RPN parser test(): expession: ") );
//        }catch( ExpError::SyntaxError e ){
//            Logger::logf(LOG_WARNING, _T("RPN parser test(): expession:") );
//        }catch( ExpError::ExpError){
//            Logger::logf(LOG_WARNING, _T("RPN parser test(): expession:  BAD!") );
//        }
    /*Logger::logf(LOG_WARNING, _T("RPN parser test(): START") );

    RPNParser rpn;
    DoubleHash testH;

    DoubleHash varH;

    varH[_T("a")] = 12;
    varH[_T("pi")] = 3.14;


    testH[_T("4 3 +")] = 7;
    testH[_T("4 7 -")] = 4-7;
    testH[_T("1 2 3 - +")] = 0;
    testH[_T("1 -2 3 - +")] = -4;

    testH[_T("1 - +")] = -4; // BAD throw exception

    testH[_T("1.5 2 3 + *")] = 7.5;
    testH[_T("1.5 2 3 + * 2.5 +")] = 10;

    testH[_T("1.5 2 3 + * 2.5 + 5 /")] = 2;


    testH[_T("1.5 2 2 - /")] = 2; // Zero Division

    testH[_T("a pi +")] = 15.14;


    //testH[_T("0 1000 &")] = 0;
    testH[_T("10 3 &")] = 10 & 3;

    testH[_T("8 1 |")] = 8 | 1;
   // Logger::logf(LOG_MSG, _T("//////////////////////////////////////"));
    testH[_T("8 1 >>")] = 8 >> 1;
    testH[_T("8 2 >>")] = 8 >> 2;
    testH[_T("8 3 >>")] = 8 >> 3;

    testH[_T("1 1 <<")] = 1 << 1;
    testH[_T("1 2 <<")] = 1 << 2;
    testH[_T("1 3 <<")] = 1 << 3;
    testH[_T("1 !")] = !1;
    testH[_T("0 !")] = !0;
    testH[_T("9 !")] = !9;

    testH[_T("1 ~")] = ~1;
    testH[_T("8 ~")] = ~8;
    testH[_T("9 ~")] = ~9;

    rpn.setVariableHash( &varH );

    DoubleHash::iterator it;

    for( it = testH.begin(); it != testH.end(); it++ )
    {
        wxString key = it->first;
        double expValue = it->second;

        rpn.parse(key);

        double res;
        try{
            res = rpn.evaluate();
            if(res == expValue){
                Logger::logf(LOG_WARNING, _T("RPN parser test(): expession: ")+key+ _T("=%f OK!"), res);
            }else{
                Logger::logf(LOG_WARNING, _T("RPN parser test(): expession: ")+key+ _T("=%f != %f FAILED!"), res, expValue );
            }
        }catch(ExpError::ZeroDivide ){
            Logger::logf(LOG_WARNING, _T("RPN parser test(): expession: ")+key+ _T(" ZeroDivide!") );
        }catch(ExpError::ExpError ){
            Logger::logf(LOG_WARNING, _T("RPN parser test(): expession: ")+key+ _T(" BAD!") );
        }
    }

    Logger::logf(LOG_WARNING, _T("RPN parser test(): END") ); */
}

void RPNTester::testInfix()
{
    Logger::logf(LOG_WARNING, _T("RPN parser test(): START") );

    RPNParser rpn;
    DoubleHash testH;

    DoubleHash varH;

/*
    testH[_T("2 + 2 * 6")] = 2+2*6;
    testH[_T("2.3+4.2*8.5")] = 2.3+4.2*8.5;
    testH[_T("alma * 3")] = 12 * 3;
    testH[_T("8 / 3")] = 8.0/3.0;
    testH[_T("2>>1")] = 2 >> 1;
    testH[_T("2<<1")] = 2 << 1;
    testH[_T("( 2 + 3 ) * ( 4 - 2 )")] = ( 2 + 3 ) * ( 4 - 2 );
    testH[_T("( 2 * ( 3 + 5 ) ) * ( 4 - 2 )")] = ( 2 * ( 3 + 5 ) ) * ( 4 - 2 );
    testH[_T("barack*2")] = 3.14 * 2;
    testH[_T("table ( 9 , 5 )")] = 9 + 5;
    testH[_T("table ( 9 * 2 , 5 )")] = 9 * 2 + 5;
    testH[_T("table ( table ( 3 , 4 ) , 5 )")] = 3 + 4 + 5;
    testH[_T("table(table(3,4),5)")] = 3 + 4 + 5;
    testH[_T("table(table(3,4),5")] = 3 + 4 + 5;
    testH[_T("table(4,\"5\")")] = 4 + 5;
    testH[_T("2-12*-3")] = 2-12*-3;
    testH[_T("table(-12,-3)")] = -12-3;
    testH[_T("(2+3)-(15-3)")] = (2+3)-(15-3);
    testH[_T("1 ? 2 : 3")] = 1 ? 2 : 3;
    testH[_T("0 ? 2 : 3")] = 0 ? 2 : 3;
    testH[_T("1 ? (2+2) : (3*4)")] = 1 ? (2+2) : (3*4);
    testH[_T("0 ? (2+2) : (3*4)")] = 0 ? (2+2) : (3*4);
    testH[_T("0 ? 2 + 2 : 3 * 4")] = 0 ? 2 + 2 : 3 * 4;
    testH[_T("1 ? 2 + 2 : 3 * 4")] = 1 ? 2 + 2 : 3 * 4;
    testH[_T("1 > 2")] = 1 > 2;
    testH[_T("1 < 2")] = 1 < 2;
    testH[_T("1 > 2 ? 3 : 4")] = 1 > 2 ? 3 : 4;
    testH[_T("1 < 2 ? 3 : 4")] = 1 < 2 ? 3 : 4;
    testH[_T("alma ? 3 : 4")] = 12 ? 3 : 4;
    testH[_T("alma ? -3 : -4")] = 12 ? -3 : -4;

    testH[_T("table(10, \"WBlambda100MOT.inc\")")] = 60;
    testH[_T("table(100, \"WBlambda100MOT.inc\")")] = 82;
    //table(tpsADC, "WBlambda100MOT.inc")
    //table(egoADC, "WBlambda100MOT.inc")

*/
/*
    varH[_T("alma")] = 12;
    varH[_T("alma_2")] = 11;
    varH[_T("barack")] = 3.14;

    testH[ _T("alma") ] = 12;
    testH[ _T("alma_2") ] = 11;
*/
    testH[ _T("2 <= 2") ] = 2 <= 2;
    testH[ _T("2 <= 1") ] = 2 <= 1;
    testH[ _T("1 <= 2") ] = 1 <= 2;

    testH[ _T("2 >= 2") ] = 2 >= 2;
    testH[ _T("2 >= 1") ] = 2 >= 1;
    testH[ _T("1 >= 2") ] = 1 >= 2;

    testH[ _T("2 != 2") ] = 2.0 != 2.0;
    testH[ _T("2 != 1") ] = 2 != 1;
    testH[ _T("1 != 2") ] = 1 != 2;

    testH[ _T("2 == 2") ] = 2.0 == 2.0;
    testH[ _T("2 == 1") ] = 2 == 1;
    testH[ _T("1 == 2") ] = 1 == 2;


    VariableDataDH vd( &varH );

    //rpn.setVariableHash( &varH );
    rpn.setVariableData( &vd );

    DoubleHash::iterator it;

    for( it = testH.begin(); it != testH.end(); it++ )
    {
        wxString key = it->first;
        double expValue = it->second;

        double res;

        try{
/*            rpn.parseInfix( key );
            rpn.infixToRpn();

            res = rpn.evaluate();
*/
            res = rpn.calculate( key );

            if(res == expValue){
                Logger::logf(LOG_WARNING, _T("RPN parser test(): expession: ")+key+ _T("=%f OK!"), res);
            }else{
                Logger::logf(LOG_WARNING, _T("RPN parser test(): expession: ")+key+ _T("=%f != %f FAILED!"), res, expValue );
            }
        }catch(ExpError::ZeroDivide ){
            Logger::logf(LOG_WARNING, _T("RPN parser test(): expession: ")+key+ _T(" ZeroDivide!") );
        }catch( ExpError::SyntaxError e ){
            Logger::logf(LOG_WARNING, _T("RPN parser test(): expession: %s - %s") , key.c_str(), e.toString().c_str() );
        }catch( ExpError::ExpError){
            Logger::logf(LOG_WARNING, _T("RPN parser test(): expession: ") + key + _T(" BAD!") );
        }

    }

    Logger::logf(LOG_WARNING, _T("RPN parser test(): END") );
}

void RPNTester::testInfixCache()
{
    Logger::logf(LOG_WARNING, _T("RPN parser testInfixCache(): START") );

    const uint32_t TEST_COUNT = 1000;

    RPNParser   rpn;
    DoubleHash  testH;
    DoubleHash  varH;

    varH[_T("alma")] = 12;
    varH[_T("barack")] = 3.14;

    VariableDataDH vd( &varH );
    rpn.setVariableData( &vd );
    //rpn.setVariableHash( &varH );

    testH[_T("(2+3)-(15-3)")] = (2+3)-(15-3);
    testH[_T("1 ? 2 : 3")] = 1 ? 2 : 3;
    testH[_T("0 ? 2 : 3")] = 0 ? 2 : 3;
    testH[_T("1 ? (2+2) : (3*4)")] = 1 ? (2+2) : (3*4);
    testH[_T("0 ? (2+2) : (3*4)")] = 0 ? (2+2) : (3*4);
    testH[_T("0 ? 2 + 2 : 3 * 4")] = 0 ? 2 + 2 : 3 * 4;
    testH[_T("1 ? 2 + 2 : 3 * 4")] = 1 ? 2 + 2 : 3 * 4;
    testH[_T("1 > 2")] = 1 > 2;
    testH[_T("1 < 2")] = 1 < 2;
    testH[_T("1 > 2 ? 3 : 4")] = 1 > 2 ? 3 : 4;
    testH[_T("1 < 2 ? 3 : 4")] = 1 < 2 ? 3 : 4;
    testH[_T("alma ? 3 : 4")] = 12 ? 3 : 4;
    testH[_T("alma ? -3 : -4")] = 12 ? -3 : -4;
    testH[_T("table(10, \"WBlambda100MOT.inc\")")] = 60;
    testH[_T("table(100, \"WBlambda100MOT.inc\")")] = 82;


    double res = 0.0;

    Logger::logMilli( LOG_MSG, _T(" - Parse with cache - START") );

	uint32_t i = 0;

    for( i = 0; i < TEST_COUNT; i++ )
    {

        DoubleHash::iterator it;

        for( it = testH.begin(); it != testH.end(); it++ )
        {
            try{
                res += rpn.calculate( it->first );

            }catch( ExpError::ExpError){

            }
        }
    }

    Logger::logf(LOG_WARNING, _T("Result %f"), res );

    Logger::logMilli( LOG_MSG, _T(" - Parse with cache - END") );

    res = 0.0;

    RPNParser rpnNoCache;

//    rpnNoCache.setVariableHash( &varH );
//    VariableDataDH vd( &varH );
//    rpn.setVariableData( &vd )


    Logger::logMilli( LOG_MSG, _T(" - Parse without cache - START") );

    for(  i = 0; i < TEST_COUNT; i++ )
    {

        DoubleHash::iterator it;

        for( it = testH.begin(); it != testH.end(); it++ )
        {
            try{
                res += rpnNoCache.calculateNoCache( it->first );
            }catch( ExpError::ExpError){

            }

        }
    }

    Logger::logf(LOG_WARNING, _T("Result %f"), res );

    Logger::logMilli( LOG_MSG, _T(" - Parse without cache - END") );

    Logger::logf(LOG_WARNING, _T("RPN parser testInfixCache(): END") );
}
