#ifndef VARIABLEDATA_H
#define VARIABLEDATA_H

class DoubleHash;
class IntSet;

#include <wx/string.h>
#include "../common/VemsMatrix.h"

class VariableData
{
    public:
        VariableData();
        virtual ~VariableData();

        virtual bool getValue( const wxString& name, double* value, IntSet* dirty = NULL ) = 0;
        virtual bool getValue( const wxString& name, VemsMatrix<double>& data ) = 0;
    protected:
    private:
};

class VariableDataDH : public VariableData
{
    public:
        VariableDataDH();
        VariableDataDH( DoubleHash* dh );
        virtual ~VariableDataDH();
        void addValue( const wxString& name, double value );
        bool getValue( const wxString& name, double* value, IntSet* dirty = NULL );
        bool getValue( const wxString& name, VemsMatrix<double>& data );
        DoubleHash* getDoubleHash();
        size_t size();
    private:
        DoubleHash* m_variables;
        bool m_isInternal;
};

#endif // VARIABLEDATA_H
