#ifndef MAPFILEPARSER_H
#define MAPFILEPARSER_H

#include "parserbase.h"
#include "../logger.h"

class MapSymbol {
    public:
        MapSymbol() { size = -1; address = -1; name = wxEmptyString; }
        MapSymbol( long int s_size, long int s_address, const wxString& s_name = _T("") ) : size(s_size), address(s_address), name(s_name) {}

    public:
        long int    size;
        long int    address;
        wxString    name;
};

WX_DECLARE_STRING_HASH_MAP( MapSymbol, MapSymbolHash );

class MapFileParser : public ParserBase
{
    public:
        MapFileParser() {}

        void parseLine();

        MapSymbolHash   getMapSymbols() const { return m_symbols; }

    private:
        MapSymbolHash   m_symbols;
};

#endif // MAPFILEPARSER_H
