#include "RpmFromFile.h"

#include "../logger.h"
#include "../Utils.h"
#include "../signalgen/AudioPanel.h"
#include "../AudioController.h"

RpmFromFile::RpmFromFile(AudioPanel* audiopanel)
:m_RpmValue (1500),m_RpmIdx(0)
{
    m_audiopanel=audiopanel;
    //ctor
      parse(_T("/tmp/test1.csv"),true);


    Logger::logf(LOG_MSG,_T("rpmfromfile constructor"));
//    double rpmvalue;
//    parseNextLine();
//    rpmvalue=GetRpmValue();
//    m_rpmSlider->SetValue(rpmvalue);
//    setRpm(rpmvalue);
//AudioPanel::setrpmslider(rpmvalue);

/**
*   it shows how to acces to rpm from here
    m_audiopanel->setRpmSlider(4000);
    AudioController* a_controller=m_audiopanel->getAudioController();
    a_controller->setRpm(4000);
*/
}

RpmFromFile::~RpmFromFile()
{
    //dtor
}

void RpmFromFile::parseLine()
{
    //Logger::logf(LOG_MSG,_T("rpmfromfile::parseLine(),%s"),m_line.GetData());

   //     ECULogItemArray * ecuLogItemArray = csvDataLogDesc.getVEMSDataLog();
    wxArrayString * columnArray = csvDataLogDesc.getVEMSDataLogHeader();
    if( m_lineNumber < 1) return;
    //The first line define the Column heeaders
    // parse theheader only once in bach parse
    if( m_lineNumber == 1 && columnArray->Count() == 0){
        Utils::tokenizeToArray(m_line,_T("\t"), *columnArray);
    }

    wxArrayString rowStrArray;
    Utils::tokenizeToArray(m_line,_T("\t"), rowStrArray);

	// header and values count do not match
	if(rowStrArray.Count() != columnArray->Count())
	{
        return;
    }
    int rpmIdx = columnArray->Index(_("rpm"));
    wxString rpmVstring = rowStrArray.Item(rpmIdx);
    double  value = -1;
    rpmVstring.ToDouble(&value);
    int rpmV = (int)value;
/*

    DoubleArray * rowArray = new DoubleArray();
    // parse strings to double
    wxString loggerstring;
    loggerstring=_T("");
    for(uint16_t i= 0; i < rowStrArray.Count(); i++){
        wxString  rowStr = rowStrArray.Item(i);
        double value = -1;
        rowStr.ToDouble(&value);
        rowArray->Add(value);
        loggerstring += rowStr +_T("\t");
    }
    //double timeV = rowArray->Item(timeIdx);
    int rpmV = rowArray->Item(rpmIdx);


    if ( m_line.StartsWith( _T("#") ) ) { return; }     //ignore comment
    //if( m_lineNumber == 0) return;

    double rpmValue;

    if (m_line.ToDouble (&rpmValue)) Logger::logf(LOG_MSG,_T("rpmfromfile::parseLine(),isnumber"));
    m_RpmArray.Add(rpmValue);


    Logger::logf(LOG_MSG,_T("rpmfromfile::parseLine(): columnarray:%s"),loggerstring.GetData());
*/
    Logger::logf(LOG_MSG,_T("rpmfromfile::parseLine(): rpmidx=%d rpm value:%d"),rpmIdx,rpmV);
    m_RpmArray.Add(rpmV);
}

double RpmFromFile::GetRpmValue()
{
    return m_RpmValue;

}

void RpmFromFile::refresh(DoubleHash* table)
{
//    Logger::logf(LOG_MSG,_T("RpmFromFile::refresh"));

    if (m_RpmIdx==m_RpmArray.GetCount()) return;// no more data
    //if (m_RpmIdx==m_RpmArray.GetCount()) m_RpmIdx=0;// restart replay

    uint16_t rpmvalue = m_RpmArray[m_RpmIdx];
    m_RpmIdx++;
    m_audiopanel->setRpmSlider(rpmvalue);
    AudioController* a_controller=m_audiopanel->getAudioController();
    a_controller->setRpm(rpmvalue);
}
