#ifndef FIRMWARE_H
#define FIRMWARE_H

#include "common/wxhashdef.h"
#include "Observable.h"
#include <wx/stream.h>

class VemsProtocol;
class FirmwareConfig;
class FirmwareConfigItemArray;
class CompareResult;

/*
enum upload{
    UPLOAD_CONFIG = 2,
    UPLOAD_TABLE = 1,
    DRY = 0
};
*/
enum process_type
{
    VERIFY,
    UPLOAD
};

enum config_type
{
    TYPE_MCD = 1,
    TYPE_MCT = 2
};
/*
enum firmware_result{
        FIRMWARE_IDENTICAL  = 0,
        FIRMWARE_DIFFERENT = 1,
        FIRMWARE_ERASE_FAILED = 2,

        FIRMWARE_CONFIG_IDENTICAL = 0,
        FIRMWARE_CONFIG_MINOR_DIFFERENT = 1,
        FIRMWARE_CONFIG_DIFFERENT = 2,

        FIRMWARE_COMMUNICATION_ERROR = -1,
        FIRMWARE_FILE_NOT_FOUND_ERROR = -1
};
*/
class Firmware : public Observable
{
    public:
        Firmware(VemsProtocol* vemsProtocol);
        virtual ~Firmware();

        int sendFile(wxString& strFile);
        StringHash* writeEcuTextFile(wxString& fileName);
        wxString getOneWireID();

        int configDownloadMgr(FirmwareConfigItemArray* configItemA);
        int configMgr(FirmwareConfig* fileConfig, bool isWrite);

        FirmwareConfig* getFirmwareConfig(FirmwareConfigItemArray* configItemA);

    protected:
        FirmwareConfig* getConfig(int type, wxOutputStream *os);
        void initBuffer();
        int loadHexFile(const wxString& file, bool isInitBuffer);
        wxString getHexFile(FirmwareConfigItemArray* configItemA); //MOVED
        wxArrayString* getPatchFiles(FirmwareConfigItemArray* configItemA);
        int flood(int count);
        int sendConfig(wxArrayString& array);
        int sendArray(wxArrayString& array);
    private:

        int getResult(int error_cnt);
        void printResult( CompareResult * cr,
                StringHash& fileConfigHash,
                StringHash& ecuConfigHash);

//        char linebuf[ LINEBUFSIZE ];
        //struct pagebuffer_t pageBuffer;
//        struct line_t hex_line;
 //       struct pagebuffer_t allPageBuffer[FLASH_PAGE_NUM];
//        IntelHex *ihex;
        VemsProtocol * vp;

//        static NTCFinder *ntcf;

        wxString CONFIG_INDEX_MSG;
};



#endif // FIRMWARE_H

