#ifndef CONFIGCRITERIA_H
#define CONFIGCRITERIA_H
#include <wx/wx.h>

#include "ConfigCriteriaRange.h"


class ConfigCriteria
{
    public:
        enum ConfigCriteriaType{
            CC_RULE_FIRST_MATCH = 0,
            CC_RULE_ALL_ERROR = 1
        };

        ConfigCriteria( const wxString& name, const wxString& errorMsg = wxEmptyString,
            const wxString& warningMsg = wxEmptyString,
            ConfigCriteria::ConfigCriteriaType type = CC_RULE_FIRST_MATCH,
            wxArrayString vars = wxArrayString() );

//        void validate( RPNParser* rpn );
        void setHtmlErrorMsg(const wxString msg);


        void addRange( ConfigCriteriaRange* range )
        {
            m_rangeArray.Add( range );
        }
        wxString getName() const { return m_name; }
        wxString getErrorMsg() const;
        wxString getWarningMsg() const { return m_warningMsg; }

        wxArrayString getVariables() const { return m_vars; }
        void addVariable( const wxString& var ) { m_vars.Add( var ); }

        ConfigCriteriaType getType() const { return m_type; }


        wxString getHtmlErrorMsg() const;

        int getRangeTypeFound() const { return m_rangeTypeFound; }
        const ConfigRangeArray& getRangeArray() const { return m_rangeArray; }

    private:
        ConfigRangeArray    m_rangeArray;
        wxString            m_name;
        wxString            m_errorMsg;
        wxString            m_htmlErrorMsg;
        wxString            m_warningMsg;
        wxArrayString       m_vars;
        int                 m_rangeTypeFound; //
        int                 m_ruleIdx;
        ConfigCriteriaType  m_type;

};

WX_DEFINE_ARRAY( ConfigCriteria*, ConfigCriteriaArray );


#endif // CONFIGCRITERIA_H
