#ifndef CONFIGREPLACERMGR_H
#define CONFIGREPLACERMGR_H

#include "../expression/RPNParser.h"
#include "../common/VemsMessageViewerBase.h"
#include "../expression/VariableData.h"

class ConfigCriteriaData;
class ConfigCriteria;
class ConfigCriteriaRange;
class SymbolTable;
class FirmwareConfigData;

class ConfigReplacerMgr
{
    public:
        ConfigReplacerMgr(ConfigCriteriaData* criteriaData);
        virtual ~ConfigReplacerMgr();
        void registerVemsMessageViewer(VemsMessageViewerBase* vemsMessageViewer);
        void replace(FirmwareConfigData& fcd, const wxArrayString& missingKeys, wxArrayString& replacedA );
    protected:
    private:
        ConfigCriteriaData* m_criteriaData;
        RPNParser m_rpn;
        VemsMessageViewerBaseArray m_viewerA;

        void setVariableData(VariableDataDH& vd, SymbolTable& variableHash);
        void show(const VemsMessage& vemsMsg);


};

#endif // CONFIGREPLACERMGR_H
