#include "ConfigSaverDialog.h"

#include "ConfigSaver.h"
#include "../DirHelper.h"
#include "../logger.h"

#include "../bcWidgets/bcCarrierPanel.h"
#include "../bcWidgets/bcProgressBar.h"
//#include "../bcWidgets/bcWrapper.h"


ConfigSaverDialog::ConfigSaverDialog(wxWindow* parent, ConfigSaver* cfg_saver)

{
    //ctor
    wxString title = _T("Download config in progress!");
    Create(parent,wxID_ANY, title);


    m_msg = _T("Line: ");

    m_configSaver = cfg_saver;

    wxBoxSizer* mainsizer = new wxBoxSizer(wxVERTICAL);

    m_msgText = new wxStaticText(this, wxID_ANY, m_msg);

    mainsizer->Add(m_msgText,0, wxALL,10);

//    wxAnimation anim;
//    anim.LoadFile( DirHelper::GetPath( dGRAPHICS ) + _T("progress2.gif"), wxANIMATION_TYPE_GIF );
//    m_anim = new wxAnimationCtrl( this, wxID_ANY, anim, wxDefaultPosition, wxSize( 200, 30 ) );
//    mainsizer->Add(m_anim, 0, wxALL | wxEXPAND, 5);

    bcCarrierPanel* panel = new bcCarrierPanel(this);
    m_bar = new bcProgressBar(panel);
    m_bar->SetStyle(BCPBS_INFINITY);

    mainsizer->Add( panel, 0, wxALL | wxEXPAND, 5);

    SetSizer(mainsizer);
    mainsizer->SetSizeHints(this);

    Connect(wxEVT_COMMAND_ENTER,wxCommandEventHandler(ConfigSaverDialog::OnCommand));

    m_configSaver->SetEventHandler(this);
    SetSize( 300, 100 );
}

void ConfigSaverDialog::OnCommand(wxCommandEvent& evt)
{
    int line = evt.GetInt();

    if(line == -1) EndModal(wxOK);

    m_msgText->SetLabel( m_msg + wxString::Format(_T("%i"), line ) );
}

void ConfigSaverDialog::Start()
{
//    wxSafeYield(this);

    m_configSaver->start();

    //m_anim->Play();
    m_bar->StartAnim();

    ShowModal();
}

ConfigSaverDialog::~ConfigSaverDialog()
{
    //dtor
    m_configSaver->SetEventHandler(NULL);
}
