#ifndef FWCONFIGUPLOADDIALOG_H
#define FWCONFIGUPLOADDIALOG_H


#include "../vemsprotocol/CommunicationClientBase.h"
#include "../common/types/StringSet.h"


class FWConfigUploadManager;
class VemsTuneController;
class ObserverBase;
class SIPRPacket;
class bcProgressDialog;


class FWConfigUploadDialog : public CommunicationClientBase
{
    public:
                                FWConfigUploadDialog(   wxWindow* parent,
                                                        CommunicationDispatcher* dispatcher,
                                                        VemsTuneController* vemsController,
                                                        ObserverBase* observer );
                                ~FWConfigUploadDialog();

        void                    uploadConfigFile( const wxString& filename );
        void                    easyUploadConfig();
        //int                     process( const SIPRPacket& packet );
        void                    uploadConfigFromProject();
        void                    verifyConfigFromProject();

        void                    verifyConfigFromFile();
        void                    filteredConfigUpload();

        // CommunicationClientBase virtual
        void                    process();
        void                    OnSIPR( InputEvent& event );

        wxString                getUploadedConfigFileName() { return m_cfgfilename; }

        // config = -1 unknown, 0 ConfigA, 1 ConfigB
        void                    setCurrentConfigType( int config ) { m_currentConfigType = config; }
        void                    setUploadConfigType( int config ) { m_uploadConfigType = config; }

    private:
        FWConfigUploadManager*  m_pUploadManager;
//        wxProgressDialog*       m_pProgressDialog;
        bcProgressDialog*       m_pProgressDialog;
        VemsTuneController*     m_vemsController;
        ObserverBase*           m_observer;
        wxWindow*               m_parent;
        int                     m_iLineCount;
        bool                    m_bIsFilteredUpload;
        wxString                m_cfgfilename;
        int                     m_currentConfigType;
        int                     m_uploadConfigType;

    private:
        void                    uploadConfig( const wxArrayString& configFiles );

        void                    verifyConfig( bool selectManMode = true );
        void                    showFirmwareConfigResult( int result );
        void                    reset();
        bool                    openConfigFile(wxString& configFile );
        void                    parseConfigFilterFile( const wxString& name, StringSet& keys );
        bool                    checkHeaderFile();

};


#endif // FWCONFIGUPLOADDIALOG_H
