#ifndef FIRMWARECONFIGMGR_H
#define FIRMWARECONFIGMGR_H

#include "../firmwareconfig.h"
#include "../evaluation.h"
#include "../expression/RPNParser.h"

class ConfigReplace
{
          public:
          ConfigReplace(const wxString& oldKey, const wxString& newKey, const wxString& exp)
          {
                m_oldKey = oldKey;
                m_newKey = newKey;
                m_exp = exp;
          }
          wxString m_oldKey;
          wxString m_newKey;
          wxString m_exp;
};

WX_DEFINE_ARRAY(ConfigReplace *, ConfigReplaceArray);


class FirmwareConfigMgr
{
    public:
        FirmwareConfigMgr();
        virtual ~FirmwareConfigMgr();
        void validate(FirmwareConfig* fwConfig);
        void replace(FirmwareConfig* fwConfig);
        wxString getResultAsString();
        bool isFound();

        //void AddCriteria(const wxString &CriteriaKey, ConfigCriteria* ConfigCriteriaValue);

    protected:
    private:
        //ConfigCriteriaHash configCriteriaHash;
        wxArrayString m_criteriaOrder;
        //wxArrayString configArray;
         //Evaluation      m_eval;
         RPNParser  m_rpn;
         FirmwareConfig* m_fwConfig;
         ConfigReplaceArray m_configReplaceA;
         bool m_isFound;

};



#endif // FIRMWARECONFIGMGR_H
