#ifndef GAUGEPROPERTIES_H
#define GAUGEPROPERTIES_H

#include <wx/wx.h>
#include "../common/types/wxVariantHash.h"

class GaugeProperties
{
    public:
        GaugeProperties();
        virtual ~GaugeProperties();

        int         itemID;
        int         winID;

        long        x;
        long        y;
        long        width;
        long        height;

        wxString    symbolName;
        wxString    descName;
        int         gaugeType;

        wxString    groupName;
        int         groupID;
        wxString    themeName;
        wxString    groupHotkey;

        wxPoint getPos() { return wxPoint(x,y); };
        wxSize getSize() { return wxSize(width,height); };
        wxRect getRect() { return wxRect(x,y,width,height); };

        void setPos(int xp, int yp){
            x = xp;
            y = yp;
        }

        void setPos(const wxPoint &pos){
            x = pos.x;
            y = pos.y; };

        void setSize(const wxSize &size){
            width = size.x;
            height = size.y; };

        void setSize(int w, int h){
            width = w;
            height = h;
        }



        wxVariantHash   extraParams;


};

extern GaugeProperties DefaultGaugeProperties;

WX_DECLARE_OBJARRAY( GaugeProperties, GaugePropertiesArray );

#endif // GAUGEPROPERTIES_H
