#ifndef MULTIGRAPHDESC_H
#define MULTIGRAPHDESC_H

#include <wx/wx.h>
#include "../common/types/IntArray.h"
#include "../common/types/wxVariantHashArray.h"

class MultiGraphDescNode;

WX_DECLARE_OBJARRAY( MultiGraphDescNode, MultiGraphDescNodeArray );

class MultiGraphDesc
{
    public:
        MultiGraphDesc() { m_itemID = 0; IsChanged = false; };
        MultiGraphDesc(MultiGraphDesc& m);

        void Set(MultiGraphDesc* m);

        wxString GetFirstSymbol();
        wxString GetLastSymbol();

        void GetSymbolNameList(wxArrayString &arr);

        void AddRemovedSymbolID(int id) { m_removedSymbolIDs.Add(id); };
        void AddRemovedNodeID(int id) { m_removedNodeIDs.Add(id); };;
        IntArray& GetRemovedSymbols() { return m_removedSymbolIDs; };
        IntArray& GetRemovedNodes() { return m_removedNodeIDs; };
        long GetNewItemID();

        //wxVariantHash           Settings;
        MultiGraphDescNodeArray Cells;

        int         ProfileID;
        wxString    Title;
        bool        IsChanged;

        wxVariantHash* FindBy(const wxVariant& value, const wxString& fieldname = _T("name"), const wxVariant& except_value = wxNullVariant, const wxString& except_fieldname = wxEmptyString);

    private:

        IntArray    m_removedSymbolIDs;
        IntArray    m_removedNodeIDs;

        int         m_itemID;
};

WX_DECLARE_HASH_MAP( int, MultiGraphDesc*, wxIntegerHash, wxIntegerEqual, MultiGraphDescHash);

class MultiGraphDescNode
{
    public:
        MultiGraphDescNode() {};
        wxVariantHash       Properties;
        wxVariantHashArray  Symbols;

};





#endif // MULTIGRAPHDESC_H
