#ifndef GAUGEVALUESELECTOR_H
#define GAUGEVALUESELECTOR_H

#include <wx/wxprec.h>

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#include <wx/button.h>
#include <wx/frame.h>
#include <wx/listbox.h>
#include <wx/sizer.h>

class RTDataViewerBase;

class GaugeValueSelector: public wxFrame
{
	public:

		GaugeValueSelector(wxWindow* parent,wxWindowID id = -1);
		virtual ~GaugeValueSelector();

		static const long ID_LISTBOX1;
		static const long ID_BUTTON1;
		static const long ID_BUTTON2;

        wxBoxSizer* BoxSizer1;
		wxListBox* ListBox1;
		wxBoxSizer* BoxSizer2;
		wxButton* Button1;
		wxButton* Button2;
        void SetRTDataViewer(RTDataViewerBase* rtdV);
        void Clear();
        void AddItems(wxArrayString choices);
        void ResizeAndShow(bool show);

	protected:

        void OnButtonOK(wxCommandEvent& WXUNUSED(event));
        void OnButtonCN(wxCommandEvent& WXUNUSED(event));
        void OnListBoxClick(wxCommandEvent& WXUNUSED(event));



	private:
        RTDataViewerBase * m_RTDataViewerBase;
		DECLARE_EVENT_TABLE()
};

#endif
