#include "ExpressionParserHelper.h"
#include "../../logger.h"

bool VariableList::exist( const char* name )
{
    wxString str = wxString::From8BitData( name );
    return exist( str );
}

bool VariableList::exist( const wxString& name )
{
    wxString n  = name;
    trim( n );

    DoubleHash::iterator it = vars.find( n );

    if ( it == vars.end() )
        return false;
    else
        return true;
}

bool VariableList::add( const char* name, double value )
{
    wxString str = wxString::From8BitData( name );

    add( str, value );

    return true;
}

bool VariableList::add( const wxString& name, double value )
{
    wxString n  = name;
    trim( n );

    vars[n] = value;

    return true;
}

bool VariableList::del( const char* name )
{
    wxString str = wxString::From8BitData( name );

    return del( str );
}

bool VariableList::del( const wxString& name )
{
    wxString n  = name;
    trim( n );

    if ( vars.erase( n ) == 1 )
        return true;
    else
        return false;
}

bool VariableList::get_value( const char* name, double* value )
{
    wxString str = wxString::From8BitData( name );

    return get_value( str, value );
}

bool VariableList::get_value( const wxString& name, double* value )
{
    wxString n  = name;
    trim( n );

    DoubleHash::iterator it = vars.find( n );

    if ( it == vars.end() )
        return false;

    *value = it->second;

    return true;
}

bool VariableList::set_value( const char* name, const double value )
{
    return add( name, value );
}

bool VariableList::set_value( const wxString& name, const double value )
{
    wxString n  = name;
    trim( n );

    vars[n] = value;

    return true;
}

void VariableList::trim( wxString& str )
{
    str.Trim( true );
    str.Trim( false );
}
