#ifndef EXPRESSIONPARSERHELPER_H
#define EXPRESSIONPARSERHELPER_H

#define EXPR_LEN_MAX    1024
#define NAME_LEN_MAX    256

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <vector>

#include "../../common/types/DoubleHash.h"

class VariableList {
    public:
        bool    exist( const char* name );
        bool    exist( const wxString& name );

        bool    add( const char* name, double value );
        bool    add( const wxString& name, double value );

        bool    del( const char* name );
        bool    del( const wxString& name );

        bool    get_value( const char* name, double* value );
        bool    get_value( const wxString& name, double* value );

        bool    set_value( const char* name, const double value );
        bool    set_value( const wxString& name, const double value );

    private:
        DoubleHash  vars;

        void    trim( wxString& str );
};

#endif // EXPRESSIONPARSERHELPER_H
