#ifndef GPSCOMMUNICATIONEVENT_H
#define GPSCOMMUNICATIONEVENT_H

#include <wx/event.h>
#include "../GPSNMEA/NMEAParse.h"

extern const wxEventType wxEVT_GPS_COMMEVT;

#define EVT_GPS_COMMEVT(func) wx__DECLARE_EVT0(wxEVT_GPS_COMMEVT, GPSCommunicationEventHandler(func))

class GPSCommunicationEvent : public wxEvent
{
    public:
        GPSCommunicationEvent( int id = 0 );
        virtual wxEvent *Clone() const { return new GPSCommunicationEvent(*this); }

    public:
        enum GPSState { INVALID_PORT, INVALID_BAUDRATE, CANNOT_OPEN_PORT, NOT_FOUND, GPS_FOUND } state;
        enum SearchState { SEARCH_START, SEARCH_END, SEARCH_ABORTED } searchstate;

        GPSDataStruct   gpsdata;

        wxString        portName;
        int             baudRate;

        bool            isSearching;
        bool            isTesting;

        wxVariant       userdata;

    private:
        DECLARE_DYNAMIC_CLASS( GPSCommunicationEvent )
};

typedef void (wxEvtHandler::*GPSCommunicationEventFunction)(GPSCommunicationEvent&);

#define GPSCommunicationEventHandler(func) \
    (wxObjectEventFunction)(wxEventFunction)wxStaticCastEvent( GPSCommunicationEventFunction, &func )


#endif // GPSCOMMUNICATIONEVENT_H
