#ifndef GPSDETECTORCLIENT_H
#define GPSDETECTORCLIENT_H

#include <wx/wx.h>
#include "../communication/CommunicationControllerClient.h"

class GPSDetectorClient : public CommunicationControllerClient
{
    public:
        GPSDetectorClient( wxEvtHandler* evtHandler = NULL );

        virtual ~GPSDetectorClient();

        void    write( uint8_t* buffer, int& size );
        void    read( uint8_t* buffer, int size );
        void    finish();

        bool    isFinished();

    private:
        unsigned int        m_timeOutCounter;

        const int           m_maxBufferSize;

        const unsigned int  m_maxTimeOut;

        int                 m_bufferSize;

        enum State          { CHAR_IN, TIME_OUT, BUFFER_FULL };

        State               m_state;
        unsigned char*      m_buffer;
        wxEvtHandler*       m_evtHandler;

        wxStopWatch         m_sp;

    private:
        void        readChar( uint8_t* buffer, int size );
};

#endif // GPSDETECTORCLIENT_H
