#ifndef CONFIGSWITCHUPLOADDIALOG_H
#define CONFIGSWITCHUPLOADDIALOG_H


#include <wx/wx.h>

class FWConfigUploadDialog;

class ConfigSwitchUploadDialog : public wxDialog
{
    public:
        enum {  ID_OPEN_CONFIG_A,
                ID_OPEN_CONFIG_B,
                ID_UPLOAD,
                ID_CONFIG_A,
                ID_CONFIG_B,
                ID_RADIO_SAME,
                ID_RADIO_B };

    public:
        ConfigSwitchUploadDialog(  wxWindow* parent,
                            wxWindowID id,
                            const wxString& title,
                            const wxPoint& pos = wxDefaultPosition,
                            const wxSize& size = wxDefaultSize,
                            long style = wxDEFAULT_DIALOG_STYLE,
                            const wxString& name = _T("dialogBox") );

        virtual ~ConfigSwitchUploadDialog() {}

        void setUploadDialog( FWConfigUploadDialog* dialog ) { m_uploadDialog = dialog; }

    private:
        FWConfigUploadDialog*   m_uploadDialog;

        void OnOpenConfigA( wxCommandEvent& event );
        void OnOpenConfigB( wxCommandEvent& event );
        void OnSelectConfigB( wxCommandEvent& event );
        void OnUpload( wxCommandEvent& event );

        DECLARE_EVENT_TABLE()
};


#endif // CONFIGSWITCHUPLOADDIALOG_H
