#ifndef DEVICECONTROLLERPROGRESSBARMANAGER_H
#define DEVICECONTROLLERPROGRESSBARMANAGER_H


//#include "wx/progdlg.h"
#include <wx/timer.h>


class VemsDeviceControllerEvent;
class CommunicationEvent;
class bcProgressDialog;

class DeviceControllerProgressBarManager : public wxEvtHandler
{
    public:
        DeviceControllerProgressBarManager( wxWindow* parent );

        virtual ~DeviceControllerProgressBarManager();

    private:
        bcProgressDialog*       m_progressDialog;
        wxWindow*               m_parent;

        wxTimer                 m_timer;
        size_t                  m_pulseTime;

    private:
        void createProgressDialog( const wxString& title, const wxString& message );
        void destroyProgressDialog();

        void onDeviceControllerEvent( VemsDeviceControllerEvent& event );
        void onCommunicationEvent( CommunicationEvent& event );
        void onPulse( wxTimerEvent& event );
};


#endif // DEVICECONTROLLERPROGRESSBARMANAGER_H
