#ifndef ERRORREPORTDIALOG_H
#define ERRORREPORTDIALOG_H

#include <wx/wx.h>
#include "../bcWidgets/events/bcLinkEvent.h"
#include "../common/types/wxVariantHash.h"


class bcLabel;
class bcProgressBar;

class ErrorReportDialog: public wxDialog
{
    public:
        ErrorReportDialog(wxWindow* parent);
        virtual ~ErrorReportDialog();

        void SetInfo(const wxString& key, const wxVariant& data);

    protected:

        void BuildGUI();

        void OnButton(wxCommandEvent& evt);
        void OnOtherToggle(bcLinkEvent& evt);

    private:

        enum Ids {
            idButtonCreateReportPack,
            idButtonOFControlBrowse,
            idButtonOFControlRemove,
            idButtonOFControlClear,
            idOtherToggle
        };

        bcLabel*        m_fbLabel;
        wxListBox*      m_otherFilesList;
        wxBoxSizer*     m_otherFilesSizer;
        bcProgressBar*  m_progressBar;
        wxTextCtrl*     m_message;


        wxVariantHash   m_info;

        DECLARE_EVENT_TABLE();

};

#endif // ERRORREPORTDIALOG_H
