#ifndef FIRMWAREUPLOADDIALOG_H
#define FIRMWAREUPLOADDIALOG_H


#include "wx/progdlg.h"


class VemsDeviceControllerBase;
class FirmwareData;
class VemsDeviceControllerEvent;
class FirmwareUploadEvent;


class FirmwareUploadDialog : public wxProgressDialog
{
    DECLARE_DYNAMIC_CLASS( FirmwareUploadDialog )

    public:
        FirmwareUploadDialog(   wxWindow* parent,
                                VemsDeviceControllerBase* deviceController,
                                FirmwareData* firmwareData );

        virtual ~FirmwareUploadDialog();

    private:
        VemsDeviceControllerBase*   m_deviceController;
        wxString                    m_message;
        size_t                      m_pagesCount;

    private:
        /// VemsDeviceControllerEvent handlers
        void onDeviceDisconnected( VemsDeviceControllerEvent& event );

        /// FirmwareUploadEvent handlers
        void onFirmwareUploadingStarted( FirmwareUploadEvent& event );
        void onFirmwarePagesErasingSucceeded( FirmwareUploadEvent& event );
        void onFirmwareUploadingPagesStarted( FirmwareUploadEvent& event );
        void onFirmwarePageUploaded( FirmwareUploadEvent& event );
        void onFirmwareUploadingSucceeded( FirmwareUploadEvent& event );
        void onFirmwareUploadingFailed( FirmwareUploadEvent& event );

        void onClose( wxCloseEvent& event );
};

#endif // FIRMWAREUPLOADDIALOG_H
