#ifndef IGNITIONOUTPUTPANEL_H
#define IGNITIONOUTPUTPANEL_H

#include "../Symbol.h"

#include "../common/types/IntArray.h"
#include "../common/types/String2IntHash.h"
#include "../common/types/Int2StringHash.h"
#include "../vemsdialog/EconosealPanel.h"
#include "../vemsdialog/StaticViewersController.h"
#include "../vemsdialog/StaticControlPanel.h"

#include "../stdatamanager/STDataViewerBase.h"

class STDataMgrBase;
class SymbolTable;
class CommandRequestBase;

class IgnitionOutputPanel : public wxPanel, public STDataViewerBase
{
    public:
        IgnitionOutputPanel(wxWindow * parent, STDataMgrBase * stdata_mgr, SymbolTable * symbols,
            CommandRequestBase* requestMgr, wxArrayString& symbolsToMark );
        virtual ~IgnitionOutputPanel();

        StaticViewersController*  getController() { return m_statvcontroller; }
    protected:
    private:
        wxArrayString               m_symbolsToMark;

        SymbolTable *               m_symboltable;
        CommandRequestBase*         m_requestMgr;
        EconosealPanel*             m_p36;
        EconosealPanel*             m_p18;
        StaticViewersController *   m_statvcontroller;
        StaticControlPanel *        m_statcpanel;

        IntArray                    m_radioIds;
        IntArray                    m_comboIds;
        IntArray                    m_testIds;

        IntArray                    m_hexIds;
        wxTextCtrl*                 m_hexIdTxt[8];

        wxComboBox*                 m_dualMode;
        wxComboBox*                 m_outputNum;
        wxComboBox*                 m_outputCombo[8];
        wxComboBox*                 m_testingMode;

        wxRadioButton*              m_showPins[8];
        wxButton*                   m_testButtons[8];

        wxArrayString               m_validSymbols;
        String2IntHash              m_out2channel;
        Int2StringHash              m_channel2str;

        wxArrayString               m_idStrArray;

        wxBoxSizer*                 m_mainsizer;

        wxStaticBitmap*             m_conflictBMP[8];
        wxBitmap*                   m_warningbmp;


        void        buildGUI(wxWindow* parent);
        void        getValidSymbols();
        void        setCombos();
        void        showPins(int id);

        void        update();

        void        requestRead() {}
        void        updateModel();
        void        requestWrite();

        /// event handlers
        void        OnDualMode( wxCommandEvent& event );
        void        OnOutputNum( wxCommandEvent& event );
        void        OnOutputCombo( wxCommandEvent& event );
        void        OnRadio( wxCommandEvent& event );
        void        OnTestingMode( wxCommandEvent& event );

        void        OnTestButton( wxCommandEvent& event );
        void        OnClose( wxCloseEvent & event );

        DECLARE_EVENT_TABLE()

};

#endif // IGNITIONOUTPUTPANEL_H
