#include "helper.h"


#include <wx/filename.h>


wxString Helper::ChooseDirectory(wxWindow* parent,
                                 const wxString& message,
                                 const wxString& initialPath,
                                 const wxString& basePath,
                                 bool askToMakeRelative, // relative to initialPath
                                 bool showCreateDirButton) // where supported
{
    wxDirDialog dlg(parent,
                    message,
                    _T(""),
                    (showCreateDirButton ? wxDD_NEW_DIR_BUTTON : 0) | wxRESIZE_BORDER);
    dlg.SetPath(initialPath);
//    PlaceWindow(&dlg);
    if (dlg.ShowModal() != wxID_OK)
        return wxEmptyString;

    wxFileName path(dlg.GetPath());
    if (askToMakeRelative && !basePath.IsEmpty())
    {
        // ask the user if he wants it to be kept as relative
        if (V3MessageBox(_("Keep this as a relative path?"),
                         _("Question"),
                         wxICON_QUESTION | wxYES_NO) == wxID_YES)
        {
            path.MakeRelativeTo(basePath);
        }
    }
    return path.GetFullPath() + wxFileName::GetPathSeparator();//(wxPATH_GET_VOLUME | wxPATH_GET_SEPARATOR);
}

int Helper::V3MessageBox(const wxString& message, const wxString& caption, int style, wxWindow *parent, int x, int y)
{
    wxMessageDialog dlg(parent, message, caption, style, wxPoint(x,y));
//    PlaceWindow(&dlg);
    return dlg.ShowModal();
};
