!include "registerExtension.nsh"
!include FontRegAdv.nsh
!include FontName.nsh

; example2.nsi
;
; This script is based on example1.nsi, but it remember the directory, 
; has uninstall support and (optionally) installs start menu shortcuts.
;
; It will install example2.nsi into a directory that the user selects,

;--------------------------------

; The name of the installer
Name "VemsTune"

; The file to write
!define /date MyTIMESTAMP "%Y-%m-%d"
OutFile "VemsTune-Install-${MyTIMESTAMP}.exe"

; The default installation directory
InstallDir $PROGRAMFILES\VemsTune

; Registry key to check for directory (so if you install again, it will 
; overwrite the old one automatically)
!define MY_APPLICATION_NAME "VemsTune"
InstallDirRegKey HKLM "Software\${MY_APPLICATION_NAME}" "Install_Dir"

; Request application privileges for Windows Vista
RequestExecutionLevel admin

;--------------------------------

; Pages

Page components
Page directory
Page instfiles

UninstPage uninstConfirm
UninstPage instfiles

;--------------------------------

; The stuff to install
Section "${MY_APPLICATION_NAME} (required)"

  SectionIn RO
  
  ; Set output path to the installation directory.
  SetOutPath $INSTDIR
  
  ; Put exe
  File "..\vemsTune-c.exe"
  File "..\vemsTune.exe"
  File "..\VemsLogger.exe"
  
  ;Put dlls
  File "..\dll\*.*"
  
  
  SetOutPath $INSTDIR\fonts
  File /x ".svn"  "..\fonts\*.*"
  
  SetOutPath $INSTDIR\3rdparty
  File "..\3rdparty\*.*"
  
  SetOutPath $INSTDIR\defaultfirmwareconfigs
  File "..\defaultfirmwareconfigs\*.*"
  
  SetOutPath $INSTDIR\coolantfactor
  File "..\coolantfactor\*.*"

  SetOutPath $INSTDIR\matfactor
  File "..\matfactor\*.*"
  
  ;Put config files
;  SetOutPath $INSTDIR\config
;  File /x "*.bak" /x "workingdirs.db" "..\config\*.*"
  
  SetOutPath $INSTDIR\config
  File /x ".svn"  /x "*.bak" /x "dialogLayout.db" "..\config-svn\*.*"
  # Make the directory "$INSTDIR\database" read write accessible by all users
  AccessControl::GrantOnFile \
    "$INSTDIR\config" "(BU)" "GenericRead + GenericWrite"

  
  SetOutPath $INSTDIR\config\include
  File /x ".svn"  /x "*.bak" "..\config-svn\include\*.ini"
  AccessControl::GrantOnFile \
    "$INSTDIR\config\include" "(BU)" "GenericRead + GenericWrite"
  
  SetOutPath $INSTDIR\config\hotkeys
  File /x ".svn"  "..\config-svn\hotkeys\*.*"
  
  SetOutPath $INSTDIR\config\defaultstatements
  File /x ".svn" "..\config-svn\defaultstatements\*.*"
  
  
   ;Put configlets files
  SetOutPath $INSTDIR\configlets
  File /r /x ".svn" "..\configlets\*.*"
  
  SetOutPath $INSTDIR\configfilters
  File "..\configfilters\*.*"
  
  ;Put icons
  SetOutPath $INSTDIR\graphics
  File /r /x ".svn" "..\graphics\*.*"
  
  ;Put some logs
  SetOutPath $INSTDIR\logs
  ;File "..\logs\rawECUlog-2008.02.14-09.25.19.vemslog"
  # Make the directory "$INSTDIR\database" read write accessible by all users
  AccessControl::GrantOnFile \
    "$INSTDIR\logs" "(BU)" "GenericRead + GenericWrite"

  SetOutPath $INSTDIR\webcache
  # Make the directory "$INSTDIR\database" read write accessible by all users
  AccessControl::GrantOnFile \
    "$INSTDIR\webcache" "(BU)" "GenericRead + GenericWrite"

  
  SetOutPath $INSTDIR\webcache\fw
  # Make the directory "$INSTDIR\database" read write accessible by all users
  AccessControl::GrantOnFile \
    "$INSTDIR\webcache\fw" "(BU)" "GenericRead + GenericWrite"

  
  

 
   ;Help
  SetOutPath $INSTDIR\help
  File /r /x ".svn" "..\help\*.htm"
  File /r /x ".svn" "..\help\*.html"
  File /r /x ".svn" "..\help\*.hhc"
  File /r /x ".svn" "..\help\*.hhk"
  File /r /x ".svn" "..\help\*.chm"
  File /r /x ".svn" "..\help\*.hhp"
  File /r /x ".svn" "..\help\*.png"
  File /r /x ".svn" "..\help\*.jpg"

  
  SetOutPath $INSTDIR\help2
  File /r /x ".svn" "..\help2\"
  
;  SetOutPath $INSTDIR\help\images
;  File /r "..\help\images\*.png"
;  File /r "..\help\images\*.jpg"
    

;-------------
; Put Firmwares

  SetOutPath $INSTDIR\vemsprojects
  File /r /x ".svn" /x "configexamples" /x "round" /x bin /x doc /x etc /x inc "..\vemsprojects\*.h"
  File /r /x ".svn" /x "configexamples" /x "round" /x bin /x doc /x etc /x inc  "..\vemsprojects\*.hex"
  File /r /x ".svn" /x "configexamples" /x "round" /x bin /x doc /x etc /x inc  "..\vemsprojects\*.chex"
  File /nonfatal /r /x ".svn" /x "configexamples" /x "round" /x bin /x doc /x etc /x inc  "..\vemsprojects\*.vemsprj"
  File /nonfatal /r /x ".svn" /x "configexamples" /x "round" /x bin /x doc /x etc /x inc  "..\vemsprojects\config-audi"
  File /nonfatal /r /x ".svn" /x "configexamples" /x "round" /x bin /x doc /x etc /x inc  "..\vemsprojects\config-audi\*.txt"

  SetOutPath $INSTDIR\vemsprojects\configexamples
  File /nonfatal /r /x ".svn" "..\vemsprojects\configexamples\*.vemscfg"

  # Make the directory "$INSTDIR\database" read write accessible by all users
  AccessControl::GrantOnFile \
    "$INSTDIR\vemsprojects" "(BU)" "GenericRead + GenericWrite"
;-------------
  
  
  ;Put FastExplorer shell extension
  SetOutPath $INSTDIR\shell
  File "shell\*.*"
  
  SetOutPath $INSTDIR
  
  ; Write the installation path into the registry
  WriteRegStr HKLM SOFTWARE\${MY_APPLICATION_NAME} "Install_Dir" "$INSTDIR"
  
  ; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${MY_APPLICATION_NAME}" "DisplayName" "${MY_APPLICATION_NAME}"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${MY_APPLICATION_NAME}" "UninstallString" '"$INSTDIR\uninstall.exe"'
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${MY_APPLICATION_NAME}" "NoModify" 1
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${MY_APPLICATION_NAME}" "NoRepair" 1
  WriteUninstaller "uninstall.exe"
  
  ;set exe location in fastexplorer ini
  ;.vemslog Convert to xls
  WriteINIStr $INSTDIR\shell\FastExplorer.ini "Dynamic Items" "Application1" "$INSTDIR\vemsTune.exe"
  WriteINIStr $INSTDIR\shell\FastExplorer.ini "Dynamic Items" "IconFile1" "$INSTDIR\vemsTune.exe"
  
  ;.vemslog Play with vemstune
  WriteINIStr $INSTDIR\shell\FastExplorer.ini "Dynamic Items" "Application2" "$INSTDIR\vemsTune.exe"
  WriteINIStr $INSTDIR\shell\FastExplorer.ini "Dynamic Items" "IconFile2" "$INSTDIR\vemsTune.exe"
  
  ;.hex VemsTune project setup
  WriteINIStr $INSTDIR\shell\FastExplorer.ini "Dynamic Items" "Application3" "$INSTDIR\vemsTune.exe"
  WriteINIStr $INSTDIR\shell\FastExplorer.ini "Dynamic Items" "IconFile3" "$INSTDIR\vemsTune.exe"
  
  ;vemsprj  VemsTune quick upload
  WriteINIStr $INSTDIR\shell\FastExplorer.ini "Dynamic Items" "Application4" "$INSTDIR\vemsTune.exe"
  WriteINIStr $INSTDIR\shell\FastExplorer.ini "Dynamic Items" "IconFile4" "$INSTDIR\vemsTune.exe"  

  ;vemsprj  VemsTune quick firmware upload
  WriteINIStr $INSTDIR\shell\FastExplorer.ini "Dynamic Items" "Application5" "$INSTDIR\vemsTune.exe"
  WriteINIStr $INSTDIR\shell\FastExplorer.ini "Dynamic Items" "IconFile5" "$INSTDIR\vemsTune.exe"  

  ;vemsprj  VemsTune quick config upload
  WriteINIStr $INSTDIR\shell\FastExplorer.ini "Dynamic Items" "Application6" "$INSTDIR\vemsTune.exe"
  WriteINIStr $INSTDIR\shell\FastExplorer.ini "Dynamic Items" "IconFile6" "$INSTDIR\vemsTune.exe"  

  ;register extension
  ${registerExtension} "$INSTDIR\vemsTune.exe" ".vemslog" "VEMSLOG File" 
  ${registerExtension} "$INSTDIR\vemsTune.exe" ".hex" "HEX File"   
  ${registerExtension} "$INSTDIR\vemsTune.exe" ".chex" "CHEX File"
  ${registerExtension} "$INSTDIR\vemsTune.exe" ".vemsprj" "VEMS Project File"
  
  
  StrCpy $FONT_DIR $FONTS
  !insertmacro InstallTTF "..\fonts\VisitorTT2-BRK-.ttf"
  
  ;register fast explorer
  ExecWait 'regsvr32 /s "$INSTDIR\shell\FEShlExt.dll"'
  ;RegDLL $INSTDIR\shell\FEShlExt.dll
  
SectionEnd

; Optional section (can be disabled by the user)
Section "Start Menu Shortcuts"

  CreateDirectory "$SMPROGRAMS\${MY_APPLICATION_NAME}"
  CreateShortCut "$SMPROGRAMS\${MY_APPLICATION_NAME}\${MY_APPLICATION_NAME}.lnk" "$INSTDIR\vemsTune.exe" "" "$INSTDIR\vemsTune.exe" 0
  CreateShortCut "$SMPROGRAMS\${MY_APPLICATION_NAME}\Uninstall.lnk" "$INSTDIR\uninstall.exe" "" "$INSTDIR\uninstall.exe" 0
 
SectionEnd

;Optional section 
Section "Desktop shortcut"
  CreateShortCut "$DESKTOP\${MY_APPLICATION_NAME}.lnk" "$INSTDIR\${MY_APPLICATION_NAME}.exe" "" "$INSTDIR\${MY_APPLICATION_NAME}.exe" 1
SectionEnd

;--------------------------------

; Uninstaller

Section "Uninstall"
  
  ; Remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${MY_APPLICATION_NAME}"
  DeleteRegKey HKLM SOFTWARE\${MY_APPLICATION_NAME}
  
  ;unregister extension
  ${unregisterExtension} ".vemslog" "VEMSLOG File"
  ${unregisterExtension} ".hex" "HEX File"   
  ${unregisterExtension} ".chex" "CHEX File"   
  ${unregisterExtension} ".vemsprj" "VEMS Project File"  

  ;Unregister FastExplorer's dll
  ;UnRegDLL $INSTDIR\shell\FEShlExt.dll
  ExecWait 'regsvr32 /u /s "$INSTDIR\shell\FEShlExt.dll"'

  ; Remove files and uninstaller
  Delete $INSTDIR\vemsTune.exe
  Delete $INSTDIR\vemsTune-c.exe
  Delete $INSTDIR\uninstall.exe

  ; Remove shortcuts, if any
  Delete "$SMPROGRAMS\${MY_APPLICATION_NAME}\*.*"
  
  ;Remove desktop shortcut
  Delete "$DESKTOP\${MY_APPLICATION_NAME}.lnk"

  ; Remove directories used
  RMDir "$SMPROGRAMS\${MY_APPLICATION_NAME}"
  
  RMDir  /r $INSTDIR\config
  RMDir  /r $INSTDIR\graphics
  RMDir  /r $INSTDIR\shell
  RMDir  /r $INSTDIR\coolantfactor
  RMDir  /r $INSTDIR\matfactor
  Delete $INSTDIR\*.*
  ;RMDir  /r $INSTDIR

SectionEnd