#ifndef LOGGER_H
#define LOGGER_H

#include <wx/string.h>

class wxLog;

enum logType
{
	LOG_MSG,
	LOG_WARNING,
	LOG_ERROR,
};


class Logger
{
    public:
		static void initLog( const wxString& targetFileFullPath = wxEmptyString );
		static void cleanup();

		static void setTextColor( const wxColor& color );
		static void log(logType type, const wxString& str);
        static void logf(logType type, const wxChar *szFormat, ...);
        static void logC(logType type, char* buff);
        static void logMilli(logType type, const wxString& str);

    private:
		static wxLog*	fileLogTarget;
		static void     saveConsoleAttrib();
		static void     setTextAttrib( unsigned int attrib );

		static unsigned int m_attrib;

		Logger() {}
		virtual ~Logger() {}
};

#if(_MSC_VER >= 1400) //  1400 = VS2005 1500 = VS2008
#define LOG { wxString LL0GSS(__FILE__, wxConvUTF8); \
	Logger::logf( LOG_MSG, LL0GSS + _T(" in line:%d "), __LINE__ );}

#define LOGP(x) { wxString LL0GSS(__FILE__, wxConvUTF8); \
	wxString y = x; Logger::logf( LOG_MSG, LL0GSS + _T(" in line:%d ") + (y), __LINE__ );}
#else
#define LOG { wxString LL0GSS(__PRETTY_FUNCTION__, wxConvUTF8); \
    wxString LLOGTMPS = LL0GSS.BeforeFirst('(')+ _T("()") + LL0GSS.AfterLast(')'); \
    Logger::logf( LOG_MSG, LLOGTMPS + _T(" in line:%d "), __LINE__ );}

#define LOGP(x) { wxString LL0GSS(__PRETTY_FUNCTION__, wxConvUTF8); \
    wxString LLOGTMPS = LL0GSS.BeforeFirst('(')+ _T("()") + LL0GSS.AfterLast(')'); \
    Logger::logf( LOG_MSG, LLOGTMPS + _T(" in line:%d ") + (x), __LINE__ );}
#endif

#endif // LOGGER_H
