#ifndef EXPRESSIONSQL_H
#define EXPRESSIONSQL_H

#include <wx/wx.h>
#include <wx/wxsqlite3.h>
#include "../common/types/StringHash.h"
#include "../common/types/DoubleHashArray.h"

#define deleteFilter(x) deleteExpression((x))

WX_DEFINE_ARRAY(StringHash*, StringHashA);

class ExpressionSQL
{
    public:
        ExpressionSQL() {}
        static StringHashA      getFilters(bool orderByName = true);
        static StringHashA      getExpressions( bool orderByName = true);

        static wxString         getFilterByName(const wxString& filterName);
        static wxString         getExpressionByName(const wxString& expressionName);

        static bool             saveFilter(const wxString& filter_name, const wxString& filter);
        static bool             saveExpression(const wxString& expression_name, const wxString& expression);

        static wxArrayString    getSymbols();
        static bool             deleteExpression(const wxString& expression_name);
        static DoubleHashArray  getExpressionColor( const wxString& expression );
        static DoubleHashArray  getExpressionColor( const int& coloring_id );

    protected:

    private:
        static wxSQLite3Database db;
        static void     checkDb();
        static void     openDb();

        static StringHashA _get(bool isExpression, bool orderByName);
        static wxString _getbyname( const wxString& name, bool isExpression );
        static bool     _save( const wxString& expression_name, const wxString& expression, bool isExpression );

        static bool     checkForExpression(const wxString& expression_name);
};

#endif // EXPRESSIONSQL_H
