#ifndef LOGHISTORYSEARCH_H
#define LOGHISTORYSEARCH_H

#include "LogFilter.h"

class Section {
    public:
        Section() { beginIdx = -1, endIdx = -1; };
        Section(int begin, int end) { beginIdx = begin; endIdx = end; };
        int beginIdx;
        int endIdx;

        bool isOk() const {
            return (beginIdx >= 0 && endIdx > 0 && endIdx > beginIdx) ? true : false;
        };

        bool operator== (const Section& sec) const {
            return (beginIdx == sec.beginIdx && endIdx == sec.endIdx) ? true : false;
        };
};

extern Section DefaultSection;

WX_DECLARE_OBJARRAY( Section, SectionArray );

class LogHistorySearch : public LogFilter
{
    public:
        LogHistorySearch( const wxString& filter, size_t endIdx, SectionArray* externalArr = NULL );

        virtual void  processData( const DoubleHash& data, bool passedFilter );

        SectionArray    getIndices() { return m_indices; }

    private:

        SectionArray    m_indices;
        SectionArray*   m_externalIndicesArr;

        int             m_startIdx;
        int             m_endIdx;

        size_t          m_searchEndIdx;

};

#endif // LOGHISTORYSEARCH_H
