#ifndef SEARCHRESULTDIALOG_H
#define SEARCHRESULTDIALOG_H

#include "LogHistorySearch.h"

#include <wx/listctrl.h>

#include "../common/types/BoolIntHash.h"

class SearchResultDialog: public wxFrame
{
    public:
        SearchResultDialog(wxWindow* parent, int id, SectionArray& result, const wxString& title = _T("Search result"));
        virtual ~SearchResultDialog();

        void SetHandler(wxEvtHandler* handler) { m_handler = handler; };

    protected:

        void AddLine(Section& sect);

        void InitList();

        void OnListActivated(wxListEvent& evt);
        void OnListHeaderClick(wxListEvent &evt);

        wxString GetListCtrlCellText(wxListCtrl * lc, long item, int col);


    private:

        enum ImageList {
            IMG_NULL = 0,
            IMG_UP,
            IMG_DOWN

        };

        enum{
            idResultList
        };

        wxEvtHandler*   m_handler;

        wxListCtrl*     m_resultList;

        SectionArray    m_sectionList;

        BoolIntHash     m_listColOrders;

        int             m_lastOrderedCol;

        DECLARE_EVENT_TABLE();
};

#endif // SEARCHRESULTDIALOG_H
