#include "ntcfinder.h"

#include <wx/dir.h>
#include <wx/filename.h>

#include "logger.h"

#include "fileparser/IHexParser.h"
//#include "FirmwareData.h"



NTCFinder::NTCFinder():
isOk (false)
{
    //ctor
}

NTCFinder::~NTCFinder()
{
    //dtor
}


void NTCFinder::getFileArrray(int type)
{
    isOk = false;

    wxString dirname = wxFileName::GetCwd();
    dirname += wxFileName::GetPathSeparator();
    wxString filespec;
    if(type == NTC_COOLANT){
        dirname += _T("coolantfactor");
        filespec = _T("*.clt");
    }else if(type == NTC_MAT){
        dirname += _T("matfactor");
        filespec = _T("*.air");
    }else{
        dirname += _T("ntc");
        filespec = _T("*.hex");
    }
   // wxDir dir = wxDir();

    wxArrayString files;
    wxDir::GetAllFiles(dirname, &files, filespec);

    FirmwareData* fwData;
    for(unsigned int i = 0; i< files.Count(); i++){
       // vp->sendString((char *)line.c_str());
        wxString file = files.Item(i);
        //Logger::log(LOG_MSG, _T("NTCFinder::getFileArrray() File: ")+file);
         IHexParser ihexParser(ECUInfo::DEVICE_V3);
         ihexParser.parse(file);
         fwData = ihexParser.getFirmwareData();

         wxFileName fName = wxFileName(file);
         wxString fileName = fName.GetName();

         IntSet pageSet = fwData->getPageSet();
         m_file2PageSet[fileName] = pageSet;

        IntSet::iterator it;

        for( it = pageSet.begin(); it != pageSet.end(); ++it )
        {
            int page = *it;
            //Logger::log(LOG_MSG, wxString::Format(_T("NTCFinder::getFileArrray() Page: %d"), page) );
            uint32_t chkNum = fwData->getPageCheckSum(page);
            //Logger::log(LOG_MSG, wxString::Format(_T("NTCFinder::getFileArrray() Chk: %08X"), chkNum) );
            m_chk2File[chkNum] = fileName;
        }
         //StringSet pageChkSet = fw->getPageAndChkSet();


         //pageChk2file[chk] = file;
        isOk = true;
    }

}

wxString NTCFinder::getFile(const uint32_t chkNum)
{
    if ( m_chk2File.find( chkNum ) ==  m_chk2File.end() )
        return wxEmptyString;

    return m_chk2File[chkNum];
}

IntSet NTCFinder::getPageSet(const wxString& file)
{
    return m_file2PageSet[file];
}

void NTCFinder::toString()
{
    /*Uint32Hash::iterator it32;


    for( it32 = m_chk2File.begin(); it32 !=  m_chk2File.end(); ++it32){
        uint32_t chkNum = it32->first;
        wxString file = it32->second;
        //Logger::log(LOG_MSG,  wxString::Format(_T("TCFinder::toString() chksum: %08X, %s"), chkNum, file.c_str() ) );
    }*/

    IntSetHash::iterator it;

    for( it = m_file2PageSet.begin(); it !=  m_file2PageSet.end(); ++it){
        wxString file = it->first;
        IntSet pageSet = it->second;
        wxString msg = _T("File: ")+ file;

        IntSet::iterator it2;
        for( it2 = pageSet.begin(); it2 != pageSet.end(); ++it2 )
        {
            int page = *it2;
            msg += wxString::Format(_T(" %d,"), page);
        }
        //Logger::log(LOG_MSG,_T("TCFinder::toString() ")  msg);
    }


}
