#include "pageexception.h"



PageException::PageException(pageExceptionCode code, int idx)
{
    m_code = code;
    m_idx = idx;
}

PageException::~PageException()
{
    //dtor
}

wxString PageException::toString()
{
    wxString tmp;
    switch (m_code)
    {
        //case PAGE_NOT_VALID:
        //    break;
        case PAGE_ADDRESS_SYNC_ERROR: //TODO: put the msg to the exception
            tmp.Printf(_T("Fatal error: OUT OF SYNC unable to send address at page: %i"), m_idx);
            break;
        case PAGE_VERIFY_CHECKSUM_ERROR:
            tmp.Printf(_T("CheckSum error at page: %i (file: 0x%08X ecu: 0x%08X)"), m_idx,
                   m_pageCheckSum,
                   m_ecuCheckSum);
            break;
        case PAGE_WRITE_ERROR:
            tmp.Printf(_T("Page write error at page: %i!"), m_idx);
            break;
        case PAGE_WRITE_SYNC_ERROR:
            tmp.Printf(_T("Page write sync error at page: %i!"), m_idx);
            break;
        case PAGE_WRITE_CHECKSUM_ERROR:
            tmp.Printf(_T("Page write checksum error at page: %i!"), m_idx);
            break;
        default:
            tmp.Printf(_T("Page write OK!"));
    }
    return tmp;
}
