#include "RingBuffer.h"

#include "../logger.h"

// recordCount or ringBufSize (not really recordSize)
RingBuffer::RingBuffer(int recordSize, int bufferSize)
{
    Logger::logf(LOG_MSG,_T("RingBuffer() create rb:(%d*%d)"), recordSize, bufferSize);
    //ctor
    m_recordSize = recordSize;
    m_bufferSize = bufferSize;

    Create(recordSize, bufferSize);
}

RingBuffer::~RingBuffer()
{
    Logger::logf(LOG_MSG,_T("RingBuffer() DTOR START") );
    //dtor
    for(int i =0; i < m_recordSize; i++){
        delete[] m_buff[i];
    }
    delete[] m_buff;

    Logger::logf(LOG_MSG,_T("RingBuffer() DTOR STOP") );
}

void RingBuffer::Create(int recordSize, int bufferSize)
{
    m_buff = new char *[recordSize];

    for(int i =0; i < recordSize; i++){
        m_buff[i] = new char[bufferSize];
    }
    m_head = 0;
    m_tail = 0;
/*
     char * tmp = "11111111111111111111111111111111111111111111";
     memcpy ( m_buff[m_head], tmp,  strlen(tmp) );
     char *ptr = getHeadPointer();
      memcpy ( ptr, tmp,  strlen(tmp) );
      */
}

void RingBuffer::init()
{
    m_head = 0;
    m_tail = 0;
}

bool RingBuffer::isEmpty()
{
    return (m_head == m_tail);
}

bool RingBuffer::isFull()
{
    int next_head = getNextIdx(m_head);
    return (next_head == m_tail);
}

int RingBuffer::getNextIdx(int idx)
{
    idx++;
    if(idx < m_recordSize ){
        return idx;
    }
    return 0;
}

char * RingBuffer::getHeadPointer()
{
    char * ptr = m_buff[m_head];
    return ptr;
}

char * RingBuffer::getTailPointer()
{
    char * ptr = m_buff[m_tail];
    return ptr;
}

int RingBuffer::nextHead()
{
     if( isFull() ) return m_head;

     m_head = getNextIdx(m_head);
     return m_head;
}

int RingBuffer::nextTail()
{
    if ( isEmpty() ) return m_tail;

    m_tail = getNextIdx(m_tail);
    return m_tail;
}

bool RingBuffer::Write(char * src, int len)
{
    if( isFull() ) return false;
    if(len > m_bufferSize) len = m_bufferSize;

    m_head = getNextIdx(m_head);
 //   memcpy ( m_buff[m_head], src, len );

    return true;
}

bool RingBuffer::Read(char * desc, int len)
{
    if( isEmpty() ) return false;
    if(len > m_bufferSize) len = m_bufferSize;

    m_tail = getNextIdx(m_tail);
//    memcpy ( desc, m_buff[m_tail], len );

    return true;
}

bool RingBuffer::Write(char * src)
{
    Write(src, m_bufferSize);
	return true;
}

bool RingBuffer::Read(char* desc)
{
    Read(desc, m_bufferSize);
	return true;
}

int  RingBuffer::getBufferSize(){
    return m_bufferSize;
}
