#ifndef RINGBUFFERREADERTHREAD_H
#define RINGBUFFERREADERTHREAD_H

#include <wx/thread.h>
#include "RingBuffer.h"
#include "ThreadConditionBase.h"

class RTDataMgrBase;

class RingBufferReaderThread : public wxThread
{
    public:
        RingBufferReaderThread();
        virtual ~RingBufferReaderThread();
        virtual void* Entry();
        //virtual bool writeRingBuffer() = 0;
        void setRingBuffer(RingBuffer *rb);
        void setThreadConditionBase(ThreadConditionBase *cb);
        void setRTDataMgrBase(RTDataMgrBase *mgr);
    protected:
    private:
        bool readRingBuffer();
        void waitRingBufferNotEmpty();
        void waitInputSource();
        void waitViewers();

    RingBuffer          *m_ringBuffer;
    ThreadConditionBase *m_tc;
    RTDataMgrBase       *m_mgrBase;

};



#endif // RINGBUFFERREADERTHREAD_H
