#ifndef RINGBUFFERTHREADTESTER_H
#define RINGBUFFERTHREADTESTER_H

#include "RingBuffer.h"
#include "RingBufferWriterThread.h"

#include "../FirmwareInfo.h"

#include "../RTDataInputBase.h"

class RTDataMgrBase;
class MTConfigData;
class STDataMgrBase;
class ThreadBase;
class VemsProtocol;

class RingBufferThreadTester
{
    public:
        RingBufferThreadTester();
        virtual ~RingBufferThreadTester();
        void start();
        void init(RTDataMgrBase * mgrBase, STDataMgrBase* stdataMgr, MTConfigData* mtConfigData,
        VemsProtocol* m_vp);
        void init(RTDataMgrBase * mgrBase);
        bool isConnected();
        RingBuffer * getRingBuffer();
        FirmwareInfo * GetFirmwareInfo() { return m_ringBufferWriter->GetFirmwareInfo(); };
        void setLocked(bool lock);
        void setRawDataLog(bool b);
        bool isRawLog() { return m_ringBufferWriter->isRawLog(); };
        bool isBootMode(){ return m_ringBufferWriter->isBootMode(); }
        void setSTDataMgr( STDataMgrBase* stdataMgr){
            m_ringBufferWriter->setSTDataMgr(stdataMgr);
        }
        void setActiveInput(RTDataInputType inputType);
    protected:
    private:
        RingBuffer *m_ringBuffer;
        RingBufferWriterThread * m_ringBufferWriter;
        ThreadBase* m_ecuThread;
        ThreadBase* m_fileThread;
};



#endif // RINGBUFFERTHREADTESTER_H
