#ifndef RINGBUFFERWRITERTHREAD_H
#define RINGBUFFERWRITERTHREAD_H

#include <wx/thread.h>
#include "../common/typedef.h"

class VemsProtocol;
class RTDataMgrFacade;
class STDataMgrBase;
class RingBuffer;
class ThreadConditionBase;
class RTDataRawLogger;
class FirmwareInfo;
class STDataMgrBase;

class RingBufferWriterThread : public wxThread
{
    public:
        RingBufferWriterThread();
        virtual ~RingBufferWriterThread();
        virtual void* Entry();
        //virtual bool writeRingBuffer() = 0;

        void setVemsProtocol(  VemsProtocol* vp);
        void setInputMgr(RTDataMgrFacade* inputMgr);
        void setRingBuffer(RingBuffer* rb);
        void setThreadConditionBase(ThreadConditionBase *cb);
        void setLocked(bool b);

        void setRawLog(bool b);
        bool isRawLog() { return m_isRawLog; };
        bool isBootMode(){ return m_isbootMode; }

        FirmwareInfo* GetFirmwareInfo() { return m_fwInfo; };
        bool readFirmwareInfo(uint8_t trycount = 5, bool force = false);
        bool isConnected();
        //int getState();
        void setSTDataMgr( STDataMgrBase* stdataMgr){
            m_stdataMgr = stdataMgr;
        }
    protected:
        void waitOnline();
        void waitRingBufferNotFull();
        bool writeRingBuffer();
        void writeHeader();


    private:
        FirmwareInfo* m_fwInfo;
        RTDataMgrFacade* m_inputMgr;
        STDataMgrBase* m_stdataMgr;
        RingBuffer* m_ringBuffer;
        ThreadConditionBase* m_tc;
        bool m_locked;
        int m_inputType;
        bool m_connected;
        uint8_t* m_RTBuff;
        int m_RTLen;

        RTDataRawLogger* m_rtDataRawLogger;

        VemsProtocol* m_vp;
        bool m_isRawLog;
        bool m_isbootMode;

};



#endif // RINGBUFFERWRITERTHREAD_H
