#ifndef SFLOODPROCESS_H
#define SFLOODPROCESS_H

#include "../common/typedef.h"
#include "../common/ProcessBase.h"
#include "../Observable.h"

class CommunicationBase;
class FSMString;

class SFloodProcess : public ProcessBase, public Observable ///, SimpleFSM
{
    public:
        enum TX_STATE{
            TX_S,
            TX_WAIT
        };
        SFloodProcess(CommunicationBase* commBase);
        virtual ~SFloodProcess();

        void start();
        void stop();
        bool process();
        void reset();

    protected:
    private:
        CommunicationBase* m_commBase;
        FSMString* m_fsm;
        TX_STATE m_txState;
        uint8_t                 m_rxBuff[16];
        uint8_t                 m_txBuff[255];
        void finished();

        int readBytes();
        int writeBytes();
        int getTx(uint8_t* m_txBuff);
};

#endif // SFLOODPROCESS_H
