#include "ThreadBase.h"

#include "../logger.h"
// #include "RingBuffer.h"

ThreadBase::ThreadBase()
{
    //ctor
    m_isNotDisabled = new wxCondition(m_enabledMutex);
    m_waitToDisabled = new wxCondition(m_waitDisabledMutex);
    m_disabled = false;
    m_isWaiting = false;
    m_isStoped = false;
}

ThreadBase::~ThreadBase()
{
    //dtor
}


void ThreadBase::setEnable(bool enable, bool isBlocking)
{
    if(isBlocking){
        setEnableBlocking(enable);
        return;
    }

    //Logger::logf(LOG_MSG,_T("ThreadBase::setEnable 0"));

    m_disabled = !enable;
     if(enable){
		 m_isNotDisabled->Broadcast();
     }

    //Logger::logf(LOG_MSG,_T("ThreadBase::setEnable 2"));

}

void ThreadBase::setEnableBlocking(bool enable)
{
    m_disabled = !enable;
    if(enable){
        m_isNotDisabled->Broadcast();
        //Logger::logf(LOG_MSG, _T("ThreadBase::setEnable() m_isNotDisabled->Broadcast()"));
    }else if(!m_isWaiting){
        m_waitToDisabled->Wait();
    }
}

void ThreadBase::waitEnable()
{
    while( m_disabled && !m_isStoped )
    {
        m_waitToDisabled->Broadcast();
        //m_connected = false;
        //Logger::logf(LOG_MSG, _T("ThreadBase::waitEnable() "));
        m_isWaiting = true;
        m_isNotDisabled->Wait();
        Logger::logf(LOG_MSG, _T("ThreadBase::waitEnable() released"));
        m_isWaiting = false;
    }

}

bool ThreadBase::isEnable()
{
    Logger::logf(LOG_MSG, _T("ThreadBase::isEnable() isDisabled: %i"), m_disabled);
    //if(m_disabled) return false;
    //return true;
    return !m_disabled;
}

void ThreadBase::stop()
{
    m_isStoped = true;

    m_disabled = false;
    m_isNotDisabled->Broadcast();
}
