#include "ThreadControllerAudio.h"

#include "RingBufferSync.h"
#include "RingBuffer.h"
#include "../signalgen/signalgen.h"

ThreadControllerAudio::ThreadControllerAudio(RingBufferSync* ringBufferSync, SignalGen* signalGen)
{
    //ctor
    m_ringBufferSync = ringBufferSync;
    m_signalGen = signalGen;

}

ThreadControllerAudio::~ThreadControllerAudio()
{
    //dtor
}

void ThreadControllerAudio::stop()
{

    /// very important set to disabled and release the runguffer
    setDisabled(true);
    m_ringBufferSync->nextTailAndBroadcast();
    this->ProcessBase::stop();

    //m_ringBufferSync->nextTailAndBroadcast();
}

void ThreadControllerAudio::start()
{
    setDisabled(false);
    this->ProcessBase::start();
}

void ThreadControllerAudio::finished()
{

}

bool ThreadControllerAudio::process()
{
    m_ringBufferSync->waitRingBufferNotFull();
    if(m_isDisabled) return false;

    char* buff = m_ringBufferSync->m_ringBuffer->getHeadPointer();
    m_signalGen->generateBlock( (int16_t*) buff, m_ringBufferSync->m_ringBuffer->getBufferSize()/4);

    m_ringBufferSync->nextHeadAndBroadcast();

    return true;
}
