#include "ThreadControllerVemslog.h"

#include "../events/InputEvent.h"
#include "../vemsprotocol/VemsLogReader.h"
#include "../vemsprotocol/SIPRTypes.h"

#include "../logger.h"

ThreadControllerVemslog::ThreadControllerVemslog(VemsLogReader* vemsLogReader, wxEvtHandler* eventHandler)
{
    //ctor
    m_vemsLogReader = vemsLogReader;
    m_eventHandler = eventHandler;
}

ThreadControllerVemslog::~ThreadControllerVemslog()
{
    //dtor
}

bool ThreadControllerVemslog::process()
{
    int result = m_vemsLogReader->getNext(m_siprPacket);
    if( result == -2 ){
        Logger::logf(LOG_MSG, _T("ThreadControllerVemslog::process() END"));
        return false;
    }
    if(result < 0){
        Logger::logf(LOG_MSG, _T("ThreadControllerVemslog::process start again"));
        ///m_DataLogWriter->flushBuffers();
        m_vemsLogReader->start();
        //Exit();
        //Logger::logf(LOG_MSG, _T("RawToHighLogConverter::Entry: after exit \n"));

    }else{
//        Logger::logf(   LOG_MSG, _T("FileProducerThread::Entry() - send event - packet type:%d, size: %d"),
//                       m_siprPacket.type(), m_siprPacket.size() );
        sendEvent(m_siprPacket, SIPR_EVENT_TYPE_INPUT);
    }

    //Logger::logf(LOG_MSG, _T("FileProducerThread::Entry() loop"));
    //m_rtDataMgr->updateInputModel(INPUT_TYPE_RINGBUFFER_RAWFILE);
    //Logger::logf(LOG_MSG, _T("FileProducerThread::Entry() start 2"));
    if( m_siprPacket.type() == SIPR_READ_SENSORS){
        wxThread::Sleep(80);
    }else{
        wxThread::Sleep(10);
    }
    //wxThread::Sleep(1000);
    return true;
}

void ThreadControllerVemslog::sendEvent( const SIPRPacket& packet, int eventType )
{
    InputEvent e;
    e.setPacket( packet );
    e.setType( eventType );
    m_eventHandler->AddPendingEvent( e );
}
