#ifndef THREADLOGPLAYER_H
#define THREADLOGPLAYER_H

#include "../common/ProcessBase.h"
#include "../vemsprotocol/SIPRPacket.h"
#include "../vemsprotocol/VEMSLogBuffer.h"
#include "../Observable.h"

class wxEvtHandler;
class LogHistoryMgr;
class FilePlayCommander;

class ThreadLogPlayer : public ProcessBase //, public Observable
{
    public:
        ThreadLogPlayer( FilePlayCommander* fpc, LogHistoryMgr* loghistory, wxEvtHandler* eventHandler );
        virtual ~ThreadLogPlayer();

    public:
        bool        process();
        void        setLogHistory(LogHistoryMgr* mgr);
        void        reset();
        void        stop();
        void        setPosition( size_t pos );
        void        setSpeed( unsigned char speed );
        void        setRepeat( bool repeat );

    private:
        LogHistoryMgr*  m_logHistory;
        wxEvtHandler*   m_eventHandler;
        FilePlayCommander*  m_fpc;
        bool                m_initialized;
        size_t              m_position;
        size_t              m_historyLen;
        unsigned char       m_speed;
        bool                m_repeat;

    private:
        void finished();
        void sendEvent( SIPRPacket packet, int eventType );

};

#endif // THREADLOGPLAYER_H
