#include "../logger.h"
#include "RTDataAnalyzerBase.h"

RTDataAnalyzerBase::RTDataAnalyzerBase()
{
    m_symregistered = false;
}

RTDataAnalyzerBase::~RTDataAnalyzerBase()
{
    unregisterSymbols();
}

void RTDataAnalyzerBase::setRequiredSymbols( wxArrayString symbols )
{
    m_requiredSymbols = symbols;
}

void RTDataAnalyzerBase::require()
{
    if ( m_symregistered == false )
    {
        size_t cnt = m_requiredSymbols.GetCount();
        for ( size_t i = 0; i < cnt; ++i )
        {
            m_rtDataMgr->registerSymbol( m_requiredSymbols[i] );
        }

        m_symregistered = true;
    }
}

void RTDataAnalyzerBase::unregisterSymbols()
{
    if ( m_symregistered )
    {
        size_t cnt = m_requiredSymbols.GetCount();
        for ( size_t i = 0; i < cnt; ++i )
        {
            m_rtDataMgr->unregisterSymbol( m_requiredSymbols[i] );
        }

        m_symregistered = false;
    }
}

void RTDataAnalyzerBase::refresh( DoubleHash* table )
{
    m_data = table;
    processData();
}
