#ifndef RTDATAINPUTRINGBUFFERSYNCGPS_H
#define RTDATAINPUTRINGBUFFERSYNCGPS_H

#include <wx/wfstream.h>

#include "RTDataInputRingBufferSync.h"
#include "../GPSInfo.h"
#include "../GPSNMEA/NMEAParse.h"

class CommunicationBase;
class GPSData;
class RTDataRawLogger;

class RTDataInputRingBufferSyncGPS : public RTDataInputRingBufferSync
{
    public:
        RTDataInputRingBufferSyncGPS( RingBuffer* rb, SymbolMgr* mt,SyncObj* so, CommunicationBase* sph, GPSData* gps, RTDataRawLogger* rawLogger );
        virtual ~RTDataInputRingBufferSyncGPS();

        /*virtual*/ RTDataInputType getType();
        /*virtual*/ int updateInputModel();
        /*virtual*/ int updateViewerModel();

        void enableLog( bool enable = true );
    protected:
    private:
        wxFileOutputStream* m_fileOutputStream;
        CommunicationBase*  m_commBase;
        GPSInfo::State      m_state;
        NMEAParse   m_parser;
        GPSData*    m_gpsData;
        char*       m_gpsDataBuffer;        //raw gps data line
        int         m_gpsDataIdx;           //line idx
        bool        m_recording;            //nmea line making started
        bool        m_isLog;
        uint8_t     m_packedGpsData[13+16];
        uint8_t     m_buff;

        GPSInfo::State  getGPSData();       //read one byte from gps
        int            processGPSData();   //write packed gps data and log nmea lines
        void            packData();         //pack a nmea dataline to raw bytes
        RTDataRawLogger* m_rawLogger;
};



#endif // RTDATAINPUTRINGBUFFERSYNCGPS_H
