#include "RTDataInputSignalgen.h"

#include "../logger.h"
#include "../signalgen/SignalProcessThread.h"

RTDataInputSignalgen::RTDataInputSignalgen(RingBuffer* rb, SymbolMgr* mt, SyncObj* syncObj )
: RTDataInputRingBufferSync(rb, mt, syncObj )
{
    //ctor
    //RingBuffer *rbp, RTDataMgrBase *mgr,  DoubleHash* viewerModel

}

RTDataInputSignalgen::~RTDataInputSignalgen()
{
    //dtor
}

void RTDataInputSignalgen::initSignalProcess()
{
    m_signalProcess = new SignalProcessThread(m_ringBuffer, m_rtDataMgrBase, m_RegisteredSymbolTable);
}

void RTDataInputSignalgen::setTriggerType(const wxString& type)
{
    Logger::logf(LOG_MSG, _T("RTDataInputSignalgen: trigger type: %s"),type.GetData());

    m_signalProcess->setTriggerType(type);
}

void RTDataInputSignalgen::processPulseTrainPacket(SIPRPacket &pulsePacket)
{
    //Logger::logf(LOG_MSG, _T("RTDataInputSignalgen:processPulseTrainPacket"));
    m_signalProcess->processPulseTrainDataBlock(pulsePacket);

}

/**
 * so getValue can query m_signalProcess (hack)
 */
 /*
void RTDataInputSignalgen::setDataSource( SignalProcessThread * signalprocess )
{
    m_signalProcess = signalprocess;
    m_signalProcess->
}
*/
/** @brief refresh
  *
  * @todo: document this function
  */
int RTDataInputSignalgen::refresh()
{
    DoubleHash::iterator it;

    // Logger::logMilli(LOG_MSG,wxString::Format(_T("RTDataInputSignalgen::refresh() START m_RegisteredSymbolTable->size = %i"),m_RegisteredSymbolTable->size()));

/*
    for( it = m_RegisteredSymbolTable->begin(); it != m_RegisteredSymbolTable->end(); ++it )
    {
        wxString symbolName = it->first;

        if( symbolName == (_T("rpm")) ){
            (*m_RegisteredSymbolTable)[symbolName] = m_signalProcess->getRPM();
        } else if( symbolName == _T("sparkPeak") ) {

            double avg = (double )m_signalProcess->getSparkPeaks()->getAverage();
            double peakN = (double )m_signalProcess->getSparkPeaks()->getPeakN();
            double peakP = (double )m_signalProcess->getSparkPeaks()->getPeakP();

            (*m_RegisteredSymbolTable)[symbolName] = avg;
            (*m_RegisteredSymbolTable)[symbolName+_T("_low")] = peakN;
            (*m_RegisteredSymbolTable)[symbolName+_T("_high")] = peakP;
            //dwellTimeHistogram->vectorPrint();
            //Logger::logf(LOG_MSG,_T("RTDataInputSignalgen::refresh()  spartPeak (peak_n, avg, peakp), %f,%f,%f"), peakN, avg, peakP);

        }else{
            ResultHistogram *sparkPhaseHistogram = m_signalProcess->getSparkPhaseHistogram();
            sparkPhaseHistogram->vectorPrint(m_RegisteredSymbolTable);
            //(*m_RegisteredSymbolTable)[symbolName] = getValue(symbolName);
        }

    }
*/
    return 0;
}

/** @brief getValue
  *
  * @todo: document this function
  */
double RTDataInputSignalgen::getValue(const wxString& symbolname)
{
    uint16_t rpm = m_signalProcess->getRPM();
    return (double) rpm;
}

/** @brief isExist
  *
  * @todo: document this function
  */
bool RTDataInputSignalgen::isExist(const wxString& symbolname)
{
    return true;
}

/** @brief isValid
  *
  * @todo: document this function
  */
bool RTDataInputSignalgen::isValid()
{
    return true;
}

/** @brief getType
  *
  * @todo: document this function
  */
RTDataInputType RTDataInputSignalgen::getType()
{
    return INPUT_TYPE_SIGNALGEN;
}

void RTDataInputSignalgen::reset()
{

}

void RTDataInputSignalgen::fillSymbolValues()
{
    //Logger::logf(LOG_MSG, _T("RTDataInputSignalgen::fillSymbolValues() start!"));
//  m_signalProcess->processBlock((short*)m_rtDataBuffer, 1024, 2);
    //Logger::logf(LOG_MSG, _T("RTDataInputSignalgen::fillSymbolValues() end!"));
}


int RTDataInputSignalgen::updateInputModel()
{
        return 0;
}

