#ifndef RTDATALOGWRITER_H
#define RTDATALOGWRITER_H

#include <wx/textfile.h>

#include "RTDataViewerBase.h"
#include "../InterpolateViewerData.h"
#include "../common/typedef.h"

class DataLogEntryArray;

class RTDataLogWriter : public RTDataViewerBase
{
    public:
        RTDataLogWriter(const DataLogEntryArray* entries);
        virtual ~RTDataLogWriter();


        void refresh(DoubleHash* table);
        //void require(DoubleHash* table);
        void require();
        void unregisterSymbols();

        void SetValue(double value) {}
		wxString GetSelectedSymbol() {return wxEmptyString; }
		void SetValueIdx(int idx) {}

        void setFileName(const wxString& filename);
		bool writeHeaders();

		wxString getFileName();

		void setRTDataPerBlock(long rtDataPerBlock);
		void flushBuffers();

		void setGPSCapturedRef(bool* ref){
                m_isGPSCapturedRef = ref;
        }

    protected:
    private:
        double m_timeInterval; // in milli sec
        uint32_t m_rowCount;
        uint32_t m_samplesBeforeFirstChange;
        uint32_t m_count;

        double m_currMilliSec, m_prevMilliSec, m_prevRowCount;
        double m_prevSec, m_currSec;
        int m_sampleCountPerSec;

        //uint32_t m_RecordPerBlock;
        //uint32_t m_prevBlockCount;
        int m_gpsCaptureLine;
        uint32_t m_prevCapturedIdx;
        long m_RTDataPerBlock;
        long m_sameIdxCount;

        wxFile* m_file;
        wxString m_fileName;
        const DataLogEntryArray* m_entries;
        bool m_isSymbolsRegistered;

        InterpolateViewerData *m_interpolate;

        wxString getFilePath();


        void calcualteGPSCaptureLine(DoubleHash *table);
        void calculateTimeMilli(DoubleHash *table);
        void writeLogWithoutInterpolate();

        bool* m_isGPSCapturedRef;

        void init();
};

#endif
