#ifndef RTDATAMGRFACADE_H
#define RTDATAMGRFACADE_H

#include <wx/event.h>

//#include "../Observable.h"

#include "RTDataMgrBase.h"
#include "RTDataInputBase.h"
//#include "RTDataInputSourceEvent.h"
#include "../vemsprotocol/SIPRPacket.h"

WX_DECLARE_HASH_MAP( int, RTDataInputBase *, wxIntegerHash, wxIntegerEqual, Int2RTDataInputBaseHash);

class RTDataMgrFacade : public RTDataMgrBase //, public Observable
{
    public:
        RTDataMgrFacade(SymbolMgrBase* smgrb = NULL);
        virtual ~RTDataMgrFacade();
        void registerInput(RTDataInputBase* input);
        void selectInput(RTDataInputType type);
        void selectInput(const wxString& fileName);
        RTDataInputBase* getInput(RTDataInputType type);
        RTDataInputBase* getInput(){ return m_currInput; }
        void SetInput(RTDataInputBase* input);
        int updateViewerModel();
        int updateInputModel();
        int updateInputModel(RTDataInputType type);
//        void sendInputEvent(int type, int inputEvent);
        int getInputType();
        double getValue(const wxString& symbolname);
        bool isExist(const wxString& symbolname);
        bool isValid();

        bool process(const SIPRPacket& p );
        bool filteredProcess(const SIPRPacket& p );
        void reset();

    protected:
    private:
        //void OnInputSourceEvent(RTDataInputSourceEvent& evt);

        RTDataInputBase * m_currInput;
        Int2RTDataInputBaseHash m_inputSourceH;

        wxEvtHandler* vemsTuneEventController;
};



#endif // RTDATAMGRFACADE_H
