#include "RTDataMgrLog.h"
#include "../fileparser/vemsdatalogdesc.h"

#include "../logger.h"

RTDataMgrLog::RTDataMgrLog(VEMSDataLogDesc* desc)
{
    m_symbolNames = desc->getVEMSDataLogHeader();
    m_items = desc->getVEMSDataLog();
    m_maxCount = m_items->GetCount();
    m_count = 0; //why?
}

RTDataMgrLog::~RTDataMgrLog()
{
    //dtor
}


/** @brief refreshRTData
  *
  * @todo: document this function
  */
int RTDataMgrLog::refresh()
{
    m_count++;

    for(size_t i=0; i<m_symbolNames->GetCount(); i++){
        DoubleHash::iterator it = m_RegisteredSymbolTable->find(m_symbolNames->Item(i));
        if(it == m_RegisteredSymbolTable->end()){
            (*m_RegisteredSymbolTable)[m_symbolNames->Item(i)] = m_items->Item(m_count)->Item(i);
            continue;
        }
        it->second = m_items->Item(m_count)->Item(i);
    }
    return 0;
}

/** @brief getValue
  *
  * @todo: document this function
  */
double RTDataMgrLog::getValue(const wxString& symbolname)
    {
        //return 10 +rand()/5;

    int idx = m_symbolNames->Index(symbolname,false);

    if(idx == wxNOT_FOUND){
		//Logger::logf(LOG_MSG,_T("symbol not found : %s"), symbolname.c_str() );
        //wxLogMessage(wxString::Format(_T("symbol not found : %s"), symbolname.c_str()));     //c wince
        return -1; //need exception?
    }


	Logger::logf(LOG_MSG,_T("symbol found : %s"), symbolname.c_str() );
    //wxLogMessage(wxString::Format(_T("symbol found : %s"), symbolname.c_str()));  //c wince

    if(m_maxCount == 0 || m_count >= m_maxCount){
		//Logger::logf(LOG_MSG,_T("size error : count %d, max %d"), m_count, m_maxCount );
        //wxLogMessage(wxString::Format(_T("size error : count %d, max %d"), m_count, m_maxCount));  //c wince
        return -1;  //need exception?
    }

    DoubleArray* item = m_items->Item(m_count);
    double d = item->Item(idx);
    //wxLogMessage(wxString::Format(_T("count %d, max %d, value %f"), m_count, m_maxCount, d));
	//Logger::logf(LOG_MSG,_T("count %d, max %d, value %f"), m_count, m_maxCount, d);
    return d;

}

RTDataInputType RTDataMgrLog::getType()
{
    return INPUT_TYPE_FILE;
}

/** @brief isExist
  *
  * @todo: document this function
  */
bool RTDataMgrLog::isExist(const wxString& symbolname)
{
    if(m_symbolNames->Index(symbolname,false) == wxNOT_FOUND){
        return false;
    }

    return true;
}

bool RTDataMgrLog::isValid()
{
    return true; //TODO: implement
}


