#ifndef MMCLOGGER_H
#define MMCLOGGER_H

#include "../Observable.h"
#include "../ObserverBase.h"

WX_DEFINE_ARRAY_INT(uint32_t, Uint32_tArray);


class MMCLoggerViewerBase;
class MMCFilesDesc;
class FirmwareInfo;
class MTConfigData;

class MmcOverviewFrame;

class MMCLogger : public Observable, public ObserverBase
{
    public:
        MMCLogger();
        void Update(int logtype=1);
        uint32_t getIntervalIdx(uint16_t interval_time);
        uint32_t getStartIdx(uint16_t back_time=60);
        uint32_t getStopIdx(int logtype=1);


        virtual ~MMCLogger();

        void notify( int i );
        void notify( int i, int idx ) {}
        void notify( const wxString& str) {}
        void Init( const wxString& name, const wxString& msg, const int max ) {}
        int ExtOverview( MMCLoggerViewerBase* oframe );
        //int save(const FirmwareInfo& fwInfo, wxArrayString& files, uint32_t startIdx = 0, uint32_t endIdx = 0);
        int save(const FirmwareInfo& fwInfo, wxArrayString& files, const MMCFilesDesc& mmcFileDesc,  MTConfigData* mtConfigData);
        int overview(MMCLoggerViewerBase* oframe, uint32_t startIdx);
        int Summary( MMCFilesDesc * desc );
        bool CheckSectorIsEmpty(uint32_t blockIdx);

        virtual void start()=0;
        virtual void stop()=0;
        virtual void erase()=0;
        virtual bool getStatus()=0;
        virtual bool needsUpdate()=0;
        virtual void flushBuffer()=0;
        virtual bool getMMCBlock(uint32_t blockIdx, uint8_t* data, int len )=0;
        virtual void ResetBaudrate() = 0;
        virtual void SetBaudrate() = 0;

    protected:

        bool CheckSectorIsEmpty(uint8_t * data, size_t len);
        uint32_t CalcLogTimeLenght( uint32_t addresslen, int datasize );
        bool isNextLog(uint8_t * data);
        int getDataSize(uint32_t address = 0);
        //wxString writeHeader(int dataSize);

        virtual bool isCRCValid( uint8_t* data, int len)=0;
        virtual bool isDataValid( uint8_t* data, int len);

        int recordPerBlock( int blocksize, int datasize ) { return (int)((blocksize-1)/datasize); }

        uint32_t m_stopIdx;
        int m_size;
        bool m_needUpdate;

        bool                m_isAborted;
        wxString            m_fileName;
        int                 m_lastSecCountInBlock;
        int                 m_startNewLogBlockIdx;
        int                 m_blockCount;
};



#endif // MMCLOGGER_H
