#include "MMCLoggerExtOverviewFrame.h"


#include "../logger.h"
#include "MMCLoggerManager.h"


BEGIN_EVENT_TABLE( MMCLoggerExtOverviewFrame, wxDialog )

    EVT_GRID_CMD_CELL_LEFT_CLICK( idFileListGrid, MMCLoggerExtOverviewFrame::OnCellLeftClick)

    EVT_BUTTON(idSaveButton, MMCLoggerExtOverviewFrame::OnButton)
    EVT_BUTTON(idGetSummaryButt, MMCLoggerExtOverviewFrame::OnButton)
    EVT_BUTTON(idSelectAllButton, MMCLoggerExtOverviewFrame::OnButton)
    EVT_BUTTON(idMMCCloseButton, MMCLoggerExtOverviewFrame::OnButton)

    EVT_LISTBOX(idFileListBox, MMCLoggerExtOverviewFrame::OnListBoxClick)
    EVT_CLOSE(MMCLoggerExtOverviewFrame::OnClose)
END_EVENT_TABLE()

MMCLoggerExtOverviewFrame::MMCLoggerExtOverviewFrame(wxWindow* parent, int id, const wxPoint &pos, const wxSize &size)
{

    Create( parent, id, _T("SD Card Extended Overview") , pos, size,wxDEFAULT_FRAME_STYLE | wxFRAME_FLOAT_ON_PARENT);
    SetBackgroundColour(wxSystemSettings::GetColour(wxSYS_COLOUR_3DFACE));
    ClearBackground();

    m_isAllSelected = false;
    m_isCancelled = false;


    m_summaryGrid = new wxGrid(this, idSummaryGrid);
    m_summaryGrid->CreateGrid(0, 2);

/*
    m_fileListGrid = new wxGrid(this, idFileListGrid);
    m_fileListGrid->CreateGrid(0,3);


    wxGridCellAttr * colattr = new wxGridCellAttr();

    colattr->SetRenderer( new wxGridCellBoolRenderer);
    colattr->SetEditor( new wxGridCellBoolEditor);
    colattr->SetAlignment(wxALIGN_CENTRE, wxALIGN_BOTTOM);

    m_fileListGrid->SetColAttr( 0 , colattr);

    wxGridCellAttr * timecolattr = new wxGridCellAttr();
    timecolattr->SetReadOnly( true );

    m_fileListGrid->DisableDragRowSize();

    m_fileListGrid->SetColLabelValue(0, _T("Save"));
    m_fileListGrid->SetColLabelValue(1, _T("Filename"));
    m_fileListGrid->SetColLabelValue(2, _T("Time"));
    m_fileListGrid->SetColSize(0, 45);

    m_fileListGrid->SetColAttr( 2,timecolattr );
    m_fileListGrid->SetSelectionMode(wxGrid::wxGridSelectRows);
*/

    m_fileListBox = new wxCheckListBox(this, idFileListBox,wxDefaultPosition,wxSize(200,-1) );

    m_summaryGrid->DisableDragRowSize();
    m_summaryGrid->SetColLabelValue(0, _T("Prop."));
    m_summaryGrid->SetColLabelValue(1, _T("Value"));
    m_summaryGrid->EnableEditing(false);

    m_saveselbutton = new wxButton(this, idSaveButton, _T("Save selected files") );
    m_selallbutton = new wxButton( this, idSelectAllButton, _T("Select/unselect all"));

    m_summbutt = new wxButton(this, idGetSummaryButt, _T("Create Summary") );

    m_summaryProgress = new ProgressBar(this,wxID_ANY,wxDefaultPosition,wxSize(-1,20));

    m_sampleCntCtrl = new wxTextCtrl(this, wxID_ANY);

	wxTextValidator validator(wxFILTER_NUMERIC);
	m_sampleCntCtrl->SetValidator(validator);
	m_sampleCntCtrl->SetMaxLength(3);

    m_mainsizer = new wxBoxSizer(wxVERTICAL);

    wxBoxSizer * gridlevelsizer = new wxBoxSizer(wxHORIZONTAL);

    //gridlevelsizer->Add( m_fileListGrid, 0, wxALL , 5);
    gridlevelsizer->Add( m_fileListBox, 0, wxALL  , 5);

    wxBoxSizer * summsizer = new wxBoxSizer(wxVERTICAL);

    summsizer->Add( m_sampleCntCtrl, 0, wxALL | wxEXPAND, 5);
    summsizer->Add( m_summbutt, 0, wxALL | wxALIGN_CENTER_HORIZONTAL, 5);
    summsizer->Add( m_summaryProgress, 0, wxALL | wxEXPAND, 5);

    summsizer->Add( m_selallbutton, 0, wxALL| wxALIGN_CENTER_HORIZONTAL,5);
    summsizer->Add( m_saveselbutton, 0, wxALL| wxALIGN_CENTER_HORIZONTAL,5);

    gridlevelsizer->Add(summsizer, 1, wxALL| wxEXPAND, 5);

    gridlevelsizer->Add( m_summaryGrid, 0, wxALL | wxALIGN_RIGHT , 5);

    m_mainsizer->Add( gridlevelsizer, 0, wxALL | wxEXPAND, 5);

    m_summaryProgress->SetWindowStyle( wxBORDER_SUNKEN );
    m_summaryProgress->SetProgressStyle(PB_PERCENTTEXT_INNER);
    m_summaryProgress->Update(0);


    wxStaticBoxSizer* sboxs = new wxStaticBoxSizer( wxVERTICAL, this, _T("Saving progress") );
    m_logProgress = new ProgressBar( this, wxID_ANY, wxDefaultPosition, wxSize(-1,20) );
    m_overallProgress = new ProgressBar( this, wxID_ANY, wxDefaultPosition, wxSize(-1,20) );
    wxButton* cancel = new wxButton( this, idCancelButton, _T("Cancel") );
    m_closeButton = new wxButton( this, idMMCCloseButton, _T("Close") );
    Connect( idCancelButton, wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler( MMCLoggerExtOverviewFrame::OnCancelButton ), 0, this);

    wxStaticText* txt = new wxStaticText( this, -1, _T("Current log progress:") );
    wxStaticText* txt2 = new wxStaticText( this, -1, _T("Overall progress:") );
    sboxs->Add( txt, 0, wxALL | wxEXPAND, 5 );
    sboxs->Add( m_logProgress, 0, wxALL | wxEXPAND, 5 );
    sboxs->Add( txt2, 0, wxALL | wxEXPAND, 5 );
    sboxs->Add( m_overallProgress, 0, wxALL | wxEXPAND, 5 );

    wxBoxSizer* buttS = new wxBoxSizer( wxHORIZONTAL );
    buttS->Add( cancel, 0, wxALL | wxALIGN_CENTER_HORIZONTAL, 5 );
    buttS->Add( m_closeButton, 0, wxALL | wxALIGN_CENTER_HORIZONTAL, 5 );

    sboxs->Add( buttS, 0, wxALL | wxALIGN_CENTER_HORIZONTAL, 5 );

    m_logProgress->SetProgressStyle(PB_PERCENTTEXT_INNER); m_logProgress->Update(0.);
    m_overallProgress->SetProgressStyle(PB_PERCENTTEXT_INNER);m_overallProgress->Update(0.);

    m_mainsizer->Add( sboxs, 1, wxEXPAND | wxALL, 5 );
    m_mainsizer->AddSpacer(10);


	SetSizer(m_mainsizer);
	m_mainsizer->Fit(this);
	m_mainsizer->SetSizeHints(this);

 //   m_mmcLog = &mmclog;

}

MMCLoggerExtOverviewFrame::~MMCLoggerExtOverviewFrame()
{
    //dtor

}

void MMCLoggerExtOverviewFrame::AddFileListLine(MMCFilesDesc& fdesc)
{
    /*
    m_fileListGrid->AppendRows();
    int lastRow = m_fileListGrid->GetNumberRows() - 1;

    m_fileListGrid->SetCellValue(lastRow, 1, wxString::Format(_T("%i.vemslog"),lastRow));
    m_fileListGrid->SetCellValue(lastRow, 2, wxString::Format(_T("%d"),fdesc.Time));
*/

    int time = fdesc.Time;

    int min = time / 60;
    int sec = time % 60;

    int c = m_fileListBox->GetCount()+1;

    int lastRow = m_fileListBox->Append( wxString::Format(_T("%i. %02i:%02i"),c,min,sec) );

    fdesc.RowId = lastRow;

    m_fileDataDescHash[lastRow] = fdesc;

    m_mainsizer->RecalcSizes();
    m_mainsizer->Fit(this);
    m_mainsizer->SetSizeHints(this);
}

void MMCLoggerExtOverviewFrame::OnCellLeftClick(wxGridEvent &evt)
{
    //m_mainsizer->Fit(this);
    // Logger::logf(LOG_MSG,_T("row=%i"), evt.GetRow());

    PutSummary( m_fileDataDescHash[evt.GetRow()] );

    evt.Skip();
}

void MMCLoggerExtOverviewFrame::PutSummary(MMCFilesDesc &fdesc)
{

    m_summaryGrid->ClearGrid();

    size_t rowIdx = 0;

    int diff = m_summaryGrid->GetNumberRows() - fdesc.Summaries.size();

    // Logger::logf(LOG_MSG,_T("MMCLoggerExtOverviewFrame::PutSummary %i"),diff);

    if( diff < 0 )
        m_summaryGrid->AppendRows( abs(diff) );
    else if( diff > 0 )
        m_summaryGrid->DeleteRows( m_summaryGrid->GetNumberRows() - diff , diff );

    for( wxVariantHash::iterator it = fdesc.Summaries.begin(); it != fdesc.Summaries.end() ; it++ ){

        m_summaryGrid->SetCellValue( rowIdx, 0, it->first);
        m_summaryGrid->SetCellValue( rowIdx, 1, it->second.MakeString());

        rowIdx++;
    }
    m_summaryGrid->AutoSize();
    //m_mainsizer->Layout();
    //m_mainsizer->Fit(this);
}

void MMCLoggerExtOverviewFrame::SaveSelectedFiles()
{
    m_isCancelled = false;
    m_currentId = -1;

    // disable buttons
    enableButtons( false );

    if(!m_mmcLoggerMgr) return;

    m_numselected = 0;
    m_timeAll = 0;
    m_timeCtr = 0;
    m_counter = 0;

    m_logProgress->Update( 0 );
    m_overallProgress->Update( 0 );

    for ( size_t a=0; a < m_fileListBox->GetCount(); a++ )
    {
        if ( m_fileListBox->IsChecked(a) )
        {
            ++m_numselected;
            m_timeAll += m_fileDataDescHash[a].Time;
        }
    }

    // searching for first selected item

    size_t a;

    for ( a = 0; a < m_fileListBox->GetCount(); a++ )
        if ( m_fileListBox->IsChecked(a) )
            break;

    m_mmcLoggerMgr->registerObserver(this);

    if ( a >= m_fileListBox->GetCount() )
    {
        wxMessageBox( _T("No files were selected"), _T("Error"), wxOK );
        enableButtons();
    }
    else
    {
        m_currentId = a;
        m_mmcLoggerMgr->start( m_fileDataDescHash[a] , false);
    }
}

void MMCLoggerExtOverviewFrame::OnButton(wxCommandEvent &evt)
{
    switch(evt.GetId()){
        case idSaveButton:
            SaveSelectedFiles();
            break;

        case idGetSummaryButt: {
            if (m_fileListBox->GetSelection()==-1) break;
            MMCFilesDesc &desc = m_fileDataDescHash[m_fileListBox->GetSelection()];
            // Logger::logf(LOG_MSG,_T("MMCLoggerExtOverviewFrame::OnButton idGetSummaryButt m_fileListBox->GetSelection()=%d"),m_fileListBox->GetSelection());
            m_sampleCntCtrl->GetValue().ToLong(&desc.SampleCnt);

            m_mmcLoggerMgr->Summary( &desc, this, this );

            PutSummary( desc );
            m_summaryProgress->Update(100.0);
            }break;

        case idSelectAllButton:
        {
            m_isAllSelected = !m_isAllSelected;
            for ( size_t i = 0; i < m_fileListBox->GetCount(); ++i )
                m_fileListBox->Check( i, m_isAllSelected );

            break;
        }
        case idMMCCloseButton:
        {
            if(m_mmcLoggerMgr) m_mmcLoggerMgr->OverViewEnd();
            Destroy();
            break;
        }

        default:
            break;
    }
}

void MMCLoggerExtOverviewFrame::OnListBoxClick(wxCommandEvent &evt)
{
    MMCFilesDesc &desc = m_fileDataDescHash[evt.GetSelection()];

    m_sampleCntCtrl->SetValue( wxString::Format(_T("%i"),desc.SampleCnt) );

    PutSummary( desc );
}

void MMCLoggerExtOverviewFrame::notify(int i, int idx)
{
    if ( i != -1 )
        m_summaryProgress->Update( (double)i / (double)idx * 100.0 );

    else
    {
        wxSafeYield( this, true );
        m_logProgress->Update( (double) idx);

        double percent = (double) ( m_timeCtr + (double)idx/100.0 * m_fileDataDescHash[m_currentId].Time )/ (double) m_timeAll * 100.0;
        m_overallProgress->Update( percent );
    }
}

void MMCLoggerExtOverviewFrame::notify( int i )
{

}

void MMCLoggerExtOverviewFrame::notify( const wxString& str )
{
    if ( str.StartsWith( _T("Searching") ) )
        return;

    long id; str.ToLong(&id);

    m_fileListBox->Check( id, false );

    m_timeCtr += m_fileDataDescHash[id].Time;
    ++m_counter;

    double percent = (double) m_timeCtr / (double) m_timeAll * 100.0;
    m_overallProgress->Update( percent );

    if ( m_isCancelled )
    {
        m_isCancelled = false;

        wxMessageBox( _T("Operation cancelled"), _T("Information"), wxOK | wxICON_INFORMATION );

        m_logProgress->Update(0);
        m_overallProgress->Update(0);
        m_mmcLoggerMgr->stop();
        m_mmcLoggerMgr->unRegisterObserver(this);
        enableButtons();
    }
    else
    {
        size_t a;
        for ( a = id+1; a < m_fileListBox->GetCount(); a++ )
            if ( m_fileListBox->IsChecked(a) )
                break;

        if ( a >= m_fileListBox->GetCount())
        {
            wxMessageBox( wxString::Format( _T("%d logs created"), m_counter ),  _T("Information"), wxOK | wxICON_INFORMATION );
            enableButtons();
            m_mmcLoggerMgr->stop();
            m_mmcLoggerMgr->unRegisterObserver(this);
            m_logProgress->Update(0);
        }
        else
        {
            m_currentId = a;
            m_mmcLoggerMgr->start( m_fileDataDescHash[a] , false);
        }
    }
}

void MMCLoggerExtOverviewFrame::enableButtons( bool enable )
{
    m_saveselbutton->Enable(enable);
    m_selallbutton->Enable(enable);
    m_summbutt->Enable(enable);
    m_closeButton->Enable(enable);
}

void MMCLoggerExtOverviewFrame::OnClose(wxCloseEvent &evt)
{

    Logger::logf(LOG_MSG,_T("MMCLoggerExtOverviewFrame::~MMCLoggerExtOverviewFrame()"));

    if(m_mmcLoggerMgr) m_mmcLoggerMgr->OverViewEnd();
    evt.Skip();
}

void MMCLoggerExtOverviewFrame::OnCancelButton(wxCommandEvent& evt)
{
    m_isCancelled = true;
//    m_mmcLoggerMgr->stop();
//    notify(_T("1"));
}
