#ifndef MMCOVERVIEWFRAME_H
#define MMCOVERVIEWFRAME_H
#include <wx/grid.h>
#include <wx/wx.h>
#include "../common/typedef.h"
#include "../wxVariantDataDoubleHash.h"
#include "../common/types/DoubleHashArray.h"

#include "MMCLoggerViewerBase.h"

class MMCLoggerManager;

class MmcOverviewFrame : public wxFrame, public MMCLoggerViewerBase
{
    public:
        MmcOverviewFrame(wxWindow* parent, MMCLoggerManager * mgr);
        virtual ~MmcOverviewFrame();
        void AddGridLine(DoubleHash& Ovhash);
        void AddFileListLine(MMCFilesDesc& fdesc ){};
    protected:
    private:
        MMCLoggerManager * m_mmcLoggerMgr;
        wxGrid* m_overviewGrid;
        wxButton* m_selectStartTimeButton;
        wxButton* m_selectStopTimeButton;
        wxButton* m_SaveButton;
        DoubleHashArray m_timeArray;
        int m_selectedTop;
        int m_selectedBottom;
        double m_startTime;
        double m_stopTime;
        uint32_t m_startIdx;
        uint32_t m_stopIdx;

        wxStaticText * m_startText;
        wxStaticText * m_stopText;
        wxStaticText * m_intervalText;
        wxStaticText * m_messageText;
        wxStaticText * m_errorText;

        void OnSaveButton( wxCommandEvent &evt );
        void OnStartButton( wxCommandEvent &evt );
        void OnStopButton( wxCommandEvent &evt );
        void OnGridRangeSelect(wxGridRangeSelectEvent &evt);

    DECLARE_EVENT_TABLE();

};



#endif // MMCOVERVIEWFRAME_H
