#ifndef SERIALCONFIG_H
#define SERIALCONFIG_H

#include <wx/wx.h>
#include <wx/string.h>

class SerialConfig : public wxObject
{
    DECLARE_DYNAMIC_CLASS(SerialConfig)
    public:

        SerialConfig();
        virtual ~SerialConfig();
        SerialConfig( const SerialConfig& config );
        SerialConfig& operator=( const SerialConfig& config );

        wxString getPortName() const;
        void setPortName(const wxString& portName);
        long getBaudRate() const;
        wxString getBaudRateStr() const;
        void setBaudRate(long baudRate);
        void setEnabled(bool enabled) { m_enabled = enabled; }
        bool isEnabled() const { return m_enabled; }
		const char* getPortNameC();
    protected:
    private:
        wxString m_portName;
		const char*	m_portNameC;
        long m_baudRate;
        bool m_enabled;
};



#endif // SERIALCONFIG_H

