#ifndef SERIALPORTHANDLER_H
#define SERIALPORTHANDLER_H

#include <wx/string.h>

#if defined (__WINCE_STANDARDSDK__)
	#include "wince/src/getopt.h"
	#include "wince/src/iobase.h"
	#include "wince/src/serport.h"
	#include "wince/src/timer.h"
#elif (_MSC_VER >= 1400) //  1400 = VS2005 1500 = VS2008 1600 = VS2010
    #ifdef SFILE_LIB
        #include "v3gui/src/serial/SFile.h"
    #else
        #include "v3gui/src/getopt.h"
        #include "v3gui/src/iobase.h"
        #include "v3gui/src/serport.h"
    #endif
	#include "v3gui/src/timer.h"
#else
	#include <wx/ctb/getopt.h>
	#include <wx/ctb/iobase.h>
	#include <wx/ctb/serport.h>
	#include <wx/ctb/timer.h>
#endif

#ifdef SFILE_LIB
	#include "v3gui/src/serial/SFile.h"
#endif

#include "common/typedef.h"
#include "CommunicationBase.h"



class SerialConfig;

class SerialPortHandler: public CommunicationBase
{
    public:
//        SerialPortHandler();
        SerialPortHandler(SerialConfig* serialConfig);
        //SerialPortHandler(wxString * path);
        virtual ~SerialPortHandler();

        //void setSerialConfig(SerialConfig * serialConfig);
        SerialConfig* getSerialConfig(){ return m_serialConfig; };
        bool IsOpen();
        void close();

        int SendString( const wxString& str);
      //  int SendString(wxChar * chr);
        int SendString(const uint8_t* chr);
        int SendString(const uint8_t* str, size_t len);
        int sendStringBlock(uint8_t* value, size_t len, size_t blockLen);

        int Read(uint8_t* str, size_t len);
        int ReadString(uint8_t* str, size_t len);
        int ReadString(uint8_t* data, size_t len, int maxTryCount);
        //int ReadUntilEOS(char ** readbuf,
//            char * eosString = "\n", long timeout_in_ms = 1000L);
        /*virtual*/void setBaudRate(int bRate);
        /*virtual*/int  clear();
        int getBaudRate();

        void setPortName( const wxString& portname ) {}
        wxString getPortName() const { return wxEmptyString; }

        int clearSerialBuffer(int len);
        int clearSerialBufferCircle(int len, int count);

        int sendNumber(uint32_t number, int length);
        int sendNumber(uint16_t number);

    protected:

    private:
        //wxIOBase * dev;
#ifdef SFILE_LIB
        SFile * dev;
        DWORD m_baudrate;
#else
    #ifdef CTB15
        ctb::SerialPort * dev;
        int m_baudrate;
    #else
        wxSerialPort * dev;
        wxBaud m_baudrate;
    #endif
#endif
        SerialConfig* m_serialConfig;

        int open();
        int getTimeOut(size_t len);

        double m_magicTimeoutConstA;
        double m_magicTimeoutConstB;


};

#endif // SERIALPORTHANDLER_H

