#ifndef HISTOGRAM_H
#define HISTOGRAM_H

#define SPARKPHASE_BINS 720
// if signal peak2peak > 32767, than it will clamp:
#define AMPLIDUDE_BINS 256
#include "../common/typedef.h"

class Histogram
{
    public:
        Histogram();
        virtual ~Histogram();
        void printModell();
        void printHisztogram();
        uint16_t putInHistogram(uint16_t amplitude,uint16_t sparkphase);
        void setModell(uint16_t amplitude);
        double konvulucio();
        void printPacked(void);
        void loadHistogram(void);
        void saveAmplitudeSums(uint16_t amplitude);
        void saveSparkphase(uint16_t sparkphase);

        uint16_t m_hisztogram_array[AMPLIDUDE_BINS][SPARKPHASE_BINS]; // take in it incidence of amplitudes
        //uint32_t m_amplitudesum[AMPLIDUDE_BINS][1];
        uint16_t m_modell_array[AMPLIDUDE_BINS][SPARKPHASE_BINS];   //it's approximation for real hisztogram

        uint16_t GetMaxRate() { return m_maxRate; }
        void CheckMaxRate(uint16_t rate) {
            if(rate > m_maxRate)
                m_maxRate = rate;
        }

        struct amplitudevalues_t{
          int summation;
          int sumofpower;
        };
    uint16_t sparkringbuffer[255];
    struct amplitudevalues_t amplitudevalues[AMPLIDUDE_BINS];
    protected:

    private:
        uint16_t m_maxRate;
        uint16_t m_idx;
};



#endif // HISTOGRAM_H
