#ifndef MAIN_H
#define MAIN_H

#include "app.h"
#include <wx/notebook.h>

// #include "AudioThread.h"
class AudioThread;
class RingBuffer;
class RTDataMgrBase;
class SignalProcessThread;
class GaugeFrame;
class VEMSGaugeDescArray;
class GUIConsumerThread;

class SparkTesterWidgetFactory;

class SparkMyFrame: public wxFrame
{
	public:
        SparkMyFrame( wxFrame* frame, const wxString& title );
		~SparkMyFrame();
	private:
        VEMSGaugeDescArray*     m_gaugeDescA;
        RTDataMgrBase*          m_signalProcessMgr;
        //RTDataMgrBase*          m_rtDataMgr; // data manager signalprocessing => gauge
        //RTDataMgrBase*          m_rtDataMgr2; // data manager signalprocessing => gauge
        AudioThread*            m_audioThread;
        GUIConsumerThread*      m_guiThread;

        wxBookCtrl*             m_book;
        RingBuffer*             m_ringBufferRecord;
        wxPanel*                m_logPanel;
        wxPanel*                m_settingsPanel;
        wxTimer                 m_timer;
        bool isWriteInFile;
        SparkTesterWidgetFactory* m_sparkTesterWidgetFactory;

        void init();
		uint16_t getSample(char * buf, int index, int channel);
        //void registerGauge(GaugeFrame *frame);
        void initGaugeDesc();

        void OnShowDevices( wxCommandEvent& event );
        void OnFullDuplex( wxCommandEvent& event );
        void OnFullDuplex1( wxCommandEvent& event );
        void SetSoundDialog();
		void OnQuit(wxCommandEvent& event);
		void OnAbout(wxCommandEvent& event);
		void OnAddGauge(wxCommandEvent& event);
		void OnGaugeTest(wxCommandEvent& event);
		void OnTimer(wxTimerEvent& event);
		void onWriteInFile(wxCommandEvent& event);
		//void Grid(wxCommandEvent& event);
		DECLARE_EVENT_TABLE();
};

#endif // MAIN_H
