#ifndef VEMS2DHISTOGRAMWIDGET_H
#define VEMS2DHISTOGRAMWIDGET_H

#include "RTSignalViewerBase.h"
#include <wx/dcbuffer.h>
#include <wx/dcmemory.h>
//#include <stdlib.h>
#include <wx/string.h>
#include <wx/font.h>

#include <wx/control.h>

class UpdateViewerEvent;

class Vems2DHistogramWidget: public wxControl, public RTSignalViewerBase
{
    public:
        Vems2DHistogramWidget(wxWindow* parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxString& name = wxPanelNameStr);
        virtual ~Vems2DHistogramWidget();

        virtual void refresh(DoubleHash* table);

        int updateInputModel();
        void sendInputEvent(int type, int inputEvent);
        bool   isExist(const wxString& symbolname);

    protected:
        int updateViewerModel();
        double getValue(const wxString& symbolname);

        DECLARE_EVENT_TABLE();

        void PaintBackGround();

    private:

        void OnPaint(wxPaintEvent &event);
        void paintGrid(wxMemoryDC& memdc,int startx,int starty ,int  distance);
        void paintAxle(wxMemoryDC& memdc,int startx,int starty ,int  distance);
        void getMouseCoordinates(wxMouseEvent& event);
        void onoffZoomFunction(wxMouseEvent& event);
        void setzoom(wxMouseEvent& event);
        void OnWindowCreate(wxWindowCreateEvent& event);
        void zoomWindow(wxMouseEvent& event);
        void OnUpdateValue( UpdateViewerEvent& event );

        uint16_t m_tmp[256][720];

        wxCoord m_x;
        wxCoord m_y;
        wxCoord m_mousex;
        wxCoord m_mousey;

        wxBitmap    *m_backGround;
        wxColor     m_pixelColor;

        bool m_redrawFace;
        bool bgsem ;
        int zoomheigh; //
        int zoomwidth; //
        int zoomsize;
        int state ;
};

#endif // VEMS2DHISTOGRAMWIDGET_H
