#include "VemsSignalGridWidget.h"
#include "../../logger.h"
#include "../Histogram.h"
#include "../../events/UpdateViewerEvent.h"
int idSGrid = wxNewId();

BEGIN_EVENT_TABLE(VemsSignalGridWidget, wxFrame)

    EVT_UPDATE_VIEWER_EVENT( wxID_ANY, VemsSignalGridWidget::OnUpdateValue )

END_EVENT_TABLE()

VemsSignalGridWidget::VemsSignalGridWidget(wxWindow* parent, wxWindowID id, const wxString &title,  const wxPoint& pos, const wxSize& size, long style, const wxString& name)
        :wxFrame(parent, id, title ,pos, size, style)
{
    //ctor
    wxBoxSizer *mainSizer = new wxBoxSizer(wxHORIZONTAL);

    SetInitialSize(size);

    m_grid = new wxGrid(this,idSGrid);
    m_grid->CreateGrid(40,4);

    m_grid->SetColSize(-1,20);

    for(uint8_t a=0;a<40;a++) {
        wxString key = wxString::Format(_T("%i"),a);

        //m_grid->SetColLabelValue(a,key);
        m_grid->SetRowLabelValue(a,key);
    }

    m_grid->SetColLabelValue(0,_T("amp sum"));
    m_grid->SetColLabelValue(1,_T("sparkphs"));
    m_grid->SetColLabelValue(2,_T("Rate"));
    m_grid->SetColLabelValue(3,_T("sumofpow"));
    //m_grid->AutoSize();
    mainSizer->Add(m_grid);
	SetSizer(mainSizer);
	mainSizer->Fit(this);
	mainSizer->SetSizeHints(this);

	Show(1);
}

VemsSignalGridWidget::~VemsSignalGridWidget()
{
    //dtor
    UnRegisterViewer();
}


void VemsSignalGridWidget::refresh(DoubleHash* table)
{

   //Logger::logf(LOG_MSG, _T("--------------------------------VemsSignalGridWidget::Update"));

    /// ??????

    UpdateViewerEvent event;
    this->AddPendingEvent( event );


    int counter1 = 0;//amplitude bin counter
    int counter2 = 0;//sparkphase counter
    int lowamplitudeborder = 0;
    int lowsparkphsborder = 0;
    bool flag =0; // flag == 1 if This is the first time when current rate and next rate == 0, when it is false flag == 0
    int nextrate = 0;
    int n = 0;// which is the current row of the grid
    wxString stringnumber ;

    for(counter1 = 0 ;counter1 < AMPLIDUDE_BINS ; counter1++){
              for(counter2 = 0 ; counter2 < SPARKPHASE_BINS ; counter2++){

                     int currenrate = m_hist->m_hisztogram_array[counter1][counter2];
                     int sum = m_hist->amplitudevalues[( counter1 )].summation;
                     int sumofpower = m_hist->amplitudevalues[( counter1 )].sumofpower;

                     if( (counter2 + 1) == SPARKPHASE_BINS ){//sparkphase counter is never biggger as SPARKPHASE_BINS
                            nextrate = m_hist->m_hisztogram_array[counter1+1][0];
                     }else{
                            nextrate = m_hist->m_hisztogram_array[counter1][counter2+1];

                     }
                     if( (currenrate == 0) && (nextrate == 0) ){ //if 2 next bins values == 0 save 2 counter
                         if(flag == 0){
                            lowamplitudeborder = counter1;
                            lowsparkphsborder = counter2;
                            flag = 1;
                    }
                    }else{
                            if(flag == 1 ){
                                //printf("-----------------------------start(amp%d-spark%d) end(amp%d -spark%d) ... \n",samp,sspark,counter1,counter2);
                                stringnumber = (wxString::Format(wxT("%d"), (int)lowamplitudeborder*256)) +(_T("-")) + (wxString::Format(wxT("%d"), (int)counter1*256));
                                //stringnumber +=_T("-");
                                //stringnumber += wxString::Format(wxT("%d"), (int)counter1*256);
                                addwxStringValueToCell(n,0,stringnumber);
                                //m_grid->SetCellValue(n,0,stringnumber);
                                stringnumber = (wxString::Format(wxT("%d"), (int)lowsparkphsborder)) + (_T("-")) + (wxString::Format(wxT("%d"), (int)counter2));
                                //stringnumber +=_T("-");
                                //stringnumber += wxString::Format(wxT("%d"), (int)counter2);
                                addwxStringValueToCell(n,1,stringnumber);
                                //m_grid->SetCellValue(n,1,stringnumber);
                                stringnumber =_T("...");
                                addwxStringValueToCell(n,2,stringnumber);
                                //m_grid->SetCellValue(n,2,stringnumber);
                                n++;
                                flag =0;
                            }
                            if( currenrate > 0 ){//when current rate biger as 0  save current sum sumofpower...
                               //printf("-----------------------------amplitude= %3d spark = %3d value = %d\n",counter1,counter2,currenrate);
                               addIntValueToCell(n, 0, sum);
                               //stringnumber = wxString::Format(wxT("%d"), (int)sum);
                               //m_grid->SetCellValue(n,0,stringnumber);
                               addIntValueToCell(n, 1, counter2);
                               //stringnumber = wxString::Format(wxT("%d"), (int)counter2);
                               //m_grid->SetCellValue(n,1,stringnumber);
                               addIntValueToCell(n, 2, currenrate);
                               //stringnumber = wxString::Format(wxT("%d"), (int)currenrate);
                               //m_grid->SetCellValue(n,2,stringnumber);
                               addIntValueToCell(n, 3, sumofpower);
                               //stringnumber = wxString::Format(wxT("%d"), (int)sumofpower);
                               //m_grid->SetCellValue(n,3,stringnumber);
                               n++;
                            }
                        }
        }
    }
     //Logger::logf(LOG_MSG, _T("---------------------------------Histogram::printPacked() END"));
}

void VemsSignalGridWidget::addIntValueToCell(int row, int col, int value)
{
        wxString stringnumber = wxString::Format(wxT("%d"), (int)value);
        m_grid->SetCellValue(row,col,stringnumber);
}

void VemsSignalGridWidget::addwxStringValueToCell(int row, int col, wxString& stringnumber)
{
        m_grid->SetCellValue(row,col,stringnumber);
}

wxString VemsSignalGridWidget::linkwxString(wxString& s1,wxString& s2)
{
     s1 += s2;
    return s1;
}
int VemsSignalGridWidget::updateInputModel()
{
        return 0;
}

void VemsSignalGridWidget::sendInputEvent(int type, int inputEvent)
{

}

bool VemsSignalGridWidget::isExist(const wxString& symbolname)
{
    return true;
}

int VemsSignalGridWidget::updateViewerModel()
{
    return 0;
}

double VemsSignalGridWidget::getValue(const wxString& symbolname)
{
    return 0;
}

void VemsSignalGridWidget::OnUpdateValue( UpdateViewerEvent& event )
{

}

