#include "WriteInFileByTime.h"
#include "../../logger.h"
#include "../../events/UpdateViewerEvent.h"
#include "../../wxVariantDataDoubleHash.h"

BEGIN_EVENT_TABLE(WriteInFileByTime, wxEvtHandler)

    EVT_UPDATE_VIEWER_EVENT( wxID_ANY, WriteInFileByTime::OnUpdateValue )

END_EVENT_TABLE()

WriteInFileByTime::WriteInFileByTime()
:missingCnt(0),missingCnt2(0),startCnt(0)
{
    m_missingPointer=0;
    for (int i=0;i<MISSINGDATACNT;i++){
        m_missingdata[i]=0;
        m_missingdata2[i]=0;
    }
    wxDateTime now = wxDateTime::Now();

    wxString filename = _T("/tmp/test");

    wxString date = now.FormatDate();

    //date=date.SubString(1,2)+_T("_")+date.SubString(4,5)+_T("_")+date.SubString(7,8)+_T("_");
    //const wxChar prew = '/';
    //const wxChar next = '_';
    //.Replace(&prew,&next);
    date.Replace(_T("/"), _T("_"));
    wxString time =now.FormatTime();
   // time=time.SubString(1,2)+_T("_")+time.SubString(4,5)+_T("_")+time.SubString(7,8)+_T("_");
    time.Replace(_T(":"), _T("_"));


    filename += date+_T("_")+time+ _T(".txt");

    Logger::logf(LOG_MSG,_T("WriteInFileByTime::WriteInFileByTime() file name ")+filename);

    m_file = new wxFile(filename,wxFile::write);
    m_file->Write(_T("#v3GUI\n"),wxConvUTF8);
    m_file->Write(_T("time\tSpark\tSparkW\tSpark_ch2\tSparkW_ch2\trpm\tdwell\tdwell_ch2\tmissing\tmissingRatio\tmissing_ch2\tmissingRatio_ch2\tpw_ch1\tpw_ch2\tdwell_pos_ch1\tdwell_pos_ch2\n"),wxConvUTF8);
    //ctor
}

WriteInFileByTime::~WriteInFileByTime()
{
    //dtor
    UnRegisterViewer();
}


void WriteInFileByTime::refresh(DoubleHash* table)
{
    //Logger::logf(LOG_MSG,_T("WriteInFileByTime::refresh(DoubleHash* table)"));
    if((startCnt++)<STARTCNT) return ;

    DoubleHash hash;

    UpdateViewerEvent event;

    event.m_userData[_T("missing")] = (*table)[_T("missing")];
    event.m_userData[_T("phase")]   = (*table)[_T("phase")];
    event.m_userData[_T("rpm")]     = (*table)[_T("rpm")];
    event.m_userData[_T("dwell")]   = (*table)[_T("dwell")];
    event.m_userData[_T("missing2")] = (*table)[_T("missing2")];
    event.m_userData[_T("phase2")]   = (*table)[_T("phase2")];
    event.m_userData[_T("dwell2")]   = (*table)[_T("dwell2")];
    event.m_userData[_T("pw")]   = (*table)[_T("pulse_width")];
    event.m_userData[_T("pw2")]   = (*table)[_T("pulse_width2")];
    event.m_userData[_T("Dphase")]   = (*table)[_T("Dphase")];
    event.m_userData[_T("Dphase2")]   = (*table)[_T("Dphase2")];

    m_missingdata[m_missingPointer]=(uint8_t) (*table)[_T("missing")];
    m_missingdata2[m_missingPointer]=(uint8_t) (*table)[_T("missing2")];
    m_missingPointer++;
    if (m_missingPointer==MISSINGDATACNT) m_missingPointer=0;
    uint16_t sum=0;
    uint16_t sum2=0;
    for (int i=0;i<MISSINGDATACNT;i++){
        sum=sum+m_missingdata[i];
        sum2=sum2+m_missingdata2[i];
    }
    sum=sum*100;
    sum2=sum2*100;
    m_missingRatio=sum/MISSINGDATACNT;
    m_missingRatio2=sum2/MISSINGDATACNT;

    this->AddPendingEvent( event );
}
int WriteInFileByTime::updateInputModel()
{
    return 0;
}

void WriteInFileByTime::sendInputEvent(int type, int inputEvent)
{

}

bool WriteInFileByTime::isExist(const wxString& symbolname)
{
    return true;
}

int WriteInFileByTime::updateViewerModel()
{
    return 0;
}

double WriteInFileByTime::getValue(const wxString& symbolname)
{
    return 0;
}

void WriteInFileByTime::OnUpdateValue( UpdateViewerEvent& event )
{
    //Logger::logf(LOG_MSG,_T("WriteInFileByTime::OnUpdateValue( UpdateViewerEvent& event )0"));

    int missing = event.m_userData[_T("missing")].GetLong();
    int sparkP = event.m_userData[_T("phase")].GetLong();
    int rpm    = event.m_userData[_T("rpm")].GetLong();
    int dwell  = event.m_userData[_T("dwell")].GetLong();
    int missing2 = event.m_userData[_T("missing2")].GetLong();
    int sparkP2 = event.m_userData[_T("phase2")].GetLong();
    int dwell2  = event.m_userData[_T("dwell2")].GetLong();
    int pw  = event.m_userData[_T("pw")].GetLong();
    int pw2 = event.m_userData[_T("pw2")].GetLong();
    int dwellP = event.m_userData[_T("Dphase")].GetLong();
    int dwellP2 = event.m_userData[_T("Dphase2")].GetLong();


    int sparkPW = sparkP %360;
    if (sparkPW>(MIDSPARK+50)) sparkPW=(MIDSPARK+50)+(MIDSPARK+50-sparkPW)/10;
    if (sparkPW<(MIDSPARK-50)) sparkPW=(MIDSPARK-50)-(MIDSPARK-50-sparkPW)/10;
    int sparkPW2 = sparkP2 %360;
    if (sparkPW2>(MIDSPARK2+50)) sparkPW2=(MIDSPARK2+50)+(MIDSPARK2+50-sparkPW2)/10;
    if (sparkPW2<(MIDSPARK2-50)) sparkPW2=(MIDSPARK2-50)-(MIDSPARK2-50-sparkPW2)/10;
    wxString writeData;
    if(missing){
        missingCnt++;
    }
    if(missing2){
        missingCnt2++;
    }
    wxDateTime now = wxDateTime::UNow();
    //wxTimeSpan now = wxTimeSpan::Second();
    wxString timeInString = now.Format(_T("%S"))+_T("."+now.Format(_T("%l")));

    //wxString timeInString = wxString::Format(wxT("%l"),now.GetSeconds());
    wxString sparkPString = wxString::Format(wxT("%d"),sparkP);
    wxString sparkPStringW = wxString::Format(wxT("%d"),sparkPW);
    wxString rpmString = wxString::Format(wxT("%d"),rpm);
    wxString dwellString = wxString::Format(wxT("%d"),dwell);
    wxString missingCntString = wxString::Format(wxT("%d"),missingCnt);
    wxString missingRatioString = wxString::Format(wxT("%d"),m_missingRatio);
    wxString sparkPString2 = wxString::Format(wxT("%d"),sparkP2);
    wxString sparkPStringW2 = wxString::Format(wxT("%d"),sparkPW2);
    wxString dwellString2 = wxString::Format(wxT("%d"),dwell2);
    wxString missingCntString2 = wxString::Format(wxT("%d"),missingCnt2);
    wxString missingRatioString2 = wxString::Format(wxT("%d"),m_missingRatio2);
    wxString pwString = wxString::Format(wxT("%d"),pw);
    wxString pwString2 = wxString::Format(wxT("%d"),pw2);
    wxString dpString = wxString::Format(wxT("%d"),dwellP);
    wxString dpString2 = wxString::Format(wxT("%d"),dwellP2);


    writeData =  timeInString +_T("\t");
    writeData += sparkPString +_T("\t");
    writeData += sparkPStringW +_T("\t");
    writeData += sparkPString2 +_T("\t");
    writeData += sparkPStringW2 +_T("\t");
    writeData += rpmString +_T("\t");
    writeData += dwellString+_T("\t");
    writeData += dwellString2+_T("\t");
    writeData += missingCntString+_T("\t");
    writeData += missingRatioString+_T("\t");
    writeData += missingCntString2+_T("\t");
    writeData += missingRatioString2+_T("\t");
    writeData += pwString+_T("\t");
    writeData += pwString2+_T("\t");
    writeData += dpString+_T("\t");
    writeData += dpString2+_T("\n");
    m_file->Write(writeData,wxConvUTF8);
}
