#include "signalgenwx.h"

#include <wx/textfile.h>
#include <wx/filename.h>
#include "../logger.h"
#include "../Utils.h"
#include "../UnicodeHelper.h"

SignalGenWx::SignalGenWx()
{
    //ctor
}

SignalGenWx::~SignalGenWx()
{
    //dtor
}

int SignalGenWx::generateWavFile(const wxString& iniFile)
{
    wxArrayString params;
    parseIniFile(iniFile, params);

    return generateWavFile(params,dirName);
}

int SignalGenWx::generateWavFile(const wxArrayString &params,const wxString& dir)
{
    const char * dir_c = UnicodeHelper::U2C(dir);
    fprintf(stdout, "writing to dir: %s\n", dir_c);

    size_t count = params.GetCount();
    char * argList[255];


    fillCharList(params, argList);

    if( process_param( count, argList ) ){
		usage( "signalgen" );
	} else {
        generateFileName(dir_c);
        if( openWavFile() ){
            return generate_wav_output();
        }else{
            //
        }
	}
    fprintf(stdout, "Done!!\n");
	return 0;

}

int SignalGenWx::parseIniFile(const wxString& strFile, wxArrayString& params)
{
    wxFileName iniFile = wxFileName(strFile);
    dirName = iniFile.GetPath(wxPATH_GET_VOLUME | wxPATH_GET_SEPARATOR);

    if ( strFile.Length()  < 1){ return INVALID_FILENAME; }

    wxTextFile file;
    if ( ! file.Open(strFile) ){ return CANNOT_OPEN_FILE; }
    wxString line;

    bool firstline = true;
    line = file.GetFirstLine();

    do
    {
        if ( firstline ) firstline = false;
        else line = file.GetNextLine();
        //fprintf(stdout, "Trigger line: %s\n", UnicodeHelper::U2C(line) );
        Utils::tokenizeToArray(line, wxT(" "), params);

    }
    while ( !file.Eof() );

    return 0;
}

void SignalGenWx::addDir()
{

//    snprintf( filename, FILENAMEMAXLEN, "%s_%s_%s_%s_%s_%s.wav", type_str, rpm_str, seconds_str, campos_str, amplitude_str, fading_str);
    //wxFileName::GetPathSeparator();
    fprintf(stdout, "Trigger file: %s\n", filename);
    wxString fileName_wx; fileName_wx.Printf(_T("%s"), filename ); // more portable this way
    //fileName_wx.Replace(":","-", true);
    Logger::log(LOG_MSG, fileName_wx);
    wxString tmp = dirName + fileName_wx;

    Logger::log(LOG_MSG, tmp);
    //const char* filename_c = UnicodeHelper::U2C( dirName );
    //fprintf(stdout, "Trigger file: %s", filename_c);
    //strcpy(filename, filename_c);
}

void SignalGenWx::fillCharList(const wxArrayString& params, char ** argList)
{
    size_t count = params.GetCount();

    for ( size_t n = 0; n < count; n++ )
    {
        wxString item = params.Item(n);
        const void *chp = UnicodeHelper::U2C( item );
        argList[n] = (char *)chp;
        fprintf(stdout, "%s\n", argList[n]);
    }

}
