#include "wxSQLite3DbManager.h"

#include "../logger.h"

DatabaseArr wxSQLite3DbManager::m_dbarray;
bool wxSQLite3DbManager::m_initialized = false;

wxSQLite3DbManager::wxSQLite3DbManager()
{
}

wxSQLite3DbManager::~wxSQLite3DbManager()
{
}

/* static */
wxSQLite3Database* wxSQLite3DbManager::Open( const wxString& filename )
{
    if ( ! m_initialized )
        initialize();

    DatabaseArr::iterator it = m_dbarray.find( filename );

    if ( it != m_dbarray.end() )
    {
        wxSQLite3Database* db = it->second;
        if ( db->IsOpen() == false )
        {
            db->Open( filename );
        }
        return db;
    }

    wxSQLite3Database* db = NULL;
    db = new wxSQLite3Database;

    try {
        db->Open( filename );
        m_dbarray[filename] = db;
    }
    catch (...)
    {
    }

    return db;
}

/* static */
void wxSQLite3DbManager::cleanUp()
{
    DatabaseArr::iterator it = m_dbarray.begin();

    for ( ; it != m_dbarray.end(); ++it )
    {
        it->second->Close();
    }

    m_dbarray.clear();
}

void wxSQLite3DbManager::initialize()
{
    wxSQLite3Database::InitializeSQLite();
    m_dbarray.clear();
    m_initialized = true;
}
