#include "STDataHelper.h"

#include "../expression/VariableData.h"
#include "STDataModelBase.h"
#include "../Symbol.h"

/* static */

void STDataHelper::fillVariableHashFromModel(const STDataModelBase& stModel, const SymbolTable& symbolTable, VariableDataDH& variableH)
{
    SymbolTable::const_iterator it = symbolTable.begin();

    for ( ; it != symbolTable.end(); ++it )
    {
        const wxString& key = it->first;

        Symbol* symbol = it->second;

        uint8_t rawValue = stModel.getRawData( *symbol );

        variableH.addValue( key, (double) rawValue );
    }
}
