#ifndef STDATAIOV3_H
#define STDATAIOV3_H

#include "STDataIOBase.h"
#include "../common/typedef.h"

class SymbolTable;
class SIPRDescriptor;
class VemsProtocol;
class Int2DoubleHash;

class STDataIOV3 : public STDataIOBase
{
    public:
        STDataIOV3( const SymbolTable& symbols, SIPRDescriptor* siprDesc, VemsProtocol* vp );
        virtual ~STDataIOV3();

        void initModel();
        void readAllData();
        void writeAllData();
        void burnData();
        void readData( const STDataViewerBaseList* symbolA );
        void writeData( const STDataViewerBaseList* symbolA );
    protected:
    private:
        SIPRDescriptor*             m_pSIPRDescriptor;
        const SymbolTable&          m_symbolTable;
        VemsProtocol*               m_vp;
        uint8_t                     m_buff[256];

        void readPage( int pageNo);
        void failSafePageRead( int pageNo );
        void writeScalarSymbol( int pageNo, int offset, int size );
        void writeArraySymbol( int pageNo, int symbolOffset, const Int2DoubleHash* dirtyOffsetHash );
};

#endif // STDATAIOV3_H
