#include "STDataModelHelper.h"
#include "STDataModelBase.h"


IntToIntSetHash STDataModelHelper::compare( STDataModelBase* modelOne, STDataModelBase* modelTwo, const IntArray& pages )
{
    IntToIntSetHash differences;

    for ( size_t i = 0; i < pages.GetCount(); ++i ) {

        int page = pages[i];
        uint8_t* pageBufferOne = modelOne->getRawBuffer(page);
        uint8_t* pageBufferTwo = modelTwo->getRawBuffer(page);

        if ( ( pageBufferOne == NULL ) || ( pageBufferTwo == NULL ) ) {
            continue;
        }

        if ( ( modelOne->getPageSize(page) != modelTwo->getPageSize(page) ) ) {
            continue;
        }

        for ( size_t j = 0; j < modelOne->getPageSize(page); ++j  ) {

            if ( pageBufferOne[j] != pageBufferTwo[j] ) {
                differences[page].insert(j);
            }

        }
    }

    return differences;
}
