#include "wx/defs.h"
#include <wx/filename.h>

#include "../../logger.h"
#include "../../DirHelper.h"

#include "../../ConfigHelper.h"
#include "Raw2HighConverter.h"

void testRaw2HighConverter()
{
	ConfigHelper::initConfig(CONFIG_TYPE_GUI);

	wxString inputDir = DirHelper::GetPath( dDEBUGLOG ) + _T("CSVConverterTest") + DirHelper::Separ();
	wxString inputFile = _T("v3.2_n000315-2009.10.12-19.50.59.vemslog");
	wxString inputFileFullPath = inputDir + inputFile;

	Raw2HighConverter converter;
	converter.convert( inputFileFullPath );
}


int main( int argc, char **argv )
{
    wxInitializer initializer;
	if ( !initializer )
	{
		printf("Error initializing wx libs\n");
		exit(1);
	}

	wxFileName tmp = wxFileName( wxString::FromAscii( argv[0] ) );
    DirHelper::SetProgramRootDir( tmp.GetPath() );
	
	wxString targetFileFullPath = DirHelper::GetPath(dDEBUGLOG) + _T("filelog.txt");
	Logger::initLog( targetFileFullPath );

	testRaw2HighConverter();

	Logger::logf( LOG_MSG, _T("Test finished! Press ENTER to exit!") );

	getchar();

	wxString logFile = DirHelper::GetPath( dDEBUGLOG ) + _T("filelog.txt");

	::wxExecute( _T("notepad++.exe ") + logFile );

	Logger::cleanup();

	return 0;
}

