#ifndef RAW2HIGHCONVERTERDIALOG_H
#define RAW2HIGHCONVERTERDIALOG_H

#include <wx/string.h>

#include "../../common/wxhashdef.h"

#include "../../ObserverBase.h"

class MTConfigData;
class STDataMgrFacade;
class STDataModelSerial;
class RTDataStatHelper;
class RTDataMgrFacade;
class RTDataInputSIPR;
class RTDataCSVWriter;
class RTDataLogWriter;
class VemsLogReader;
class LogHistoryMgr;
class LogFilter;
class FirmwareInfo;
class RawToHighLogConverter;


class Raw2HighConverter : public ObserverBase
{
    public:
        Raw2HighConverter();
        virtual ~Raw2HighConverter();

        //void setInputFile( const wxString& inputFile );
		void convert( const wxString& inputFile );
		bool isFinished() { return m_isFinished; }

		void notify( int i ){};
        void notify(int i, int idx){};
        void notify(const wxString& str);
        void Init(const wxString& name, const wxString& msg, const int max){};

    private:
        MTConfigData*			m_mtConfigData;

        STDataMgrFacade*		m_stController;
        STDataModelSerial*		m_staticModel;

        RTDataMgrFacade*		m_rtDataMgr;
        RTDataCSVWriter*		m_dataLogWriter;
        RTDataInputSIPR*		m_rtInput;
		RTDataStatHelper*		m_historyConverter;
		DoubleHash				m_viewerModel;

        VemsLogReader*			m_vemsLogReader;
        
        LogHistoryMgr*			m_logHisoryMgr;
		RawToHighLogConverter*	m_converter;
		bool					m_isFinished;

    private:
        void init();
        void initSTModule();
        void initRTModule();
        
		void registerStaticViewers();
		bool ParseHeader(const wxString& filename, FirmwareInfo &fwInfo );
		bool DoConvert( const wxString& input, const wxString& output );

		//void startNext();
        ////void iniParser();
        //bool ConvertFirstItem();
        void clearStaticViewers();
        //void printDoubleHash();
        //wxArrayString m_inputFiles;
        //wxArrayString m_outputFiles;
        //wxString m_outFileName;
        //wxString m_outFilePath;
        //wxString m_iniFileName;
        //int m_cond1;
        //wxDirDialog *m_dirDialog;
        //wxString    m_iniDefStr;
        //wxString    m_logInitDir;
        //LogFilter*          m_logWriter;
};

#endif // RAW2HIGHCONVERTERDIALOG_H


