#include "app.h"
#include "main.h"

#include <wx/string.h>
#include <wx/filename.h>

#include "../../DirHelper.h"
#include "../../logger.h"
#include "../../confighelper.h"

IMPLEMENT_APP(MyApp);

bool MyApp::OnInit()
{
	//int crtDebugFlag = _CrtSetDbgFlag(_CRTDBG_REPORT_FLAG);
	//_CrtSetDbgFlag( crtDebugFlag & ~_CRTDBG_LEAK_CHECK_DF );

	wxFileName prgName = wxFileName(argv[0]);
    wxString path = prgName.GetPath();
    if(path.StartsWith(_T(".")))
	{
         path  = wxFileName::GetCwd();
    }
	DirHelper::SetProgramRootDir(path);

    wxString logfile = DirHelper::GetPath(dDEBUGLOG) + _T("filelog.txt");
    Logger::initLog( logfile );

	ConfigHelper::initConfig(CONFIG_TYPE_GUI);

	MyFrame* frame = new MyFrame(0L, _("wxWidgets Application Template"));
	frame->Show();
	return true;
}

int MyApp::OnExit()
{
	//Logger::cleanup();
	ConfigHelper::cleanup();
	//_CrtDumpMemoryLeaks();
	return 0;
}