#include "main.h"
#include <wx/filedlg.h>
#include <wx/panel.h>
#include <wx/regex.h>

//helper functions
enum wxbuildinfoformat {
    short_f, long_f };

wxString wxbuildinfo(wxbuildinfoformat format)
{
    wxString wxbuild(wxVERSION_STRING);

    if (format == long_f )
    {
#if defined(__WXMSW__)
        wxbuild << _T("-Windows");
#elif defined(__UNIX__)
        wxbuild << _T("-Linux");
#endif

#if wxUSE_UNICODE
        wxbuild << _T("-unicode build");
#else
        wxbuild << _T("-ANSI build");
#endif // wxUSE_UNICODE
    }

    return wxbuild;
}

int idMenuQuit  = wxNewId();
int idMenuAbout = wxNewId();
int idMenuOpen  = wxNewId();

BEGIN_EVENT_TABLE(MyFrame, wxFrame)
    EVT_MENU(idMenuQuit, MyFrame::OnQuit)
    EVT_MENU(idMenuAbout, MyFrame::OnAbout)
END_EVENT_TABLE()

MyFrame::MyFrame(wxFrame *frame, const wxString& title)
    : wxFrame(frame, -1, title)
{
#if wxUSE_MENUS
    // create a menu bar
    wxMenuBar* mbar = new wxMenuBar();
    wxMenu* fileMenu = new wxMenu(_T(""));
    fileMenu->Append(idMenuOpen, _("&Open\tCtrl-O"), _("Open file"));
    fileMenu->Append(idMenuQuit, _("&Quit\tAlt-F4"), _("Quit the application"));
    mbar->Append(fileMenu, _("&File"));

    wxMenu* helpMenu = new wxMenu(_T(""));
    helpMenu->Append(idMenuAbout, _("&About\tF1"), _("Show info about this application"));
    mbar->Append(helpMenu, _("&Help"));

    SetMenuBar(mbar);
#endif // wxUSE_MENUS

#if wxUSE_STATUSBAR
    // create a status bar with some information about the used wxWidgets version
    CreateStatusBar(2);
    //SetStatusText(_("Hello Code::Blocks user !"),0);
    //SetStatusText(wxbuildinfo(short_f),1);
#endif // wxUSE_STATUSBAR

    //Build gui
    m_notebook = new wxNotebook(this,wxID_ANY);

    TestPanel* testTab = new TestPanel(m_notebook, wxID_ANY);
    testTab->setParser(&m_parser);

    EvalPanel* evalTab = new EvalPanel(m_notebook, wxID_ANY);
    evalTab->setParser(&m_parser);

    m_notebook->AddPage(testTab, _T("File"));
    m_notebook->AddPage(new LogPanel(m_notebook, wxID_ANY), _T("Log"));
    m_notebook->AddPage(evalTab, _T("EvalTest"));
}

MyFrame::~MyFrame()
{
    //dtor
}

void MyFrame::OnQuit(wxCommandEvent& event)
{
    Close();
}

void MyFrame::OnAbout(wxCommandEvent& event)
{
    //wxString msg = wxbuildinfo(long_f);
    //wxMessageBox(msg, _("Welcome to..."));
    wxMessageBox(event.GetEventObject()->GetClassInfo()->GetClassName());
}
