#include "TbTbConfigValidate.h"
#include "../DirHelper.h"
#include "../logger.h"
#include "../FirmwareInfo.h"
#include "../firmwareconfig/ConfigValidatorHelper.h"
#include "../vemsdialog/UserDialogBase.h"
#include "../stdatamanager/STDataModelBase.h"

IMPLEMENT_DYNAMIC_CLASS(TbTbConfigValidate,VemsToolBarToolBase);

enum ToolBitmapIds
{

    TBI_CVALI_RED,
    TBI_CVALI_GREY,
    TBI_CVALI_GOLD,
    TBI_CVALI_GREEN,
    TBI_CVALI_RED_BROKEN
};

TbTbConfigValidate::TbTbConfigValidate(int id)
    :VemsToolBarToolBase(id)
{
    m_bmpKeyListArray[TBI_CVALI_GREY].Add( DirHelper::GetPath(dICON) + _T("check-48-grey.png"));
    m_bmpKeyListArray[TBI_CVALI_GOLD].Add( DirHelper::GetPath(dICON) + _T("check-48-gold.png"));
    m_bmpKeyListArray[TBI_CVALI_GREEN].Add( DirHelper::GetPath(dICON) + _T("check-48-green.png"));
    m_bmpKeyListArray[TBI_CVALI_RED].Add( DirHelper::GetPath(dICON) + _T("check-48-red.png"));
    m_bmpKeyListArray[TBI_CVALI_RED_BROKEN].Add( DirHelper::GetPath(dICON) + _T("check-48-red-broken.png"));

    m_stDataModel = NULL;
    m_fwInfo = NULL;
    m_userDialog = NULL;
}

TbTbConfigValidate::~TbTbConfigValidate()
{
    //dtor
}
void TbTbConfigValidate::OnTool(wxCommandEvent &event)
{
    ConfigValidatorMgr::ButtonState btnState = ConfigValidatorHelper::validate( m_fwInfo,
                                                                                m_stDataModel,
                                                                                m_userDialog );

    switch ( btnState )
    {
        case ConfigValidatorMgr::CFV_RED:
        case ConfigValidatorMgr::CFV_RED_BLINKING:
            SetToolBmp(m_bmpHash[TBI_CVALI_RED]);
            break;

        case ConfigValidatorMgr::CFV_YELLOW:
        case ConfigValidatorMgr::CFV_YELLOW_BLINKING:
            SetToolBmp(m_bmpHash[TBI_CVALI_GOLD]);
            break;

        case ConfigValidatorMgr::CFV_UNKNOWN:
            SetToolBmp(m_bmpHash[TBI_CVALI_RED_BROKEN]);
            break;

        case ConfigValidatorMgr::CFV_GREEN:
            SetToolBmp(m_bmpHash[TBI_CVALI_GREEN]);
            break;
    }
}

void TbTbConfigValidate::OnToolR(wxCommandEvent &event)
{
}

void TbTbConfigValidate::OnToolEnter(wxCommandEvent &event)
{
}

void TbTbConfigValidate::Init()
{

    InitBmpRes();

    m_defaultBitmap = m_bmpHash[TBI_CVALI_GREY];
    m_inactiveBitmap = m_bmpHash[TBI_CVALI_GREY];

//    AddRequest(TN_GaugeGroupManager);
//    AddRequest(TN_VemsController);
    AddRequest(TN_STDataModelBase);
    AddRequest(TN_FirmwareInfo);
    AddRequest(TN_UserDialogBase);



    m_shortHelpString = _T("Validate Config");
    m_longHelpString  = _T("Validate Config");

}

bool TbTbConfigValidate::SendObject(int id, wxObject *object, const wxString &message)
{
     switch(id) {
         /*
        case TN_VemsController:
            m_vemsTuneController = dynamic_cast<VemsTuneController*> (object);
            if(!m_vemsTuneController){
                Logger::logf(LOG_MSG,_T("TbTbDevices::SendObject() dynamic_cast failed!"));
                return;
            }
            break;
        */
        case TN_STDataModelBase:
            m_stDataModel =  dynamic_cast<STDataModelBase*> (object);
             if(!m_stDataModel){
                Logger::logf(LOG_MSG,_T("TbTbDevices::SendObject() STDataModelBase dynamic_cast failed!"));
                return false;
            }
            break;
        case TN_FirmwareInfo:
            m_fwInfo = dynamic_cast<FirmwareInfo*> (object);
            if(!m_fwInfo){
                Logger::logf(LOG_MSG,_T("TbTbDevices::SendObject() FirmwareInfo dynamic_cast failed!"));
                return false;
            }
            break;
         case TN_UserDialogBase:
            m_userDialog = dynamic_cast<UserDialogBase*> (object);
            if(!m_userDialog){
                Logger::logf(LOG_MSG,_T("TbTbDevices::SendObject() UserDialogBase dynamic_cast failed!"));
                return false;
            }
            break;
        default:
            break;
    }
    return false;
}
