#ifndef TBTBGAUGEGROUP_H
#define TBTBGAUGEGROUP_H

#include "VemsToolBarToolBase.h"

#include "../gaugedesc/GaugeGroupDesc.h"

class GaugeGroupManager;
class FrameLayoutHandler;

class TbTbGaugeGroup : public VemsToolBarToolBase
{
    DECLARE_DYNAMIC_CLASS(TbTbGaugeGroup);

    public:
        TbTbGaugeGroup() {};
        TbTbGaugeGroup(int id, FrameLayoutHandler* handler);
        virtual ~TbTbGaugeGroup();

        virtual void OnTool(wxCommandEvent &event);
        virtual void OnToolR(wxCommandEvent &event);
        virtual void OnToolEnter(wxCommandEvent &event);
        virtual void Init();
        virtual bool SendObject(int id, wxObject *object, const wxString &message = wxEmptyString);

        void SetGroupId(int id) { m_groupIDtmp = id; };
        void SetGroupInfo(const GaugeGroupDesc& desc);

        void InitGaugeGroupMgr(GaugeGroupManager* mgr);

    protected:

        void ApplyLabel();

        void DrawIconText();
        void InitGGMenu();

        void ChangeGroup(const GaugeGroupDesc& desc);
        void SetGroup(const GaugeGroupDesc& desc);

        void StickGroup();

    private:

        void OnMenu(wxCommandEvent &evt);


        int idMenuAddNew;
        int idMenuRemove;
        int idMenuStick;

        int m_groupIDtmp;

        GaugeGroupDesc      m_groupInfo;
        GaugeGroupManager*  m_gaugeGroupManager;
        wxMenu*             m_popupMenu;
        wxMenu*             m_gMenu;
        FrameLayoutHandler* m_handler;
};

#endif // TBTBGAUGEGROUP_H
