#ifndef TRIGGERLOGCONTROLLER_H
#define TRIGGERLOGCONTROLLER_H


#include "../communication/clients/TimeoutListener.h"
#include "../communication/clients/DeviceModeSelectorListener.h"
#include "../vemsprotocol/ECUInfo.h"
#include "../events/CommunicationEvent.h"


class VemsDeviceControllerBase;
class GeneralEvent;

class TriggerLogController
    : public wxEvtHandler
    , public TimeoutListener
    , public DeviceModeSelectorListener
{
    public:
        TriggerLogController(  VemsDeviceControllerBase* deviceController );
        virtual ~TriggerLogController();

        /// listeners
        void OnTimeout();
        void OnDeviceModeSelected( ECUInfo::EcuMode deviceMode );

        void start();
        void stop();

    private:
        VemsDeviceControllerBase*       m_deviceController;
        ECUInfo::EcuMode                m_deviceMode;
        wxEvtHandler*                   m_evtHandler;

        void registerDeviceModeSelector();
//        void onStartEvent( wxCommandEvent& event );
        void OnCommunicationEvent( CommunicationEvent& event );
        void OnGeneralEvent( GeneralEvent& event );

        DECLARE_EVENT_TABLE()
};


#endif // TRIGGERLOGCONTROLLER_H
