#include "TriggerLogEventManager.h"
#include "TriggerLogV3Dialog.h"
#include "../DirHelper.h"
#include "../logger.h"
#include "../events/RawTriggerLogEvent.h"
#include "../vemsprotocol/VemsDeviceController.h"


TriggerLogEventManager::TriggerLogEventManager( wxWindow* parent, VemsDeviceController* deviceController )
{
    m_deviceController = deviceController;

//    m_v3dialog = NULL;
//
//    if ( m_v3dialog == NULL) {
//        m_v3dialog = new TriggerLogV3Dialog( parent );
//    }
//
//    // notify dlg: read bytes
//    registerObserver( m_v3dialog );
//
//    // notify this from dlg: start/stop/save button
//    m_v3dialog->registerObserver( this );
//
//    m_v3dialog->Show();
    m_deviceController->Connect( wxEVT_RAW_TRIGGER_LOG, RawTriggerLogEventHandler( TriggerLogEventManager::onRawTriggerLogEvent ), NULL, this );
}

TriggerLogEventManager::~TriggerLogEventManager()
{
    m_deviceController->Disconnect( wxEVT_RAW_TRIGGER_LOG, RawTriggerLogEventHandler( TriggerLogEventManager::onRawTriggerLogEvent ), NULL, this );
}


//bool TriggerLogEventManager::StartSession()
//{
//    if( m_vemsTuneController->getDevice() != ECUInfo::DEVICE_V3)
//    {
//        return false;
//    }
//
//    m_vemsTuneController->setECUOnline( false, true );
//
//    m_vemsTuneController->getEcuStateMgr()->setState( ECUInfo::MAN );
//
//    return true;
//}
//
//bool TriggerLogEventManager::EndSession()
//{
////    if ( !wasECUOnline )
////        return false;
//    m_vemsTuneController->setECUOnline(true, false);
//
//    return true;
//}

///// PROCESSBASE
//
//bool TriggerLogEventManager::process()
//{
//    if ( m_isDisabled )
//        return false;
//
//    int data;
//
//    bool ret = m_triggerLog->getData( data );
//
//    if ( ret )
//    {
//        /// notify TriggerLogV3Dialog: read bytes
//        observerNotify( data );
//    }
//
//    return ret;
//}
//
//void TriggerLogEventManager::stop()
//{
//    setDisabled(true);
//    this->ProcessBase::stop();
//}
//
//void TriggerLogEventManager::reset()
//{
//    /// NOP
//}
//
//void TriggerLogEventManager::finished()
//{
//    if ( m_triggerLog->isTimeOut() )
//    {
//        observerNotify( -3 );
//        return;
//    }
//    observerNotify( -2 );
//}

/// OBSERVERBASE_H
void TriggerLogEventManager::notify( int i )
{
//    if ( i == TriggerLogV3Dialog::TL_ID_START )
//    {
////        StartSession();
////        m_triggerLog->start();
////        start();
//        m_deviceController->startTriggerLog();
//    }
//
//    if ( i == TriggerLogV3Dialog::TL_ID_STOP )
//    {
////        // stop
////        stop();
////        m_triggerLog->stop();
////        EndSession();
//        m_deviceController->stopTriggerLog();
//    }
//
//    if ( i == TriggerLogV3Dialog::TL_ID_CLOSE )
//    {
//        m_v3dialog->unRegisterObserver( this );
//        unRegisterObserver( m_v3dialog );
//        m_v3dialog->Destroy();
//        m_v3dialog = NULL;
//    }
}

void TriggerLogEventManager::onRawTriggerLogEvent( RawTriggerLogEvent& event )
{
    wxMemoryBuffer& buffer = event.GetDataBuffer();

    for ( size_t i = 0; i < buffer.GetDataLen(); ++i ) {
        observerNotify( (int)(((uint8_t*)buffer.GetData())[i]) );
    }
}
