#include "Unescaper.h"

#include "../logger.h"

Unescaper::Unescaper()
{
    init();
}

void Unescaper::init()
{
    m_state = WAITING_ESC;
    m_escCount = 0;
    m_escErrorCount = 0;
}

/// src: raw unescaped data
/// out: escaped data;
/// return: true if out is updated!!!
bool Unescaper::parse( uint8_t src, uint8_t& out )
{
    bool res = true;

    switch( m_state )
    {
        case WAITING_ESC:
            if ( src == 0x7d )
            {
                m_state = ESC_FOUND;
                res = false; // OK but out is not updated
            }
            else
            {
                out = src;
            }

            break;

        case ESC_FOUND:
            if ( src == 0x5e )
            {
                out = 0x7e;
                ++m_escCount;
            }
            else if (src == 0x5d )
            {
                out = 0x7d;
                ++m_escCount;
            }
            else
            {
                ++m_escErrorCount;
                // Escaping error!!!
                Logger::logf(LOG_ERROR,_T("Unescaper::parse(() Escaping error %i, v: %02x"), m_escErrorCount, src);
                //out = src; ????????
                res = false;
            }

            m_state = WAITING_ESC;

            break;
    }

    return res;
}

