#include "unidlg2test.h"

//(*InternalHeaders(Unidlg2Test)
#include <wx/artprov.h>
#include <wx/bitmap.h>
#include <wx/intl.h>
#include <wx/image.h>
#include <wx/string.h>
//*)

#include <wx/filename.h>

#include "project/ProjectConfigSaver.h"
#include "helper.h"
#include "logger.h"

/*
ConfigItem();
Name
Value
type:   isFile, isDir, none
parent: ConfigItem
active: true, false;
validate: true, false;

Line:
Config:
Name: Iac
Value: c:\\xxxx...
isFileSelect
isDirSelect
parentName null-->absolut normal: parent = baseDir

active = (chkbox is on/off)
validate = (check if valid and set the bitmap)
*/

//(*IdInit(Unidlg2Test)
const long Unidlg2Test::ID_STATICTEXT1 = wxNewId();
const long Unidlg2Test::ID_TEXTCTRL1 = wxNewId();
const long Unidlg2Test::ID_STATICBITMAP1 = wxNewId();
const long Unidlg2Test::ID_CHECKBOX1 = wxNewId();
const long Unidlg2Test::ID_BUTTONFILE = wxNewId();



//*)
//const long Unidlg2Test::ID_STATICLINE1 = wxNewId();
BEGIN_EVENT_TABLE(Unidlg2Test,wxDialog)

    EVT_BUTTON(idSaveProject, Unidlg2Test::OnButton)
    EVT_BUTTON(wxID_OK, Unidlg2Test::OnButton)
    EVT_BUTTON(wxID_CANCEL, Unidlg2Test::OnButton)

END_EVENT_TABLE()

Unidlg2Test::Unidlg2Test(wxWindow* parent,wxWindowID id)
{
    m_prjCfgSaver = NULL;
    defaultParent = NULL;
    isAddNewLine = false;
    m_isInGroup = false;
    //m_topSizer = new wxBoxSizer(wxVERTICAL);

	//(*Initialize(Unidlg2Test)
	//*)

	errorBitMap = wxArtProvider::GetBitmap(wxART_ERROR,wxART_MENU,wxSize(14,17));
    tickBitMap = wxArtProvider::GetBitmap(wxART_TICK_MARK,wxART_MENU,wxSize(14,17));
    deleteLineBitMap = wxArtProvider::GetBitmap(wxART_DEL_BOOKMARK,wxART_FRAME_ICON);
    addLineBitMap = wxArtProvider::GetBitmap(wxART_ADD_BOOKMARK,wxART_FRAME_ICON);


	Create(parent, id, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxDEFAULT_DIALOG_STYLE, _T("id"));
	m_topSizer = new wxStaticBoxSizer(wxVERTICAL, this, _(""));

//	wxGridSizer* GridSizer1 = new wxGridSizer(0, 5, 0, 0);
	/*
	StaticText1 = new wxStaticText(this, ID_STATICTEXT1, _("Label"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT1"));
	GridSizer1->Add(StaticText1, 0, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
	TextCtrl1 = new wxTextCtrl(this, ID_TEXTCTRL1, _("Text"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL1"));
	GridSizer1->Add(TextCtrl1, 0, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
	StaticBitmap1 = new wxStaticBitmap(this, ID_STATICBITMAP1, wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_ERROR")),wxART_MENU,wxSize(14,17)), wxDefaultPosition, wxSize(14,17), 0, _T("ID_STATICBITMAP1"));
	GridSizer1->Add(StaticBitmap1, 0, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
	CheckBox1 = new wxCheckBox(this, ID_CHECKBOX1, _("Label"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_CHECKBOX1"));
	CheckBox1->SetValue(false);
	GridSizer1->Add(CheckBox1, 0, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
	FileSelectButton = new wxButton(this, ID_BUTTONFILE, _("..."), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTONFILE"));
	GridSizer1->Add(FileSelectButton, 0, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
	*/
//	m_topSizer->Add(GridSizer1, 0, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);

	SetSizer(m_topSizer);
	m_topSizer->Fit(this);
	m_topSizer->SetSizeHints(this);

    m_boxCount=0;

    addDialogButtons();
//	SetAcceleratorTable( *(parent->GetAcceleratorTable()) );


}

void Unidlg2Test::OnButton(wxCommandEvent &evt)
{
    int id = evt.GetId();

    switch(id){
        case idSaveProject:
            if(m_prjCfgSaver)
                m_prjCfgSaver->SaveConfig(m_configItemArray);
            else
                Logger::logf(LOG_MSG,_T("Unidlg2Test::OnButton idSaveProject m_prjCfgSaver = NULL !!!"));
            break;
        default:
            EndModal(id);

    }

}

void Unidlg2Test::addDialogButtons()
{
    const long ID_STATICLINE1 = wxNewId();
    wxStaticLine* StaticLine1 = new wxStaticLine(this,ID_STATICLINE1,wxDefaultPosition,wxSize(10,-1),wxLI_HORIZONTAL,_T("ID_STATICLINE1"));
    m_topSizer->Add(StaticLine1,0,wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,4);

    wxBoxSizer *buttsizer = new wxBoxSizer(wxHORIZONTAL);
    buttsizer->Add(new wxButton(this,idSaveProject, _T("Save prj")),0, wxALL | wxALIGN_CENTER_HORIZONTAL | wxALIGN_CENTER_VERTICAL, 3);
    buttsizer->Add(new wxButton(this,wxID_OK, _T("OK")),0, wxALL | wxALIGN_CENTER_HORIZONTAL | wxALIGN_CENTER_VERTICAL, 3);
    buttsizer->Add(new wxButton(this,wxID_CANCEL, _T("Cancel")),0, wxALL | wxALIGN_CENTER_HORIZONTAL | wxALIGN_CENTER_VERTICAL, 3);

    m_topSizer->Add(buttsizer,0,wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,4);


	SetSizer(m_topSizer);
	m_topSizer->Fit(this);
	m_topSizer->SetSizeHints(this);
    m_topSizer->Layout();
}

Unidlg2Test::~Unidlg2Test()
{

}

void Unidlg2Test::setButtonOK(wxString& name)
{
        m_buttonOK = name;
}

void Unidlg2Test::setDialogType(const wxString& dtype )
{
     //Types: config:    base, header, config,
    //firmware:    base, firmware, firmware_patch
     if(dtype == _T("config_download")){
        type2BoxName[_T("base")] = _T("Base");
        //type2BoxName[_T("header")] = _T("Base");
        type2BoxName[_T("config_download")] = _T("Config Files");

        typesA.Add(_T("base"));
        //typesA.Add(_T("header"));
        typesA.Add(_T("config_download"));
        //TODO: upload check off! is exist image off!!

        addBox(_T("Base"));
        addBox(_T("Config Files"));

   } else if(dtype == _T("config_upload")){
        type2BoxName[_T("base")] = _T("Base");
        type2BoxName[_T("header")] = _T("Base");
        //type2BoxName[_T("config_download")] = _T("Config Files");
        type2BoxName[_T("config")] = _T("Config Files");

        typesA.Add(_T("base"));
        typesA.Add(_T("header"));
        typesA.Add(_T("config_download"));
        typesA.Add(_T("config"));
        //typesA.Add(_T("config_download"));

        addBox(_T("Base"));
        addBox(_T("Config Files"));

    }else if(dtype == _T("config")){
        type2BoxName[_T("base")] = _T("Base");
        type2BoxName[_T("header")] = _T("Base");
        type2BoxName[_T("config")] = _T("Config Files");
        //type2BoxName[_T("config_download")] = _T("Config Files");

        typesA.Add(_T("base"));
        typesA.Add(_T("header"));
        typesA.Add(_T("config"));
        //typesA.Add(_T("config_download"));

        addBox(_T("Base"));
        addBox(_T("Config Files"));

    }else if(dtype == _T("firmware")){
        type2BoxName[_T("base")] = _T("Base");
        type2BoxName[_T("firmware")] = _T("Base");
        type2BoxName[_T("firmware_patch")] = _T("Patch Files");

        typesA.Add(_T("base"));
        typesA.Add(_T("firmware"));
        typesA.Add(_T("firmware_patch"));

        addBox(_T("Base"));
        addBox(_T("Patch Files"));

    }

}
void Unidlg2Test::addBox(const wxString& boxName)
{
    Logger::logf(LOG_MSG, _T("Unidlg2Test::addBox() boxName=")+boxName);



    wxStaticBoxSizer* StaticBoxSizer
    = new wxStaticBoxSizer(wxHORIZONTAL,this,boxName);
	wxFlexGridSizer* GridSizer
	// = new wxGridSizer(0,7,0,0);
	= new wxFlexGridSizer(0,6,0,0);
    GridSizer->AddGrowableCol(2,1);


    m_currGBSizer = new wxGridBagSizer();

    //StaticBoxSizer->Add(GridSizer,1,wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,1);
    StaticBoxSizer->Add(m_currGBSizer,1,wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,1);


  //  if(m_boxCount < 1){
  //          m_boxCount = 1;
  //  }
    Logger::logf(LOG_MSG, _T("Unidlg2Test::addBox() boxCount=%d"), m_boxCount);
    m_topSizer->Insert(m_boxCount,StaticBoxSizer,0,wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,1);

    m_currGridSizer = GridSizer;

    sizerHash[boxName] = m_currGridSizer;
    m_sizerHash[boxName] = m_currGBSizer;

    m_boxCount++;

    //boxRowCount = 0;
    boxRowCountHash[boxName] = 0;
    m_currBoxName = boxName;

    //addCaption();
}

void Unidlg2Test::addCaption()
{
    wxArrayString captionArray = wxArrayString();

    //captionArray.Add(_T("No") );
    captionArray.Add(_T("Delete Line"));
    captionArray.Add(_T("Config Name"));
    captionArray.Add(_T("Config File"));
    captionArray.Add(_T("Valid"));
    captionArray.Add(_T("Upload"));
    captionArray.Add(_T("File select"));

    /*wxGridSizer* actualSizer = sizerHash[m_currBoxName]; */

    wxGridBagSizer * actualGBSizer = m_sizerHash[m_currBoxName];

    short currRow = actualGBSizer->GetRows();

    Logger::logf(LOG_MSG,_T("Unidlg2Test::addCaption() currRow=%i"),currRow);

    for(uint32_t i=0; i< captionArray.Count(); i++){
        wxString cName = captionArray.Item(i);

        wxStaticText *StaticTextNo = new wxStaticText(this,wxID_ANY,cName, wxDefaultPosition,wxDefaultSize,5,cName);
        //actualBoxSizer->Add(StaticTextNo,0,wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,0);
        actualGBSizer->Add(StaticTextNo,wxGBPosition(currRow,i+1),wxDefaultSpan,wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,0);

        wxFont  font = StaticTextNo->GetFont();
        font.SetWeight(wxBOLD);
        StaticTextNo->SetFont(font);
    }


    m_currGBSizer->SetRows(currRow+1);

    boxRowCountHash[m_currBoxName] ++;


    addRowEventId(0);

    wxArrayString *lineNameArray = getLineNameArray();
    lineNameArray->Add(_T("CAPTION"));
}

void Unidlg2Test::addNewLine()
{
    short currRow = m_currGBSizer->GetRows();

    Logger::logf(LOG_MSG,_T("Unidlg2Test::addNewLine(), currRow=%i"),currRow);

    wxStaticText *StaticText = new wxStaticText(this,wxID_ANY,_T("Add New Line: "),wxDefaultPosition,wxDefaultSize,0,_T(""));
    //  m_currGridSizer->Add(StaticText,0,wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,0); // 1.
    m_currGBSizer->Add(StaticText,wxGBPosition(currRow,1),wxDefaultSpan,wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,3); // 1.

    wxArrayString choices;// = wxArrayString;
    choices.Add(_T("Config"));
    choices.Add(_T("Tables"));
    choices.Add(_T("Trigger"));
    choices.Add(_T("IAC"));
    choices.Add(_T("Ignition"));
    choices.Add(_T("etc"));

    wxString defValue = _T("Config");
    wxComboBox * ComboBox = new wxComboBox(this,wxID_ANY,defValue,wxDefaultPosition,wxDefaultSize,choices,0,wxDefaultValidator,_T("ADD_LINE_COMBO"));
//	m_currGridSizer->Add(ComboBox,0,wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,0); // 2.
    m_currGBSizer->Add(ComboBox,wxGBPosition(currRow,2),wxDefaultSpan,wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,3); // 2.



	const long ID_ADD = wxNewId();
	wxBitmapButton *BitmapButton1 = new wxBitmapButton(this,ID_ADD, addLineBitMap,wxDefaultPosition,wxDefaultSize,wxBU_AUTODRAW,wxDefaultValidator,_T("ID_BITMAPBUTTON1"));
	BitmapButton1->SetDefault();
    BitmapButton1->SetToolTip(_("Add Config Line"));
    //m_currGridSizer->Add(BitmapButton1,0,wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,0); //3.
    m_currGBSizer->Add(BitmapButton1,wxGBPosition(currRow,3),wxDefaultSpan,wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,3); //3.

    this->Connect( ID_ADD, wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler(Unidlg2Test::OnAddLine) );
/*
    for(int i=0; i<3; i++){
        m_currGridSizer->Add(0,0,0,wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,0); //4-7
    }
*/

    m_currGBSizer->SetRows(currRow+1);

    isAddNewLine = true;

    addRowEventId(0);

     wxArrayString *lineNameArray = getLineNameArray();
    lineNameArray->Add(_T("addNewLine BUTTON"));
}
///
void Unidlg2Test::addRowEventId(int id)
{

    IntArray* deleteLineArray = deleteLineHash[m_currBoxName];
   if(deleteLineArray == NULL){
         Logger::log(LOG_MSG,_T("Unidlg2Test::addEmptyRow(): new deleteLineArray"));
         deleteLineArray = new IntArray();
         deleteLineHash[m_currBoxName] = deleteLineArray;
    }
    deleteLineArray->Add(id);
}

wxPoint Unidlg2Test::GetGroupBorders(wxGridBagSizer * actualSizer, int row, int col)
{

    int a = row,b=0,e=0;
    wxGBSizerItem *sitem2 = NULL;

    while(a){
        a--;
        sitem2 = actualSizer->FindItemAtPosition(wxGBPosition(a, col));

        if(sitem2) continue;
        b = a+1;
        break;


    }

    a = row;

    while(a<20){
        a++;
        sitem2 = actualSizer->FindItemAtPosition(wxGBPosition(a, col));

        if(sitem2) continue;
        e = a-1;
        break;
    }



    return wxPoint(b,e);

}

void Unidlg2Test::DeleteStaticCaptionLine(wxGridBagSizer * actualSizer, wxGBPosition pos)
{

    DeleteStaticLine(actualSizer, pos);
    DeleteStaticLine(actualSizer, wxGBPosition(pos.GetRow(),pos.GetCol()+2));

}

void Unidlg2Test::DeleteStaticLine(wxGridBagSizer * actualSizer, wxGBPosition pos)
{

    wxGBSizerItem * item = actualSizer->FindItemAtPosition(pos);

    if(!item) return;

    wxSizer *s = item->GetSizer();

    if(!s) return;

    size_t c = s->GetChildren().GetCount();

    for(size_t is = 0; is < c; is++)
    {

        wxSizerItem *i = s->GetItem((size_t)0);

        if(!i) continue;

        wxWindow * w = i->GetWindow();

        if(!w) continue;

        s->Detach(w);

        delete w;
    }

    actualSizer->Detach(s);

}

void Unidlg2Test::deleteLine(int itemRowIndex, int sizerRowIndex, const wxString& actualBoxName)
{
   //size_t index;

    //wxGridSizer* actualSizer = sizerHash[actualBoxName];
    wxGridBagSizer * actualSizer = m_sizerHash[actualBoxName];

    if(actualSizer == NULL ){return;}

    int cols = actualSizer->GetCols();
    Logger::log(LOG_MSG, wxString::Format(_T("Unidlg2Test::deleteLine: col size: %d"), cols) );


    uint16_t rows = actualSizer->GetRows();

    //Logger::logf(LOG_MSG,_T("actualSizer->GetRows = %i, cols=%i"),rows,cols);


    wxGBSizerItem *sItem;
    for(uint16_t a=sizerRowIndex+1; a < rows; a++) {
        for(int i = 0; i < cols; i++){
            sItem = actualSizer->FindItemAtPosition(wxGBPosition(a, i));

            wxString tmp;

            if(sItem) {
                tmp = wxString::Format(_T(", rowspan=%i, colspan=%i"),sItem->GetSpan().GetRowspan(),sItem->GetSpan().GetColspan());
            }

            Logger::logf(LOG_MSG,_T("delete ----------- row=%i, col=%i, item=%p")+tmp,a,i,sItem);

        }

    }



    int sorterdiff = 1;

    for(int i = 0; i < cols; i++){

        wxGBSizerItem *sItem = actualSizer->FindItemAtPosition(wxGBPosition(sizerRowIndex, i));

        if(sItem == NULL){
            Logger::log(LOG_MSG, _T("Unidlg2Test::deleteLine: GetItem() = null") );
            continue;
        }

        if( sItem->IsSizer()) {

            /* wxSizer * bs = sItem->GetSizer(); */

            //actualSizer->Detach(sItem->GetSizer());
            wxPoint c = GetGroupBorders(actualSizer, sizerRowIndex, i);
            //Logger::logf(LOG_MSG,_T("b=%i,e=%i"),c.x,c.y);
            wxGBSizerItem *sItemC = actualSizer->FindItemAtPosition(wxGBPosition(c.x, i));

            if(c.x == c.y) {

                if(!i) {
                    DeleteStaticCaptionLine(actualSizer,wxGBPosition(sizerRowIndex-1, 1));
                    DeleteStaticLine(actualSizer,wxGBPosition(sizerRowIndex+1, 1));
                    sorterdiff += 2;
                }

                DeleteStaticLine(actualSizer,wxGBPosition(c.x, i));
                DeleteStaticLine(actualSizer,wxGBPosition(c.x, cols-1));



            } else {

                wxGBSpan span = sItemC->GetSpan();
                span.SetRowspan(span.GetRowspan()-1);
                sItemC->SetSpan(span);
            }

        }


        if( sItem->IsWindow() ){
            //sItem->Show(false);
            wxWindow* w = sItem->GetWindow();
            actualSizer->Detach(w);
            delete w;

        }

    }



//    wxGBSizerItem *sItem;
    for(uint16_t a=sizerRowIndex+1; a < rows; a++) {
        for(int i = 0; i < cols; i++){
            sItem = actualSizer->FindItemAtPosition(wxGBPosition(a, i));

            wxString tmp;

            if(sItem) {
                tmp = wxString::Format(_T(", rowspan=%i, colspan=%i"),sItem->GetSpan().GetRowspan(),sItem->GetSpan().GetColspan());
            }

            Logger::logf(LOG_MSG,_T("delete ----------- row=%i, col=%i, item=%p")+tmp,a,i,sItem);

            if(sItem)
                sItem->SetPos(wxGBPosition(a-sorterdiff,i));

        }

    }



	actualSizer->RecalcSizes();

	actualSizer->Layout();

    //Logger::logf(LOG_MSG,_T("Unidlg2Test::addLine topsize after cnt=%i"),actualSizer->GetChildren().GetCount());

	m_topSizer->Layout();


    wxArrayString *lineNameArray = getLineNameArray();
    wxString name = lineNameArray->Item(itemRowIndex);
    lineNameArray->RemoveAt(itemRowIndex);


    for(uint32_t i = 0;i < m_configItemArray.Count(); i++){
        FirmwareConfigItem * fwi = m_configItemArray.Item(i);
        if(fwi->name == name){
            //m_configItemArray.RemoveAt(i);
            fwi->status = FirmwareConfigItem::FWIS_REMOVED;
            break;
        }
    }



}

void Unidlg2Test::sessionSelect()
{

}

wxArrayString* Unidlg2Test::getLineNameArray()
{
    wxArrayString *lineNameArray = lineNameArrayHash[m_currBoxName];
    if(lineNameArray == NULL){
        lineNameArray = new wxArrayString();
        lineNameArrayHash[m_currBoxName] = lineNameArray;
    }
    return lineNameArray;
}

wxStaticLine * Unidlg2Test::addStaticLine(wxGridBagSizer * currLineSizer, int style, uint8_t lenght, int align, wxGBPosition pos)
{

    wxBoxSizer * item = new wxBoxSizer(style);

    int linestyle = wxLI_VERTICAL;

    wxGBSpan span(1,1);
    int wstyle = wxALL|wxEXPAND;

    if(style == wxHORIZONTAL) {
        linestyle = wxLI_HORIZONTAL;
        span.SetColspan(lenght);

    } else if(style == wxVERTICAL) {
        span.SetRowspan(lenght);
    }


    wxStaticLine * sline = new wxStaticLine(this, wxID_ANY, wxDefaultPosition, wxSize(2,2) , linestyle);

   // Logger::logf(LOG_MSG,_T("Unidlg2Test::addStaticLine wxStaticLine = %p"),sline);

    item->Add(sline,1,align);

    currLineSizer->Add(item, pos, span, wstyle, 3);

    Logger::logf(LOG_MSG,_T("------ addStaticLine ----- span: col=%i, row=%i"),span.GetColspan(), span.GetRowspan());
    Logger::logf(LOG_MSG,_T("------ addStaticLine ----- pos : col=%i, row=%i"),pos.GetCol(), pos.GetRow());

/*
    wxGBSizerItem * slitem = currLineSizer->FindItem(m_temp1);

    Logger::logf(LOG_MSG,_T("Unidlg2Test::addStaticLine wxGBSizerItem = %p"),slitem);
*/
    return sline;



}

void Unidlg2Test::addStaticCaption(wxGridBagSizer * currLineSizer, uint8_t lenght, const wxString &caption, int rowidx)
{
    wxBoxSizer * csizer = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer * lsizer = new wxBoxSizer(wxHORIZONTAL);

    int wstyle = wxALL|wxEXPAND;

    uint8_t startcol = 1;

    wxGBSpan cspan(1,2);
    wxGBSpan lspan(1,lenght-cspan.GetColspan());

    wxStaticLine * sline = new wxStaticLine(this, wxID_ANY, wxDefaultPosition, wxSize(2,2) , wxLI_VERTICAL);
    wxStaticText * stext = new wxStaticText(this, wxID_ANY, _T(" / ") + caption + _T(" \\ "), wxDefaultPosition, wxDefaultSize, wxALIGN_CENTRE);

    wxStaticLine * cline1 = new wxStaticLine(this, wxID_ANY, wxDefaultPosition, wxSize(2,2) , wxLI_VERTICAL);
    wxStaticLine * cline2 = new wxStaticLine(this, wxID_ANY, wxDefaultPosition, wxSize(2,2) , wxLI_VERTICAL);

   // wxSize ssize = stext->GetSize();
   // Logger::logf(LOG_MSG,_T("++++++++++++++++ x=%i,y=%i"),ssize.x,ssize.y);

    csizer->Add(cline1,1,wxALIGN_BOTTOM);
    csizer->Add(stext,0, wxALIGN_CENTER_VERTICAL | wxRIGHT | wxLEFT ,2);
    csizer->Add(cline2,1,wxALIGN_BOTTOM);

    //csizer->SetItemMinSize(stext,ssize);

    lsizer->Add(sline,1,wxALIGN_BOTTOM,0);

    currLineSizer->Add(csizer, wxGBPosition(rowidx,startcol), cspan, wstyle & ~wxRIGHT, 3);
    currLineSizer->Add(lsizer, wxGBPosition(rowidx,cspan.GetColspan()+startcol), lspan, wstyle & ~wxLEFT, 3);

}

void Unidlg2Test::addLine(FirmwareConfigItem * fwItem)
{

    wxString lineName = fwItem->name;

    bool isGroup = false;
    bool isGrpChanged = false;

    //m_currGrp

    if(fwItem->grpName != wxEmptyString)
        isGroup = true;

    if(fwItem->grpName != m_currGrp)
        isGrpChanged = true;


    //fwItem->toString();
    //BeforeLast(wxChar ch) const
    wxArrayString *lineNameArray = getLineNameArray();

    int idx = lineNameArray->Index(lineName);
    if( idx != wxNOT_FOUND)
    {
        //wxString tmp = lineName +_T("-1");
       //  Logger::log(LOG_MSG,_T("Already existing Window name: ") + lineName );
        //lineNameArray->Add(tmp);
    }else{
        lineNameArray->Add(lineName);
    }

    //wxFlexGridSizer * currLineSizer = m_currGridSizer;
    wxGridBagSizer * currLineSizer = m_currGBSizer;

    //int cols = currLineSizer->GetCols();
    short currRow = currLineSizer->GetRows();

    Logger::logf(LOG_MSG,_T("Unidlg2Test::addLine currRow = %i, lineName = ")+lineName,currRow);

    wxString name_ctrl =lineName+_T("_ctrl");
    wxString name_chkbox =lineName+_T("_chkbox");
    wxString name_button =lineName+_T("_button");
    wxString name_bmap =lineName+_T("_bmap");

 //   const long ID_NUMBER = wxNewId();
    const long ID_DELETE = wxNewId();

    const long ID_STATIC = wxNewId();
    const long ID_CTRL = wxNewId();
    id2FirmwareConfigItem[ID_CTRL] = fwItem;

    const long ID_BMAP = wxNewId();
    const long ID_CHECKBOX = wxNewId();
    const long ID_BUTTONFILE = wxNewId();

    wxString value_ctrl =  _T("");
    wxString value_chkbox = _T("");

    short startCol = 1;

//    uint8_t colc = 9;
    int rbstyle = 0;

    if(isGroup && isGrpChanged && !m_isInGroup) {

        //addStaticLine(currLineSizer, wxHORIZONTAL, 8, wxALIGN_BOTTOM, wxGBPosition(currRow,0));

        addStaticCaption(currLineSizer, 6, fwItem->grpName, currRow);

        currRow++;
        m_grpBeginIdx = currRow;
        rbstyle |= wxRB_GROUP;
    }



    if(isGrpChanged && m_isInGroup) {


        //int rheight = currRow-m_grpBeginIdx;

        addStaticLine(currLineSizer, wxVERTICAL, currRow-m_grpBeginIdx, 0, wxGBPosition(m_grpBeginIdx,0));
        addStaticLine(currLineSizer, wxVERTICAL, currRow-m_grpBeginIdx, 0, wxGBPosition(m_grpBeginIdx,7));
        addStaticLine(currLineSizer, wxHORIZONTAL, 6, wxALIGN_TOP, wxGBPosition(currRow,1));

        currRow++;


        if(isGroup){
            addStaticCaption(currLineSizer, 6, fwItem->grpName, currRow);

            currRow++;
            m_grpBeginIdx = currRow;
            rbstyle |= wxRB_GROUP;
        }

    }


/* Item count
     wxStaticText *StaticTextNo
    = new wxStaticText(this,ID_NUMBER,wxString::Format(_T("%d"),  boxRowCountHash[m_currBoxName] + 1),wxDefaultPosition,wxDefaultSize,0,_T(""));
	currLineSizer->Add(StaticTextNo,0,wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,0);
*/
    // Delete line button
    if(fwItem->mandatory || !isAddNewLine ){
        //currLineSizer->Add(0,0,0,wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,0);

    }else{
        wxBitmapButton *BitmapButton1 = new wxBitmapButton(this,ID_DELETE, deleteLineBitMap,wxDefaultPosition,wxDefaultSize,wxBU_AUTODRAW,wxDefaultValidator,_T("ID_BITMAPBUTTON1"));
        BitmapButton1->SetDefault();
        BitmapButton1->SetToolTip(_("Delete Line"));
        //currLineSizer->Add(BitmapButton1,0,wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL,0);
        currLineSizer->Add(BitmapButton1,wxGBPosition(currRow,startCol),wxDefaultSpan,wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL,3);
    }



    wxStaticText *StaticText1 = new wxStaticText(this,ID_STATIC,lineName,wxDefaultPosition,wxDefaultSize,5,lineName);
//	currLineSizer->Add(StaticText1,0,wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,0);
    currLineSizer->Add(StaticText1,wxGBPosition(currRow,startCol+1),wxDefaultSpan,wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,3);

    wxFont  font = StaticText1->GetFont();
    font.SetWeight(wxBOLD);
    StaticText1->SetFont(font);

    /// Text control
	wxTextCtrl *TextCtrl1 = new wxTextCtrl(this,ID_CTRL,value_ctrl,wxDefaultPosition,wxSize(300, 20),2,wxDefaultValidator,name_ctrl);
//	currLineSizer->Add(TextCtrl1,1,wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,1);
    currLineSizer->Add(TextCtrl1,wxGBPosition(currRow,startCol+2),wxDefaultSpan,wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,3);

	TextCtrl1->SetValue(fwItem->value);
	if(fwItem->active){
        TextCtrl1->Enable();
	}else{
	    TextCtrl1->Disable();
	}

    AddTextChangeEvent(ID_CTRL);

    // Validation bitmap
	wxStaticBitmap *StaticBitmap1;
	//= new wxStaticBitmap(this,ID_BMAP,wxNullBitmap,wxDefaultPosition,wxDefaultSize,0,_T("ID_STATICBITMAP2"));
	if(fwItem->type == _T("config_download")){
        //currLineSizer->Add(0,0,0,wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,0);

	}else if( fwItem->validate ){
	    StaticBitmap1 = new wxStaticBitmap(this,ID_BMAP,errorBitMap,wxDefaultPosition,wxSize(14,17),2,name_bmap);
        //currLineSizer->Add(StaticBitmap1,0,wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,0);
        currLineSizer->Add(StaticBitmap1,wxGBPosition(currRow,startCol+3),wxDefaultSpan,wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,3);
    }else{
        StaticBitmap1 = new wxStaticBitmap(this,ID_BMAP,tickBitMap,wxDefaultPosition,wxSize(14,17),2,name_bmap);
        //currLineSizer->Add(StaticBitmap1,0,wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,0);
        currLineSizer->Add(StaticBitmap1,wxGBPosition(currRow,startCol+3),wxDefaultSpan,wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,3);
    }


    // CheckBox
    if(fwItem->type == _T("config_download")){
        //currLineSizer->Add(0,0,0,wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,0);
    }else if(fwItem->mandatory){
        //currLineSizer->Add(0,0,0,wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,0);
    }else{
        if( fwItem->grpName == wxEmptyString ) {
            wxCheckBox *CheckBox1 = new wxCheckBox(this,ID_CHECKBOX,value_chkbox,wxDefaultPosition,wxDefaultSize,2,wxDefaultValidator,name_chkbox);
            currLineSizer->Add(CheckBox1,wxGBPosition(currRow,startCol+4),wxDefaultSpan,wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,3);
            CheckBox1->SetValue(fwItem->active);
        } else {
            wxRadioButton *RadioButton = new wxRadioButton(this,ID_CHECKBOX,value_chkbox,wxDefaultPosition,wxDefaultSize,rbstyle,wxDefaultValidator,name_chkbox);
            currLineSizer->Add(RadioButton,wxGBPosition(currRow,startCol+4),wxDefaultSpan,wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,3);
            RadioButton->SetValue(fwItem->active);
        }

    }

	wxButton *FileSelectButton = new wxButton(this,ID_BUTTONFILE,_("..."),wxDefaultPosition,wxSize(28,14),2,wxDefaultValidator,name_button);
	//currLineSizer->Add(FileSelectButton,0,wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,0);
    currLineSizer->Add(FileSelectButton,wxGBPosition(currRow,startCol+5),wxDefaultSpan,wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,3);

	//StaticBoxSizer1->Add(GridSizer1,0,wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,0);


    Logger::logf(LOG_MSG,_T("Unidlg2Test::addLine topsize cnt=%i"),currLineSizer->GetChildren().GetCount());


    m_isInGroup = isGroup;

    m_currGrp = fwItem->grpName;


    if(fwItem->lastInPanel && isGroup){

        currRow++;

        addStaticLine(currLineSizer, wxVERTICAL, currRow-m_grpBeginIdx, 0, wxGBPosition(m_grpBeginIdx,0));
        addStaticLine(currLineSizer, wxVERTICAL, currRow-m_grpBeginIdx, 0, wxGBPosition(m_grpBeginIdx,7));
        addStaticLine(currLineSizer, wxHORIZONTAL, 6, wxALIGN_TOP, wxGBPosition(currRow,1));

        m_isInGroup = false;

    }


    AddDeleteEvent(ID_DELETE);
    AddButtonEvent(ID_BUTTONFILE);

    AddCheckBoxEvent(ID_CHECKBOX);
    AddRadioButtonEvent(ID_CHECKBOX);


    SetSizer(m_topSizer);
	m_topSizer->Fit(this);
	m_topSizer->SetSizeHints(this);
	m_topSizer->Layout();
    boxRowCountHash[m_currBoxName] ++;



}

void Unidlg2Test::AddTextChangeEvent(int id)
{
    this->Connect( id,
    wxEVT_COMMAND_TEXT_UPDATED, wxCommandEventHandler(Unidlg2Test::OnTextChange) );
}

void Unidlg2Test::AddCheckBoxEvent(int id)
{
    this->Connect( id,
    wxEVT_COMMAND_CHECKBOX_CLICKED, wxCommandEventHandler(Unidlg2Test::OnCheckBox) );
}

void Unidlg2Test::AddRadioButtonEvent(int id)
{
    this->Connect( id,
    wxEVT_COMMAND_RADIOBUTTON_SELECTED, wxCommandEventHandler(Unidlg2Test::OnRadioButton) );
}

void Unidlg2Test::AddButtonEvent(int id)
{
    this->Connect( id,
    wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler(Unidlg2Test::OnBrowse) );

    onBrowseHash[id] = m_currBoxName;

}


void Unidlg2Test::AddDeleteEvent(int id)
{
    this->Connect( id,
    wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler(Unidlg2Test::OnDelete) );

    //deleteLineHash[id] = index;
    addRowEventId(id);
    //IntArray deleteLineArray = deleteLineHash(actualBoxName);
    onDeleteHash[id] = m_currBoxName;
}

void Unidlg2Test::OnDelete(wxCommandEvent& event)
{
    wxString _C = _T("Unidlg2Test ");
    wxString _F = _T("OnDelete() ");

    int id  = event.GetId();
    if(onDeleteHash.find(id) == onDeleteHash.end() ) {return;}

    wxString actualBoxName = onDeleteHash[id];


    wxGBPosition gbpos = m_sizerHash[actualBoxName]->GetItemPosition( (wxWindow*)event.GetEventObject() );
    Logger::logf(LOG_MSG,_T("Unidlg2Test::OnDelete button pos col=%i, row=%i"),gbpos.GetCol(), gbpos.GetRow() );


    IntArray* deleteLineArray = deleteLineHash[actualBoxName];
    if(deleteLineArray == NULL) return;

    int rowIndex = deleteLineArray->Index(id);
    Logger::log(LOG_MSG,wxString::Format(_T("Unidlg2Test::OnDelete() window id: %d, rowIndex: %d"),id, rowIndex ));

    if(rowIndex == wxNOT_FOUND) return;

    deleteLineArray->RemoveAt(rowIndex);


    ///******************

    /*

    wxArrayString *lineNameArray = getLineNameArray();
    wxString name = lineNameArray->Item(rowIndex);
    lineNameArray->RemoveAt(rowIndex);


    for(uint32_t i = 0;i < m_configItemArray.Count(); i++){
        FirmwareConfigItem * fwi = m_configItemArray.Item(i);
        if(fwi->name == name){
            //m_configItemArray.RemoveAt(i);
            fwi->status = FirmwareConfigItem::FWIS_REMOVED;
            break;
        }
    }

*/







//    deleteLine(rowIndex, actualBoxName);
    deleteLine(rowIndex, gbpos.GetRow(), actualBoxName);


}

void Unidlg2Test::OnTextChange(wxCommandEvent& event)
{
    int id  = event.GetId();
   // Logger::logf(LOG_MSG, _T("void Unidlg2Test::OnTextChange( eventid = %d"),id);
    fprintf( stderr, "UniDlg::OnCheckBox event id: %i\n", id);
    wxWindow * w = FindWindow(id);
    if(!w){
        return;
    }
    bool isTextCtrl = w->IsKindOf(CLASSINFO(wxTextCtrl));
    if(! isTextCtrl ){ return;}
    wxString value = ((wxTextCtrl*) w)->GetValue();
 //   fprintf( stderr, "UniDlg::OnTextChange: %s\n", value.c_str());

    if( id2FirmwareConfigItem.find(id) ==  id2FirmwareConfigItem.end() ){ return;}

    FirmwareConfigItem * actualItem = id2FirmwareConfigItem[id];

    if(actualItem->status == FirmwareConfigItem::FWIS_REMOVED) return;

    actualItem->value = value;
    actualItem->status = FirmwareConfigItem::FWIS_MODIFIED;
 //   Logger::log(LOG_MSG, _T("Unidlg2Test::OnTextChange value: ") +value );
    wxString currPath = actualItem->getAbsolutePath();
    //wxString currPath = actualItem->getR
    //Logger::log(LOG_MSG, _T("Unidlg2Test::OnTextChange FileName: ") +currPath );

    //bool isExist = wxFileName::FileExists(currPath);

    //TODO: revalidate upload button()
    //TODO: revalidate bitmap()
    //TODO: fill vars;

    refreshAllBitmap();
    //validateButton();
}



void Unidlg2Test::refreshAllBitmap()
{

    Int2FirmwareConfigItem::iterator it;
    bool res = true;
   // bool first = true;

    for( it = id2FirmwareConfigItem.begin(); it != id2FirmwareConfigItem.end(); ++it){

        int id =  it->first;
        FirmwareConfigItem * actualItem = it->second;

        if(actualItem->status == FirmwareConfigItem::FWIS_REMOVED) continue;

        wxString currPath = actualItem->getAbsolutePath();

        wxWindow * w = FindWindow(id);
        if(w == NULL){continue;}

        wxString wName = w->GetName();
        wxString baseName = wName.BeforeLast('_');
        wxString bMapName = baseName +_T("_bmap");
        wxWindow* w2 = FindWindowByName(bMapName, this);
        if(w2 == NULL) continue;

      //  Logger::log(LOG_MSG, _T("OnTextChange Bitmap name: ") + bMapName );
        bool iswxStaticBitmap = w2->IsKindOf(CLASSINFO(wxStaticBitmap));
        if(!iswxStaticBitmap) continue;

        bool isExist;
        if(actualItem->isFile){
            isExist = wxFileName::FileExists(currPath);
        }else{
            isExist = wxFileName::DirExists(currPath);
        }

        if(isExist){
            ((wxStaticBitmap*) w2)->SetBitmap(tickBitMap);
        }else{
            ((wxStaticBitmap*) w2)->SetBitmap(errorBitMap);
        }
        //////////////////// validate OK button
        bMapName = baseName +_T("_chkbox");
        w2 = FindWindowByName(bMapName, this);
        if(w2 == NULL){
           res &= isExist;
            continue;
        }

        bool iswxCheckBox = w2->IsKindOf(CLASSINFO(wxCheckBox));
        if(! iswxCheckBox){ continue ;}
        bool isChecked = ((wxCheckBox*) w2)->IsChecked();

        res &= (!isChecked) | isExist;



    }

    wxWindow * w = FindWindow(wxID_OK);
    if(w == NULL){return;}
    w->Enable(res);

}

wxString Unidlg2Test::SetRadioButton(int id, bool set)
{

    wxWindow * w = FindWindow(id);
    if(!w)  return wxEmptyString;

    bool iswxRadioButton = w->IsKindOf(CLASSINFO(wxRadioButton));
    if(!iswxRadioButton) return wxEmptyString;

    wxString wName = w->GetName();

    FirmwareConfigItem *fwItem = getConfigItemByWindowName(wName);
    if(fwItem == NULL) return wxEmptyString;

    if(fwItem->status == FirmwareConfigItem::FWIS_REMOVED) return wxEmptyString;

    fwItem->active = set;
    fwItem->status = FirmwareConfigItem::FWIS_MODIFIED;
    getTextWindowByName(wName)->Enable(set);

    return fwItem->grpName;

}

void Unidlg2Test::OnRadioButton(wxCommandEvent& event)
{
    int id  = event.GetId();
    Logger::logf( LOG_MSG, _T("Unidlg2Test::OnRadioButton event id: %i ---------------"), id);


    wxString grpname = SetRadioButton(id,true);

    Logger::logf( LOG_MSG, _T("Unidlg2Test::OnRadioButton event lastid: %i ---------------"), m_rbLastIDs[grpname]);

    SetRadioButton(m_rbLastIDs[grpname],false);

    m_rbLastIDs[grpname] = id;

    refreshAllBitmap();

}

void Unidlg2Test::OnCheckBox(wxCommandEvent& event)
{
    int id  = event.GetId();
    Logger::logf( LOG_MSG, _T("Unidlg2Test::OnCheckBox event id: %i ---------------"), id);
    wxWindow * w = FindWindow(id);
    if(!w){
        return;
    }
    bool iswxCheckBox = w->IsKindOf(CLASSINFO(wxCheckBox));
    if(!iswxCheckBox){ return; }

    bool isChecked = ((wxCheckBox*) w)->IsChecked();
    fprintf( stderr, "UniDlg::OnCheckBox isChecked: %d\n", isChecked);


    wxString wName = w->GetName();

    FirmwareConfigItem *fwItem = getConfigItemByWindowName(wName);
    if(fwItem == NULL){return; }

    fwItem->active = isChecked;
    fwItem->status = FirmwareConfigItem::FWIS_MODIFIED;

     w = getTextWindowByName(wName);
     if( fwItem->active ){
        w->Enable();
    }else{
        w->Disable();
    }
    Logger::log(LOG_MSG, wxString::Format(_T("Window ID: %d, wname: %s, itemname: %s"), id, wName.c_str(),fwItem->name.c_str()) ) ;

    refreshAllBitmap();
    //TODO: revalidate upload button()
    //TODO: fill vars;
}

void Unidlg2Test::OnBrowse(wxCommandEvent& event)
{
    wxString _C = _T("Unidlg2Test ");
    wxString _F = _T("OnBrowse() ");

    int id  = event.GetId();
    fprintf( stderr, "UniDlg::OnBrowse event id: %i\n", id);
    wxWindow * w = FindWindow(id);
    if(!w){
        return;
    }
    wxString wName = w->GetName();
    Logger::log(LOG_MSG, wxString::Format(_C+_F+ _T("Window ID: %d, name: %s"), id, wName.c_str()) ) ;

    FirmwareConfigItem *fwItem = getConfigItemByWindowName(wName);
    if(fwItem == NULL){return; }

    wxString listDir = fwItem->getListDir();
    //TODO: basedir sould be base or the curr dir of v3gui.exe!!

    Logger::log(LOG_MSG, _T("Unidlg2Test::OnBrowse() listDir: ") +listDir );

     bool isFile = fwItem->isFile;
     if(isFile){
         wxString filter = _T("*.*");
/*        if(fwItem->type == _T("firmware") || fwItem->type == _T("firmware_patch")){
            filter = _T("*.hex");
        }else if(fwItem->type == _T("config")){
            filter = _T("*.txt");
        }
        */
        if(fwItem->type == _T("firmware")){
            filter =  _T("Hex files (*.hex)|*.hex");
            filter += _T("|All files (*.*)|*.*");

        }else if(fwItem->type == _T("firmware_patch")){
            if(fwItem->name == _T("Air patch file")){
                if( !listDir.Contains(_T("matfactor")) ){
                    listDir = listDir+ wxFileName::GetPathSeparator()+ _T("matfactor");
                }
                filter =  _T("Air patch files (*.air)|*.air");
                filter += _T("|All files (*.*)|*.*");
            }
            else {//if(fwItem->name == _T("Coolant patch file"))
                 if( !listDir.Contains(_T("coolantfactor")) ){
                     listDir = listDir + wxFileName::GetPathSeparator()+ _T("coolantfactor");
                 }
                filter =  _T("Coolant patch files (*.clt)|*.clt");
                filter += _T("|All files (*.*)|*.*");
            }
        }else if(fwItem->type == _T("config")){
            filter = _T("*.txt");
        }
        Logger::log(LOG_MSG, _T("Unidlg2Test::OnBrowse() listDir2: ") +listDir );
        wxString message = _T("File select:");
        wxString path =    v3FileDialog(message, listDir, filter, 0);
        Logger::log(LOG_MSG, _T("Unidlg2Test::OnBrowse() path: ") +path );
        fwItem->active = true; ///!!!!!!!!!!!!!!!!!!!! Find better place

        if(path.IsEmpty() ) return;

        wxWindow *w = getTextWindowByName(wName);
        if(w){
            if(fwItem->active){
                w->Enable();
            }else{
                w->Disable();
            }
        }else{
            return;
        }

        wxFileName pathName = wxFileName::FileName(path);
        //TODO: check relative or abs
        if( listDir.IsEmpty() ){
            Logger::log(LOG_MSG, _T("Unidlg2Test::OnBrowse() listDir is Empty!") );
        }
        //if(fwItem->IsRelative() ){

        pathName.MakeRelativeTo( fwItem->getRelativeTo() );
        //}

        ((wxTextCtrl*) w)->SetValue(pathName.GetFullPath());
#ifdef __WXGTK__
        id = ((wxTextCtrl*) w)->GetId();
        wxCommandEvent commandEvent;
        commandEvent.SetId(id);
        Logger::logf(LOG_MSG, _T("Unidlg2Test::OnBrowse() id =%d "),id );
        OnTextChange(commandEvent);
#endif
        //Logger::logf(LOG_MSG, _T("Unidlg2Test::OnBrowse() commandEventid =%d "),commandEvent. );
        Logger::log(LOG_MSG, _T("Unidlg2Test::OnBrowse() base: ") +fwItem->getRelativeTo() );
        Logger::log(LOG_MSG, _T("Unidlg2Test::OnBrowse() path: ") +pathName.GetFullPath() );

        //TODO: select the checkbox  automatically:
        autoSelectCheckBox(wName);
    }else{
        wxString message = _T("Directory select:");
         wxString path = Helper::ChooseDirectory(this, message, listDir,
                listDir, false, false);

        if (path.IsEmpty()){ return;}

        wxWindow* w = getTextWindowByName(wName);
        if(!w){ return; }

        ((wxTextCtrl*) w)->SetValue(path);
#ifdef __WXGTK__
        id = ((wxTextCtrl*) w)->GetId();
        Logger::logf(LOG_MSG, _T("Unidlg2Test::OnBrowse() id =%d "),id );
        wxCommandEvent commandEvent;
        commandEvent.SetId(id);
        OnTextChange(commandEvent);
#endif

    }
}

wxWindow * Unidlg2Test::getTextWindowByName(const wxString& wName)
{
    wxString baseName = wName.BeforeLast('_');
    wxString currTextWindowName = baseName +_T("_ctrl");
    wxWindow* w = FindWindowByName(currTextWindowName, this);
    return w;
}

wxWindow * Unidlg2Test::getCheckBoxWindowByName(const wxString& wName)
{
    wxString baseName = wName.BeforeLast('_');
    wxString currTextWindowName = baseName +_T("_chkbox");
    wxWindow* w = FindWindowByName(currTextWindowName, this);
    return w;
}

FirmwareConfigItem * Unidlg2Test::getConfigItemByWindowName(const wxString& wName)
{
     wxWindow* w = getTextWindowByName(wName);
    if(!w){ return NULL; }

    int id = w->GetId();
    if( id2FirmwareConfigItem.find(id) ==  id2FirmwareConfigItem.end() ){ return NULL;}

    FirmwareConfigItem * actualItem = id2FirmwareConfigItem[id];

    if(actualItem->status == FirmwareConfigItem::FWIS_REMOVED) return NULL;

    return actualItem;
}

void Unidlg2Test::OnAddLine(wxCommandEvent& event)
{
    wxString lineName;
     wxWindow* w = FindWindowByName(_T("ADD_LINE_COMBO"), this);
     bool isCombo = w->IsKindOf(CLASSINFO(wxComboBox));
    if(isCombo){
        lineName = ((wxComboBox*) w)->GetValue();
    }

     FirmwareConfigItem * fwConfItem = new FirmwareConfigItem();
    fwConfItem->name = lineName;
    fwConfItem->value = _T("");
    fwConfItem->type = _T("config");
    fwConfItem->mandatory = false;
    fwConfItem->active = true;
    fwConfItem->validate = true;
    fwConfItem->isFile = true;
    fwConfItem->parent = defaultParent;
    fwConfItem->status = FirmwareConfigItem::FWIS_NEW;

    wxArrayString *lineNameArray = lineNameArrayHash[m_currBoxName];
    if(lineNameArray == NULL){ return;}

    int idx = lineNameArray->Index(lineName);
    if( idx != wxNOT_FOUND){
        //Logger::log(LOG_MSG,wxString::Format(_T("Already existing Window name: ")+ lineName +_T(" idx=%d"), idx) );
        wxString msg = _T("Config name: \"")+  fwConfItem->name+ _T("\" already exist!\n");
        msg += _T("Please give/select unique name!\n");
         wxMessageBox(msg,
                _T("Add new line error!"), wxOK | wxICON_ERROR|wxSTAY_ON_TOP  );
        return;
    }

    m_configItemArray.Add(fwConfItem);
    addLine(fwConfItem);

}


wxString Unidlg2Test::v3FileDialog(wxString & message, wxString& defaultDir, wxString & filter, bool multiSel)
{

wxFileDialog dlg(NULL, message, defaultDir,
                wxEmptyString, filter, wxCHANGE_DIR | (multiSel ? wxMULTIPLE : 0) );

wxString path = wxEmptyString;
//        PlaceWindow(&dlg);
        if (dlg.ShowModal() == wxID_OK)
        {
//           if (multiSel)
//                dlg.GetPaths(multiSel);
//            else
                path = dlg.GetPath();
                Logger::logf(LOG_MSG,_T("Unidlg2Test::v3FileDialog path:")+path);
        }
        Logger::logf(LOG_MSG,_T("Unidlg2Test::v3FileDialog end"));
        return path;
}

void Unidlg2Test::setDefaultParent(FirmwareConfigItem *dp)
{
    defaultParent = dp;
}

void Unidlg2Test::deleteBox(const wxString & name)
{
    if(boxRowCountHash.find(name) == boxRowCountHash.end())
    {
            return;
    }
    int rowCount = boxRowCountHash[name];
    Logger::log(LOG_MSG,wxString::Format(_T("Unidlg2Test::deleteBox rowCount: %i, name: "),rowCount) + name );


/*
    for(int i=0; i < rowCount; i++){
        if( name == _T("Config Files")){
            deleteLine(14, name);
             boxRowCountHash[name] = 2;
        }else{
            deleteLine(0, name);
            boxRowCountHash[name] = 0;
        }
    }
    */
 boxRowCountHash[name] = 0;

 wxSizer *s = sizerHash[name];
 if(s == NULL) return;
 s->Clear(true);
//m_topSizer->Hide(s, true);
//m_topSizer->Remove(1);
/*
    boxRowCountHash.erase(name);
    wxSizer *s = sizerHash[name];
    //s->Clear();
    s->Hide(s, false);
    s->Layout();

    m_topSizer->Remove(s);
    sizerHash.erase(name);
    m_boxCount--;
    */
    wxArrayString *lineNameArray = lineNameArrayHash[name];
    if(lineNameArray == NULL) return;
    lineNameArray->Clear();


}

void Unidlg2Test::loadProject(FirmwareConfigItemArray configItemA)
{
//    Logger::logf(LOG_MSG,_T("Unidlg2Test::loadProject 0"));

    m_configItemArray.Clear();

    WX_APPEND_ARRAY(m_configItemArray, configItemA);

  //  Logger::logf(LOG_MSG,_T("Unidlg2Test::loadProject 1"));

    fillDlg();

    //Logger::logf(LOG_MSG,_T("Unidlg2Test::loadProject 2"));

}

void Unidlg2Test::fillDlg()
{

    bool firstConfig = false;
    for(uint32_t i = 0; i < m_configItemArray.Count(); i++)
    {
        FirmwareConfigItem *firmwareConfigItem = m_configItemArray.Item(i);

        if(firmwareConfigItem->status == FirmwareConfigItem::FWIS_REMOVED) continue;

        wxString type = firmwareConfigItem->type;
        //firmwareConfigItem->toString();
         if(firmwareConfigItem->name == _T("Base")){
            setDefaultParent(firmwareConfigItem);
         }

        //: TODO better:
        if( type2BoxName.find(type) == type2BoxName.end() ){ continue;}
        m_currBoxName = type2BoxName[type];
        m_currGridSizer = sizerHash[m_currBoxName];
        m_currGBSizer = m_sizerHash[m_currBoxName];

        if(type == _T("config") && !firstConfig){
            addNewLine();
            addCaption();
            firstConfig = true;
        }

        if(i+1 == m_configItemArray.Count())
            firmwareConfigItem->lastInPanel = true;

        addLine(firmwareConfigItem);
    }

    /// If type="config" not found in the array
    if(firstConfig == false &&  (type2BoxName.find(_T("config")) != type2BoxName.end() ) ){
        m_currBoxName = type2BoxName[_T("config")];

        m_currGridSizer = sizerHash[m_currBoxName];
        m_currGBSizer = m_sizerHash[m_currBoxName];

        addNewLine();
        addCaption();
        Logger::logf(LOG_MSG,_T("Unidlg2Test::fillDlg()-----------------------------------------------------"));
        Logger::logf(LOG_MSG,_T("Unidlg2Test::fillDlg(): m_currBoxName=")+m_currBoxName);
        Logger::logf(LOG_MSG,_T("Unidlg2Test::fillDlg()-----------------------------------------------------"));
    }

//    if(type != _T("config_download") ){
        refreshAllBitmap();
//    }
    //validateButton();

}


void Unidlg2Test::openSession(const wxString& name)
{
}

void Unidlg2Test::OnSessionDelete(wxCommandEvent& event)
{
}

void Unidlg2Test::OnSessionSave(wxCommandEvent& event)
{
}

wxString Unidlg2Test::getSessionComboValue()
{
    wxWindow* w = FindWindowByName( _T("SELECT_SES_COMBO"), this);
    bool iswxComboBox = w->IsKindOf(CLASSINFO(wxComboBox));
    if(!iswxComboBox){ return wxEmptyString; }

    wxString sessionName = ((wxComboBox *) w)->GetValue();
    return sessionName;
}

void Unidlg2Test::OnSessionLoad(wxCommandEvent& event)
{

    //deleteBox(_T("Base") );
    //deleteBox(_T("Config Files") );
    for(uint32_t i =0; i< typesA.Count(); i++){
        wxString type = typesA.Item(i);
        wxString boxName = type2BoxName[type];
        deleteBox(boxName);
    }
//    addBox(_T("Base") );
//    addBox(_T("Config Files") );

    wxString sessionName = getSessionComboValue();

    Logger::log(LOG_MSG, _T("--------------Unidlg2Test::OnSessionLoad----------------"));

    openSession( sessionName );

    m_topSizer->Layout();
}

FirmwareConfigItemArray* Unidlg2Test::getConfigItemArray()
{
        return &m_configItemArray;
}

void Unidlg2Test::autoSelectCheckBox(const wxString& wName)
{

    wxWindow * w = getCheckBoxWindowByName(wName);
    if(w == NULL){ return;}

    bool iswxCheckBox = w->IsKindOf(CLASSINFO(wxCheckBox));

    if( !iswxCheckBox){ return;}

    ((wxCheckBox*) w)->SetValue(true);
}

wxString Unidlg2Test::getHeaderFile()
{
    for(uint16_t i = 0; i <m_configItemArray.Count(); i++ ){
        FirmwareConfigItem* configItem = m_configItemArray[i];

        if(configItem->status == FirmwareConfigItem::FWIS_REMOVED) continue;

        if( configItem->type == _T("header") ){
            Logger::logf(LOG_MSG,_T("Unidlg2Test::getHeaderFile(): ")+ configItem->getAbsolutePath() );
            //configItem->toString();
            return configItem->getAbsolutePath();
        }
    }
    return wxEmptyString;
}

wxArrayString Unidlg2Test::getConfigFiles()
{
    return getFiles(_T("config"));
}

wxArrayString Unidlg2Test::getFiles(const wxString& type)
{
    wxArrayString configFiles;
    for(uint16_t i = 0; i <m_configItemArray.Count(); i++ ){
        FirmwareConfigItem* configItem = m_configItemArray[i];

        if(configItem->status == FirmwareConfigItem::FWIS_REMOVED) continue;

        if( configItem->type == type ){
            //m_configItemArray.toString();
            //path = configItem->getPath();
            //Logger::log(LOG_MSG,_T("Config file path: ")+ configItem->getAbsolutePath() );

            if(configItem->active){
                Logger::log(LOG_MSG,_T("Unidlg2Test::getFiles(): ")+ configItem->getAbsolutePath() );
                configFiles.Add( configItem->getAbsolutePath() );
            }else{
                Logger::log(LOG_MSG,_T("Unidlg2Test::getFiles(): ")+ configItem->getAbsolutePath() );

            }
        }
    }
    return configFiles;
}

wxArrayString Unidlg2Test::getDownloadConfigFiles()
{
    wxArrayString configFiles;
    for(uint16_t i = 0; i <m_configItemArray.Count(); i++ ){
        FirmwareConfigItem* configItem = m_configItemArray[i];

        if( configItem->status == FirmwareConfigItem::FWIS_REMOVED) continue;


       if( configItem->type == _T("config_download") ){
            configFiles.Add( configItem->getAbsolutePath() );
        }
    }
    return configFiles;
}
