/***************************************************************
 * Name:      VTGaugesApp.cpp
 * Purpose:   Code for Application Class
 * Author:     ()
 * Created:   2010-06-25
 * Copyright:  ()
 * License:
 **************************************************************/


#include "VTGaugesApp.h"


#include <wx/image.h>
#include <wx/filename.h>
#include <wx/socket.h>

#include "../DirHelper.h"
#include "../logger.h"

#include "../configmanager/ConfigHelper2.h"

#include "../common/VemsContext.h"
#include "../common/VemsMessageHashHelper.h"

#include "../bcWidgets/BitmapCanvasSystemSettings.h"

#include "VTGaugesMainFrame.h"

#include "../vemsgauge/GaugeType.h"

IMPLEMENT_APP(VTGaugesApp);

bool VTGaugesApp::OnInit()
{
    wxSocketBase::Initialize();

    wxFileName prgName = wxFileName(argv[0]);
    wxString path = prgName.GetPath();
    if(path.StartsWith(_T("."))){
        path  = wxFileName::GetCwd();
    }
    DirHelper::SetProgramRootDir(path);

    wxString logfile = DirHelper::GetPath(dDEBUGLOG) + _T("filelog_gauges.txt");
    Logger::initLog( logfile );
    //Logger::logf(LOG_MSG, AutoVersion::getFullVersion() );

    ConfigHelper2::init();

    ::wxInitAllImageHandlers();

    wxObject* obj = NULL;

    BitmapCanvasSystemSettings::Init();

    obj = VemsContext::initObject(_T("VemsMessageHashClass"));
    VemsMessageHashHelper::Parse( *((VemsMessageHashClass*)obj) );

    GaugeType::InitDefaults();
    GaugeType::Init();


    VTGaugesMainFrame* f = new VTGaugesMainFrame(NULL,-1,_T("VemsTune logviewer application"));
    f->Show(1);


    return true;
}
