#ifndef VTGAUGESMAINFRAME_H
#define VTGAUGESMAINFRAME_H

#include "../bcWidgets/BitmapCanvasParentBase.h"
#include "../common/types/Int2StringHash.h"

class VTGaugesMainFrame: public wxFrame, public BitmapCanvasParentBase
{
    public:
        VTGaugesMainFrame(wxWindow* parent = NULL, int id = wxID_ANY, const wxString& title = _T("VemsTune logviewer application"), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize);
        virtual ~VTGaugesMainFrame();

        void Init(const wxString& historyfile = wxEmptyString);

        void OnPaint(wxPaintEvent& evt);

    protected:

        void OnLogLeftDown(wxMouseEvent& evt);
        void DrawBackground();

        void OnButton(wxCommandEvent& evt);

        void OpenLog(const wxString& filename);

        void RefreshHistory(const wxString& newfile);

        void OnLeftDown(wxMouseEvent& evt);
        void OnMouseMove(wxMouseEvent& evt);
        void OnLeftUp(wxMouseEvent& evt);

        void InsertHistoryLine(int lineidx);

    private:

        enum {
            idButtonOpen,
            idButtonOpenExp,
            idButtonClose
        };

        Int2StringHash m_logFileLinks;

        wxBitmap* m_bgBitmap;

        wxArrayString   m_logFileHistory;
        wxString        m_historyFile;

        wxFlexGridSizer* m_recentfilesizer;
        wxImage         m_vemslogo16;

        wxPoint m_startDrag;

        DECLARE_EVENT_TABLE();

};

#endif // VTGAUGESMAINFRAME_H
