#ifndef CARPARAMETERS_H
#define CARPARAMETERS_H

#include <wx/string.h>

class DoubleHash;

class CarParameters
{
    public:
        CarParameters();
        CarParameters(CarParameters& in);
        virtual ~CarParameters();
                double getTorque(double drpmPerdt);
                void setCurrentDrivetrain(const wxString& gear);
                void setdrivetrainH(DoubleHash *drivetrainH);
                void setWheelRadius(double value);
                void setaNull(double value);
                void setfNull(double value);
                void setMass(double value);

                double getWheelRadius();
                double getaNull();
                double getfNull();
                double getMass();

                double getDrivetrain();
                DoubleHash * getDrivetrainH();
                double getrpm2v();

                void print();
                CarParameters *Clone();
    protected:
    private:
          DoubleHash * m_driveTrainH;

          double  m_wheelradius;
          double  m_aNull;
          double  m_fNull;
          double  m_mass;

          double  m_drivetrain;
          //double  m_rpm2v;
};

WX_DECLARE_HASH_MAP( int, CarParameters *, wxIntegerHash, wxIntegerEqual, CarParametersH);


#endif // CARPARAMETERS _H
