#ifndef CALIBRATIONBASE_H
#define CALIBRATIONBASE_H

#include "../Symbol.h"
#include "../rtdatamanager/RTDataViewerBase.h"
#include "../stdatamanager/STDataViewerBase.h"


class CommandRequestBase;
class STDataMgrBase;
class RTDataMgrBase;


class CalibrationBase: public RTDataViewerBase
{
    public:
        CalibrationBase();
        virtual ~CalibrationBase();
        virtual void start() = 0;
        virtual void stop() = 0;

        void SetCommandRequest(CommandRequestBase* commandRequest);
        //void SetDataMgrObj(RTDataMgrBase* rtDataMgr);
        void SetDataMgrObj(STDataMgrBase* stDataMgr);
        void AddSTViewer(const wxString& name, STDataViewerBase* stDataViewer);
        /// Additional CalibrationBase specific lanel or null;
        //wxPanel* = getPanel();

    protected:
        CommandRequestBase* m_commandRequest;

        STDataMgrBase* m_stDataMgr;
        //STDataViewerBaseA m_viewerBaseA;
        STDataViewerBaseHash m_viewerBaseH;
    private:

};

class STDataViewerCalibration: public STDataViewerBase
{
    public:
        STDataViewerCalibration(){};
        virtual ~STDataViewerCalibration(){};

        void update(){};
        void requestRead() {}
        void updateModel(){};
        void requestWrite() {}

        void setSymbol( const Symbol& symbol_in ) { m_symbol = symbol_in; }
        wxString toString();

    private:
        Symbol              m_symbol;
};

#endif // CALIBRATIONBASE_H
