#ifndef CheckBoxMatrix_H
#define CheckBoxMatrix_H

//(*Headers(CheckBoxMatrix)
#include <wx/panel.h>
#include <wx/tglbtn.h>

#include "../common/types/IntArray.h"
#include "../common/types/Int2IntHash.h"
#include "../common/types/wxObjectHash.h"
#include "../Observable.h"

class wxCheckBox;
class wxGridSizer;
class CheckBoxMatrixDesc;
//*)

class CheckBoxMatrix: public wxPanel, public Observable
{
	public:

		CheckBoxMatrix(CheckBoxMatrixDesc* pDesc,
            wxWindow* parent,wxWindowID id=wxID_ANY);
		virtual ~CheckBoxMatrix();
        void setValue(int row, int col, bool value);
        int getValue(int row); /// offset;

        void setOutput( int row, const wxString& output, bool isConflicted, const wxString& conflicts = wxEmptyString );
        void showTestButtons( bool show = true );
        void SwitchOffAllsignals();

        void setInjectorNum( unsigned char injnum );

		//(*Declarations(CheckBoxMatrix)
		//wxCheckBox* CheckBox1;
		//*)

		//(*Identifiers(CheckBoxMatrix)
		//static const long ID_CHECKBOX1;
		//*)

		//(*Handlers(CheckBoxMatrix)
		//*)

	protected:

    private:
        wxStaticText**    m_outputs;
        wxToggleButton**  m_testButtons;
        IntArray    m_buttonIds;

        wxStaticBitmap* m_red_arrow;


        CheckBoxMatrixDesc* m_pDesc;
        Int2IntHash m_guiIDToRow;
        Int2IntHash m_guiIDToCol;
        wxObjectHash m_indexToCheckbox;
        wxObjectHash m_summaryCol;

         Int2IntHash m_rowSum;

		void BuildContent(wxWindow* parent,wxWindowID id);

		void calcSummary(int row);
		wxObject* getObject(int row, int col);

        void OnCheckBox(wxCommandEvent& event);
        void setBold(wxWindow* w);

        void OnTestButton( wxCommandEvent& event );

        void SwitchOffTests( unsigned char outputnr );

        wxBitmap getArrow( int start_x, int start_y, int end_x, int end_y );

		DECLARE_EVENT_TABLE()
};

#endif
