#ifndef CONFIGSWITCHADVANCEDUPLOADDIALOG_H
#define CONFIGSWITCHADVANCEDUPLOADDIALOG_H

#include <wx/wx.h>

#include "../common/ConfigSwitchTargetTypes.h"
#include "../bcWidgets/bcParentPanel.h"

class bcStaticBitmap;

class CFGSW_HeadPanel: public bcParentPanel
{
    public:
        CFGSW_HeadPanel(wxWindow* parent, int id, int target = CFG_BOTH);
        virtual ~CFGSW_HeadPanel() {};

        void SetTarget(int target);

    protected:

    private:

        wxString GetTargetIconFile(int target);

        bcStaticBitmap* m_icon;

};

class ConfigSwitchAdvancedUploadDialog: public wxDialog
{
    public:
        ConfigSwitchAdvancedUploadDialog(wxWindow* parent, int configType, int id = wxID_ANY,
            const wxString& title = _T("Upload Advanced") );

        virtual ~ConfigSwitchAdvancedUploadDialog();

        void BuildGui();

        int GetChoosed();

    protected:

        void OnRadio(wxCommandEvent& evt);

    private:

        enum {
            idRBCfgA = 2000,
            idRBCfgB,
            idRBCfgBoth
        };

        wxRadioButton* m_cfgA;
        wxRadioButton* m_cfgB;
        wxRadioButton* m_cfgBoth;

        CFGSW_HeadPanel* m_headPanel;
        int m_currentConfigType;


        DECLARE_EVENT_TABLE();
};



#endif // CONFIGSWITCHADVANCEDUPLOADDIALOG_H
