#include "DialogsLayoutManager.h"

#include "../DirHelper.h"
#include "../wxSqliteHelper.h"
#include "../DisplayHelper.h"

DialogsLayoutManager::DialogsLayoutManager()
{
    //ctor
}

DialogsLayoutManager::~DialogsLayoutManager()
{
    //dtor
}

void DialogsLayoutManager::OpenDB(const wxString &dbfile)
{
    if(dbfile == wxEmptyString)
        m_dbFileName = DirHelper::GetPath(dCONFIG) + _T("dialogLayout.db");
    else
        m_dbFileName = dbfile;

    m_db.Open( m_dbFileName );

    if( !m_db.TableExists(_T("layout")) ) {
        wxString qs = _T("CREATE TABLE [layout] ([name] VARCHAR(128) UNIQUE NULL,[xpos] INTEGER NULL,[ypos] INTEGER NULL,[width] INTEGER  NULL,[height] INTEGER NULL, [maximized] INTEGER(1)  NULL);");
        m_db.ExecuteUpdate(qs);
    }

    wxSqliteHelper::ColumnExists( &m_db, _T("layout"), _T("maximized"), true, _T("INTEGER(1)") );

}

bool DialogsLayoutManager::SaveLayout(const wxString &name, int xpos, int ypos, int width, int height, bool ismaximized )
{
    wxSQLite3ResultSet res = m_db.ExecuteQuery(wxString::Format(_T("select xpos from layout where name='%s';"),name.c_str()));

    int afrows = 0;

    if(ismaximized) {

        if(res.Eof()){
            afrows = m_db.ExecuteUpdate(wxString::Format(_T("insert into layout (name,maximized) values ('%s',%i)"),name.c_str(),1));
        } else {
            afrows = m_db.ExecuteUpdate(wxString::Format(_T("update layout set maximized=1 where name='%s';"),name.c_str()));
        }

    } else {

        if(res.Eof()){
            afrows = m_db.ExecuteUpdate(wxString::Format(_T("insert into layout (name,xpos,ypos,width,height,maximized) values ('%s',%i,%i,%i,%i,0)"),name.c_str(),xpos,ypos,width,height));
        } else {
            afrows = m_db.ExecuteUpdate(wxString::Format(_T("update layout set xpos=%i, ypos=%i, width=%i, height=%i, maximized=0 where name='%s';"),xpos,ypos,width,height,name.c_str()));
        }

    }

    return afrows!=0?true:false;
}


bool DialogsLayoutManager::LoadLayout(const wxString &name, wxPoint &pos, wxSize &size, bool &ismax)
{
    wxSQLite3ResultSet res = m_db.ExecuteQuery(wxString::Format(_T("select * from layout where name='%s';"),name.c_str()));

    if(res.Eof()) return false;

    pos.x  = res.GetInt(_T("xpos"));
    pos.y  = res.GetInt(_T("ypos"));
    size.x = res.GetInt(_T("width"));
    size.y = res.GetInt(_T("height"));
    ismax = res.GetInt(_T("maximized"))!=0?true:false;

    wxSize ds = DisplayHelper::GetDisplaySize();

    if( pos.x >= ds.x ) pos.x = 10;
    if( pos.y >= ds.y ) pos.y = 10;

    if( pos.x < 0 ) pos.x = 10;
    if( pos.y < 0 ) pos.y = 10;

    if( size.x > ds.x || size.x < 100 ) size.x = 500;
    if( size.y > ds.y || size.y < 200 ) size.y = 300;

    return true;
}
