#ifndef INTERPOLATIONWIDGET_H
#define INTERPOLATIONWIDGET_H

#include "../rtdatamanager/RTDataViewerBase.h"
#include "../stdatamanager/STDataViewerBase.h"
#include "StaticViewersController.h"

class InterpolationWidgetDescriptor;
class InterpolationWidgetInputField;
class AggGraphControl;
class SymbolMgr;

class InterpolationWidgetTextCtrl : public wxTextCtrl, public STDataViewerBase
{
    public:
        InterpolationWidgetTextCtrl(    wxWindow* parent,
                                        wxWindowID id,
                                        InterpolationWidgetInputField* desc,
                                        STDataMgrBase* stController,
                                        SymbolMgr* symbolMgr );
        ~InterpolationWidgetTextCtrl();

        ///STDataViewerBase virtual methods
        void update();
        void requestRead();
        void updateModel();
        void requestWrite();

        SymbolArray getSymbols();

    private:
        wxString    m_expression;
        wxString    m_enableExpr;
        Symbol      m_symbol;
        bool        m_isActive;

        void        OnKillFocus( wxFocusEvent& event );

        DECLARE_EVENT_TABLE()
};

class InterpolationWidget : public wxPanel, public RTDataViewerBase, public StaticViewersController
    //public STDataViewerBase //,
{
    DECLARE_DYNAMIC_CLASS(InterpolationWidget)

    public:
        InterpolationWidget();
        InterpolationWidget(    wxWindow* parent,
                                InterpolationWidgetDescriptor* desc,
                                STDataMgrBase* stController,
                                RTDataMgrBase* rtController );

        virtual ~InterpolationWidget();

        ///RTDataViewerBase virtual methods
        void SetValue( double value ) {}
        void refresh( DoubleHash* table );
        void require();
        void unregisterSymbols();
        void SetValueIdx( int idx ) {}

        ///STDataViewerBase virtual methods
        void update();
        void requestRead() {}
        void updateModel() {}
        void requestWrite() {}

    private:
        InterpolationWidgetDescriptor*  m_desc;
        AggGraphControl*                m_curve;
        wxString                        m_realtimeSymbol;
        bool                            m_isSymbolRegistered;

        void buildGUI();
};

#endif // INTERPOLATIONWIDGET_H
