#ifndef SCALINGWIDGETDESCRIPTOR_H
#define SCALINGWIDGETDESCRIPTOR_H

#include <wx/wx.h>

struct InterpolationWidgetAxisDesc
{
    wxString    title;
    wxString    unit;
    wxString    format;
    double      min;
    double      max;
    int         divisions;
};

struct InterpolationWidgetInputField
{
    enum Type { NUMBER, VARIABLE, EXPRESSION, INVALID };

    int      type;
    wxString label;
    wxString value;
    wxString expression;

    wxString toString() const
    {
        wxString result = _T("type: ") + typeToString( type );
        result += _T(", label: ") + label;
        result += _T(", value: ") + value;
        result += _T(", expression: ") + expression;

        return result;
    }

    wxString typeToString( int type ) const
    {
        switch ( type )
        {
            case NUMBER:
                return _T("NUMBER");
            case VARIABLE:
                return _T("VARIABLE");
            case EXPRESSION:
                return _T("EXPRESSION");
            default:
                return _T("INVALID");
        }
    }
};

struct InterpolationWidgetDescriptor : public wxObject
{
    DECLARE_DYNAMIC_CLASS(InterpolationWidgetDescriptor)

    wxString                id;
    wxString                title;
    wxString                realtime;

    InterpolationWidgetAxisDesc xAxis;
    InterpolationWidgetAxisDesc yAxis;

    InterpolationWidgetInputField x0;
    InterpolationWidgetInputField x1;
    InterpolationWidgetInputField y0;
    InterpolationWidgetInputField y1;

    wxString toString() const
    {
        wxString result = _T("id: ") + id + _T("\n");
        result += _T("title: ") + title + _T("\n");
        result += _T("realtime: ") + realtime + _T("\n");
        result += _T("x0: ") + x0.toString() + _T("\n");
        result += _T("x1: ") + x1.toString() + _T("\n");
        result += _T("y0: ") + y0.toString() + _T("\n");
        result += _T("y1: ") + y1.toString() + _T("\n");

        return result;
    }
};


WX_DECLARE_STRING_HASH_MAP( InterpolationWidgetDescriptor*, InterpolationWidgetDescH );

#endif // SCALINGWIDGETDESCRIPTOR_H
