#ifndef STARRAYVIEWERPANEL_H
#define STARRAYVIEWERPANEL_H

#include <wx/wx.h>
#include <wx/panel.h>
#include "../Symbol.h"
#include "../stdatamanager/STDataViewerBase.h"
#include "../common/VemsMatrix.h"

WX_DEFINE_ARRAY( wxTextCtrl*, wxTextCtrlArray );


class STArrayViewerPanel : public wxPanel, public STDataViewerBase
{
    public:
        STArrayViewerPanel( wxWindow* parent, const Symbol& s, const wxString& title = wxEmptyString );

        void update();

        void requestRead() {}
        void updateModel();
        void requestWrite();

        void getOldValues( VemsMatrix<double>& a ) const;
        void getNewValues( VemsMatrix<double>& a ) const;

        // verify monotonity, min, max
        bool verify();
        wxString toString();

    private:
        wxTextCtrlArray m_showCtrls;        //
        wxTextCtrlArray m_editCtrls;        //
        wxString        m_title;
        Symbol          m_symbol;
        bool            m_isSymbolAccepted; //this viewer display only 1-dimension array symbol

        void init();
        void get( const wxTextCtrlArray& ctrls,  VemsMatrix<double>& a ) const;
};

#endif // STARRAYVIEWERPANEL_H
