#ifndef SUPERCURVEEDITOR_H
#define SUPERCURVEEDITOR_H


#include "../stdatamanager/STDataViewerBase.h"


class UserDialogFrameBase;
class SuperCurveDescriptor;
class VemsCurveDialogDescH;
class VemsCurveDialogDesc;
class UserDialogBase;
class RTDataMgrBase;
class SymbolMgr;
class CurveEditor;


class SuperCurveEditor : public wxPanel, public STDataViewerBase
{
    public:
        SuperCurveEditor(   UserDialogFrameBase* parent,
                            SuperCurveDescriptor* superCurveDesc,
                            VemsCurveDialogDescH* curveDescs,
                            UserDialogBase* dialogManager,
                            STDataMgrBase* staticController,
                            RTDataMgrBase* realtimeController,
                            SymbolMgr* symbolManager );

        virtual ~SuperCurveEditor();

        CurveEditor*        getCurrentCurve();

        /// STDataViewerBase methods
        void update();

        void requestRead() {}
        void updateModel() {}
        void requestWrite() {}

    private:
        SuperCurveDescriptor*   m_superCurveDesc;
        VemsCurveDialogDescH*   m_curveDescs;
        UserDialogBase*         m_dialogManager;
        RTDataMgrBase*          m_realtimeController;
        SymbolMgr*              m_symbolManager;
        CurveEditor*            m_curveEditor;

    private:
        void changeToCurve( const wxString& name );
        void createCurve( VemsCurveDialogDesc* curveDesc );
};




#endif // SUPERCURVEEDITOR_H
