#ifndef TABLEMAPPER_H
#define TABLEMAPPER_H

#include <wx/panel.h>
#include "StaticViewersController.h"


class STDataMgrBase;
class SymbolTable;
class TblMapDesc;
class Symbol;

class TableMapper : public wxPanel, public StaticViewersController
{
    public:
        TableMapper( wxWindow* parent,
                     const TblMapDesc& desc,
                     STDataMgrBase* stController,
                     SymbolTable* symbols );
        virtual ~TableMapper();

        void remap();
    protected:
    private:
        //STDataMgrBase*  m_pSTController;
        SymbolTable*    m_pSymbolTable;
        //TblMapDesc*     m_pDesc;            // mapper descriptor
        Symbol*         m_pRowHeaderTbl;
        Symbol*         m_pColHeaderTbl;
        bool            m_isAccepted;       // all parameter ok

        int init(const TblMapDesc& desc);
        void buildGUI(const TblMapDesc& desc);
};

#endif // TABLEMAPPER_H
