#ifndef VEMSFLAGDESCEDITOR_H
#define VEMSFLAGDESCEDITOR_H

#include <wx/gbsizer.h>
#include <wx/wx.h>
#include <wx/wxsqlite3.h>

#include "../gaugedesc/GUIDescStructItem.h"
#include "../common/types/Int2IntHash.h"
#include "../gaugedesc/GUIDescGUIItem.h"

class VemsFlagStates;
class wxTextCtrlNullEx;
class VemsFlagStateDesc;
class VemsFlagDescManager;

class VemsFlagDescEditor: public wxFrame
{
    public:
        VemsFlagDescEditor(wxWindow* parent, VemsFlagDescManager* mgr);
        virtual ~VemsFlagDescEditor();

    protected:

        bool BulidGUI();

        void OnFlagListBox(wxCommandEvent& evt);

        bool LoadFlagStates(const wxString& name, bool checkBlink = true);

        void CreateStateStructDesc();

        void OnStateDelButton(wxCommandEvent& evt);

        void OnButton(wxCommandEvent& evt);

        void AddStateLine(VemsFlagStateDesc& state, int row, int padding);

        void AddNewState();
        void SaveFlagName();
        void DelSelectedFlags();
        void AddNewFlag();
        void SaveFlagStates();

        wxString GetSelectedFlag();

        void RefreshStatePanel();

        void OnChangeCurrentFlagCtrl(wxCommandEvent& evt);

    private:

        enum{
            idFlagListBox,
            idBtnDelFlag,
            idBtnEditFlag,
            idBtnAppendFlag,
            idBtnCloseEditor,
            idBtnAddFlagState,
            idBtnSaveFlagStates,
            idPanelStates
        };

        VemsFlagDescManager*    m_flagMgr;

        wxListBox*              m_flagsListBox;

        wxTextCtrl*             m_newFlagCtrl;
        wxTextCtrlNullEx*       m_currentFlagCtrl;

        wxPanel*                m_flagStatesPanel;

        VemsFlagStates*         m_currentFlagStateDesc;

        GUIDescStructItemArray  m_statesGuiDesc;

        Int2IntHash             m_delBtnId2StateId;

        GUIDescGUIItemArrayIntHash m_stateGUIHash;

        wxSQLite3Database       m_db;

        wxGridBagSizer *        m_currStateSizer;

        wxButton *              m_saveStatesBtn;
        wxButton *              m_setFlagNameBtn;

        int                     m_stateLinePadding;
        int                     m_lastStateLineRowIdx;

        DECLARE_EVENT_TABLE();
};

#endif // VEMSFLAGDESCEDITOR_H
