#ifndef WINDOWTIPPERAGG_H
#define WINDOWTIPPERAGG_H

#include <wx/wx.h>

class WindowTipperAgg: public wxFrame
{
    public:
        WindowTipperAgg(wxWindow * parent, int id = wxID_ANY, const wxPoint &pos = wxDefaultPosition);
        virtual ~WindowTipperAgg();

        void SetMessage(const wxString &msg);

        void ShowWindow(int showlenms = 1000, bool moveToParentCorner = true);
        void ShowWindow(const wxPoint& pos, int showlenms = 5000, int delayedms = 500);


        void HideWin();

        wxString GetMessage() { return m_msg; };

    protected:

        void OnTimer(wxTimerEvent& evt);
        void OnPaint(wxPaintEvent& evt);
        void OnLeave(wxMouseEvent& evt);

    private:

        wxSize DrawLabel(const wxString& msg);

        enum {
            idTimer
        };

        wxWindow*   m_parent;
        wxTimer     m_timer;
        wxBitmap*   m_faceBmp;
        wxString    m_msg;
        int         m_showLen;
        bool        m_isDelayedShow;

        DECLARE_EVENT_TABLE();

};

#endif // WINDOWTIPPERAGG_H
