#ifndef GAUGEGROUPEDITOR_H
#define GAUGEGROUPEDITOR_H

#include <wx/wx.h>
#include <wx/wxsqlite3.h>


#include "../ObserverBase.h"

class wxCheckBoxEx;
class wxTextCtrlNullEx;
class wxComboBoxNullEx;

WX_DECLARE_STRING_HASH_MAP( wxCheckBoxEx*, wxCheckBoxHash );

class GaugeGroupManager;
class wxTextCtrlHotKey;


class GaugeGroupEditor: public wxFrame, public ObserverBase
{
    public:
        GaugeGroupEditor(wxWindow * parent, GaugeGroupManager * ggmgr);
        virtual ~GaugeGroupEditor();

        bool SelectGroup(const wxString &name);

        void Init();

        virtual void notify( int i );
        virtual void notify(int i, int idx) {};
        virtual void notify(const wxString& str) {};
        virtual void Init(const wxString& name, const wxString& msg, const int max) {};

    protected:

        void GetGroupList( wxArrayString &arr );
        bool FillGroupProperitesBox();
        void SaveProperties(const wxString& groupname = wxEmptyString);

        void OnChange(wxCommandEvent& evt);

        void OnGaugeGroup(wxCommandEvent &evt);
        void OnButton(wxCommandEvent &evt);

        void DelGroup();
        void DuplicateCurrentGroup();

    private:
        enum {
            idGGCombo,
            idButtSave,
            idButtClose,
            idButtDelGrp,
            idButtShowGrp,
            idButtDuplicateGrp
        };

        GaugeGroupManager   *   m_ggMgr;
        wxSQLite3Database       m_db;

        wxComboBox  *   m_gaugeGroups;
        wxCheckBoxHash  m_checks;
        wxTextCtrlHotKey    *   m_hkeyCtrl;
        wxTextCtrlNullEx*   m_ggNameCtrl;
        wxTextCtrlNullEx*   m_ggShortNameCtrl;
        wxComboBoxNullEx*   m_themeList;
        wxStaticText        *   m_hotkeyFeedBack;
        wxTextCtrl          *   m_newGgrpCtrl;

        wxButton*           m_savePropsButton;

        wxString            m_lastSelectedGroup;


        DECLARE_EVENT_TABLE();
};

#endif // GAUGEGROUPEDITOR_H
