#ifndef GAUGEGROUPMANAGERXML_H
#define GAUGEGROUPMANAGERXML_H

#include <wx/xml/xml.h>
#include "GaugeGroupManager.h"

WX_DEFINE_ARRAY( wxXmlNode*,  wxXmlNodeArray );
WX_DECLARE_HASH_MAP( GaugeCarrierFrame*, wxXmlNode*, wxPointerHash, wxPointerEqual, FramePtrToNodePtr );

class GaugeGroupManagerXml: public GaugeGroupManager
{
    public:
        GaugeGroupManagerXml(wxWindow* window, wxMenu* parent, MTConfigData* mtConfigData, RTDataMgrBase* rtDataMgrBase, STDataMgrBase* stDataMgrBase);
        virtual ~GaugeGroupManagerXml();

        virtual bool load(const wxString& filename);
        virtual bool save(const wxString& filename);

        virtual void showOnStartup();
        virtual short showGroup(const wxString& groupName);

        virtual void setStickGroup(const wxString &groupname, bool isStick);
        virtual bool isStickedGroup(const wxString &groupname) { return m_stickedGroups[groupname]; };


        virtual void SaveTheme(int gaugeID, const wxString &name) {};
        virtual void SaveDesc(int gaugeID, const wxString &name) {};
        virtual void SaveSymbolname(int gaugeID, const wxString &name) {};
        virtual void SaveMultiSymbolname(int gaugeID, const wxString &name) {};

        virtual bool showGroupByHotkey(const wxString &hkey) { return false; };

        virtual bool IsGroupFloating(const wxString &grpname) { return false; };

        virtual wxString GetHotKeyStringByGroupname(const wxString &grpname) { return wxEmptyString; };

        virtual wxString& GetDataBaseFileName() { return m_dbfile; };

    protected:

        virtual void SetTheme(int id);
        virtual void DoRemoveGauge(GaugeCarrierFrame* gaugeFrame);
        virtual void DoRemoveGauge(GroupMemberObject * gmo){};
        virtual void DoAddGauge( const wxString &groupName, wxString gaugeType);

    private:

        wxString m_dbfile;

        wxXmlDocument       m_groupsXML;
        FramePtrToNodePtr   m_frameToNode;


        wxXmlNode* getGroupNode( const wxString& groupName );

        void setGaugeNodeProperties(    wxXmlNode* gaugeNode,
                                        const wxString& type,
                                        const wxString& name,
                                        int x,
                                        int y,
                                        int size,
                                        int height,
                                        const wxString& theme,
                                        const wxString& desc );

        BoolHash    m_stickedGroups;

};

#endif // GAUGEGROUPMANAGERXML_H
