#ifndef GAUGETYPE_H
#define GAUGETYPE_H

#include <wx/wx.h>
#include <wx/string.h>
#include "../common/types/Int2StringHash.h"

WX_DECLARE_HASH_MAP( int, wxVariant, wxIntegerHash, wxIntegerEqual, Int2wxVariantHash);
WX_DECLARE_STRING_HASH_MAP( Int2wxVariantHash, Int2wxVariantHashStringHash );

class GaugeType
{
    public:
        enum GaugeTypes
        {
            ROUND       = 0,
            DIGITAL     = 1,
            TEXT        = 2,
            GRAPH       = 3,
            FLAG        = 4,
            ARCBAR      = 5,
            TABLE       = 6,
            MULTIGRAPH  = 7,
            DIFFER      = 8,
            TABLE3D     = 9,
            EXPRESSION_GRID = 10,
            GPSCOMPASS  = 11,
            GPSROUTE    = 12,
            COLSGAUGE   = 13
        };

        static int getType( const wxString &type );
        static wxString toString( int type );

        static void Init();

        static void InitDefaults();

        static wxVariant GetDefault( const wxString &type, int gaugetype);
        static wxVariant GetDefault( const wxString &type, const wxString& gaugetype) { return GetDefault( type, getType(gaugetype) ); };


    private:

        static Int2wxVariantHashStringHash m_defaults;

        static Int2StringHash m_gaugeTypes;

};

#endif // GAUGETYPE_H
