#include "GroupMember.h"

#include "../logger.h"

#include "GaugeGroupManager.h"  // use only to pass
#include "GroupMemberObject.h"

/**
  * GroupMember
  */
GroupMember::GroupMember( wxWindow* parent, GaugeProperties& props, GaugeGroupManager* manager, int winid )
{
    initGroupMember( parent, props, manager, winid );

}

void GroupMember::initGroupMember( wxWindow* parent, GaugeProperties& props, GaugeGroupManager* manager, int winid )
{
    m_groupManager  = manager;
    m_parentWindow  = parent;
    m_winID         = winid;
    m_props         = props;

    //if( manager )
    //Logger::logf(LOG_MSG,_T("GroupMember::initGroupMember m_itemID=%i"),m_itemID);
//    if( m_itemID != -1 )
//    {
//        int id = m_parentWindow->GetId();
//        m_parentWindow->Connect(  id, wxEVT_CLOSE_WINDOW , wxCloseEventHandler( GaugeGroupManager::OnFrameClose ),
//                            new GroupMemberObject( m_parentWindow, m_groupName,wxEmptyString,m_itemID), m_groupManager );
//    }
}

GroupMember::~GroupMember()
{
    //dtor
    //Logger::logf(LOG_MSG,_T("GroupMember::~GroupMember()"));
}

wxMenuItem* GroupMember::createFocusMenu()
{
    int id = wxNewId();
    wxMenuItem* fMenu = new wxMenuItem( NULL, id, _T("Set focus after show"),_T(""), wxITEM_CHECK );
    m_parentWindow->Connect( id, wxEVT_COMMAND_MENU_SELECTED, wxCommandEventHandler( GaugeGroupManager::OnSetItemFocusId ),
                       new GroupMemberObject( m_parentWindow, m_props.groupName,wxEmptyString,m_props.itemID, m_winID ), m_groupManager );

    return fMenu;
}

wxMenuItem* GroupMember::createAddMenu()
{
    int id = wxNewId();
    wxMenuItem* addMenu = new wxMenuItem( NULL, id, _T("add") );
    m_parentWindow->Connect( id, wxEVT_COMMAND_MENU_SELECTED, wxCommandEventHandler( GaugeGroupManager::OnAddGauge ),
                       new GroupMemberObject( m_parentWindow, m_props.groupName ), m_groupManager );
    return addMenu;
}

wxMenu* GroupMember::createAddSubMenu()
{
    wxMenu* addMenu = new wxMenu( wxEmptyString );

    int id = wxNewId();
    addMenu->Append( id, _T("VemsGauge") );
    m_parentWindow->Connect( id, wxEVT_COMMAND_MENU_SELECTED, wxCommandEventHandler( GaugeGroupManager::OnAddGauge ),
                       new GroupMemberObject( m_parentWindow, m_props.groupName, _T("VemsGauge"), m_props.itemID , m_winID ), m_groupManager );

    id = wxNewId();
    addMenu->Append( id, _T("Digital") );
    m_parentWindow->Connect( id, wxEVT_COMMAND_MENU_SELECTED, wxCommandEventHandler( GaugeGroupManager::OnAddGauge ),
                       new GroupMemberObject( m_parentWindow, m_props.groupName, _T("Digital"),m_props.itemID, m_winID ), m_groupManager );

    id = wxNewId();
    addMenu->Append( id, _T("Text") );
    m_parentWindow->Connect( id, wxEVT_COMMAND_MENU_SELECTED, wxCommandEventHandler( GaugeGroupManager::OnAddGauge ),
                       new GroupMemberObject( m_parentWindow, m_props.groupName, _T("Text"),m_props.itemID, m_winID ), m_groupManager );

    id = wxNewId();
    addMenu->Append( id, _T("Flag") );
    m_parentWindow->Connect( id, wxEVT_COMMAND_MENU_SELECTED, wxCommandEventHandler( GaugeGroupManager::OnAddGauge ),
                       new GroupMemberObject( m_parentWindow, m_props.groupName, _T("Flag"),m_props.itemID, m_winID ), m_groupManager );

    id = wxNewId();
    addMenu->Append( id, _T("Graph") );
    m_parentWindow->Connect( id, wxEVT_COMMAND_MENU_SELECTED, wxCommandEventHandler( GaugeGroupManager::OnAddGauge ),
                       new GroupMemberObject( m_parentWindow, m_props.groupName, _T("Graph"),m_props.itemID, m_winID ), m_groupManager );

    id = wxNewId();
    addMenu->Append( id, _T("ArcBar") );
    m_parentWindow->Connect( id, wxEVT_COMMAND_MENU_SELECTED, wxCommandEventHandler( GaugeGroupManager::OnAddGauge ),
                       new GroupMemberObject( m_parentWindow, m_props.groupName, _T("ArcBar"),m_props.itemID, m_winID ), m_groupManager );

    id = wxNewId();
    addMenu->Append( id, _T("ColumnsGauge") );
    m_parentWindow->Connect( id, wxEVT_COMMAND_MENU_SELECTED, wxCommandEventHandler( GaugeGroupManager::OnAddGauge ),
                       new GroupMemberObject( m_parentWindow, m_props.groupName, _T("ColumnsGauge"),m_props.itemID, m_winID ), m_groupManager );

    id = wxNewId();
    addMenu->Append( id, _T("Differ") );
    m_parentWindow->Connect( id, wxEVT_COMMAND_MENU_SELECTED, wxCommandEventHandler( GaugeGroupManager::OnAddGauge ),
                       new GroupMemberObject( m_parentWindow, m_props.groupName, _T("Differ"),m_props.itemID, m_winID ), m_groupManager );

    id = wxNewId();
    addMenu->Append( id, _T("Multi Graph") );
    m_parentWindow->Connect( id, wxEVT_COMMAND_MENU_SELECTED, wxCommandEventHandler( GaugeGroupManager::OnAddGauge ),
                       new GroupMemberObject( m_parentWindow, m_props.groupName, _T("MultiGraph"),m_props.itemID, m_winID ), m_groupManager );

    id = wxNewId();
    addMenu->Append( id, _T("Table") );
    m_parentWindow->Connect( id, wxEVT_COMMAND_MENU_SELECTED, wxCommandEventHandler( GaugeGroupManager::OnAddGauge ),
                       new GroupMemberObject( m_parentWindow, m_props.groupName, _T("table"),m_props.itemID, m_winID ), m_groupManager );

    id = wxNewId();
    addMenu->Append( id, _T("Table 3D") );
    m_parentWindow->Connect( id, wxEVT_COMMAND_MENU_SELECTED, wxCommandEventHandler( GaugeGroupManager::OnAddGauge ),
                       new GroupMemberObject( m_parentWindow, m_props.groupName, _T("table3d"),m_props.itemID, m_winID ), m_groupManager );

    id = wxNewId();
    addMenu->Append( id, _T("Compass") );
    m_parentWindow->Connect( id, wxEVT_COMMAND_MENU_SELECTED, wxCommandEventHandler( GaugeGroupManager::OnAddGauge ),
                       new GroupMemberObject( m_parentWindow, m_props.groupName, _T("Compass"),m_props.itemID, m_winID ), m_groupManager );

    id = wxNewId();
    addMenu->Append( id, _T("GPS route") );
    m_parentWindow->Connect( id, wxEVT_COMMAND_MENU_SELECTED, wxCommandEventHandler( GaugeGroupManager::OnAddGauge ),
                       new GroupMemberObject( m_parentWindow, m_props.groupName, _T("GPS route"),m_props.itemID,m_winID), m_groupManager );


    return addMenu;
}

wxMenuItem* GroupMember::createRemoveMenu(wxMenu* parent)
{
    int id = wxNewId();

    wxString label = _T("remove");
#if defined ( VEMSDEBUG )
    label += wxString::Format(_T(" (id=%i)"),m_props.itemID);
#endif
    wxMenuItem* removeMenu = new wxMenuItem( parent, id, label );
    m_parentWindow->Connect( id, wxEVT_COMMAND_MENU_SELECTED, wxCommandEventHandler( GaugeGroupManager::OnRemoveGauge ),
                       new GroupMemberObject( m_parentWindow, m_props.groupName,wxEmptyString,m_props.itemID, m_winID ), m_groupManager );
    return removeMenu;
}

wxMenuItem* GroupMember::createSaveMenu(wxMenu* parent)
{
    int id = wxNewId();

    wxMenuItem* saveMenu = new wxMenuItem( parent, id, _T("save gauges layout") );
    m_parentWindow->Connect( id, wxEVT_COMMAND_MENU_SELECTED, wxCommandEventHandler( GaugeGroupManager::OnSave ), NULL, m_groupManager );
    return saveMenu;
}
