#ifndef GROUPMEMBER_H
#define GROUPMEMBER_H

#include <wx/wx.h>
#include "../gaugedesc/GaugeProperties.h"


class GaugeGroupManager;



class GroupMember
{
    public:
        GroupMember( wxWindow* parent = NULL, GaugeProperties& props = DefaultGaugeProperties, GaugeGroupManager* manager = NULL, int winid = -1 );
        virtual ~GroupMember();
		void initGroupMember( wxWindow* parent, GaugeProperties& props, GaugeGroupManager* manager, int winid = -1 );
		void SetHotKeyStr(const wxString &hk) { m_hotKeyStr = hk; };

		void SetItemID(int id) { m_props.itemID = id; };
		int  GetItemID() { return m_props.itemID; };

        wxString& GetGroupName() { return m_props.groupName; };
        void SetGroupName(const wxString& gname) { m_props.groupName = gname; };

        int GetWinID() { return m_winID; }

        GaugeProperties& GetGaugeProperties() { return m_props; };

    protected:
        wxMenuItem* createFocusMenu();
        wxMenuItem* createAddMenu();
        wxMenuItem* createRemoveMenu(wxMenu* parent);
        wxMenuItem* createSaveMenu(wxMenu* parent);
        wxMenu*     createAddSubMenu();

        GaugeGroupManager*  m_groupManager;

        wxString            m_hotKeyStr;


        int         m_winID;

        GaugeProperties     m_props;

    private:
        wxWindow*   m_parentWindow;

};

#endif // GROUPMEMBER_H
