#include "vemsgauge.h"
#include <math.h>
//#include <iostream>

#include <wx/dcclient.h>
#include <wx/brush.h>

#include <wx/image.h>

#include "../logger.h"
#include "gaugeframe.h"


//-----------------------------------------------------------------------
#include "wx/rawbmp.h"

typedef wxPixelData<wxBitmap, wxNativePixelFormat> PixelData;

//-----------------------------------------------------------------------
// I hope it will working
void VemsGauge::TestRawAccess(wxBufferedPaintDC &DC)
  {

	Logger::log(LOG_MSG,_T("TestRawAccess 1 (func START)"));

    BYTE      **SL;       // ScanLines
    int       W, H;       // Sizes (Widtzh, Height)
    wxBitmap  *BMP;       // Temporary bitmap
    BYTE      R, G, B;    // Colour elements
    int       x1, y1;     // From
    int       x2, y2;     // To
    double    x,  y;      // run coordinates
    int       X,  Y;      // rounded coordinates
    double    dx, dy;     // step increments
    int       To;         // core cycle run until this
    BYTE      *pB;        // if don't work, you can use unsigned char!!!!!
    double    R1, R2;     // In & Out raidius of pointer
    wxMemoryDC  myDC;     // Self DC
    double    Alpha;      // actual angle


    ////////////////////////////////////////////
    B = 255;    //
    G = 255;    // Set highlighted Cyan colour
    R = 128;    //
    ////////////////////////////////////////////

    DC.GetSize(&W, &H);

    Logger::log(LOG_MSG,wxString::Format(_T("W=%i, H=%i"),W,H));

    if( H > W )
    {
        R1 = 0.2 * (W / 2);
        R2 = 0.75 * (W / 2);
    }else{
        R1 = 0.2 * (H / 2);
        R2 = 0.75 * (H / 2);
    }

    BMP = new wxBitmap(W, H, 24);

	Logger::log(LOG_MSG,wxString::Format(_T("BMP depth=%i"),BMP->GetDepth()));

    if(BMP == NULL)
      {
        Logger::log(LOG_MSG,_T("Bitmap didn't created!"));
        return;
      }

    if(!BMP->IsOk())
      {
        Logger::log(LOG_MSG,_T("Bitmap has some problem..."));
        return;
      }

    SL = new BYTE*[H];

	Logger::log(LOG_MSG,_T("TestRawAccess 3"));

    PixelData Data(*BMP);

    Logger::log(LOG_MSG,_T("TestRawAccess 4"));

    if ( !Data )
      {
        Logger::log(LOG_MSG,_T("We have a problem, raw acccess didn't work, i'm so sorry!"));
        return;
      }
    else
      {
        Logger::log(LOG_MSG,_T("TestRawAccess 5"));
        PixelData::Iterator P(Data);

        for(Y = 0; Y < H; Y++)
          {
            P.MoveTo(Data, 0, Y);

            //(void *)&(p_B.Blue())
            SL[Y] = (BYTE *)&(P.Blue());
          }
		Logger::log(LOG_MSG,_T("TestRawAccess 6"));
      }



    Alpha = (1.5 * M_PI) + (2 * M_PI / 8000) * m_value;
    x1 = W / 2 + cos(Alpha) * R1;
    y1 = H / 2 + sin(Alpha) * R1;
    x2 = W / 2 + cos(Alpha) * R2;
    y2 = H / 2 + sin(Alpha) * R2;

    dx = x2 - x1;
    dy = y2 - y1;

	Logger::log(LOG_MSG,_T("TestRawAccess 7"));

    if(fabs(dx) < fabs(dy))
      {
		Logger::log(LOG_MSG,_T("TestRawAccess 8a"));

        dx = dx / fabs(dy);

		Logger::log(LOG_MSG,_T("TestRawAccess 9"));

        if(y1 < y2)
          {
            y  = y1;
            To = y2;
            x  = x1;
          }
        else
          {
            y  = y2;
            To = y1;
            x  = x2;
            dx = -dx;
          }

		Logger::log(LOG_MSG,_T("TestRawAccess 10"));
/*
        PixelData::Iterator p(Data);

        X = floor(x);
        Y = floor(y);
        p.Offset(Data, 0, 0);

		Logger::log(LOG_MSG,wxString::Format(_T("x=%f, y=%f"),x,y));
		Logger::log(LOG_MSG,wxString::Format(_T("X=%i, Y=%i"),X,Y));

        while(y <= To)
        {

            PixelData::Iterator rowStart = p; Logger::log(LOG_MSG,_T("TestRawAccess 11"));

            p.Red() = 0x10;			Logger::log(LOG_MSG,_T("TestRawAccess 12"));
            p.Green() = 0x10;		Logger::log(LOG_MSG,_T("TestRawAccess 13"));
            p.Blue() = 0xA5;		Logger::log(LOG_MSG,_T("TestRawAccess 14"));


            p = rowStart;
            p.OffsetY(Data, 1);
            y++;
        }
        */

        while(y <= To)
          {
            X = floor(x);				Logger::log(LOG_MSG,_T("TestRawAccess 11"));
            Y = floor(y);				Logger::log(LOG_MSG,_T("TestRawAccess 12"));
            pB = SL[Y] + (3 * X);		Logger::log(LOG_MSG,_T("TestRawAccess 13"));
            *pB++ = B;					Logger::log(LOG_MSG,_T("TestRawAccess 14"));
            *pB++ = G;					Logger::log(LOG_MSG,_T("TestRawAccess 15"));
            *pB   = R;					Logger::log(LOG_MSG,_T("TestRawAccess 16"));
            x += dx;					Logger::log(LOG_MSG,_T("TestRawAccess 17"));
            y++;						Logger::log(LOG_MSG,_T("TestRawAccess 18"));
          }

		Logger::log(LOG_MSG,_T("TestRawAccess 20"));

      }
    else
      {
		Logger::log(LOG_MSG,_T("TestRawAccess 8b"));
        dy = dy / fabs(dx);
        if(x1 < x2)
          {
            x  = x1;
            To = x2;
            y  = y1;
          }
        else
          {
            x  = x2;
            To = x1;
            y  = y2;
            dy = -dy;
          }

        while(x <= To)
          {
            X = floor(x);
            Y = floor(y);
            pB = SL[Y] + (3 * X);
            *pB++ = B;
            *pB++ = G;
            *pB   = R;
            y += dy;
            x++;
          }
      }


		Logger::log(LOG_MSG,_T("TestRawAccess 80"));

    myDC.SelectObject(*BMP);

		Logger::log(LOG_MSG,_T("TestRawAccess 81"));

    DC.Blit(wxPoint(0,0),wxSize(W,H), &myDC, wxPoint(0,0));

		Logger::log(LOG_MSG,_T("TestRawAccess 82"));

    delete SL;

    delete BMP;

	Logger::log(LOG_MSG,_T("TestRawAccess func END"));
  }//VemsGauge::TestRawAccess()
