#include "VemsExpressionGridWidgetHelper.h"

#include "../common/types/StringSet.h"
#include "../common/types/DoubleHash.h"

size_t VemsExpressionGridWidgetHelper::getVariablesFromString( const wxString& str, StringSet& variables )
{
    enum  { WAIT_DOLLAR, WAIT_START_BRACKET, WAIT_END_BRACKET};

    wxString DOLLAR = _T("$");
    wxString BRACKET_START = _T("{");
    wxString BRACKET_END = _T("}");
    size_t found = 0;
    int state = WAIT_DOLLAR;
    wxString varName;
    for(size_t i = 0; i < str.size(); ++i){
        wxChar chr = str.GetChar(i);
        switch(state){
            case WAIT_DOLLAR:
                if( DOLLAR.IsSameAs( chr ) ){
                    state = WAIT_START_BRACKET;
                }
                break;
            case WAIT_START_BRACKET:
                if( BRACKET_START.IsSameAs(chr) ){
                    state = WAIT_END_BRACKET;
                }else{
                    state = WAIT_START_BRACKET;
                }
                break;
            case WAIT_END_BRACKET:
                 if(BRACKET_END.IsSameAs(chr) ){
                    variables.insert(varName);
                    found++;
                    varName.Clear();
                    state = WAIT_DOLLAR;
                }else{
                    varName.Append(chr);
                }
                break;
        }
    }
    return found;
}

void VemsExpressionGridWidgetHelper::replaceRTVariables( DoubleHash& variables, const StringSet& varSet, wxString* cellStr, int precison )
{

    //DoubleHash::const_iterator* IT = m_rtVariables->begin();

    double var;
    StringSet::const_iterator IT = varSet.begin();
    for(; IT != varSet.end(); ++IT){
        wxString varName = *IT;
        if( !getValue( variables, varName, var)){ continue; }

        wxString valueStr;
        if(var < -999999.0){
            valueStr = _T("NA");
        }else{
            wxString val_mask;
            val_mask.sprintf(_T("%%.%df"), precison );

            //valueStr = wxString::Format(_T("%.3f"), var);
            valueStr = wxString::Format( val_mask, var);

        }

        cellStr->Replace( _T("${")+ varName + _T("}"), valueStr);
    }
}

bool VemsExpressionGridWidgetHelper::getValue( DoubleHash& variables, const wxString& name, double& var )
{
    DoubleHash::const_iterator IT = variables.find(name);
     if( IT == variables.end() ){
        return false;
    }
    var = IT->second;
    return true;
}
