#ifndef VEMSFLAGWIDGET_H
#define VEMSFLAGWIDGET_H

#include <wx/xml/xml.h>

#include "GroupMember.h"
#include "../wxStaticTextEx.h"
#include "../rtdatamanager/RTDataViewerBase.h"
#include "VemsWidgetBase.h"
#include "../gaugedesc/VemsFlagDescManager.h"

class MenuExtendsHandlerBase;
class SymbolNameSaverBase;
class LayoutUpdaterBase;
class UpdateViewerEvent;


class VemsFlagWidget : public VemsWidgetBase
{
    DECLARE_DYNAMIC_CLASS(VemsFlagWidget);

    public:
        VemsFlagWidget() {};
        VemsFlagWidget( wxWindow* parent, wxWindowID id, GaugeDescManager * gdmgr, GaugeProperties &prop);

        virtual ~VemsFlagWidget();

        void SetMenuExtendsHandler(MenuExtendsHandlerBase* handler) { m_menuExtender = handler; }

        void SetValue(double value);
        void SetValueIdx(int idx);

        virtual wxRegion GetShape();
        virtual wxRegion GetBorderRegion() { return wxRegion(); }

        virtual void UpdateSize() {};
        virtual void setSize(int x , int y) {};

        wxString GetSelectedSymbol();

        void SetSymbolSaver(SymbolNameSaverBase * snsb) { m_symbolSaver = snsb; };
        void SetParentLayoutUpdater(LayoutUpdaterBase * lub) { m_parentLayoutUpdaterBase = lub; };

        void InitGauge();

        int GetMaxWidth(int fontsize);

    protected:

        void createMenu(wxMenu* parentMenu);

        void OnSize(wxSizeEvent& evt);

        int CalcFontSize(int height);

        void OnPaint(wxPaintEvent& evt);

        void OnFlashTimer(wxTimerEvent& evt);

        void OnMenuHL(wxMenuEvent & evt);
        void OnShowHelpMenu(wxCommandEvent& evt);

    private:

        enum {
            idFlashTimer,
            idMenuShowHelp
        };

        VemsFlagStateDesc*  m_currStateDesc;

        VemsFlagDescManager* m_descMgr;

        wxPoint             m_beginMousePosition;
        bool                m_isCloseMenu;
        bool                m_isErrorSam0;
        bool                m_isErrorSam1;
        bool                m_isMouseDown;
        int                 m_prevValue;

        Int2IntHash         m_menuId2FlagId;

        wxTimer             m_stateFlashTimer;

        int                 m_currFlashState;

        SymbolNameSaverBase *m_symbolSaver;
        LayoutUpdaterBase* m_parentLayoutUpdaterBase;
        MenuExtendsHandlerBase* m_menuExtender;

        void OnPopupMenuSelectSymbol(wxCommandEvent& event);
        void OnMouseRightClick(wxMouseEvent& event);
        void OnDoubleClick( wxMouseEvent& event );
        DECLARE_EVENT_TABLE();
};


#endif // VEMSFLAGWIDGET_H
