#ifndef VEMSGAUGEAGG_H
#define VEMSGAUGEAGG_H

#include "../agg/wxAgg.h"
#include "VemsWidgetBase.h"

WX_DECLARE_LIST( wxPoint, PointList );

class VemsGaugeAgg : public VemsWidgetBase
{
    public:
        enum DrawingStyle { USE_AGG_POINTER  = 1 };

        VemsGaugeAgg();
		VemsGaugeAgg( wxWindow* parent, wxWindowID id,GaugeDescManager * gdmgr, GaugeProperties &prop);
        virtual ~VemsGaugeAgg();

        void setGradient( const wxColor& begin, const wxColor& end, double angle );

        //VemsWidgetBase virtual functions
        wxRegion GetShape();
        wxRegion GetBorderRegion();
        void UpdateSize();
        void setSize( int x , int y );

        //RTDataViewerBase virtual functions
        void SetValue( double value );

        void SetNewTheme(WidgetThemeTable *theme);

    protected:

    private:
        //control properties
        int         m_width;
        int         m_height;
    	wxPoint     m_centerPoint;

		//gauge properties
		wxColor m_gradientBeginColor;
        wxColor m_gradientEndColor;
        wxColor m_pointerColor;
        wxColor m_backgroundColor;
        wxColor m_tickColor;
        double  m_gradientAngle;
        double  m_gaugeOuterRadius;
        double  m_gaugeInnerRadius;
        double  m_gaugeMiddleRadius;

        double  m_gaugeCoverOuterRadius;
        double  m_gaugeCoverInnerRadius;
        double  m_gaugeCoverX;
        double  m_gaugeCoverY;

  		double  m_tickInnerRadius;
		double  m_tickOuterRadius;
		double  m_tickTextRadius;
		double  m_tickTextHeight;
		wxColor m_tickTextColor;

		double  m_unitTextHeight;
		double  m_unitTextY;
		wxColor m_unitTextColor;

        double  m_valueTextHeight;
        double  m_valueTextY;
		wxColor m_valueTextColor;

		double  m_titleTextHeight;
        double  m_titleTextY;
		wxColor m_titleTextColor;

        double  m_pointerRadius;

        bool        m_isResized;
        wxBitmap*   m_gaugeBMP;         //gauge without pointer and cover
        wxBitmap*   m_gaugeCoverBMP;
        RealPointArray m_tmpPointerCordArray;

        wxFont      m_font;
        int         m_fontSize;

        bool        m_useAggPointer;

        double      m_overResValue;
        bool        m_isDataValid;
        bool        m_firstSetValue;

        bool m_isValueMaxChanged;
        bool m_isValueMinChanged;

        void initMinMax();
        void initTmpGaugePointer();

        void calculateSize();
        void calculatePointerCord(double value, RealPointArray& gaugePointerArray, double pointerRadius);

        void drawGaugeFrame( wxAgg& agg );
		void drawGaugeFrame( wxDC& dc );
        void drawTickMarks( wxAgg& agg );
		void drawTickMarks( wxDC& dc );
        void drawGaugeCover( wxAgg& agg );
        void drawColoredArea( wxAgg& agg );
        void drawPointer( wxAgg& agg, double value, wxColor pointerColor, double pointerRadius);
        void drawUnitText( wxDC& dc );
        void drawGaugeNumbers( wxDC& dc );
        void drawValueText( wxDC& dc );
        void drawTitleText( wxDC& dc );
        void drawPointer( wxDC& dc, double value, wxColor pointerColor, double pointerRadius);
        void drawMultiLineTitleText( wxDC &dc );
        void drawResizedGauge( wxDC& dc );

        void setFrame( double outerRadius, double innerRadius );
        wxString    getValueString();

        void OnPaint(wxPaintEvent &event);
        void OnSize( wxSizeEvent &event );
        DECLARE_EVENT_TABLE()
};

#endif // VEMSGAUGEAGG_H
