#include "VemsGridWidget.h"

#include "../common/typedef.h"

int idGrid = wxNewId();



VemsGridWidget::VemsGridWidget(wxWindow *parent, wxWindowID id)
        :wxFrame(parent, id, _T("gridwidget"))
{
    //ctor
    wxBoxSizer *mainSizer = new wxBoxSizer(wxHORIZONTAL);

    m_grid = new wxGrid(this,idGrid);
    m_grid->CreateGrid(40,2);

    m_grid->SetColSize(-1,20);

    for(uint8_t a=0;a<40;a++) {
        wxString key = wxString::Format(_T("%i"),a);

        //m_grid->SetColLabelValue(a,key);
        m_grid->SetRowLabelValue(a,key);
    }
    //test();
    addNewVAlue(1, 1, 1);
    //m_grid->AutoSize();
    mainSizer->Add(m_grid);
	SetSizer(mainSizer);
	mainSizer->Fit(this);
	mainSizer->SetSizeHints(this);

	m_isSymbolsRegistered = false;
}

VemsGridWidget::~VemsGridWidget()
{
    //dtor
    UnRegisterViewer();
}

void VemsGridWidget::refresh(DoubleHash* table)
{

    DoubleHash::const_iterator it;

    for(uint8_t a=0;a<40;a++) {
        wxString key = wxString::Format(_T("%i"),a);

        it = table->find(key);

        if( it == table->end() )
            continue;

        //double value = (*table)[key];

        //m_grid->SetCellValue(0,a, key); // wxString::Format(_T("%.0f"), it->second

          m_grid->SetCellValue(0,a, wxString::Format(_T("%.1f"), it->second));
    }

}
void VemsGridWidget::test(void)
{

m_grid->SetCellValue(1, 1,_T("test"));

}

void VemsGridWidget::addNewVAlue(int row, int col, int value)
{
wxString stringnumber = wxString::Format(wxT("%d"), (int)value);
m_grid->SetCellValue(row, col,stringnumber);

}

/*
void VemsGridWidget::require(DoubleHash* table)
{

    for(uint8_t a=0;a<40;a++) {
        wxString key = wxString::Format(_T("%i"),a);
        (*table)[key] = 0.3;
    }

}
*/

void VemsGridWidget::require()
{

    if( !m_isSymbolsRegistered )
    {
        for(uint8_t a=0;a<40;a++)
        {
            wxString key = wxString::Format(_T("%i"),a);
            m_rtDataMgr->registerSymbol( key );
        }

        m_isSymbolsRegistered = true;
    }
}

void VemsGridWidget::unregisterSymbols()
{

    if( m_isSymbolsRegistered )
    {
        for(uint8_t a=0;a<40;a++)
        {
            wxString key = wxString::Format(_T("%i"),a);
            m_rtDataMgr->unregisterSymbol( key );
        }

        m_isSymbolsRegistered = true;
    }
}
