#ifndef VEMSTABLEDESC_H
#define VEMSTABLEDESC_H

#include <wx/wx.h>

class VemsTableDesc : public wxObject
{
    DECLARE_DYNAMIC_CLASS(VemsTableDesc)

    public:
        VemsTableDesc();
        virtual ~VemsTableDesc();

        wxString toString();

        wxString    xSTSymbol;
        wxString    xRTSymbol;
        wxString    ySTSymbol;
        wxString    yRTSymbol;
        wxString    zSTSymbol;
        wxString    zRTSymbol;
        wxString    title;
        wxString    name;
        wxString    coupleName;     // 3D or 2D table name
        double      largeCellStep;
        double      smallCellStep;
        bool        is3D;
        int         numberWidth;
        int         numberPrec;
        bool        useTableMapper;
    protected:
    private:
};

WX_DECLARE_STRING_HASH_MAP( VemsTableDesc*, VemsTableDescH );

/**********************************************************
*   VemsTableDescList
**********************************************************/

class VemsTableDescList
{
    public:
        VemsTableDescList();
        virtual ~VemsTableDescList();

        void add( const wxString& name, const wxString& title );
        void setX( const wxString& name, const wxString& xst, const wxString& xrt );
        void setY( const wxString& name, const wxString& yst, const wxString& yrt );
        void setZ( const wxString& name, const wxString& yst );
        void setNumberWidth( const wxString& name, int numberWidth );
        void setNumberPrec( const wxString& name, int numberPrec );
        void setLargeCellStep( const wxString& name, double step );
        void setSmallCellStep( const wxString& name, double step );

        //const USER_DIALOGS* getUserDialogs() const { return &m_uds; } //TEST ONLY!!!
    protected:
    private:
        VemsTableDescH m_vtds;
};

#endif // VEMSTABLEDESC_H
