#include "ComCtrlStates.h"
#include "ECUStateMgrBase.h"
#include "CommunicationController.h"
#include "ProtocolBase.h"
#include "SIPRTypes.h"
#include "../AIMParser.h"
#include "../FirmwareInfo.h"
#include "../logger.h"
#include "../MTConfigHelper.h"
#include "../events/ECUEvent.h"

#include "../events/InputEvent.h"

#include "VemsCommand.h"

#include "TerminalPanel.h"

#include <wx/richtext/richtextctrl.h>

class PWInfoDialog : public wxDialog
{
    public:
        PWInfoDialog();
    private:
};

PWInfoDialog::PWInfoDialog()
{
    Create( NULL, -1, _T("Error"), wxDefaultPosition, wxSize(500,220), wxDEFAULT_DIALOG_STYLE | wxSTAY_ON_TOP );

    wxRichTextCtrl* richTextCtrl = new wxRichTextCtrl( this, wxID_ANY, wxEmptyString, wxDefaultPosition, wxSize(500,220), wxRE_READONLY | wxBORDER_NONE );
    richTextCtrl->SetBackgroundColour( wxSystemSettings::GetColour( wxSYS_COLOUR_3DFACE ) );

    wxFont textFont = wxFont( 10, wxROMAN, wxNORMAL, wxNORMAL );

    richTextCtrl->SetFont( textFont );
    wxRichTextCtrl& r = *richTextCtrl;

    r.BeginBold();
    r.BeginTextColour( wxColour(255, 0, 0) );
    r.WriteText( _T("ECU is password protected!") );
    r.EndTextColour();
    r.EndBold();
    r.Newline(); r.Newline();

    r.BeginAlignment( wxTEXT_ALIGNMENT_JUSTIFIED );
    r.WriteText( _T("If you have the password belonging to the ECU then add it to the ") );
    r.BeginBold(); r.WriteText( _T("config\\password.txt") ); r.EndBold();
    r.WriteText( _T(" file similarly to the example. If the file does not exist just create it and write the 6-digit ECU serial number and the passphrase as follows:"));
    r.EndAlignment();
    r.Newline();
    r.BeginBold(); r.WriteText( _T("xxxxxx=passphrase") ); r.EndBold(); r.Newline(); r.Newline();
    r.BeginItalic();r.WriteText( _T("Example:") ); r.EndItalic(); r.Newline();
    r.WriteText( _T("001234=ABCDEFGH") );
    r.Newline(); r.Newline();
    r.BeginTextColour( wxColor( 160, 0, 0 ) );
    r.WriteText( _T("After creating and/or modifying the file, restart VemsTune!") );
    r.EndTextColour();

    wxBoxSizer* sizer = new wxBoxSizer( wxVERTICAL );
    sizer->Add( richTextCtrl, 0, wxALL, 5 );

    wxSizer* bs = CreateStdDialogButtonSizer( wxOK );
    if ( bs )
    {
        sizer->Add( bs, 0, wxRIGHT | wxLEFT | wxBOTTOM, 5 );
    }

    SetSizer( sizer );
    sizer->Fit( this );
    sizer->SetSizeHints( this );
}


/** States of CommunicationController
    //CCS_Sync
	//CCS_Detect - detect device and state of device
	CCS_GetFirmwareInfoSIPR - ...
	CCS_GetFirmwareInfo - ...

    CCS_Normal
    CCS_ChangeState
    CCS_ChangeBaud
*/

/////******************************************************************CCS_Detect
//CCS_Detect* CCS_Detect::s_pInstance = NULL;
//
//
//void CCS_Detect::reset()
//{
//    m_state             = IDLE;
//    m_iDetectingIdx     = 0;
//    m_iEmptyReadCount   = 0;
//    m_iReadCount        = 0;
//    m_device            = ECUInfo::DEVICE_UNKNOWN;
//}
//
//
//void CCS_Detect::execute( CommunicationController* controller )
//{
//    switch ( m_state )
//    {
//        case IDLE:
//        {
//            Logger::logf( LOG_MSG, _T("-----CCS_Detect::execute() - IDLE\n") );
//
//            /// TODO
//            //controller->m_device = ECUInfo::DEVICE_V3;
//            //controller->m_device = ECUInfo::UNKNOWN_DEVICE;
//            controller->m_commBase->setBaudRate( 19200 );
//
//            if ( controller->m_detectingOrder.IsEmpty() )
//            {
//                wxThread::Sleep( 1000 );
//                return;
//            }
//
//            m_iDetectingIdx     = 0;
//            m_iEmptyReadCount   = 0;
//            m_iReadCount        = 0;
//
//            controller->setProtocolForState( controller->m_detectingOrder[ m_iDetectingIdx ] );
//            /*if ( controller->m_pCurrentProtocol )
//            {
//                controller->m_pCurrentProtocol->enable();
//            }*/
//            m_state = READ;
//        } break;
//
//        case READ:
//        {
//            //Logger::logf( LOG_MSG, _T("-----CCS_Detect::execute() - READ") );
//
//            if ( !controller->readBytes() )
//            {
//                if ( ++m_iEmptyReadCount == MAX_EMPTY_READ )
//                {
//                    Logger::logf( LOG_MSG, _T("-----CCS_Detect::execute() - READ - MAX_EMPTY_READ reached \n") );
//                    m_state = DETECT;
//                    m_iDetectingIdx = 0;
//                }
//
//                wxThread::Sleep( 1 );
//
//                return;
//            }
//
//            m_iEmptyReadCount = 0;
//
//            if ( ++m_iReadCount < MAX_READ ) return;
//
//            Logger::logf( LOG_MSG, _T("-----CCS_Detect::execute() - READ - MAX_READ reached\n") );
//
//            m_iReadCount = 0;
//
//            if ( ++m_iDetectingIdx >= controller->m_detectingOrder.GetCount() )
//            {
//                m_iDetectingIdx = 0;
//                wxThread::Sleep( 1000 );
//            }
//
//            controller->setProtocolForState( controller->m_detectingOrder[ m_iDetectingIdx ] );
//
//        } return;
//
//        case DETECT:
//        {
//            //handle AIM
//            if ( controller->m_detectingOrder[ m_iDetectingIdx ] == ECUInfo::AIM )
//            //if ( controller->getState() == ECUInfo::AIM )
//            {
//                if ( ++m_iDetectingIdx >= controller->m_detectingOrder.GetCount() )
//                {
//                    m_iDetectingIdx = 0;
//                    wxThread::Sleep( 1000 );
//                    return;
//                }
//            }
//
//            controller->setProtocolForState( controller->m_detectingOrder[ m_iDetectingIdx ] );
//
//            Logger::logf( LOG_MSG, _T("-----CCS_Detect::execute() - DETECT - protocol: ") +
//                ECUInfo::getStateAsString( controller->getState() ) + _T("\n") );
//
//            controller->m_pCurrentProtocol->reset();
//            controller->m_pCurrentProtocol->enable();
//            controller->m_pCurrentProtocol->request( new PingCommand() );
//            m_state = WAIT;
//        } break;
//
//        case WAIT:
//        {
//            controller->communicate();
//        } break;
//    }
//}
//
//
//void CCS_Detect::OnSipr( CommunicationController* controller, InputEvent& event )
//{
//    Logger::logf( LOG_MSG, _T("-----CCS_Detect::OnSipr() - protocol: ") +
//        ECUInfo::getStateAsString( controller->getState() ) + _T("\n") );
//
//    SIPRPacket p = event.getPacket();
//
//    switch ( p.type() )
//    {
//        case SIPR_TIMEOUT:
//        {
//            if ( m_state != WAIT ) return;
//
//            Logger::logf( LOG_MSG, _T("-----CCS_Detect::OnSipr() - TIMEOUT - protocol: ") +
//                ECUInfo::getStateAsString( controller->getState() ) + _T("\n") );
//
//            controller->m_pCurrentProtocol->reset();
//
//            if ( ++m_iDetectingIdx >= controller->m_detectingOrder.GetCount() )
//            {
//                m_iDetectingIdx = 0;
//                wxThread::Sleep( 1000 );
//                m_state = IDLE;
//            }
//            else
//            {
//                m_state = DETECT;
//            }
//        } break;
//        case SIPR_ACK:
//        {
//            Logger::logf( LOG_MSG, _T("-----CCS_Detect::OnSipr() - PING OK - protocol: ") +
//                    ECUInfo::getStateAsString( controller->getState() ) + _T("\n") );
//
//            switch ( m_state )
//            {
//                case READ:
//                {
//                    if ( controller->getState() == ECUInfo::AIM ) // isStateIsSameAs( ECUInfo::AIM )
//                    {
//                        m_state = IDLE;
//                        controller->m_pCurrentProtocol->reset();
//                        CCS_GetFirmwareInfo::instance()->reset();
//                        controller->setCtrlState( CCS_GetFirmwareInfo::instance() );
//                    }
//                } break;
//                case WAIT:
//                {
//                    m_state = IDLE;
//
//                    switch ( controller->getState() )
//                    {
//                        case ECUInfo::SIPR:
//                            CCS_GetFirmwareInfoSipr::instance()->reset();
//                            controller->setCtrlState( CCS_GetFirmwareInfoSipr::instance() );
//                            break;
//                        case ECUInfo::MAN:
//                        case ECUInfo::MEGATUNE:
//                        //case ECUInfo::AIM:
//                            CCS_GetFirmwareInfo::instance()->reset();
//                            controller->setCtrlState( CCS_GetFirmwareInfo::instance() );
//                            m_state = IDLE;
//                            break;
//                    }
//                } break;
//            }
//        } break;
//    }
//}

///******************************************************************CCS_GetFirmwareInfoSipr
CCS_GetFirmwareInfoSipr* CCS_GetFirmwareInfoSipr::s_pInstance = NULL;

void CCS_GetFirmwareInfoSipr::execute( CommunicationController* controller )
{
    //Logger::logf( LOG_MSG, _T("-----CCS_GetFirmwareInfoSipr::execute() - m_state = %d\n"), m_state );

    switch ( m_state )
    {
        case IDLE:
        {
            Logger::logf( LOG_MSG, _T("-----CCS_GetFirmwareInfoSipr::execute() - IDLE\n") );
            controller->m_pCurrentProtocol->request( new GetCompileTimeCommand() );
            controller->m_pCurrentProtocol->request( new GetFirmwareVersionCommand() );
            controller->m_pCurrentProtocol->request( new GetHwsigCommand() );
            controller->m_pCurrentProtocol->request( new GetMtsigCommand() );
            m_state = WAIT;
        } break;
        case WAIT: break;
    }

    controller->communicate();
}

void CCS_GetFirmwareInfoSipr::OnSipr( CommunicationController* controller, InputEvent& event )
{
    switch ( m_state )
    {
        case WAIT:
        {
            SIPRPacket p = event.getPacket();

            switch ( p.type() )
            {
                case SIPR_TIMEOUT:
                {
                    //m_state = IDLE;
                    controller->m_pCurrentProtocol->reset();
                    //controller->setCtrlState( CCS_Detect::instance() );
                } break;

                case SIPR_GET_COMPILE_TIME:
                {
                    wxString s = wxString::From8BitData( (const char*)p.data(), p.size() );
                    controller->m_fwInfo->setCompilationTime( s );
                } break;

                case SIPR_GET_VERSION:
                {
                    wxString version = wxString::Format( _T("%d.%d.%d"), p.data()[0], p.data()[1], p.data()[2] );
                    controller->m_fwInfo->setFirmwareVersion( version );

                    uint8_t op[2] = { p.data()[5], p.data()[6] };

                    wxString s = _T("VEMS Genboard v3, ") + version;

                    wxChar c1( op[0] );
                    wxChar c2( op[1] );

                    s += c1;
                    s += c2;

                    controller->m_fwInfo->setFirmwareOptions( s );
                } break;

                case SIPR_GET_HWSIG:
                {
                    wxString s = wxString::From8BitData( (const char*)p.data(), p.size() );
                    controller->m_fwInfo->setSerialNumber( s );
                } break;

                case SIPR_GET_MT_SIGNATURE:
                {
                    wxString s = wxString::From8BitData( (const char*)p.data(), p.size() );
                    controller->m_fwInfo->setSignature( s );



                    //m_state = IDLE;
                    //Logger::logf( LOG_MSG, _T("-----CCS_GetFirmwareInfoSipr::OnSipr() - IDLE - m_state = %d\n"), m_state );

                    MTConfigHelper::parseMTConfigData( *(controller->m_fwInfo) );

                    controller->m_device = ECUInfo::DEVICE_V3;
                    controller->sendConnectedEvent();
                    controller->sendDeviceEvent();

                    controller->m_VemsCommandQueue.push_back( new ReadAllPageCommand() );

                    if ( controller->m_bReadSensors )
                    {
                        controller->m_VemsCommandQueue.push_back( new EnableReadRealTimeCommand( true ) );
                    }
                    //ctrl->m_VemsCommandQueue.
                    //controller->m_pCurrentProtocol->request( new ReadAllPageCommand() );

                    controller->setCtrlState( CCS_Normal::instance() );

                } break;
            }
        } break;

        case IDLE: break;
    }
}



///******************************************************************CCS_GetFirmwareInfo
CCS_GetFirmwareInfo* CCS_GetFirmwareInfo::s_pInstance = NULL;
void CCS_GetFirmwareInfo::execute( CommunicationController* controller )
{
    /*
    switch ( m_state )
    {
        case IDLE:
        {
            switch ( controller->getState() )
            {
                case ECUInfo::AIM:
                {
                    Logger::logf( LOG_MSG, _T("-----CCS_GetFirmwareInfo::execute() - IDLE - AIM\n") );
                    controller->m_pCurrentCommand = new SetStateCommand( ECUInfo::MAN );
                    controller->setCtrlState( CCS_SetState::instance() );
                } return;

                case ECUInfo::MAN:
                {
                    Logger::logf( LOG_MSG, _T("-----CCS_GetFirmwareInfo::execute() - IDLE - MAN\n") );
                    controller->m_pCurrentProtocol->reset();
                    controller->m_pCurrentProtocol->request( new GetCompileTimeCommand() );
                    controller->m_pCurrentProtocol->request( new GetFirmwareVersionCommand() );
                    controller->m_pCurrentProtocol->request( new GetHwsigCommand() );
                    m_state = WAIT;
                } break;

                case ECUInfo::MEGATUNE:
                {
                    Logger::logf( LOG_MSG, _T("-----CCS_GetFirmwareInfo::execute() - IDLE - MEGATUNE\n") );
                    controller->m_pCurrentCommand = new SetStateCommand( ECUInfo::MAN );
                    controller->setCtrlState( CCS_SetState::instance() );
                } return;
            }
        } break;

        case WAIT_MEGATUNE:
        {
            if ( controller->getState() == ECUInfo::MEGATUNE )
            {
                Logger::logf( LOG_MSG, _T("-----CCS_GetFirmwareInfo::execute() - WAIT_MEGATUNE - MEGATUNE\n") );

                controller->m_pCurrentProtocol->request( new GetMtsigCommand() );
                m_state = WAIT;
            }
        }
    }

    controller->communicate();
    */
}


void CCS_GetFirmwareInfo::OnSipr( CommunicationController* controller, InputEvent& event )
{
    /*
    SIPRPacket p = event.getPacket();

    Logger::logf( LOG_MSG, _T("-----CCS_GetFirmwareInfo::OnSipr() - %d\n"), p.type() );

    switch ( m_state )
    {
        case WAIT:
        {
            switch ( p.type() )
            {
                case SIPR_TIMEOUT:
                {
                    Logger::logf( LOG_MSG, _T("-----CCS_GetFirmwareInfo::OnSipr() - SIPR_TIMEOUT\n") );
                    controller->m_pCurrentProtocol->reset();
                    controller->setCtrlState( CCS_Detect::instance() );
                } break;

                case SIPR_GET_COMPILE_TIME:
                {
                    wxString s = wxString::From8BitData( (const char*)p.data(), p.size() );
                    controller->m_fwInfo->setCompilationTime( s );

                    Logger::logf( LOG_MSG, _T("-----CCS_GetFirmwareInfo::OnSipr() - SIPR_GET_COMPILE_TIME - >") +
                        s + _T("<\n") );
                } break;

                case SIPR_GET_VERSION:
                {
                    wxString version = wxString::Format( _T("%d.%d.%d"), p.data()[0], p.data()[1], p.data()[2] );
                    controller->m_fwInfo->setFirmwareVersion( version );

                    Logger::logf( LOG_MSG, _T("-----CCS_GetFirmwareInfo::OnSipr() - SIPR_GET_VERSION - >") +
                        version + _T("<\n") );


                } break;

                case SIPR_GET_HWSIG:
                {
                    wxString s = wxString::From8BitData( (const char*)p.data(), p.size() );
                    controller->m_fwInfo->setSerialNumber( s );

                    Logger::logf( LOG_MSG, _T("-----CCS_GetFirmwareInfo::OnSipr() - SIPR_GET_HWSIG - >") +
                        s + _T("<\n") );

                    m_state = WAIT_MEGATUNE;
                    controller->m_pCurrentCommand = new SetStateCommand( ECUInfo::MEGATUNE );
                    controller->setCtrlState( CCS_SetState::instance() );

                } return;

                case SIPR_ACK:
                    Logger::logf( LOG_MSG, _T("-----CCS_GetFirmwareInfo::OnSipr() - PING OK - protocol: ") +
                        ECUInfo::getStateAsString( controller->getState() ) + _T("\n") );
                    break;

                case SIPR_GET_MT_SIGNATURE:
                {
                    wxString s = wxString::From8BitData( (const char*)p.data(), p.size() );
                    controller->m_fwInfo->setSignature( s );

                    Logger::logf( LOG_MSG, _T("-----CCS_GetFirmwareInfo::OnSipr() - SIPR_GET_MT_SIGNATURE: ") +
                        s + _T("\n") );

                    MTConfigHelper::parseMTConfigData( *(controller->m_fwInfo) );

                    controller->m_device = ECUInfo::DEVICE_V3;
                    controller->sendConnectedEvent();
                    controller->sendDeviceEvent();



                    controller->m_pCurrentProtocol->request( new SyncCommand() );

                    if ( controller->m_bReadSensors )
                    {
                        controller->m_VemsCommandQueue.push_back( new EnableReadRealTimeCommand( true ) );
                    }
                    //controller->m_pCurrentProtocol->request( new ReadAllPageCommand() );
                    controller->setCtrlState( CCS_Normal::instance() );
                } break;
            }
        } break;
    }
    */
}


///******************************************************************CCS_Sync
CCS_Sync* CCS_Sync::s_pInstance = NULL;

void CCS_Sync::OnSipr( CommunicationController* ctrl, InputEvent& event )
{
/*
    SIPRPacket p = event.getPacket();

    switch(p.type() ){
        case SIPR_TIMEOUT:
            m_state = CHECK_PROTOCOL;
            Logger::logf( LOG_MSG, _T("CCS_Sync::OnSipr() - SIPR_TIMEOUT") );

        break;
        case SIPR_AIM:
            /// reguest stop aim
            Logger::logf( LOG_MSG, _T("CCS_Sync::OnSipr() - SIPR_AIM") );
            VemsCommand* vemsCommand = new SetStateCommand( ECUInfo::MAN );
            ctrl->request(vemsCommand);
            m_state = CHECK_PROTOCOL;

        break;
        case SIPR_GET_MT_SIGNATURE:
            Logger::logf( LOG_MSG, _T("CCS_Sync::OnSipr() - SIPR_GET_MT_SIGNATURE") );
            /// TODO: save which protocol has been found!
            /// detect device;
            uint8_t* siprData = p.data();
            m_state = SYNC_DEVICE;
        break;

    }

    if ( ctrl->m_pEventHandler ) { ctrl->m_pEventHandler->AddPendingEvent( event ); }
*/
}
/*
void CCS_Sync::execute( CommunicationController* ctrl )
{
    Logger::logf( LOG_MSG, _T("CCS_Sync::execute() - START") );
    switch(m_state){
        //case ENTER_CHECK_PROTOCOL:
        case
        case CHECK_PROTOCOL:
             Logger::logf( LOG_MSG, _T("CCS_Sync::execute() - CHECK_PROTOCOL") );
            /// set current protocol
            if( ctrl->isLastProtocol() ){
                /// last had been reached need baudrate change
                ctrl->selectNextBaudRate();
            }
            ctrl->selectNextProtocol();
            /// send request
            VemsCommand* vemsCommand = new  GetMtsigCommand(); //VemsMCommand::getInstance(GET_MT_SIGNATURE);
            /// ????? why ctrl->request(vemsCommand);
            ctrl->request(vemsCommand);
            m_state = WAIT_PROTOCOL;
            break;

        case WAIT_PROTOCOL:
            Logger::logf( LOG_MSG, _T("CCS_Sync::execute() - WAIT_PROTOCOL") );
        break;

        case SYNC_DEVICE:
        //
        //    int protocol = ctrl->getState();
        //    switch(protocol){
        //        case ECUInfo::MAN:
        //    }
        //        SIPR_GET_COMPILE_TIME
        //        SIPR_GET_VERSION
        //        SIPR_GET_HWSIG
        //        SIPR_GET_MT_SIGNATURE
        //
            Logger::logf( LOG_MSG, _T("CCS_Sync::execute() - SYNC_DEVICE") );
        break;
    }
    //ctrl->communicate();
}
*/

void CCS_Sync::execute( CommunicationController* ctrl )
{
    //Logger::logf( LOG_MSG, _T("CCS_Sync::execute() - START") );
    //static bool  = false;

    //ECUEvent::State ecuEventID = ECUEvent::NOT_CONNECTED;

    int oldDevice = ctrl->m_stateMgr->getDevice();
    Logger::logf( LOG_MSG, _T("-----CCS_Sync::execute() old device: ")+ ECUInfo::getDeviceAsString(oldDevice) );
    //Logger::logf( LOG_MSG, _T("-----CCS_Sync::execute() getState START") );
    int state = ctrl->m_stateMgr->getState();
    //Logger::logf( LOG_MSG, _T("-----CCS_Sync::execute() getState result: ")+ ECUInfo::getStateAsString(state) );
    int newDevice = ctrl->m_stateMgr->getDevice();
    Logger::logf( LOG_MSG, _T("-----CCS_Sync::execute() new device: ")+ ECUInfo::getDeviceAsString(newDevice) );

    if ( ( newDevice == ECUInfo::DEVICE_V3 ) || ( newDevice == ECUInfo::DEVICE_ROUND ) ) {
    ctrl->m_fwInfo->setDevice( newDevice);
    }

    if ( state == ctrl->m_state && state == ECUInfo::BOOT )
    {
        ctrl->leaveBootMode();
        wxThread::Sleep( 1000 );
        return;
    }

    ctrl->m_state = state;

    switch (ctrl->m_state )
    {
        case ECUInfo::BOOT:
            ctrl->m_device = ctrl->m_stateMgr->getDevice();
            ctrl->sendBootModeEvent();
            ctrl->sendDeviceEvent();
            TerminalLog::protocolLog( ECUInfo::getStateAsString( ECUInfo::BOOT ) );
            break;
        case ECUInfo::AIM:
        case ECUInfo::MEGATUNE:
        {
            if ( !ctrl->checkPassword() ) {
                //ctrl->stop();
                //send event
/*                PWInfoDialog dlg;
                dlg.ShowModal();
  */              // wxMessageBox( _T("ECU is password protected!"), _T("Error"), wxICON_ERROR | wxOK );
                ctrl->sendPasswordProtectedEvent();
                return;
            }

            int state = ctrl->setState( ECUInfo::MAN );
            if ( state != ECUInfo::MAN ) { return; }//false
        }
        case ECUInfo::MAN:
        {
            if(ECUInfo::DEVICE_ROUND==ctrl->m_stateMgr->getDevice())
			{
				ctrl->fetchRoundFirmwareInfo();
			}
			else
			{
                ctrl->setPreferredBaudrate();
				ctrl->fetchV3FirmwareInfo();
			}

            MTConfigHelper::parseMTConfigData( *(ctrl->m_fwInfo) );

            int state = ctrl->setState(ECUInfo::MEGATUNE);

            if( state != ECUInfo::MEGATUNE )
            {
                Logger::logf( LOG_MSG, _T("-----CCS_Sync::execute() - set state failed! ( MAN -> MEGATUNE )") );
                return; //false
            }
            else
            {
                ctrl->setProtocolForState( ECUInfo::MEGATUNE );

                if ( ctrl->m_pCurrentProtocol )
                {

                    //m_pCurrentProtocol->setRealTimeLength( syncRTDataLength() );
                    ctrl->clear();
                    ctrl->m_pCurrentProtocol->reset();
                    //m_pCurrentProtocol->requestReadAllPage();

                    ctrl->m_device = ctrl->m_stateMgr->getDevice();
                    ctrl->m_pCurrentProtocol->setDevice( ctrl->m_device );
                    ctrl->m_pCurrentProtocol->setFirmwareVersion( ctrl->getFirmwareVersion() );

                    ctrl->sendConnectedEvent();
                    ctrl->sendDeviceEvent();

                    Logger::logf( LOG_MSG, _T("CCS_Sync::execute() - OK!") );
                    //ctrl->request( new ReadAllPageCommand() );
                    ctrl->request( new EnableReadRealTimeCommand( true ) );

                    //ctrl->debugPrint(_T("CCS_Sync::execute()ECUInfo::MAN"));
                    ctrl->setCtrlState( CCS_Normal::instance() );
                    //ctrl->debugPrint(_T("CCS_Sync::execute()ECUInfo::MAN"));

                    TerminalLog::protocolLog( ECUInfo::getStateAsString( ECUInfo::MEGATUNE ) );
                    return;// true;
                }

                Logger::logf( LOG_MSG, _T("CCS_Sync::execute() - FAILED!") );
                return;// false;
            }

        }
        case ECUInfo::SIPR:
        {
            const int MAX_TRY_COUNT = 1;
            bool b = false;
            int tryCount = 0;

            do {
                ctrl->clear();
                b = ctrl->fetchV3FirmwareInfoSipr();
                ++tryCount;
            } while ( !b && tryCount < MAX_TRY_COUNT );

            if ( !b ) { return; }// false; }

            MTConfigHelper::parseMTConfigData( *(ctrl->m_fwInfo) );

            ctrl->setProtocolForState( ECUInfo::SIPR );

            if ( !ctrl->m_pCurrentProtocol )  return;// false;

            ctrl->m_pCurrentProtocol->reset();
            ctrl->m_device = ctrl->m_stateMgr->getDevice();
            ctrl->sendDeviceEvent();
            ctrl->sendConnectedEvent();

            switch(ctrl->m_device){
                case ECUInfo::DEVICE_V3:
                //ctrl->request( new ReadAllPageCommand() );
                //ctrl->m_VemsCommandQueue.push_back( new ReadAllPageCommand() );
                    ctrl->m_VemsCommandQueue.push_back( new EnableReadRealTimeCommand( true ) );
                    break;
                case ECUInfo::DEVICE_ARM:
                    VemsCommand* vemsCommand = new MemoryReadCommand(0xfc00, 200);
                    ctrl->m_pCurrentProtocol->request(vemsCommand);
                    break;
            }
            //request( new ReadRealTimeCommand() );
            ctrl->setCtrlState( CCS_Normal::instance() );
            TerminalLog::protocolLog( ECUInfo::getStateAsString( ECUInfo::SIPR ) );
            return;// true;
        }
    }

    if ( ctrl->m_pEventHandler )
    {
        //Logger::logf( LOG_MSG, _T("void CCS_Sync::execute() - old device: %d, current device: %d"),
        //                oldDevice, ctrl->m_stateMgr->getDevice() );

        if ( oldDevice != ctrl->m_stateMgr->getDevice() )
        {
            ctrl->sendNotConnectedEvent();
            ctrl->m_device = ctrl->m_stateMgr->getDevice();
            ctrl->sendDeviceEvent();
        }


//
//        if ( oldDevice != ctrl->m_stateMgr->getDevice() )
//        {
//            ctrl->m_device = oldDevice;
//            ctrl->sendDeviceEvent();
//        }
//
    }
}


///******************************************************************CCS_Normal
CCS_Normal* CCS_Normal::s_pInstance = NULL;

void CCS_Normal::OnSipr( CommunicationController* ctrl, InputEvent& event )
{
    SIPRPacket p = event.getPacket();

    if ( p.type() == SIPR_TIMEOUT )
    {
        ctrl->setCtrlState( CCS_Sync::instance() );
    }

    if ( ctrl->m_pEventHandler ) { ctrl->m_pEventHandler->AddPendingEvent( event ); }
}


void CCS_Normal::execute( CommunicationController* ctrl )
{
/*
    ctrl->processNextCommand();

    if ( ctrl->m_pCurrentCommand )
    {
        switch ( ctrl->m_pCurrentCommand->getType() )
        {
            case VemsCommand::SET_STATE:
                ctrl->setCtrlState( CCS_SetState::instance() );
                break;
            case VemsCommand::SET_BAUDRATE:
                //ctrl->setCtrlState( CCS_SetBaud::instance() );
                delete ctrl->m_pCurrentCommand;
                ctrl->m_pCurrentCommand = NULL;
                break;
            default:
            {
                ctrl->m_pCurrentProtocol->request( ctrl->m_pCurrentCommand );
                ctrl->m_pCurrentCommand = NULL;
            }
        }
    }

    ctrl->communicate();
*/
}


///******************************************************************CCS_SetState

CCS_SetState* CCS_SetState::s_pInstance = NULL;

void CCS_SetState::OnSipr( CommunicationController* controller, InputEvent& event )
{

//    if ( controller->m_pEventHandler ) { controller->m_pEventHandler->AddPendingEvent( event ); }

}

/*
void CCS_SetState::execute( CommunicationController* ctrl )
{
    Logger::logf( LOG_MSG, _T("CCS_Sync::execute() - START") );
    switch(m_state){
        //case ENTER_CHECK_PROTOCOL:
        case SET_NEXT_STATE:
            Logger::logf( LOG_MSG, _T("CCS_Sync::execute() - SET_NEXT_STATE") );
            //int currentState = ctrl->getState();
            VemsCommand* vemsCommand = new SetStateCommand(m_expectedState);
            ctrl->request(vemsCommand);
            m_state = CHECK_PROTOCOL;
            break;
        case CHECK_PROTOCOL:
            Logger::logf( LOG_MSG, _T("CCS_Sync::execute() - CHECK_PROTOCOL") );

            /// send request
            VemsCommand* vemsCommand = new  GetMtsigCommand(); //VemsMCommand::getInstance(GET_MT_SIGNATURE);
            /// ????? why ctrl->request(vemsCommand);
            ctrl->request(vemsCommand);
            m_state = WAIT_PROTOCOL;
            break;

        case WAIT_PROTOCOL:
            Logger::logf( LOG_MSG, _T("CCS_Sync::execute() - WAIT_PROTOCOL") );
        break;

        case SYNC_DEVICE:

            Logger::logf( LOG_MSG, _T("CCS_Sync::execute() - SYNC_DEVICE") );
        break;
    }
    //ctrl->communicate();
}
*/

void CCS_SetState::execute( CommunicationController* controller )
{

    switch ( m_state )
    {
        case IDLE:
        {
            Logger::logf( LOG_MSG, _T("CCS_SetState::execute()") );

            if (    m_expectedState == controller->m_stateMgr->getStoredState() ||
                    !controller->isProtocolRegistered( m_expectedState ) )
            {
                Logger::logf( LOG_MSG, _T("CCS_SetState::execute() - BACK TO NORMAL") );
                controller->setCtrlState( CCS_Normal::instance() );
                return;
            }

            controller->clear();
            Logger::logf( LOG_MSG, _T("CCS_SetState::execute() - try to change protocol") );
            controller->m_stateMgr->setState( m_expectedState );
            controller->setProtocolForState( m_expectedState );
            if ( controller->m_pCurrentProtocol )
            {
                //controller->m_commBase->clear();
                controller->m_VemsCommandQueue.push_back( new EnableReadRealTimeCommand( true ) );
                controller->clear();
                controller->m_pCurrentProtocol->reset();
                controller->m_pCurrentProtocol->enable();
            }

            //m_state = IDLE;
            controller->setCtrlState( CCS_Normal::instance() );

            //controller->m_pCurrentProtocol->disable();
            //m_state = WAIT;

        } break;

        case WAIT:
        {
            if ( controller->m_pCurrentProtocol->isDisabled() )
            {
                controller->clear();
                Logger::logf( LOG_MSG, _T("CCS_SetState::execute() - try to change protocol") );
                controller->m_stateMgr->setState( m_expectedState );
                controller->setProtocolForState( m_expectedState );
                if ( controller->m_pCurrentProtocol )
                {
                    //controller->m_commBase->clear();
                    controller->m_VemsCommandQueue.push_back( new EnableReadRealTimeCommand( true ) );
                    controller->clear();
                    controller->m_pCurrentProtocol->reset();
                    controller->m_pCurrentProtocol->enable();
                }

                m_state = IDLE;
                controller->setCtrlState( CCS_Normal::instance() );

                //setControllerState( NORMAL );
                Logger::logf( LOG_MSG, _T("CCS_SetState::execute() - finished") );
                return;
            }
        } break;
    }

    controller->communicate();
}
