#ifndef COMMUNICATIONCONTROLLERGPS_H
#define COMMUNICATIONCONTROLLERGPS_H

#include <wx/event.h>

#include "../common/typedef.h"
#include "../common/ProcessBase.h"

#include "../GPSInfo.h"

class CommunicationBase;
class ProtocolBase;


class CommunicationControllerGPS : public ProcessBase
{
    public:
//        CommunicationControllerGPS(CommunicationBase* commBase, ProtocolBase* pb,
//            wxEvtHandler* pEventHandler = NULL );
        CommunicationControllerGPS( wxEvtHandler* pEventHandler );

        virtual ~CommunicationControllerGPS();

        /// ProcessBase classes
        void        start(int priority = WXTHREAD_DEFAULT_PRIORITY);
        void        stop();
        //bool        isRunning() const;
        bool        process();

        bool        IsGPSEnabled() { return m_isGPSEnabled; }

        void        reloadGPSConfig();
        int         getState(){ return  m_state; }

    protected:
    private:
        CommunicationBase*      m_commBase;
        ProtocolBase*           m_pCurrentProtocol;
        wxEvtHandler*           m_pEventHandler;

        bool                    m_isGPSEnabled;

        uint8_t                 m_rxBuff[16];
        int                     m_state;
        int m_noDataCount;
        int m_dataReceivedCount;

        //void        OnThread( wxCommandEvent& event );
        void finished();
        void reset();
        int readBytes();
        void sendEvent(GPSInfo::CommState state);
        void sendEvent(GPSInfo::State state);
};

#endif // COMMUNICATIONCONTROLLERGPS_H
