#include "ECUStateBase.h"

#include "../CommunicationBase.h"

ECUStateBase::ECUStateBase( int id, const wxString& name, CommunicationBase* commBase, int baudRate)
{
    m_id = id;
    m_name = name;
    m_baudRateA.Add(baudRate);
    m_commBase = commBase;
    m_parent_id = -1;
}

ECUStateBase::~ECUStateBase()
{
    //ctor
}

const IntArray& ECUStateBase::getBaudRates()
{
    return m_baudRateA;
}

void  ECUStateBase::addBaudRate(int baudRate)
{
    m_baudRateA.Add(baudRate);
}

void  ECUStateBase::addChangeState(int id, const wxString& command)
{
    m_changeStateH[id] = command;
    m_changeStateA.Add(id);
}

void ECUStateBase::goToState( int state )
{
    //Logger::logf( LOG_MSG, _T("ECUState::goToState - START") );
    if( m_changeStateH.find( state ) == m_changeStateH.end() )
    {
        return;
    }

    //m_commBase->setBaudRate( m_baudRate );
    m_commBase->SendString( m_changeStateH[ state ] );
#ifdef SFILE_LIB
	wxMilliSleep(50);
#endif
    //Logger::logf( LOG_MSG, _T("ECUState::goToState - END") );
}
