#ifndef ECUSTATEMGR_H
#define ECUSTATEMGR_H

#include <wx/hashmap.h>

#include "ECUStateMgrBase.h"

class EcuStateGraph;
class CommunicationBase;
class ECUStateBaseArray;
class ECUStateBase;

WX_DECLARE_HASH_MAP( int, EcuStateGraph*, wxIntegerHash, wxIntegerEqual, EcuStateGraphH );
WX_DECLARE_HASH_MAP( int, ECUStateBaseArray*, wxIntegerHash, wxIntegerEqual, ECUStateBaseArrayH );

class ECUStateMgr :public ECUStateMgrBase
{
    public:
        ECUStateMgr( CommunicationBase* commBase );
        virtual ~ECUStateMgr();

        void reset();
        const ECUStateBaseArray* getStates( int device );
        int getStoredState();
        int getDevice();    /// first call getState()
        int getState();
        int setState( int state );
        int setState( int fromState, int toState );
        void setBaudRate( int baudRate );
        int getBaudRate();
    protected:
    private:
        ECUStateBaseArrayH  m_statesH;
        EcuStateGraph*      m_currStateGraph;
        EcuStateGraphH      m_ecuStateGraphH;
        IntArray            m_baudRateA;
        int                 m_device;
        int                 m_state;

        int setState( const ECUStateBase* fromState, const ECUStateBase* toState );
        int getState( const ECUStateBaseArray* states );
        int getStateAtGivenBaudrate( const ECUStateBaseArray* states );
        void setV3();
        void setRound();
        void setARM();


};

#endif // ECUSTATEMGR_H
