#ifndef ECUSTATESIPR_H
#define ECUSTATESIPR_H


#include "ECUStateBase.h"
#include "SIPRParser.h"

class CommunicationBase;

class ECUStateSIPR: public ECUStateBase
{
    public:
                        ECUStateSIPR( CommunicationBase* commBase, int baudRate, int device );
        virtual         ~ECUStateSIPR();

        // ECUStateBase virtual methods
        bool            check();
        void            goToState( int state );

    private:
        bool            sendPing(  CommunicationBase* cb );
        bool            enterMegatune( CommunicationBase* cb );
        uint8_t         readRecord( CommunicationBase* cb );
        bool            checkDevice();
        SIPRParser      m_parser;
        int             m_device;
};

#endif // ECUSTATESIPR_H
