#ifndef PASSWORDHELPER_H
#define PASSWORDHELPER_H

#include <wx/wx.h>
#include "../common/typedef.h"


class PasswordHelper
{
    public:
        enum { PASSWORD_FILE_NOT_FOUND, PASSWORD_NOT_FOUND, INVALID_PASSWORD, PASSWORD_ACCEPTED };

        static int checkPassword( const wxString& serialNumber, wxString* crcHex = NULL );
        static bool isPasswordFormatAccepted( const wxString& password );
        static bool isPasswordAccepted( const wxString& password );

    private:
        PasswordHelper() {}
        virtual ~PasswordHelper() {}

        static bool checkMagic( uint32_t data );
        static uint16_t resolveMagic( uint32_t data );

};

#endif // PASSWORDHELPER_H
