#ifndef STATEGRAPH_H
#define STATEGRAPH_H


#include <wx/hashset.h>


#include "../common/types/IntSet.h"
#include "../common/types/IntArray.h"


WX_DECLARE_HASH_MAP( int, IntSet*, wxIntegerHash, wxIntegerEqual, IntToIntSetPtrHash );


class StateGraph
{
    public:
        void        addEdge( int from, int to );
        void        addNode( int node );
        IntArray    getRoute( int from, int to );

    private:
        IntToIntSetPtrHash   m_nodesWithEdges; // [ node ] = node array ptr
};


#endif // STATEGRAPH_H
