#include "VemsTuneEventDispatcher.h"
#include "../events/VemsDeviceControllerEvent.h"
#include "../events/CommunicationEvent.h"
#include "../logger.h"


BEGIN_EVENT_TABLE( VemsTuneEventDispatcher, wxEvtHandler )
    EVT_VEMS_DEVICE_CONTROLLER( wxID_ANY, VemsTuneEventDispatcher::OnDeviceControllerEvent )
    EVT_COMMUNICATION( wxID_ANY, VemsTuneEventDispatcher::OnCommunicationEvent )
END_EVENT_TABLE()


VemsTuneEventDispatcher::VemsTuneEventDispatcher()
{

}

VemsTuneEventDispatcher::~VemsTuneEventDispatcher()
{

}

void VemsTuneEventDispatcher::addEventHandler( wxEvtHandler* eventHandler )
{
    m_eventHandlers.Add( eventHandler );
}

void VemsTuneEventDispatcher::removeEventHandler( wxEvtHandler* eventHandler )
{
    int idx = m_eventHandlers.Index( eventHandler );

    if (  idx != wxNOT_FOUND ) {
        m_eventHandlers.RemoveAt(idx);
    }
}

void VemsTuneEventDispatcher::OnDeviceControllerEvent( VemsDeviceControllerEvent& event )
{
    for ( size_t i = 0; i < m_eventHandlers.GetCount(); ++i ) {
//        m_eventHandlers[i]->AddPendingEvent( event );
        m_eventHandlers[i]->ProcessEvent( event );
    }
}

void VemsTuneEventDispatcher::OnCommunicationEvent( CommunicationEvent& event )
{
    for ( size_t i = 0; i < m_eventHandlers.GetCount(); ++i ) {
//        m_eventHandlers[i]->AddPendingEvent( event );
        m_eventHandlers[i]->ProcessEvent( event );
    }
}
