#include "RangeRecognizer.h"
#include "../../common/TxData.h"

RangeRecognizer::RangeRecognizer( size_t minLength, size_t maxLength )
{
    m_minLength = minLength;
    m_maxLength = maxLength;

    m_received = 0;
    m_buffer = new uint8_t[m_maxLength];
}

RangeRecognizer::~RangeRecognizer()
{
    delete[] m_buffer;
}

bool RangeRecognizer::feed( char c )
{
    if ( m_received < m_maxLength )
    {
        m_buffer[m_received] = (uint8_t)c;
        ++m_received;
    }

    return ( m_received == m_maxLength );
}

void RangeRecognizer::reset()
{
    m_received = 0;
    delete[] m_buffer;
    m_buffer = new uint8_t[m_maxLength];
}

TxData* RangeRecognizer::getReceivedData()
{
    if ( m_received < m_minLength ) {
        return new TxData( m_buffer, 0 );
    } else {
        return new TxData( m_buffer, m_received );
    }
}
