#ifndef STATEICON_H
#define STATEICON_H

#include "VemsToolIconBase.h"
#include "../GPSInfo.h"

class ECUEvent;
class ECUCommEvent;
class GPSEvent;
class GPSCommEvent;
class ECULogEvent;

class VemsTuneController;

class StateIcon: public VemsToolIconBase
{
    public:
        StateIcon(wxWindow* parent, wxWindowID id, const wxString& icondir, const wxString& name, const wxPoint &pos = wxDefaultPosition);
        virtual ~StateIcon();

        void IconInit();

        void SetVemsTuneController(VemsTuneController *ctrl);

    protected:

        void showGPSState();
        void showEcuState();

    private:

        enum State{
            SI_RED,
            SI_GREEN,
            SI_YELLOW,
            SI_WHITE
        };


        void OnLeftDown(wxMouseEvent& evt);
        void OnLeftUp(wxMouseEvent& evt);

        void OnECUEvent(ECUEvent& event);
        void OnECUCommState(ECUCommEvent& event);

        void OnGPSEvent( GPSEvent& event );
        void OnGPSCommEvent( GPSCommEvent& event );

        void OnLogEvent(ECULogEvent &event);



        wxBitmapLayerHash   m_upBmps;
        wxBitmapLayerHash   m_downBmps;

        VemsTuneController *m_vemsTuneController;

        wxString    m_stateName;

        BitmapLayerArray    m_bitmaps;


        int m_EcuState;
        int m_EcuCommState;

        GPSInfo::State         m_gpsState;
        GPSInfo::CommState     m_gpsCommState;


        State m_state;

        DECLARE_EVENT_TABLE();

};



#endif // STATEICON_H
