#ifndef VTFILEUPDATER_H
#define VTFILEUPDATER_H

#include <wx/wx.h>
#include "../ObserverBase.h"
#include "../common/types/StringHash.h"
#include "../events/GeneralEvent.h"

class PrgDialog;
class VTFilesMD5CheckerThread;

class VTFilesUpdater : public wxEvtHandler, public ObserverBase
{
    public:
        VTFilesUpdater( const wxString& WXUNUSED(baseDir) );
        ~VTFilesUpdater();
        void Check( bool forceUpdate = false );

        void notify( int, int );

    private:
        enum { FILEDL_ALLDOWNLOADED = 1, FILEDL_STOPPRESSED, FILEDL_FILEDOWNLOADED, FILEDL_FILESIZE, FILEDL_DLINPROGRESS };

        // true if md5 calc is in progress, otherwise false
        bool            m_isBusy;

        bool            m_forceUpdate;

        StringHash      m_fileHash;
        wxString        m_phpUrl;
        wxString        m_baseurl;
        wxString        m_baseDir;

        wxArrayString   m_toDownload;
        unsigned        m_fileCnt;

        wxString        m_serverVersion;
        wxString        m_localVersion;

        unsigned char   m_Update;
        PrgDialog*      m_prgDialog;

        long int        m_filesize;
        long int        m_read;

        VTFilesMD5CheckerThread* m_md5checker;

        void    getSettings();
        void    checkServer();
        void    checkMD5();
        void    checkStopPressed();

        void    doDownload();

        void    saveLastUpdateTime();

        /// helper
        void    hEvtHandler( GeneralEvent& event );

        DECLARE_EVENT_TABLE()
};

#endif // VTFILEUPDATER_H
