#include "ImageContentLoaderFile.h"

#include <wx/filename.h>

//#include "../logger.h"

bool ImageContentLoaderFile::Load(wxVariantHash& params)
{

    wxString path = params[_T("filepath")].GetString();

    int imtype = params.find(_T("imagetype")) == params.end() ? wxBITMAP_TYPE_PNG : params[_T("imagetype")].GetLong();

    wxImage image;

    long restype = CLR_NO_ERROR;

    if(wxFileName::FileExists(path)) {
        if(!image.LoadFile(path,imtype))
            restype = CLR_WRONG_FORMAT;
    } else {
        restype = CLR_FILE_NOT_FOUND;
    }

    if(!image.IsOk())
        restype = CLR_WRONG_FORMAT;
    else
        params[_T("image")] << image;


    params[_T("resultType")] = restype;

    return true;
}
