#ifndef WXWEBBROWSERBASE_H
#define WXWEBBROWSERBASE_H

class bcButton;


class wxWebBrowserBase: public wxFrame
{
    public:
        wxWebBrowserBase(wxWindow* parent);
        virtual ~wxWebBrowserBase();

        virtual bool LoadURL(const wxString& url) = 0;
        virtual void SetHome(const wxString& url);
        virtual wxString GetHome() { return m_home; } ;

        static wxString GetRealURL(const wxString& url);

    protected:

        virtual bool DoBack();
        virtual bool DoForward();
        virtual bool DoHome();
        virtual bool DoReload();
        virtual wxWindow* BuildToolBar();
        virtual void BuildMainGUI(wxWindow* webwindow);

        virtual void OnToolButton(wxCommandEvent& evt);
        virtual void OnURLEntered(wxCommandEvent& evt);
        virtual void OnMenu(wxCommandEvent& evt);

        virtual void AddHistory(const wxString& url);
        virtual void SetTitlePage(const wxString& pagetitle);
        virtual void SetLoadingURL(const wxString &url);
        virtual void SetLoadingContentURL(const wxString &url);
        virtual void PageLoaded();
        virtual void ContentLoaded(const wxString &url);
        virtual void SetFocusToWeb();

        wxListBox*      m_urlHistBox;

    private:

        bool CheckHistoryPos();


        enum ids {
            idToolButtonBack = 20000,
            idToolButtonForward,
            idToolButtonHome,
            idToolButtonReload,
            idToolURLBar,
            idMenuBack,
            idMenuForward,
            idMenuHome,
            idMenuReload,
            idMenuClose,
            idMenuEND
        };

        wxComboBox*     m_urlBar;
        wxWindow*       m_webContent;
        bcButton*       m_backButton;
        bcButton*       m_forwButton;
        wxTextCtrl*     m_urlBarCtrl;


        wxString        m_home;

        wxArrayString   m_urlHistory;
        int             m_historyPos;

        DECLARE_EVENT_TABLE();

};

#endif // WXWEBBROWSERBASE_H
