#ifndef WXHSLCOLOR_H
#define WXHSLCOLOR_H

#include "common/typedef.h"

class wxHSLColor
{
    public:
        wxHSLColor();
        wxHSLColor(const wxColor& color);
        wxHSLColor(double h, double s, double l);
        virtual ~wxHSLColor();

        wxColor ToRGB();
        void ToRGB(wxColor &color);
        void ToRGB(uint8_t* red, uint8_t* green, uint8_t* blue, uint8_t* alpha = NULL);
        void FromRGB(const wxColor& color);
        void FromRGB(uint8_t red, uint8_t green, uint8_t blue, uint8_t alpha = wxALPHA_OPAQUE);

        wxString ToString(int dec);

        void OffsetLum(double o);


        double m_hue;
        double m_sat;
        double m_lum;

        uint8_t m_alpha;
};

#endif // WXHSLCOLOR_H
