#ifndef WXPOINTEX_H
#define WXPOINTEX_H

#include <wx/wx.h>

class wxPointEx: public wxPoint, public wxObject
{
    DECLARE_DYNAMIC_CLASS(wxPointEx);

    public:
        wxPointEx() {};
        wxPointEx(int x, int y);
        wxPointEx(const wxPoint& p);

        void IncBy(int d) { x += d; y += d; };
        void IncBy(int xx, int yy) { x += xx; y += yy; };
        void IncBy(const wxPointEx& p) { x += p.x; y += p.y; };

        void DecBy(int d) { x -= d; y -= d; };
        void DecBy(int xx, int yy) { x -= xx; y -= yy; };
        void DecBy(const wxPointEx& p) { x -= p.x; y -= p.y; };

        virtual ~wxPointEx();
    protected:
    private:
};

DECLARE_VARIANT_OBJECT(wxPointEx);

#endif // WXPOINTEX_H
