#include "wxRealSize.h"

IMPLEMENT_DYNAMIC_CLASS(wxRealSize, wxObject);

IMPLEMENT_VARIANT_OBJECT_SHALLOWCMP(wxRealSize);

wxRealSize wxDefaultRealSize = wxRealSize();

wxRealSize::wxRealSize(const wxRealSize& size)
{
    w = size.w;
    h = size.h;
    m_precision = size.m_precision;
}

wxRealSize::~wxRealSize()
{
    //dtor
}

void wxRealSize::Init(double width, double height, double precision)
{
    w = width;
    h = height;

    if( precision < 0 )
        m_precision = DEFAULTREALPRECISION;
    else
        m_precision = precision;
}

/** @brief operator*=
  *
  * @todo: document this function
  */
wxRealSize & wxRealSize::operator*=(double factor)
{
    w = w * factor;
    h = h * factor;
    return (*this);
}

/** @brief operator/=
  *
  * @todo: document this function
  */
wxRealSize & wxRealSize::operator/=(double factor)
{
    w = w / factor;
    h = h / factor;
    return (*this);
}

/** @brief operator/
  *
  * @todo: document this function
  */
wxRealSize wxRealSize::operator/(double factor) const
{
    wxRealSize s(w / factor,h / factor,m_precision);
    return s;
}

/** @brief operator*
  *
  * @todo: document this function
  */
wxRealSize wxRealSize::operator*(double factor) const
{
    wxRealSize s(w * factor,h * factor,m_precision);
    return s;
}

/** @brief operator-=
  *
  * @todo: document this function
  */
wxRealSize & wxRealSize::operator-=(const wxRealSize& size)
{
    w = w - size.GetWidth();
    h = h - size.GetHeight();
    return (*this);
}

/** @brief operator+=
  *
  * @todo: document this function
  */
wxRealSize & wxRealSize::operator+=(const wxRealSize& size)
{
    w = w + size.GetWidth();
    h = h + size.GetHeight();
    return (*this);
}

/** @brief operator-
  *
  * @todo: document this function
  */
wxRealSize wxRealSize::operator-(const wxRealSize& size) const
{
    wxRealSize s(w - size.GetWidth(),h - size.GetHeight(),m_precision);
    return s;
}

/** @brief operator+
  *
  * @todo: document this function
  */
wxRealSize wxRealSize::operator+(const wxRealSize& size) const
{
    wxRealSize s(w + size.GetWidth(),h + size.GetHeight(),m_precision);
    return s;
}

/** @brief operator!=
  *
  * @todo: document this function
  */
bool wxRealSize::operator!=(const wxRealSize& size) const
{
    if( (*this) == size )
        return false;
    else
        return true;
}

/** @brief operator==
  *
  * @todo: document this function
  */
bool wxRealSize::operator==(const wxRealSize& size) const
{
    if(fabs(w - size.GetWidth()) < m_precision && fabs(h - size.GetHeight()) < m_precision)
        return true;
    else
        return false;
}

/** @brief operator=
  *
  * @todo: document this function
  */
void wxRealSize::operator=(const wxRealSize& size)
{
    w = size.GetWidth();
    h = size.GetHeight();
    m_precision = size.GetPrecision();
}

void wxRealSize::operator=(const wxSize& size)
{
    w = size.x;
    h = size.y;
    m_precision = DEFAULTREALPRECISION;
}

wxSize wxRealSize::Ceil() const
{
    return wxSize( (int)ceil(w), (int)ceil(h) );
}

wxSize wxRealSize::Floor() const
{
    return wxSize( (int)floor(w), (int)floor(h) );
}
