#include "wxSQLColumnDesc.h"

#include "logger.h"

wxString ColumnDesc::GetColDefStr()
{
    wxString str = Name + _T(" ") + Type;

    if( Primary ) str += _T(" PRIMARY KEY ");
    if( Unique ) str += _T(" UNIQUE ");
    if( AutoIncrement ) str += _T(" AUTOINCREMENT ");
    if( DefaultValue != wxNullVariant )
    {
        wxString dv = DefaultValue.MakeString();
        if ( dv.IsSameAs(_T("CURRENT_TIMESTAMP"), false ) )
            str += _T(" DEFAULT CURRENT_TIMESTAMP");
        else
            str += _T(" DEFAULT '") + DefaultValue.MakeString() + _T("'");
    }
    if ( Notnull )
    {
        str += _T(" NOT NULL");
    }

    LOGP( str )
    return str;
}
