#include "wxTextCtrlHotKey.h"

#include <wx/keybinder.h>

#include "hotkeys/wxHotKeyManager.h"

#include "logger.h"

BEGIN_EVENT_TABLE(wxTextCtrlHotKey,wxTextCtrl)
    EVT_KEY_DOWN(wxTextCtrlHotKey::OnKeyDown)
    EVT_KEY_UP(wxTextCtrlHotKey::OnKeyUp)
END_EVENT_TABLE()

wxTextCtrlHotKey::wxTextCtrlHotKey(wxWindow* parent, wxWindowID id, const wxString& value, const wxPoint& pos, const wxSize& size, long style, const wxValidator& validator, const wxString& name)
    :wxTextCtrl(parent, id, value, pos, size, style, validator, name)
    ,ControlColorContentValidator(this, value, _T(""),false)
{

    m_defVal = wxEmptyString;
    //Connect(wxEVT_COMMAND_TEXT_UPDATED, wxCommandEventHandler(wxTextCtrlHotKey::OnUpdated) );
}

void wxTextCtrlHotKey::OnUpdated(wxCommandEvent& evt)
{
    LOG
}

void wxTextCtrlHotKey::OnKeyUp(wxKeyEvent &evt)
{
    if(m_isValid)
        observerNotify( 1 );
    else {
        ChangeValue( m_defVal );
        observerNotify( 2 );
    }

    DoOnUpdated();
}

void wxTextCtrlHotKey::OnKeyDown(wxKeyEvent &evt)
{
    wxString key;

    if(evt.GetKeyCode() == WXK_BACK){
        m_isValid = true;
        ChangeValue(wxEmptyString);
        SetInsertionPointEnd();
        return;
    }

    if( !(evt.GetKeyCode() >= WXK_SHIFT && evt.GetKeyCode() <= WXK_CONTROL) ) {

        key = wxHotKeyManager::NumPadKeyStrokeToString(evt.GetKeyCode());

        if(key == wxEmptyString) {
            key = wxKeyBind::KeyCodeToString(evt.GetKeyCode());
        }
    }

    if(key == wxEmptyString)
        m_isValid = false;
    else
        m_isValid = true;

    wxString keystroke = wxKeyBind::KeyModifierToString(wxKeyBind::GetKeyModifier(evt)) + key;

    ChangeValue( keystroke );
    SetInsertionPointEnd();

}
