#include "wxVariantHelper.h"

#include "DrawHelper.h"

wxRealPointEx wxVariantHelper::GetRealPointEx(const wxVariant& var)
{
    if( var.GetType() != _T("wxRealPointEx") ) return wxRealPointEx(-1.0,-1.0);

    wxRealPointEx v;
    v << var;
    return v;
}

void wxVariantHelper::SetRealPointEx(wxVariant& var, const wxRealPointEx& val)
{
    var << val;
}

/** @brief SetSizeEx
  *
  * @todo: document this function
  */
void wxVariantHelper::SetSizeEx(wxVariant& var, const wxSizeEx& val)
{
    var << val;
}

/** @brief SetRealRect
  *
  * @todo: document this function
  */
void wxVariantHelper::SetRealRect(wxVariant& var, const wxRealRect& val)
{
    var << val;
}

/** @brief SetRealSize
  *
  * @todo: document this function
  */
void wxVariantHelper::SetRealSize(wxVariant& var, const wxRealSize& val)
{
    var << val;
}

/** @brief SetPointEx
  *
  * @todo: document this function
  */
void wxVariantHelper::SetPointEx(wxVariant& var, const wxPointEx& val)
{
    var << val;
}

/** @brief SetColor
  *
  * @todo: document this function
  */
void wxVariantHelper::SetColor(wxVariant& var, const wxColor& val)
{
    var << val;
}

/** @brief GetSizeEx
  *
  * @todo: document this function
  */
wxSizeEx wxVariantHelper::GetSizeEx(const wxVariant& var)
{
    if( var.GetType() != _T("wxSizeEx") ) return wxDefaultSize;

    wxSizeEx v;
    v << var;
    return v;
}

/** @brief GetRealSize
  *
  * @todo: document this function
  */
wxRealSize wxVariantHelper::GetRealSize(const wxVariant& var)
{
    if( var.GetType() != _T("wxRealSize") ) return wxDefaultRealSize;

    wxRealSize v;
    v << var;
    return v;
}

/** @brief GetRealRect
  *
  * @todo: document this function
  */
wxRealRect wxVariantHelper::GetRealRect(const wxVariant& var)
{
    if( var.GetType() != _T("wxRealRect") ) return wxDefaultRealRect;

    wxRealRect v;
    v << var;
    return v;
}

/** @brief GetPointEx
  *
  * @todo: document this function
  */
wxPointEx wxVariantHelper::GetPointEx(const wxVariant& var)
{
    if( var.GetType() != _T("wxPointEx") ) return wxDefaultPosition;

    wxPointEx v;
    v << var;
    return v;
}

/** @brief GetColor
  *
  * @todo: document this function
  */
wxColor wxVariantHelper::GetColor(const wxVariant& var)
{
    if( var.GetType() != _T("wxColour") ) return wxNullColour;

    wxColor c;
    c << var;
    return c;
}


wxBitmap wxVariantHelper::GetBitmap(const wxVariant& var)
{
    if( var.GetType() != _T("wxBitmap") ) return wxNullBitmap;

    wxBitmap b;
    b << var;
    return b;
}

void wxVariantHelper::SetBitmap(wxVariant& var, const wxBitmap& val)
{
    var << val;
}

wxVariant wxVariantHelper::ToVariant(const wxColor& val)
{
    wxVariant var;
    var << val;
    return var;
}

wxVariant wxVariantHelper::ToVariant(const wxBitmap& val)
{
    wxVariant var;
    var << val;
    return var;
}

wxVariant wxVariantHelper::ToVariant(const wxPointEx& val)
{
    wxVariant var;
    var << val;
    return var;
}

wxVariant wxVariantHelper::ToVariant(const wxRealRect& val)
{
    wxVariant var;
    var << val;
    return var;
}

wxVariant wxVariantHelper::ToVariant(const wxRealSize& val)
{
    wxVariant var;
    var << val;
    return var;
}

wxVariant wxVariantHelper::ToVariant(const wxSizeEx& val)
{
    wxVariant var;
    var << val;
    return var;
}

wxVariant wxVariantHelper::ToVariant(const wxRealPointEx& val)
{
    wxVariant var;
    var << val;
    return var;
}

wxString wxVariantHelper::MakeString(const wxVariant& var)
{
    wxString type = var.GetType();

    if( type == _T("wxColour") ) return DrawHelper::GetColorAsString( GetColor(var) );

    if( type == _T("wxPointEx") ) return wxString::Format(_T("x=%i,y=%i"), GetPointEx(var).x, GetPointEx(var).y );

    if( type == _T("wxRealRect") ) return GetRealRect(var).GetAsString(2);

    if( type == _T("wxRealSize") ) return wxString::Format(_T("w=%0.2f,h=%0.2f"),GetRealSize(var).w,GetRealSize(var).h);

    if( type == _T("wxSizeEx") ) return wxString::Format(_T("w=%i,h=%i"), GetSizeEx(var).x, GetSizeEx(var).y );

    return var.MakeString();
}


