#ifndef WXVARIANTHELPER_H
#define WXVARIANTHELPER_H

#include "wxRealPointEx.h"
#include "wxPointEx.h"
#include "wxRealRect.h"
#include "wxRealSize.h"
#include "wxSizeEx.h"

class wxVariantHelper
{
    public:

        static wxColor GetColor(const wxVariant& var);
        static wxBitmap GetBitmap(const wxVariant& var);
        static wxPointEx GetPointEx(const wxVariant& var);
        static wxRealRect GetRealRect(const wxVariant& var);
        static wxRealSize GetRealSize(const wxVariant& var);
        static wxSizeEx GetSizeEx(const wxVariant& var);
        static wxRealPointEx GetRealPointEx(const wxVariant& var);

        static void SetColor(wxVariant& var, const wxColor& val);
        static void SetBitmap(wxVariant& var, const wxBitmap& val);
        static void SetPointEx(wxVariant& var, const wxPointEx& val);
        static void SetRealRect(wxVariant& var, const wxRealRect& val);
        static void SetRealSize(wxVariant& var, const wxRealSize& val);
        static void SetSizeEx(wxVariant& var, const wxSizeEx& val);
        static void SetRealPointEx(wxVariant& var, const wxRealPointEx& val);

        static wxVariant ToVariant(const wxColor& val);
        static wxVariant ToVariant(const wxBitmap& val);
        static wxVariant ToVariant(const wxPointEx& val);
        static wxVariant ToVariant(const wxRealRect& val);
        static wxVariant ToVariant(const wxRealSize& val);
        static wxVariant ToVariant(const wxSizeEx& val);
        static wxVariant ToVariant(const wxRealPointEx& val);

        static wxString MakeString(const wxVariant& var);

};

#endif // WXVARIANTHELPER_H
